 /* ++ BUILD Version: 0004                                            */
 /*      -- Increment this if a change has global effects             */
 /*                                                                   */
 /* Copyright (c) 1985-96, Microsoft Corporation                      */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   gl.cpy                                                          */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   Procedure declarations, constant definitions and macros         */
 /*   for the OpenGL component.                                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #_gl_h_ char ext;
 %if #_gl_h_ = '' %then %do;
 %#_gl_h_ = 'Y';


 /* Copyright 1996 Silicon Graphics, Inc.                             */
 /* All Rights Reserved.                                              */
 /*                                                                   */
 /* This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics,  */
 /* Inc.                                                              */
 /* The contents of this file may not be disclosed to third parties,  */
 /* copied or duplicated in any form, in whole or in part, without    */
 /* the prior written permission of Silicon Graphics, Inc.            */
 /*                                                                   */
 /* RESTRICTED RIGHTS LEGEND:                                         */
 /* Use, duplication or disclosure by the Government is subject to    */
 /* restrictions as set forth in subdivision (c)(1)(ii) of the        */
 /* Rights in Technical Data and Computer Software clause at DFARS    */
 /* 252.227-7013, and/or in similar or successor clauses in the FAR,  */
 /* DOD or NASA FAR Supplement. Unpublished - rights reserved under   */
 /* the Copyright Laws of the United States.                          */

 define alias GLenum     fixed bin(32) unsigned;
 define alias GLboolean  fixed bin(8)  unsigned;
 define alias GLbitfield fixed bin(32) unsigned;
 define alias GLbyte     fixed bin(7)  signed;
 define alias GLshort    fixed bin(15);
 define alias GLint      fixed bin(31);
 define alias GLsizei    fixed bin(31);
 define alias GLubyte    fixed bin(8)  unsigned;
 define alias GLushort   fixed bin(16) unsigned;
 define alias GLuint     fixed bin(32) unsigned;
 define alias GLfloat    float bin(21);
 define alias GLclampf   float bin(21);
 define alias GLdouble   float bin(53);
 define alias GLclampd   float bin(53);
 /* define alias GLvoid * */

 /* PL/I translation note:                                            */
 /* The Microsoft version uses APIENTRY, WINGDIENTRY and CALLBACK     */
 /* as defined in Windef.cpy and WinGdi.cpy. Replacing these with     */
 /* OPENGLENTRY and OPENGLCALLBACK removes the dependency on the      */
 /* the other Microsoft header files, which enhances portability.     */
 %dcl OPENGLENTRY char ext;
 %OPENGLENTRY = 'options (byvalue linkage(stdcall) nodescriptor)';

 %dcl OPENGLCALLBACK char ext;
 %OPENGLCALLBACK = 'options (byvalue linkage(stdcall) nodescriptor)';


 /*************************************************************/

 /* Version */
 dcl GL_VERSION_1_1                   fixed bin(31) value(1);

 /* AccumOp */
 dcl GL_ACCUM                         type Glenum value('0100'xu);
 dcl GL_LOAD                          type Glenum value('0101'xu);
 dcl GL_RETURN                        type Glenum value('0102'xu);
 dcl GL_MULT                          type Glenum value('0103'xu);
 dcl GL_ADD                           type Glenum value('0104'xu);

 /* AlphaFunction */
 dcl GL_NEVER                         type Glenum value('0200'xu);
 dcl GL_LESS                          type Glenum value('0201'xu);
 dcl GL_EQUAL                         type Glenum value('0202'xu);
 dcl GL_LEQUAL                        type Glenum value('0203'xu);
 dcl GL_GREATER                       type Glenum value('0204'xu);
 dcl GL_NOTEQUAL                      type Glenum value('0205'xu);
 dcl GL_GEQUAL                        type Glenum value('0206'xu);
 dcl GL_ALWAYS                        type Glenum value('0207'xu);

 /* AttribMask */
 dcl GL_CURRENT_BIT                 type GLbitfield value('00000001'xu);
 dcl GL_POINT_BIT                   type GLbitfield value('00000002'xu);
 dcl GL_LINE_BIT                    type GLbitfield value('00000004'xu);
 dcl GL_POLYGON_BIT                 type GLbitfield value('00000008'xu);
 dcl GL_POLYGON_STIPPLE_BIT         type GLbitfield value('00000010'xu);
 dcl GL_PIXEL_MODE_BIT              type GLbitfield value('00000020'xu);
 dcl GL_LIGHTING_BIT                type GLbitfield value('00000040'xu);
 dcl GL_FOG_BIT                     type GLbitfield value('00000080'xu);
 dcl GL_DEPTH_BUFFER_BIT            type GLbitfield value('00000100'xu);
 dcl GL_ACCUM_BUFFER_BIT            type GLbitfield value('00000200'xu);
 dcl GL_STENCIL_BUFFER_BIT          type GLbitfield value('00000400'xu);
 dcl GL_VIEWPORT_BIT                type GLbitfield value('00000800'xu);
 dcl GL_TRANSFORM_BIT               type GLbitfield value('00001000'xu);
 dcl GL_ENABLE_BIT                  type GLbitfield value('00002000'xu);
 dcl GL_COLOR_BUFFER_BIT            type GLbitfield value('00004000'xu);
 dcl GL_HINT_BIT                    type GLbitfield value('00008000'xu);
 dcl GL_EVAL_BIT                    type GLbitfield value('00010000'xu);
 dcl GL_LIST_BIT                    type GLbitfield value('00020000'xu);
 dcl GL_TEXTURE_BIT                 type GLbitfield value('00040000'xu);
 dcl GL_SCISSOR_BIT                 type GLbitfield value('00080000'xu);
 dcl GL_ALL_ATTRIB_BITS             type GLbitfield value('000fffff'xu);

 /* BeginMode */
 dcl GL_POINTS                        type Glenum value('0000'xu);
 dcl GL_LINES                         type Glenum value('0001'xu);
 dcl GL_LINE_LOOP                     type Glenum value('0002'xu);
 dcl GL_LINE_STRIP                    type Glenum value('0003'xu);
 dcl GL_TRIANGLES                     type Glenum value('0004'xu);
 dcl GL_TRIANGLE_STRIP                type Glenum value('0005'xu);
 dcl GL_TRIANGLE_FAN                  type Glenum value('0006'xu);
 dcl GL_QUADS                         type Glenum value('0007'xu);
 dcl GL_QUAD_STRIP                    type Glenum value('0008'xu);
 dcl GL_POLYGON                       type Glenum value('0009'xu);

 /* BlendingFactorDest */
 dcl GL_ZERO                          fixed bin(31) value(0);
 dcl GL_ONE                           fixed bin(31) value(1);
 dcl GL_SRC_COLOR                     type Glenum value('0300'xu);
 dcl GL_ONE_MINUS_SRC_COLOR           type Glenum value('0301'xu);
 dcl GL_SRC_ALPHA                     type Glenum value('0302'xu);
 dcl GL_ONE_MINUS_SRC_ALPHA           type Glenum value('0303'xu);
 dcl GL_DST_ALPHA                     type Glenum value('0304'xu);
 dcl GL_ONE_MINUS_DST_ALPHA           type Glenum value('0305'xu);

 /* BlendingFactorSrc */
 /*  GL_ZERO                 */
 /*  GL_ONE                  */
 dcl GL_DST_COLOR                     type Glenum value('0306'xu);
 dcl GL_ONE_MINUS_DST_COLOR           type Glenum value('0307'xu);
 dcl GL_SRC_ALPHA_SATURATE            type Glenum value('0308'xu);
 /*  GL_SRC_ALPHA            */
 /*  GL_ONE_MINUS_SRC_ALPHA  */
 /*  GL_DST_ALPHA            */
 /*  GL_ONE_MINUS_DST_ALPHA  */

 /* Boolean */
 dcl GL_TRUE                          fixed bin(31) value(1);
 dcl GL_FALSE                         fixed bin(31) value(0);

 /* ClearBufferMask */
 /*  GL_COLOR_BUFFER_BIT     */
 /*  GL_ACCUM_BUFFER_BIT     */
 /*  GL_STENCIL_BUFFER_BIT   */
 /*  GL_DEPTH_BUFFER_BIT     */

 /* ClientArrayType          */
 /*  GL_VERTEX_ARRAY         */
 /*  GL_NORMAL_ARRAY         */
 /*  GL_COLOR_ARRAY          */
 /*  GL_INDEX_ARRAY          */
 /*  GL_TEXTURE_COORD_ARRAY  */
 /*  GL_EDGE_FLAG_ARRAY      */

 /* ClipPlaneName */
 dcl GL_CLIP_PLANE0                   type Glenum value('3000'xu);
 dcl GL_CLIP_PLANE1                   type Glenum value('3001'xu);
 dcl GL_CLIP_PLANE2                   type Glenum value('3002'xu);
 dcl GL_CLIP_PLANE3                   type Glenum value('3003'xu);
 dcl GL_CLIP_PLANE4                   type Glenum value('3004'xu);
 dcl GL_CLIP_PLANE5                   type Glenum value('3005'xu);

 /* ColorMaterialFace */
 /*  GL_FRONT                */
 /*  GL_BACK                 */
 /*  GL_FRONT_AND_BACK       */

 /* ColorMaterialParameter   */
 /*  GL_AMBIENT              */
 /*  GL_DIFFUSE              */
 /*  GL_SPECULAR             */
 /*  GL_EMISSION             */
 /*  GL_AMBIENT_AND_DIFFUSE  */

 /* ColorPointerType         */
 /*  GL_BYTE                 */
 /*  GL_UNSIGNED_BYTE        */
 /*  GL_SHORT                */
 /*  GL_UNSIGNED_SHORT       */
 /*  GL_INT                  */
 /*  GL_UNSIGNED_INT         */
 /*  GL_FLOAT                */
 /*  GL_DOUBLE               */

 /* CullFaceMode */
 /*  GL_FRONT                */
 /*  GL_BACK                 */
 /*  GL_FRONT_AND_BACK       */

 /* DataType */
 dcl GL_BYTE                          type Glenum value('1400'xu);
 dcl GL_UNSIGNED_BYTE                 type Glenum value('1401'xu);
 dcl GL_SHORT                         type Glenum value('1402'xu);
 dcl GL_UNSIGNED_SHORT                type Glenum value('1403'xu);
 dcl GL_INT                           type Glenum value('1404'xu);
 dcl GL_UNSIGNED_INT                  type Glenum value('1405'xu);
 dcl GL_FLOAT                         type Glenum value('1406'xu);
 dcl GL_2_BYTES                       type Glenum value('1407'xu);
 dcl GL_3_BYTES                       type Glenum value('1408'xu);
 dcl GL_4_BYTES                       type Glenum value('1409'xu);
 dcl GL_DOUBLE                        type Glenum value('140A'xu);

 /* DepthFunction */
 /*      GL_NEVER            */
 /*      GL_LESS             */
 /*      GL_EQUAL            */
 /*      GL_LEQUAL           */
 /*      GL_GREATER          */
 /*      GL_NOTEQUAL         */
 /*      GL_GEQUAL           */
 /*      GL_ALWAYS           */

 /* DrawBufferMode */
 dcl GL_NONE                          type Glenum value(0);
 dcl GL_FRONT_LEFT                    type Glenum value('0400'xu);
 dcl GL_FRONT_RIGHT                   type Glenum value('0401'xu);
 dcl GL_BACK_LEFT                     type Glenum value('0402'xu);
 dcl GL_BACK_RIGHT                    type Glenum value('0403'xu);
 dcl GL_FRONT                         type Glenum value('0404'xu);
 dcl GL_BACK                          type Glenum value('0405'xu);
 dcl GL_LEFT                          type Glenum value('0406'xu);
 dcl GL_RIGHT                         type Glenum value('0407'xu);
 dcl GL_FRONT_AND_BACK                type Glenum value('0408'xu);
 dcl GL_AUX0                          type Glenum value('0409'xu);
 dcl GL_AUX1                          type Glenum value('040A'xu);
 dcl GL_AUX2                          type Glenum value('040B'xu);
 dcl GL_AUX3                          type Glenum value('040C'xu);

 /* Enable */
 /*  GL_FOG                  */
 /*  GL_LIGHTING             */
 /*  GL_TEXTURE_1D           */
 /*  GL_TEXTURE_2D           */
 /*  GL_LINE_STIPPLE         */
 /*  GL_POLYGON_STIPPLE      */
 /*  GL_CULL_FACE            */
 /*  GL_ALPHA_TEST           */
 /*  GL_BLEND                */
 /*  GL_INDEX_LOGIC_OP       */
 /*  GL_COLOR_LOGIC_OP       */
 /*  GL_DITHER               */
 /*  GL_STENCIL_TEST         */
 /*  GL_DEPTH_TEST           */
 /*  GL_CLIP_PLANE0          */
 /*  GL_CLIP_PLANE1          */
 /*  GL_CLIP_PLANE2          */
 /*  GL_CLIP_PLANE3          */
 /*  GL_CLIP_PLANE4          */
 /*  GL_CLIP_PLANE5          */
 /*  GL_LIGHT0               */
 /*  GL_LIGHT1               */
 /*  GL_LIGHT2               */
 /*  GL_LIGHT3               */
 /*  GL_LIGHT4               */
 /*  GL_LIGHT5               */
 /*  GL_LIGHT6               */
 /*  GL_LIGHT7               */
 /*  GL_TEXTURE_GEN_S        */
 /*  GL_TEXTURE_GEN_T        */
 /*  GL_TEXTURE_GEN_R        */
 /*  GL_TEXTURE_GEN_Q        */
 /*  GL_MAP1_VERTEX_3        */
 /*  GL_MAP1_VERTEX_4        */
 /*  GL_MAP1_COLOR_4         */
 /*  GL_MAP1_INDEX           */
 /*  GL_MAP1_NORMAL          */
 /*  GL_MAP1_TEXTURE_COORD_1 */
 /*  GL_MAP1_TEXTURE_COORD_2 */
 /*  GL_MAP1_TEXTURE_COORD_3 */
 /*  GL_MAP1_TEXTURE_COORD_4 */
 /*  GL_MAP2_VERTEX_3        */
 /*  GL_MAP2_VERTEX_4        */
 /*  GL_MAP2_COLOR_4         */
 /*  GL_MAP2_INDEX           */
 /*  GL_MAP2_NORMAL          */
 /*  GL_MAP2_TEXTURE_COORD_1 */
 /*  GL_MAP2_TEXTURE_COORD_2 */
 /*  GL_MAP2_TEXTURE_COORD_3 */
 /*  GL_MAP2_TEXTURE_COORD_4 */
 /*  GL_POINT_SMOOTH         */
 /*  GL_LINE_SMOOTH          */
 /*  GL_POLYGON_SMOOTH       */
 /*  GL_SCISSOR_TEST         */
 /*  GL_COLOR_MATERIAL       */
 /*  GL_NORMALIZE            */
 /*  GL_AUTO_NORMAL          */
 /*  GL_VERTEX_ARRAY         */
 /*  GL_NORMAL_ARRAY         */
 /*  GL_COLOR_ARRAY          */
 /*  GL_INDEX_ARRAY          */
 /*  GL_TEXTURE_COORD_ARRAY  */
 /*  GL_EDGE_FLAG_ARRAY      */
 /*  GL_POLYGON_OFFSET_POINT */
 /*  GL_POLYGON_OFFSET_LINE  */
 /*  GL_POLYGON_OFFSET_FILL  */

 /* ErrorCode */
 dcl GL_NO_ERROR                      type Glenum value(0);
 dcl GL_INVALID_ENUM                  type Glenum value('0500'xu);
 dcl GL_INVALID_VALUE                 type Glenum value('0501'xu);
 dcl GL_INVALID_OPERATION             type Glenum value('0502'xu);
 dcl GL_STACK_OVERFLOW                type Glenum value('0503'xu);
 dcl GL_STACK_UNDERFLOW               type Glenum value('0504'xu);
 dcl GL_OUT_OF_MEMORY                 type Glenum value('0505'xu);

 /* FeedBackMode */
 dcl GL_2D                            type Glenum value('0600'xu);
 dcl GL_3D                            type Glenum value('0601'xu);
 dcl GL_3D_COLOR                      type Glenum value('0602'xu);
 dcl GL_3D_COLOR_TEXTURE              type Glenum value('0603'xu);
 dcl GL_4D_COLOR_TEXTURE              type Glenum value('0604'xu);

 /* FeedBackToken */
 dcl GL_PASS_THROUGH_TOKEN            type Glenum value('0700'xu);
 dcl GL_POINT_TOKEN                   type Glenum value('0701'xu);
 dcl GL_LINE_TOKEN                    type Glenum value('0702'xu);
 dcl GL_POLYGON_TOKEN                 type Glenum value('0703'xu);
 dcl GL_BITMAP_TOKEN                  type Glenum value('0704'xu);
 dcl GL_DRAW_PIXEL_TOKEN              type Glenum value('0705'xu);
 dcl GL_COPY_PIXEL_TOKEN              type Glenum value('0706'xu);
 dcl GL_LINE_RESET_TOKEN              type Glenum value('0707'xu);

 /* FogMode */
 /*  GL_LINEAR               */
 dcl GL_EXP                           type Glenum value('0800'xu);
 dcl GL_EXP2                          type Glenum value('0801'xu);


 /* FogParameter */
 /*  GL_FOG_COLOR            */
 /*  GL_FOG_DENSITY          */
 /*  GL_FOG_END              */
 /*  GL_FOG_INDEX            */
 /*  GL_FOG_MODE             */
 /*  GL_FOG_START            */

 /* FrontFaceDirection */
 dcl GL_CW                            type Glenum value('0900'xu);
 dcl GL_CCW                           type Glenum value('0901'xu);

 /* GetMapTarget */
 dcl GL_COEFF                         type Glenum value('0A00'xu);
 dcl GL_ORDER                         type Glenum value('0A01'xu);
 dcl GL_DOMAIN                        type Glenum value('0A02'xu);

 /* GetPixelMap */
 /*  GL_PIXEL_MAP_I_TO_I     */
 /*  GL_PIXEL_MAP_S_TO_S     */
 /*  GL_PIXEL_MAP_I_TO_R     */
 /*  GL_PIXEL_MAP_I_TO_G     */
 /*  GL_PIXEL_MAP_I_TO_B     */
 /*  GL_PIXEL_MAP_I_TO_A     */
 /*  GL_PIXEL_MAP_R_TO_R     */
 /*  GL_PIXEL_MAP_G_TO_G     */
 /*  GL_PIXEL_MAP_B_TO_B     */
 /*  GL_PIXEL_MAP_A_TO_A     */

 /* GetPointerTarget */
 /*  GL_VERTEX_ARRAY_POINTER        */
 /*  GL_NORMAL_ARRAY_POINTER        */
 /*  GL_COLOR_ARRAY_POINTER         */
 /*  GL_INDEX_ARRAY_POINTER         */
 /*  GL_TEXTURE_COORD_ARRAY_POINTER */
 /*  GL_EDGE_FLAG_ARRAY_POINTER     */

 /* GetTarget */
 dcl GL_CURRENT_COLOR                 type Glenum value('0B00'xu);
 dcl GL_CURRENT_INDEX                 type Glenum value('0B01'xu);
 dcl GL_CURRENT_NORMAL                type Glenum value('0B02'xu);
 dcl GL_CURRENT_TEXTURE_COORDS        type Glenum value('0B03'xu);
 dcl GL_CURRENT_RASTER_COLOR          type Glenum value('0B04'xu);
 dcl GL_CURRENT_RASTER_INDEX          type Glenum value('0B05'xu);
 dcl GL_CURRENT_RASTER_TEXTURE_COORDS type Glenum value('0B06'xu);
 dcl GL_CURRENT_RASTER_POSITION       type Glenum value('0B07'xu);
 dcl GL_CURRENT_RASTER_POSITION_VALID type Glenum value('0B08'xu);
 dcl GL_CURRENT_RASTER_DISTANCE       type Glenum value('0B09'xu);
 dcl GL_POINT_SMOOTH                  type Glenum value('0B10'xu);
 dcl GL_POINT_SIZE                    type Glenum value('0B11'xu);
 dcl GL_POINT_SIZE_RANGE              type Glenum value('0B12'xu);
 dcl GL_POINT_SIZE_GRANULARITY        type Glenum value('0B13'xu);
 dcl GL_LINE_SMOOTH                   type Glenum value('0B20'xu);
 dcl GL_LINE_WIDTH                    type Glenum value('0B21'xu);
 dcl GL_LINE_WIDTH_RANGE              type Glenum value('0B22'xu);
 dcl GL_LINE_WIDTH_GRANULARITY        type Glenum value('0B23'xu);
 dcl GL_LINE_STIPPLE                  type Glenum value('0B24'xu);
 dcl GL_LINE_STIPPLE_PATTERN          type Glenum value('0B25'xu);
 dcl GL_LINE_STIPPLE_REPEAT           type Glenum value('0B26'xu);
 dcl GL_LIST_MODE                     type Glenum value('0B30'xu);
 dcl GL_MAX_LIST_NESTING              type Glenum value('0B31'xu);
 dcl GL_LIST_BASE                     type Glenum value('0B32'xu);
 dcl GL_LIST_INDEX                    type Glenum value('0B33'xu);
 dcl GL_POLYGON_MODE                  type Glenum value('0B40'xu);
 dcl GL_POLYGON_SMOOTH                type Glenum value('0B41'xu);
 dcl GL_POLYGON_STIPPLE               type Glenum value('0B42'xu);
 dcl GL_EDGE_FLAG                     type Glenum value('0B43'xu);
 dcl GL_CULL_FACE                     type Glenum value('0B44'xu);
 dcl GL_CULL_FACE_MODE                type Glenum value('0B45'xu);
 dcl GL_FRONT_FACE                    type Glenum value('0B46'xu);
 dcl GL_LIGHTING                      type Glenum value('0B50'xu);
 dcl GL_LIGHT_MODEL_LOCAL_VIEWER      type Glenum value('0B51'xu);
 dcl GL_LIGHT_MODEL_TWO_SIDE          type Glenum value('0B52'xu);
 dcl GL_LIGHT_MODEL_AMBIENT           type Glenum value('0B53'xu);
 dcl GL_SHADE_MODEL                   type Glenum value('0B54'xu);
 dcl GL_COLOR_MATERIAL_FACE           type Glenum value('0B55'xu);
 dcl GL_COLOR_MATERIAL_PARAMETER      type Glenum value('0B56'xu);
 dcl GL_COLOR_MATERIAL                type Glenum value('0B57'xu);
 dcl GL_FOG                           type Glenum value('0B60'xu);
 dcl GL_FOG_INDEX                     type Glenum value('0B61'xu);
 dcl GL_FOG_DENSITY                   type Glenum value('0B62'xu);
 dcl GL_FOG_START                     type Glenum value('0B63'xu);
 dcl GL_FOG_END                       type Glenum value('0B64'xu);
 dcl GL_FOG_MODE                      type Glenum value('0B65'xu);
 dcl GL_FOG_COLOR                     type Glenum value('0B66'xu);
 dcl GL_DEPTH_RANGE                   type Glenum value('0B70'xu);
 dcl GL_DEPTH_TEST                    type Glenum value('0B71'xu);
 dcl GL_DEPTH_WRITEMASK               type Glenum value('0B72'xu);
 dcl GL_DEPTH_CLEAR_VALUE             type Glenum value('0B73'xu);
 dcl GL_DEPTH_FUNC                    type Glenum value('0B74'xu);
 dcl GL_ACCUM_CLEAR_VALUE             type Glenum value('0B80'xu);
 dcl GL_STENCIL_TEST                  type Glenum value('0B90'xu);
 dcl GL_STENCIL_CLEAR_VALUE           type Glenum value('0B91'xu);
 dcl GL_STENCIL_FUNC                  type Glenum value('0B92'xu);
 dcl GL_STENCIL_VALUE_MASK            type Glenum value('0B93'xu);
 dcl GL_STENCIL_FAIL                  type Glenum value('0B94'xu);
 dcl GL_STENCIL_PASS_DEPTH_FAIL       type Glenum value('0B95'xu);
 dcl GL_STENCIL_PASS_DEPTH_PASS       type Glenum value('0B96'xu);
 dcl GL_STENCIL_REF                   type Glenum value('0B97'xu);
 dcl GL_STENCIL_WRITEMASK             type Glenum value('0B98'xu);
 dcl GL_MATRIX_MODE                   type Glenum value('0BA0'xu);
 dcl GL_NORMALIZE                     type Glenum value('0BA1'xu);
 dcl GL_VIEWPORT                      type Glenum value('0BA2'xu);
 dcl GL_MODELVIEW_STACK_DEPTH         type Glenum value('0BA3'xu);
 dcl GL_PROJECTION_STACK_DEPTH        type Glenum value('0BA4'xu);
 dcl GL_TEXTURE_STACK_DEPTH           type Glenum value('0BA5'xu);
 dcl GL_MODELVIEW_MATRIX              type Glenum value('0BA6'xu);
 dcl GL_PROJECTION_MATRIX             type Glenum value('0BA7'xu);
 dcl GL_TEXTURE_MATRIX                type Glenum value('0BA8'xu);
 dcl GL_ATTRIB_STACK_DEPTH            type Glenum value('0BB0'xu);
 dcl GL_CLIENT_ATTRIB_STACK_DEPTH     type Glenum value('0BB1'xu);
 dcl GL_ALPHA_TEST                    type Glenum value('0BC0'xu);
 dcl GL_ALPHA_TEST_FUNC               type Glenum value('0BC1'xu);
 dcl GL_ALPHA_TEST_REF                type Glenum value('0BC2'xu);
 dcl GL_DITHER                        type Glenum value('0BD0'xu);
 dcl GL_BLEND_DST                     type Glenum value('0BE0'xu);
 dcl GL_BLEND_SRC                     type Glenum value('0BE1'xu);
 dcl GL_BLEND                         type Glenum value('0BE2'xu);
 dcl GL_LOGIC_OP_MODE                 type Glenum value('0BF0'xu);
 dcl GL_INDEX_LOGIC_OP                type Glenum value('0BF1'xu);
 dcl GL_COLOR_LOGIC_OP                type Glenum value('0BF2'xu);
 dcl GL_AUX_BUFFERS                   type Glenum value('0C00'xu);
 dcl GL_DRAW_BUFFER                   type Glenum value('0C01'xu);
 dcl GL_READ_BUFFER                   type Glenum value('0C02'xu);
 dcl GL_SCISSOR_BOX                   type Glenum value('0C10'xu);
 dcl GL_SCISSOR_TEST                  type Glenum value('0C11'xu);
 dcl GL_INDEX_CLEAR_VALUE             type Glenum value('0C20'xu);
 dcl GL_INDEX_WRITEMASK               type Glenum value('0C21'xu);
 dcl GL_COLOR_CLEAR_VALUE             type Glenum value('0C22'xu);
 dcl GL_COLOR_WRITEMASK               type Glenum value('0C23'xu);
 dcl GL_INDEX_MODE                    type Glenum value('0C30'xu);
 dcl GL_RGBA_MODE                     type Glenum value('0C31'xu);
 dcl GL_DOUBLEBUFFER                  type Glenum value('0C32'xu);
 dcl GL_STEREO                        type Glenum value('0C33'xu);
 dcl GL_RENDER_MODE                   type Glenum value('0C40'xu);
 dcl GL_PERSPECTIVE_CORRECTION_HINT   type Glenum value('0C50'xu);
 dcl GL_POINT_SMOOTH_HINT             type Glenum value('0C51'xu);
 dcl GL_LINE_SMOOTH_HINT              type Glenum value('0C52'xu);
 dcl GL_POLYGON_SMOOTH_HINT           type Glenum value('0C53'xu);
 dcl GL_FOG_HINT                      type Glenum value('0C54'xu);
 dcl GL_TEXTURE_GEN_S                 type Glenum value('0C60'xu);
 dcl GL_TEXTURE_GEN_T                 type Glenum value('0C61'xu);
 dcl GL_TEXTURE_GEN_R                 type Glenum value('0C62'xu);
 dcl GL_TEXTURE_GEN_Q                 type Glenum value('0C63'xu);
 dcl GL_PIXEL_MAP_I_TO_I              type Glenum value('0C70'xu);
 dcl GL_PIXEL_MAP_S_TO_S              type Glenum value('0C71'xu);
 dcl GL_PIXEL_MAP_I_TO_R              type Glenum value('0C72'xu);
 dcl GL_PIXEL_MAP_I_TO_G              type Glenum value('0C73'xu);
 dcl GL_PIXEL_MAP_I_TO_B              type Glenum value('0C74'xu);
 dcl GL_PIXEL_MAP_I_TO_A              type Glenum value('0C75'xu);
 dcl GL_PIXEL_MAP_R_TO_R              type Glenum value('0C76'xu);
 dcl GL_PIXEL_MAP_G_TO_G              type Glenum value('0C77'xu);
 dcl GL_PIXEL_MAP_B_TO_B              type Glenum value('0C78'xu);
 dcl GL_PIXEL_MAP_A_TO_A              type Glenum value('0C79'xu);
 dcl GL_PIXEL_MAP_I_TO_I_SIZE         type Glenum value('0CB0'xu);
 dcl GL_PIXEL_MAP_S_TO_S_SIZE         type Glenum value('0CB1'xu);
 dcl GL_PIXEL_MAP_I_TO_R_SIZE         type Glenum value('0CB2'xu);
 dcl GL_PIXEL_MAP_I_TO_G_SIZE         type Glenum value('0CB3'xu);
 dcl GL_PIXEL_MAP_I_TO_B_SIZE         type Glenum value('0CB4'xu);
 dcl GL_PIXEL_MAP_I_TO_A_SIZE         type Glenum value('0CB5'xu);
 dcl GL_PIXEL_MAP_R_TO_R_SIZE         type Glenum value('0CB6'xu);
 dcl GL_PIXEL_MAP_G_TO_G_SIZE         type Glenum value('0CB7'xu);
 dcl GL_PIXEL_MAP_B_TO_B_SIZE         type Glenum value('0CB8'xu);
 dcl GL_PIXEL_MAP_A_TO_A_SIZE         type Glenum value('0CB9'xu);
 dcl GL_UNPACK_SWAP_BYTES             type Glenum value('0CF0'xu);
 dcl GL_UNPACK_LSB_FIRST              type Glenum value('0CF1'xu);
 dcl GL_UNPACK_ROW_LENGTH             type Glenum value('0CF2'xu);
 dcl GL_UNPACK_SKIP_ROWS              type Glenum value('0CF3'xu);
 dcl GL_UNPACK_SKIP_PIXELS            type Glenum value('0CF4'xu);
 dcl GL_UNPACK_ALIGNMENT              type Glenum value('0CF5'xu);
 dcl GL_PACK_SWAP_BYTES               type Glenum value('0D00'xu);
 dcl GL_PACK_LSB_FIRST                type Glenum value('0D01'xu);
 dcl GL_PACK_ROW_LENGTH               type Glenum value('0D02'xu);
 dcl GL_PACK_SKIP_ROWS                type Glenum value('0D03'xu);
 dcl GL_PACK_SKIP_PIXELS              type Glenum value('0D04'xu);
 dcl GL_PACK_ALIGNMENT                type Glenum value('0D05'xu);
 dcl GL_MAP_COLOR                     type Glenum value('0D10'xu);
 dcl GL_MAP_STENCIL                   type Glenum value('0D11'xu);
 dcl GL_INDEX_SHIFT                   type Glenum value('0D12'xu);
 dcl GL_INDEX_OFFSET                  type Glenum value('0D13'xu);
 dcl GL_RED_SCALE                     type Glenum value('0D14'xu);
 dcl GL_RED_BIAS                      type Glenum value('0D15'xu);
 dcl GL_ZOOM_X                        type Glenum value('0D16'xu);
 dcl GL_ZOOM_Y                        type Glenum value('0D17'xu);
 dcl GL_GREEN_SCALE                   type Glenum value('0D18'xu);
 dcl GL_GREEN_BIAS                    type Glenum value('0D19'xu);
 dcl GL_BLUE_SCALE                    type Glenum value('0D1A'xu);
 dcl GL_BLUE_BIAS                     type Glenum value('0D1B'xu);
 dcl GL_ALPHA_SCALE                   type Glenum value('0D1C'xu);
 dcl GL_ALPHA_BIAS                    type Glenum value('0D1D'xu);
 dcl GL_DEPTH_SCALE                   type Glenum value('0D1E'xu);
 dcl GL_DEPTH_BIAS                    type Glenum value('0D1F'xu);
 dcl GL_MAX_EVAL_ORDER                type Glenum value('0D30'xu);
 dcl GL_MAX_LIGHTS                    type Glenum value('0D31'xu);
 dcl GL_MAX_CLIP_PLANES               type Glenum value('0D32'xu);
 dcl GL_MAX_TEXTURE_SIZE              type Glenum value('0D33'xu);
 dcl GL_MAX_PIXEL_MAP_TABLE           type Glenum value('0D34'xu);
 dcl GL_MAX_ATTRIB_STACK_DEPTH        type Glenum value('0D35'xu);
 dcl GL_MAX_MODELVIEW_STACK_DEPTH     type Glenum value('0D36'xu);
 dcl GL_MAX_NAME_STACK_DEPTH          type Glenum value('0D37'xu);
 dcl GL_MAX_PROJECTION_STACK_DEPTH    type Glenum value('0D38'xu);
 dcl GL_MAX_TEXTURE_STACK_DEPTH       type Glenum value('0D39'xu);
 dcl GL_MAX_VIEWPORT_DIMS             type Glenum value('0D3A'xu);
 dcl GL_MAX_CLIENT_ATTRIB_STACK_DEPTH type Glenum value('0D3B'xu);
 dcl GL_SUBPIXEL_BITS                 type Glenum value('0D50'xu);
 dcl GL_INDEX_BITS                    type Glenum value('0D51'xu);
 dcl GL_RED_BITS                      type Glenum value('0D52'xu);
 dcl GL_GREEN_BITS                    type Glenum value('0D53'xu);
 dcl GL_BLUE_BITS                     type Glenum value('0D54'xu);
 dcl GL_ALPHA_BITS                    type Glenum value('0D55'xu);
 dcl GL_DEPTH_BITS                    type Glenum value('0D56'xu);
 dcl GL_STENCIL_BITS                  type Glenum value('0D57'xu);
 dcl GL_ACCUM_RED_BITS                type Glenum value('0D58'xu);
 dcl GL_ACCUM_GREEN_BITS              type Glenum value('0D59'xu);
 dcl GL_ACCUM_BLUE_BITS               type Glenum value('0D5A'xu);
 dcl GL_ACCUM_ALPHA_BITS              type Glenum value('0D5B'xu);
 dcl GL_NAME_STACK_DEPTH              type Glenum value('0D70'xu);
 dcl GL_AUTO_NORMAL                   type Glenum value('0D80'xu);
 dcl GL_MAP1_COLOR_4                  type Glenum value('0D90'xu);
 dcl GL_MAP1_INDEX                    type Glenum value('0D91'xu);
 dcl GL_MAP1_NORMAL                   type Glenum value('0D92'xu);
 dcl GL_MAP1_TEXTURE_COORD_1          type Glenum value('0D93'xu);
 dcl GL_MAP1_TEXTURE_COORD_2          type Glenum value('0D94'xu);
 dcl GL_MAP1_TEXTURE_COORD_3          type Glenum value('0D95'xu);
 dcl GL_MAP1_TEXTURE_COORD_4          type Glenum value('0D96'xu);
 dcl GL_MAP1_VERTEX_3                 type Glenum value('0D97'xu);
 dcl GL_MAP1_VERTEX_4                 type Glenum value('0D98'xu);
 dcl GL_MAP2_COLOR_4                  type Glenum value('0DB0'xu);
 dcl GL_MAP2_INDEX                    type Glenum value('0DB1'xu);
 dcl GL_MAP2_NORMAL                   type Glenum value('0DB2'xu);
 dcl GL_MAP2_TEXTURE_COORD_1          type Glenum value('0DB3'xu);
 dcl GL_MAP2_TEXTURE_COORD_2          type Glenum value('0DB4'xu);
 dcl GL_MAP2_TEXTURE_COORD_3          type Glenum value('0DB5'xu);
 dcl GL_MAP2_TEXTURE_COORD_4          type Glenum value('0DB6'xu);
 dcl GL_MAP2_VERTEX_3                 type Glenum value('0DB7'xu);
 dcl GL_MAP2_VERTEX_4                 type Glenum value('0DB8'xu);
 dcl GL_MAP1_GRID_DOMAIN              type Glenum value('0DD0'xu);
 dcl GL_MAP1_GRID_SEGMENTS            type Glenum value('0DD1'xu);
 dcl GL_MAP2_GRID_DOMAIN              type Glenum value('0DD2'xu);
 dcl GL_MAP2_GRID_SEGMENTS            type Glenum value('0DD3'xu);
 dcl GL_TEXTURE_1D                    type Glenum value('0DE0'xu);
 dcl GL_TEXTURE_2D                    type Glenum value('0DE1'xu);
 dcl GL_FEEDBACK_BUFFER_POINTER       type Glenum value('0DF0'xu);
 dcl GL_FEEDBACK_BUFFER_SIZE          type Glenum value('0DF1'xu);
 dcl GL_FEEDBACK_BUFFER_TYPE          type Glenum value('0DF2'xu);
 dcl GL_SELECTION_BUFFER_POINTER      type Glenum value('0DF3'xu);
 dcl GL_SELECTION_BUFFER_SIZE         type Glenum value('0DF4'xu);
 /*  GL_TEXTURE_BINDING_1D          */
 /*  GL_TEXTURE_BINDING_2D          */
 /*  GL_VERTEX_ARRAY                */
 /*  GL_NORMAL_ARRAY                */
 /*  GL_COLOR_ARRAY                 */
 /*  GL_INDEX_ARRAY                 */
 /*  GL_TEXTURE_COORD_ARRAY         */
 /*  GL_EDGE_FLAG_ARRAY             */
 /*  GL_VERTEX_ARRAY_SIZE           */
 /*  GL_VERTEX_ARRAY_TYPE           */
 /*  GL_VERTEX_ARRAY_STRIDE         */
 /*  GL_NORMAL_ARRAY_TYPE           */
 /*  GL_NORMAL_ARRAY_STRIDE         */
 /*  GL_COLOR_ARRAY_SIZE            */
 /*  GL_COLOR_ARRAY_TYPE            */
 /*  GL_COLOR_ARRAY_STRIDE          */
 /*  GL_INDEX_ARRAY_TYPE            */
 /*  GL_INDEX_ARRAY_STRIDE          */
 /*  GL_TEXTURE_COORD_ARRAY_SIZE    */
 /*  GL_TEXTURE_COORD_ARRAY_TYPE    */
 /*  GL_TEXTURE_COORD_ARRAY_STRIDE  */
 /*  GL_EDGE_FLAG_ARRAY_STRIDE      */
 /*  GL_POLYGON_OFFSET_FACTOR       */
 /*  GL_POLYGON_OFFSET_UNITS        */

 /* GetTextureParameter */
 /*  GL_TEXTURE_MAG_FILTER          */
 /*  GL_TEXTURE_MIN_FILTER          */
 /*  GL_TEXTURE_WRAP_S              */
 /*  GL_TEXTURE_WRAP_T              */
 dcl GL_TEXTURE_WIDTH                 type Glenum value('1000'xu);
 dcl GL_TEXTURE_HEIGHT                type Glenum value('1001'xu);
 dcl GL_TEXTURE_INTERNAL_FORMAT       type Glenum value('1003'xu);
 dcl GL_TEXTURE_BORDER_COLOR          type Glenum value('1004'xu);
 dcl GL_TEXTURE_BORDER                type Glenum value('1005'xu);
 /*  GL_TEXTURE_RED_SIZE            */
 /*  GL_TEXTURE_GREEN_SIZE          */
 /*  GL_TEXTURE_BLUE_SIZE           */
 /*  GL_TEXTURE_ALPHA_SIZE          */
 /*  GL_TEXTURE_LUMINANCE_SIZE      */
 /*  GL_TEXTURE_INTENSITY_SIZE      */
 /*  GL_TEXTURE_PRIORITY            */
 /*  GL_TEXTURE_RESIDENT            */

 /* HintMode */
 dcl GL_DONT_CARE                     type Glenum value('1100'xu);
 dcl GL_FASTEST                       type Glenum value('1101'xu);
 dcl GL_NICEST                        type Glenum value('1102'xu);

 /* HintTarget */
 /*  GL_PERSPECTIVE_CORRECTION_HINT */
 /*  GL_POINT_SMOOTH_HINT           */
 /*  GL_LINE_SMOOTH_HINT            */
 /*  GL_POLYGON_SMOOTH_HINT         */
 /*  GL_FOG_HINT                    */
 /*  GL_PHONG_HINT                  */

 /* IndexPointerType */
 /*  GL_SHORT                       */
 /*  GL_INT                         */
 /*  GL_FLOAT                       */
 /*  GL_DOUBLE                      */

 /* LightModelParameter */
 /*  GL_LIGHT_MODEL_AMBIENT         */
 /*  GL_LIGHT_MODEL_LOCAL_VIEWER    */
 /*  GL_LIGHT_MODEL_TWO_SIDE        */

 /* LightName */
 dcl GL_LIGHT0                        type Glenum value('4000'xu);
 dcl GL_LIGHT1                        type Glenum value('4001'xu);
 dcl GL_LIGHT2                        type Glenum value('4002'xu);
 dcl GL_LIGHT3                        type Glenum value('4003'xu);
 dcl GL_LIGHT4                        type Glenum value('4004'xu);
 dcl GL_LIGHT5                        type Glenum value('4005'xu);
 dcl GL_LIGHT6                        type Glenum value('4006'xu);
 dcl GL_LIGHT7                        type Glenum value('4007'xu);

 /* LightParameter */
 dcl GL_AMBIENT                       type Glenum value('1200'xu);
 dcl GL_DIFFUSE                       type Glenum value('1201'xu);
 dcl GL_SPECULAR                      type Glenum value('1202'xu);
 dcl GL_POSITION                      type Glenum value('1203'xu);
 dcl GL_SPOT_DIRECTION                type Glenum value('1204'xu);
 dcl GL_SPOT_EXPONENT                 type Glenum value('1205'xu);
 dcl GL_SPOT_CUTOFF                   type Glenum value('1206'xu);
 dcl GL_CONSTANT_ATTENUATION          type Glenum value('1207'xu);
 dcl GL_LINEAR_ATTENUATION            type Glenum value('1208'xu);
 dcl GL_QUADRATIC_ATTENUATION         type Glenum value('1209'xu);

 /* InterleavedArrays */
 /*  GL_V2F                         */
 /*  GL_V3F                         */
 /*  GL_C4UB_V2F                    */
 /*  GL_C4UB_V3F                    */
 /*  GL_C3F_V3F                     */
 /*  GL_N3F_V3F                     */
 /*  GL_C4F_N3F_V3F                 */
 /*  GL_T2F_V3F                     */
 /*  GL_T4F_V4F                     */
 /*  GL_T2F_C4UB_V3F                */
 /*  GL_T2F_C3F_V3F                 */
 /*  GL_T2F_N3F_V3F                 */
 /*  GL_T2F_C4F_N3F_V3F             */
 /*  GL_T4F_C4F_N3F_V4F             */

 /* ListMode */
 dcl GL_COMPILE                       type Glenum value('1300'xu);
 dcl GL_COMPILE_AND_EXECUTE           type Glenum value('1301'xu);

 /* ListNameType */
 /*  GL_BYTE                        */
 /*  GL_UNSIGNED_BYTE               */
 /*  GL_SHORT                       */
 /*  GL_UNSIGNED_SHORT              */
 /*  GL_INT                         */
 /*  GL_UNSIGNED_INT                */
 /*  GL_FLOAT                       */
 /*  GL_2_BYTES                     */
 /*  GL_3_BYTES                     */
 /*  GL_4_BYTES                     */

 /* LogicOp */
 dcl GL_CLEAR                         type Glenum value('1500'xu);
 dcl GL_AND                           type Glenum value('1501'xu);
 dcl GL_AND_REVERSE                   type Glenum value('1502'xu);
 dcl GL_COPY                          type Glenum value('1503'xu);
 dcl GL_AND_INVERTED                  type Glenum value('1504'xu);
 dcl GL_NOOP                          type Glenum value('1505'xu);
 dcl GL_XOR                           type Glenum value('1506'xu);
 dcl GL_OR                            type Glenum value('1507'xu);
 dcl GL_NOR                           type Glenum value('1508'xu);
 dcl GL_EQUIV                         type Glenum value('1509'xu);
 dcl GL_INVERT                        type Glenum value('150A'xu);
 dcl GL_OR_REVERSE                    type Glenum value('150B'xu);
 dcl GL_COPY_INVERTED                 type Glenum value('150C'xu);
 dcl GL_OR_INVERTED                   type Glenum value('150D'xu);
 dcl GL_NAND                          type Glenum value('150E'xu);
 dcl GL_SET                           type Glenum value('150F'xu);

 /* MapTarget */
 /*  GL_MAP1_COLOR_4                */
 /*  GL_MAP1_INDEX                  */
 /*  GL_MAP1_NORMAL                 */
 /*  GL_MAP1_TEXTURE_COORD_1        */
 /*  GL_MAP1_TEXTURE_COORD_2        */
 /*  GL_MAP1_TEXTURE_COORD_3        */
 /*  GL_MAP1_TEXTURE_COORD_4        */
 /*  GL_MAP1_VERTEX_3               */
 /*  GL_MAP1_VERTEX_4               */
 /*  GL_MAP2_COLOR_4                */
 /*  GL_MAP2_INDEX                  */
 /*  GL_MAP2_NORMAL                 */
 /*  GL_MAP2_TEXTURE_COORD_1        */
 /*  GL_MAP2_TEXTURE_COORD_2        */
 /*  GL_MAP2_TEXTURE_COORD_3        */
 /*  GL_MAP2_TEXTURE_COORD_4        */
 /*  GL_MAP2_VERTEX_3               */
 /*  GL_MAP2_VERTEX_4               */

 /* MaterialFace */
 /*  GL_FRONT                       */
 /*  GL_BACK                        */
 /*  GL_FRONT_AND_BACK              */

 /* MaterialParameter */
 dcl GL_EMISSION                      type Glenum value('1600'xu);
 dcl GL_SHININESS                     type Glenum value('1601'xu);
 dcl GL_AMBIENT_AND_DIFFUSE           type Glenum value('1602'xu);
 dcl GL_COLOR_INDEXES                 type Glenum value('1603'xu);
 /*  GL_AMBIENT                     */
 /*  GL_DIFFUSE                     */
 /*  GL_SPECULAR                    */

 /* MatrixMode */
 dcl GL_MODELVIEW                     type Glenum value('1700'xu);
 dcl GL_PROJECTION                    type Glenum value('1701'xu);
 dcl GL_TEXTURE                       type Glenum value('1702'xu);

 /* MeshMode1 */
 /*  GL_POINT                       */
 /*  GL_LINE                        */

 /* MeshMode2 */
 /*  GL_POINT                       */
 /*  GL_LINE                        */
 /*  GL_FILL                        */

 /* NormalPointerType */
 /*  GL_BYTE                        */
 /*  GL_SHORT                       */
 /*  GL_INT                         */
 /*  GL_FLOAT                       */
 /*  GL_DOUBLE                      */

 /* PixelCopyType */
 dcl GL_COLOR                         type Glenum value('1800'xu);
 dcl GL_DEPTH                         type Glenum value('1801'xu);
 dcl GL_STENCIL                       type Glenum value('1802'xu);

 /* PixelFormat */
 dcl GL_COLOR_INDEX                   type Glenum value('1900'xu);
 dcl GL_STENCIL_INDEX                 type Glenum value('1901'xu);
 dcl GL_DEPTH_COMPONENT               type Glenum value('1902'xu);
 dcl GL_RED                           type Glenum value('1903'xu);
 dcl GL_GREEN                         type Glenum value('1904'xu);
 dcl GL_BLUE                          type Glenum value('1905'xu);
 dcl GL_ALPHA                         type Glenum value('1906'xu);
 dcl GL_RGB                           type Glenum value('1907'xu);
 dcl GL_RGBA                          type Glenum value('1908'xu);
 dcl GL_LUMINANCE                     type Glenum value('1909'xu);
 dcl GL_LUMINANCE_ALPHA               type Glenum value('190A'xu);

 /* PixelMap */
 /*  GL_PIXEL_MAP_I_TO_I            */
 /*  GL_PIXEL_MAP_S_TO_S            */
 /*  GL_PIXEL_MAP_I_TO_R            */
 /*  GL_PIXEL_MAP_I_TO_G            */
 /*  GL_PIXEL_MAP_I_TO_B            */
 /*  GL_PIXEL_MAP_I_TO_A            */
 /*  GL_PIXEL_MAP_R_TO_R            */
 /*  GL_PIXEL_MAP_G_TO_G            */
 /*  GL_PIXEL_MAP_B_TO_B            */
 /*  GL_PIXEL_MAP_A_TO_A            */

 /* PixelStore */
 /*  GL_UNPACK_SWAP_BYTES           */
 /*  GL_UNPACK_LSB_FIRST            */
 /*  GL_UNPACK_ROW_LENGTH           */
 /*  GL_UNPACK_SKIP_ROWS            */
 /*  GL_UNPACK_SKIP_PIXELS          */
 /*  GL_UNPACK_ALIGNMENT            */
 /*  GL_PACK_SWAP_BYTES             */
 /*  GL_PACK_LSB_FIRST              */
 /*  GL_PACK_ROW_LENGTH             */
 /*  GL_PACK_SKIP_ROWS              */
 /*  GL_PACK_SKIP_PIXELS            */
 /*  GL_PACK_ALIGNMENT              */

 /* PixelTransfer */
 /*  GL_MAP_COLOR                   */
 /*  GL_MAP_STENCIL                 */
 /*  GL_INDEX_SHIFT                 */
 /*  GL_INDEX_OFFSET                */
 /*  GL_RED_SCALE                   */
 /*  GL_RED_BIAS                    */
 /*  GL_GREEN_SCALE                 */
 /*  GL_GREEN_BIAS                  */
 /*  GL_BLUE_SCALE                  */
 /*  GL_BLUE_BIAS                   */
 /*  GL_ALPHA_SCALE                 */
 /*  GL_ALPHA_BIAS                  */
 /*  GL_DEPTH_SCALE                 */
 /*  GL_DEPTH_BIAS                  */

 /* PixelType */
 dcl GL_BITMAP                        type Glenum value('1A00'xu);
 /*  GL_BYTE                        */
 /*  GL_UNSIGNED_BYTE               */
 /*  GL_SHORT                       */
 /*  GL_UNSIGNED_SHORT              */
 /*  GL_INT                         */
 /*  GL_UNSIGNED_INT                */
 /*  GL_FLOAT                       */

 /* PolygonMode */
 dcl GL_POINT                         type Glenum value('1B00'xu);
 dcl GL_LINE                          type Glenum value('1B01'xu);
 dcl GL_FILL                          type Glenum value('1B02'xu);

 /* ReadBufferMode */
 /*  GL_FRONT_LEFT                  */
 /*  GL_FRONT_RIGHT                 */
 /*  GL_BACK_LEFT                   */
 /*  GL_BACK_RIGHT                  */
 /*  GL_FRONT                       */
 /*  GL_BACK                        */
 /*  GL_LEFT                        */
 /*  GL_RIGHT                       */
 /*  GL_AUX0                        */
 /*  GL_AUX1                        */
 /*  GL_AUX2                        */
 /*  GL_AUX3                        */

 /* RenderingMode */
 dcl GL_RENDER                        type Glenum value('1C00'xu);
 dcl GL_FEEDBACK                      type Glenum value('1C01'xu);
 dcl GL_SELECT                        type Glenum value('1C02'xu);

 /* ShadingModel */
 dcl GL_FLAT                          type Glenum value('1D00'xu);
 dcl GL_SMOOTH                        type Glenum value('1D01'xu);


 /* StencilFunction */
 /*  GL_NEVER                       */
 /*  GL_LESS                        */
 /*  GL_EQUAL                       */
 /*  GL_LEQUAL                      */
 /*  GL_GREATER                     */
 /*  GL_NOTEQUAL                    */
 /*  GL_GEQUAL                      */
 /*  GL_ALWAYS                      */

 /* StencilOp */
 /*  GL_ZERO                        */
 dcl GL_KEEP                          type Glenum value('1E00'xu);
 dcl GL_REPLACE                       type Glenum value('1E01'xu);
 dcl GL_INCR                          type Glenum value('1E02'xu);
 dcl GL_DECR                          type Glenum value('1E03'xu);
 /*  GL_INVERT                      */

 /* StringName */
 dcl GL_VENDOR                        type Glenum value('1F00'xu);
 dcl GL_RENDERER                      type Glenum value('1F01'xu);
 dcl GL_VERSION                       type Glenum value('1F02'xu);
 dcl GL_EXTENSIONS                    type Glenum value('1F03'xu);

 /* TextureCoordName */
 dcl GL_S                             type Glenum value('2000'xu);
 dcl GL_T                             type Glenum value('2001'xu);
 dcl GL_R                             type Glenum value('2002'xu);
 dcl GL_Q                             type Glenum value('2003'xu);

 /* TexCoordPointerType */
 /*  GL_SHORT                       */
 /*  GL_INT                         */
 /*  GL_FLOAT                       */
 /*  GL_DOUBLE                      */

 /* TextureEnvMode */
 dcl GL_MODULATE                      type Glenum value('2100'xu);
 dcl GL_DECAL                         type Glenum value('2101'xu);
 /*  GL_BLEND                       */
 /*  GL_REPLACE                     */

 /* TextureEnvParameter */
 dcl GL_TEXTURE_ENV_MODE              type Glenum value('2200'xu);
 dcl GL_TEXTURE_ENV_COLOR             type Glenum value('2201'xu);

 /* TextureEnvTarget */
 dcl GL_TEXTURE_ENV                   type Glenum value('2300'xu);

 /* TextureGenMode */
 dcl GL_EYE_LINEAR                    type Glenum value('2400'xu);
 dcl GL_OBJECT_LINEAR                 type Glenum value('2401'xu);
 dcl GL_SPHERE_MAP                    type Glenum value('2402'xu);

 /* TextureGenParameter */
 dcl GL_TEXTURE_GEN_MODE              type Glenum value('2500'xu);
 dcl GL_OBJECT_PLANE                  type Glenum value('2501'xu);
 dcl GL_EYE_PLANE                     type Glenum value('2502'xu);

 /* TextureMagFilter */
 dcl GL_NEAREST                       type Glenum value('2600'xu);
 dcl GL_LINEAR                        type Glenum value('2601'xu);

 /* TextureMinFilter */
 /*  GL_NEAREST */
 /*  GL_LINEAR */
 dcl GL_NEAREST_MIPMAP_NEAREST        type Glenum value('2700'xu);
 dcl GL_LINEAR_MIPMAP_NEAREST         type Glenum value('2701'xu);
 dcl GL_NEAREST_MIPMAP_LINEAR         type Glenum value('2702'xu);
 dcl GL_LINEAR_MIPMAP_LINEAR          type Glenum value('2703'xu);

 /* TextureParameterName */
 dcl GL_TEXTURE_MAG_FILTER            type Glenum value('2800'xu);
 dcl GL_TEXTURE_MIN_FILTER            type Glenum value('2801'xu);
 dcl GL_TEXTURE_WRAP_S                type Glenum value('2802'xu);
 dcl GL_TEXTURE_WRAP_T                type Glenum value('2803'xu);
 /*  GL_TEXTURE_BORDER_COLOR        */
 /*  GL_TEXTURE_PRIORITY            */

 /* TextureTarget */
 /*  GL_TEXTURE_1D                  */
 /*  GL_TEXTURE_2D                  */
 /*  GL_PROXY_TEXTURE_1D            */
 /*  GL_PROXY_TEXTURE_2D            */

 /* TextureWrapMode */
 dcl GL_CLAMP                         type Glenum value('2900'xu);
 dcl GL_REPEAT                        type Glenum value('2901'xu);

 /* VertexPointerType */
 /*  GL_SHORT                       */
 /*  GL_INT                         */
 /*  GL_FLOAT                       */
 /*  GL_DOUBLE                      */

 /* ClientAttribMask */
 dcl GL_CLIENT_PIXEL_STORE_BIT      type GLbitfield value('00000001'xu);
 dcl GL_CLIENT_VERTEX_ARRAY_BIT     type GLbitfield value('00000002'xu);
 dcl GL_CLIENT_ALL_ATTRIB_BITS      type GLbitfield value('ffffffff'xu);

 /* polygon_offset */
 dcl GL_POLYGON_OFFSET_FACTOR         type Glenum value('8038'xu);
 dcl GL_POLYGON_OFFSET_UNITS          type Glenum value('2A00'xu);
 dcl GL_POLYGON_OFFSET_POINT          type Glenum value('2A01'xu);
 dcl GL_POLYGON_OFFSET_LINE           type Glenum value('2A02'xu);
 dcl GL_POLYGON_OFFSET_FILL           type Glenum value('8037'xu);

 /* texture */
 dcl GL_ALPHA4                        type Glenum value('803B'xu);
 dcl GL_ALPHA8                        type Glenum value('803C'xu);
 dcl GL_ALPHA12                       type Glenum value('803D'xu);
 dcl GL_ALPHA16                       type Glenum value('803E'xu);
 dcl GL_LUMINANCE4                    type Glenum value('803F'xu);
 dcl GL_LUMINANCE8                    type Glenum value('8040'xu);
 dcl GL_LUMINANCE12                   type Glenum value('8041'xu);
 dcl GL_LUMINANCE16                   type Glenum value('8042'xu);
 dcl GL_LUMINANCE4_ALPHA4             type Glenum value('8043'xu);
 dcl GL_LUMINANCE6_ALPHA2             type Glenum value('8044'xu);
 dcl GL_LUMINANCE8_ALPHA8             type Glenum value('8045'xu);
 dcl GL_LUMINANCE12_ALPHA4            type Glenum value('8046'xu);
 dcl GL_LUMINANCE12_ALPHA12           type Glenum value('8047'xu);
 dcl GL_LUMINANCE16_ALPHA16           type Glenum value('8048'xu);
 dcl GL_INTENSITY                     type Glenum value('8049'xu);
 dcl GL_INTENSITY4                    type Glenum value('804A'xu);
 dcl GL_INTENSITY8                    type Glenum value('804B'xu);
 dcl GL_INTENSITY12                   type Glenum value('804C'xu);
 dcl GL_INTENSITY16                   type Glenum value('804D'xu);
 dcl GL_R3_G3_B2                      type Glenum value('2A10'xu);
 dcl GL_RGB4                          type Glenum value('804F'xu);
 dcl GL_RGB5                          type Glenum value('8050'xu);
 dcl GL_RGB8                          type Glenum value('8051'xu);
 dcl GL_RGB10                         type Glenum value('8052'xu);
 dcl GL_RGB12                         type Glenum value('8053'xu);
 dcl GL_RGB16                         type Glenum value('8054'xu);
 dcl GL_RGBA2                         type Glenum value('8055'xu);
 dcl GL_RGBA4                         type Glenum value('8056'xu);
 dcl GL_RGB5_A1                       type Glenum value('8057'xu);
 dcl GL_RGBA8                         type Glenum value('8058'xu);
 dcl GL_RGB10_A2                      type Glenum value('8059'xu);
 dcl GL_RGBA12                        type Glenum value('805A'xu);
 dcl GL_RGBA16                        type Glenum value('805B'xu);
 dcl GL_TEXTURE_RED_SIZE              type Glenum value('805C'xu);
 dcl GL_TEXTURE_GREEN_SIZE            type Glenum value('805D'xu);
 dcl GL_TEXTURE_BLUE_SIZE             type Glenum value('805E'xu);
 dcl GL_TEXTURE_ALPHA_SIZE            type Glenum value('805F'xu);
 dcl GL_TEXTURE_LUMINANCE_SIZE        type Glenum value('8060'xu);
 dcl GL_TEXTURE_INTENSITY_SIZE        type Glenum value('8061'xu);
 dcl GL_PROXY_TEXTURE_1D              type Glenum value('8063'xu);
 dcl GL_PROXY_TEXTURE_2D              type Glenum value('8064'xu);

 /* texture_object */
 dcl GL_TEXTURE_PRIORITY              type Glenum value('8066'xu);
 dcl GL_TEXTURE_RESIDENT              type Glenum value('8067'xu);
 dcl GL_TEXTURE_BINDING_1D            type Glenum value('8068'xu);
 dcl GL_TEXTURE_BINDING_2D            type Glenum value('8069'xu);

 /* vertex_array */
 dcl GL_VERTEX_ARRAY                  type Glenum value('8074'xu);
 dcl GL_NORMAL_ARRAY                  type Glenum value('8075'xu);
 dcl GL_COLOR_ARRAY                   type Glenum value('8076'xu);
 dcl GL_INDEX_ARRAY                   type Glenum value('8077'xu);
 dcl GL_TEXTURE_COORD_ARRAY           type Glenum value('8078'xu);
 dcl GL_EDGE_FLAG_ARRAY               type Glenum value('8079'xu);
 dcl GL_VERTEX_ARRAY_SIZE             type Glenum value('807A'xu);
 dcl GL_VERTEX_ARRAY_TYPE             type Glenum value('807B'xu);
 dcl GL_VERTEX_ARRAY_STRIDE           type Glenum value('807C'xu);
 dcl GL_NORMAL_ARRAY_TYPE             type Glenum value('807E'xu);
 dcl GL_NORMAL_ARRAY_STRIDE           type Glenum value('807F'xu);
 dcl GL_COLOR_ARRAY_SIZE              type Glenum value('8081'xu);
 dcl GL_COLOR_ARRAY_TYPE              type Glenum value('8082'xu);
 dcl GL_COLOR_ARRAY_STRIDE            type Glenum value('8083'xu);
 dcl GL_INDEX_ARRAY_TYPE              type Glenum value('8085'xu);
 dcl GL_INDEX_ARRAY_STRIDE            type Glenum value('8086'xu);
 dcl GL_TEXTURE_COORD_ARRAY_SIZE      type Glenum value('8088'xu);
 dcl GL_TEXTURE_COORD_ARRAY_TYPE      type Glenum value('8089'xu);
 dcl GL_TEXTURE_COORD_ARRAY_STRIDE    type Glenum value('808A'xu);
 dcl GL_EDGE_FLAG_ARRAY_STRIDE        type Glenum value('808C'xu);
 dcl GL_VERTEX_ARRAY_POINTER          type Glenum value('808E'xu);
 dcl GL_NORMAL_ARRAY_POINTER          type Glenum value('808F'xu);
 dcl GL_COLOR_ARRAY_POINTER           type Glenum value('8090'xu);
 dcl GL_INDEX_ARRAY_POINTER           type Glenum value('8091'xu);
 dcl GL_TEXTURE_COORD_ARRAY_POINTER   type Glenum value('8092'xu);
 dcl GL_EDGE_FLAG_ARRAY_POINTER       type Glenum value('8093'xu);
 dcl GL_V2F                           type Glenum value('2A20'xu);
 dcl GL_V3F                           type Glenum value('2A21'xu);
 dcl GL_C4UB_V2F                      type Glenum value('2A22'xu);
 dcl GL_C4UB_V3F                      type Glenum value('2A23'xu);
 dcl GL_C3F_V3F                       type Glenum value('2A24'xu);
 dcl GL_N3F_V3F                       type Glenum value('2A25'xu);
 dcl GL_C4F_N3F_V3F                   type Glenum value('2A26'xu);
 dcl GL_T2F_V3F                       type Glenum value('2A27'xu);
 dcl GL_T4F_V4F                       type Glenum value('2A28'xu);
 dcl GL_T2F_C4UB_V3F                  type Glenum value('2A29'xu);
 dcl GL_T2F_C3F_V3F                   type Glenum value('2A2A'xu);
 dcl GL_T2F_N3F_V3F                   type Glenum value('2A2B'xu);
 dcl GL_T2F_C4F_N3F_V3F               type Glenum value('2A2C'xu);
 dcl GL_T4F_C4F_N3F_V4F               type Glenum value('2A2D'xu);

 /* Extensions */
 dcl GL_EXT_vertex_array                fixed bin(31) value(1);
 dcl GL_EXT_bgra                        fixed bin(31) value(1);
 dcl GL_EXT_paletted_texture            fixed bin(31) value(1);
 dcl GL_WIN_swap_hint                   fixed bin(31) value(1);
 dcl GL_WIN_draw_range_elements         fixed bin(31) value(1);
 /*  GL_WIN_phong_shading               fixed bin(31) value(1) */
 /*  GL_WIN_specular_fog                fixed bin(31) value(1) */

 /* EXT_vertex_array */
 dcl GL_VERTEX_ARRAY_EXT                type Glenum value('8074'xu);
 dcl GL_NORMAL_ARRAY_EXT                type Glenum value('8075'xu);
 dcl GL_COLOR_ARRAY_EXT                 type Glenum value('8076'xu);
 dcl GL_INDEX_ARRAY_EXT                 type Glenum value('8077'xu);
 dcl GL_TEXTURE_COORD_ARRAY_EXT         type Glenum value('8078'xu);
 dcl GL_EDGE_FLAG_ARRAY_EXT             type Glenum value('8079'xu);
 dcl GL_VERTEX_ARRAY_SIZE_EXT           type Glenum value('807A'xu);
 dcl GL_VERTEX_ARRAY_TYPE_EXT           type Glenum value('807B'xu);
 dcl GL_VERTEX_ARRAY_STRIDE_EXT         type Glenum value('807C'xu);
 dcl GL_VERTEX_ARRAY_COUNT_EXT          type Glenum value('807D'xu);
 dcl GL_NORMAL_ARRAY_TYPE_EXT           type Glenum value('807E'xu);
 dcl GL_NORMAL_ARRAY_STRIDE_EXT         type Glenum value('807F'xu);
 dcl GL_NORMAL_ARRAY_COUNT_EXT          type Glenum value('8080'xu);
 dcl GL_COLOR_ARRAY_SIZE_EXT            type Glenum value('8081'xu);
 dcl GL_COLOR_ARRAY_TYPE_EXT            type Glenum value('8082'xu);
 dcl GL_COLOR_ARRAY_STRIDE_EXT          type Glenum value('8083'xu);
 dcl GL_COLOR_ARRAY_COUNT_EXT           type Glenum value('8084'xu);
 dcl GL_INDEX_ARRAY_TYPE_EXT            type Glenum value('8085'xu);
 dcl GL_INDEX_ARRAY_STRIDE_EXT          type Glenum value('8086'xu);
 dcl GL_INDEX_ARRAY_COUNT_EXT           type Glenum value('8087'xu);
 dcl GL_TEXTURE_COORD_ARRAY_SIZE_EXT    type Glenum value('8088'xu);
 dcl GL_TEXTURE_COORD_ARRAY_TYPE_EXT    type Glenum value('8089'xu);
 dcl GL_TEXTURE_COORD_ARRAY_STRIDE_EXT  type Glenum value('808A'xu);
 dcl GL_TEXTURE_COORD_ARRAY_COUNT_EXT   type Glenum value('808B'xu
 );
 dcl GL_EDGE_FLAG_ARRAY_STRIDE_EXT      type Glenum value('808C'xu);
 dcl GL_EDGE_FLAG_ARRAY_COUNT_EXT       type Glenum value('808D'xu);
 dcl GL_VERTEX_ARRAY_POINTER_EXT        type Glenum value('808E'xu);
 dcl GL_NORMAL_ARRAY_POINTER_EXT        type Glenum value('808F'xu);
 dcl GL_COLOR_ARRAY_POINTER_EXT         type Glenum value('8090'xu);
 dcl GL_INDEX_ARRAY_POINTER_EXT         type Glenum value('8091'xu);
 dcl GL_TEXTURE_COORD_ARRAY_POINTER_EXT type Glenum value('8092'xu);
 dcl GL_EDGE_FLAG_ARRAY_POINTER_EXT     type Glenum value('8093'xu);
 dcl GL_DOUBLE_EXT                      type Glenum value(GL_DOUBLE);


 /* EXT_bgra */
 dcl GL_BGR_EXT                         type Glenum value('80E0'xu);
 dcl GL_BGRA_EXT                        type Glenum value('80E1'xu);

 /* EXT_paletted_texture */

 /* These must match the GL_COLOR_TABLE_*_SGI enumerants */
 dcl GL_COLOR_TABLE_FORMAT_EXT          type Glenum value('80D8'xu);
 dcl GL_COLOR_TABLE_WIDTH_EXT           type Glenum value('80D9'xu);
 dcl GL_COLOR_TABLE_RED_SIZE_EXT        type Glenum value('80DA'xu);
 dcl GL_COLOR_TABLE_GREEN_SIZE_EXT      type Glenum value('80DB'xu);
 dcl GL_COLOR_TABLE_BLUE_SIZE_EXT       type Glenum value('80DC'xu);
 dcl GL_COLOR_TABLE_ALPHA_SIZE_EXT      type Glenum value('80DD'xu);
 dcl GL_COLOR_TABLE_LUMINANCE_SIZE_EXT  type Glenum value('80DE'xu);
 dcl GL_COLOR_TABLE_INTENSITY_SIZE_EXT  type Glenum value('80DF'xu);

 dcl GL_COLOR_INDEX1_EXT                type Glenum value('80E2'xu);
 dcl GL_COLOR_INDEX2_EXT                type Glenum value('80E3'xu);
 dcl GL_COLOR_INDEX4_EXT                type Glenum value('80E4'xu);
 dcl GL_COLOR_INDEX8_EXT                type Glenum value('80E5'xu);
 dcl GL_COLOR_INDEX12_EXT               type Glenum value('80E6'xu);
 dcl GL_COLOR_INDEX16_EXT               type Glenum value('80E7'xu);

 /* WIN_draw_range_elements */
 dcl GL_MAX_ELEMENTS_VERTICES_WIN       type Glenum value('80E8'xu);
 dcl GL_MAX_ELEMENTS_INDICES_WIN        type Glenum value('80E9'xu);

 /* WIN_phong_shading */
 dcl GL_PHONG_WIN                       type Glenum value('80EA'xu);
 dcl GL_PHONG_HINT_WIN                  type Glenum value('80EB'xu);

 /* WIN_specular_fog */
 dcl GL_FOG_SPECULAR_TEXTURE_WIN        type Glenum value('80EC'xu);

 /* For compatibility with OpenGL v1.0 */
 dcl GL_LOGIC_OP                      type Glenum
                                      value(GL_INDEX_LOGIC_OP);
 dcl GL_TEXTURE_COMPONENTS            type Glenum
                                      value(GL_TEXTURE_INTERNAL_FORMAT);


 /*********************************************************************/

 dcl glAccum
     entry (type GLenum,
            type GLfloat)
     OPENGLENTRY external('glAccum');

 dcl glAlphaFunc
     entry (type GLenum,
            type GLclampf)
     OPENGLENTRY external('glAlphaFunc');

 dcl glAreTexturesResident
     entry (type GLsizei,
            (*) type GLuint byaddr nonasgn,
            (*) type GLboolean byaddr)
     returns (type GLboolean byvalue optional)
     OPENGLENTRY external('glAreTexturesResident');

 dcl glArrayElement
     entry (type GLint )
     OPENGLENTRY external('glArrayElement');

 dcl glBegin
     entry (type GLenum )
     OPENGLENTRY external('glBegin');

 dcl glBindTexture
     entry (type GLenum,
            type GLuint)
     OPENGLENTRY external('glBindTexture');

 dcl glBitmap
     entry (type GLsizei,
            type GLsizei,
            type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLubyte byaddr nonasgn)
     OPENGLENTRY external('glBitmap');

 dcl glBlendFunc
     entry (type GLenum,
            type GLenum)
     OPENGLENTRY external('glBlendFunc');

 dcl glCallList
     entry (type GLuint )
     OPENGLENTRY external('glCallList');

 dcl glCallLists
     entry (type GLsizei,
            type GLenum,
            pointer)
     OPENGLENTRY external('glCallLists');

 dcl glClear
     entry (type GLbitfield )
     OPENGLENTRY external('glClear');

 dcl glClearAccum
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glClearAccum');

 dcl glClearColor
     entry (type GLclampf,
            type GLclampf,
            type GLclampf,
            type GLclampf)
     OPENGLENTRY external('glClearColor');

 dcl glClearDepth
     entry (type GLclampd)
     OPENGLENTRY external('glClearDepth');

 dcl glClearIndex
     entry (type GLfloat )
     OPENGLENTRY external('glClearIndex');

 dcl glClearStencil
     entry (type GLint )
     OPENGLENTRY external('glClearStencil');

 dcl glClipPlane
     entry (type GLenum,
            (4) type GLdouble byaddr)
     OPENGLENTRY external('glClipPlane');

 dcl glColor3b
     entry (type GLbyte,
            type GLbyte,
            type GLbyte)
     OPENGLENTRY external('glColor3b');

 dcl glColor3bv
     entry ((3) type GLbyte byaddr nonasgn)
     OPENGLENTRY external('glColor3bv');

 dcl glColor3d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glColor3d');

 dcl glColor3dv
     entry ((3) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glColor3dv');

 dcl glColor3f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glColor3f');

 dcl glColor3fv
     entry ((3) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glColor3fv');

 dcl glColor3i
     entry (type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glColor3i');

 dcl glColor3iv
     entry ((3) type GLint byaddr nonasgn)
     OPENGLENTRY external('glColor3iv');

 dcl glColor3s
     entry (type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glColor3s');

 dcl glColor3sv
     entry ((3) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glColor3sv');

 dcl glColor3ub
     entry (type GLubyte,
            type GLubyte,
            type GLubyte)
     OPENGLENTRY external('glColor3ub');

 dcl glColor3ubv
     entry ((3) type GLubyte byaddr nonasgn)
     OPENGLENTRY external('glColor3ubv');

 dcl glColor3ui
     entry (type GLuint,
            type GLuint,
            type GLuint)
     OPENGLENTRY external('glColor3ui');

 dcl glColor3uiv
     entry ((3) type GLuint byaddr nonasgn)
     OPENGLENTRY external('glColor3uiv');

 dcl glColor3us
     entry (type GLushort,
            type GLushort,
            type GLushort)
     OPENGLENTRY external('glColor3us');

 dcl glColor3usv
     entry ((3) type GLushort byaddr nonasgn)
     OPENGLENTRY external('glColor3usv');

 dcl glColor4b
     entry (type GLbyte,
            type GLbyte,
            type GLbyte,
            type GLbyte)
     OPENGLENTRY external('glColor4b');

 dcl glColor4bv
     entry ((4) type GLbyte byaddr nonasgn)
     OPENGLENTRY external('glColor4bv');

 dcl glColor4d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glColor4d');

 dcl glColor4dv
     entry ((4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glColor4dv');

 dcl glColor4f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glColor4f');

 dcl glColor4fv
     entry ((4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glColor4fv');

 dcl glColor4i
     entry (type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glColor4i');

 dcl glColor4iv
     entry ((4) type GLint byaddr nonasgn)
     OPENGLENTRY external('glColor4iv');

 dcl glColor4s
     entry (type GLshort,
            type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glColor4s');

 dcl glColor4sv
     entry ((4) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glColor4sv');

 dcl glColor4ub
     entry (type GLubyte,
            type GLubyte,
            type GLubyte,
            type GLubyte)
     OPENGLENTRY external('glColor4ub');

 dcl glColor4ubv
     entry ((4) type GLubyte byaddr nonasgn)
     OPENGLENTRY external('glColor4ubv');

 dcl glColor4ui
     entry (type GLuint,
            type GLuint,
            type GLuint,
            type GLuint)
     OPENGLENTRY external('glColor4ui');

 dcl glColor4uiv
     entry ((4) type GLuint byaddr )
     OPENGLENTRY external('glColor4uiv');

 dcl glColor4us
     entry (type GLushort,
            type GLushort,
            type GLushort,
            type GLushort)
     OPENGLENTRY external('glColor4us');

 dcl glColor4usv
     entry ((4) type GLushort byaddr nonasgn)
     OPENGLENTRY external('glColor4usv');

 dcl glColorMask
     entry (type GLboolean,
            type GLboolean,
            type GLboolean,
            type GLboolean)
     OPENGLENTRY external('glColorMask');

 dcl glColorMaterial
     entry (type GLenum,
            type GLenum)
     OPENGLENTRY external('glColorMaterial');

 dcl glColorPointer
     entry (type GLint,
            type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glColorPointer');

 dcl glCopyPixels
     entry (type GLint,
            type GLint,
            type GLsizei,
            type GLsizei,
            type GLenum)
     OPENGLENTRY external('glCopyPixels');

 dcl glCopyTexImage1D
     entry (type GLenum,
            type GLint,
            type GLenum,
            type GLint,
            type GLint,
            type GLsizei,
            type GLint)
     OPENGLENTRY external('glCopyTexImage1D');

 dcl glCopyTexImage2D
     entry (type GLenum,
            type GLint,
            type GLenum,
            type GLint,
            type GLint,
            type GLsizei,
            type GLsizei,
            type GLint)
     OPENGLENTRY external('glCopyTexImage2D');

 dcl glCopyTexSubImage1D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLint,
            type GLint,
            type GLsizei)
     OPENGLENTRY external('glCopyTexSubImage1D');

 dcl glCopyTexSubImage2D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLint,
            type GLint,
            type GLint,
            type GLsizei,
            type GLsizei)
     OPENGLENTRY external('glCopyTexSubImage2D');

 dcl glCullFace
     entry (type GLenum)
     OPENGLENTRY external('glCullFace');

 dcl glDeleteLists
     entry (type GLuint,
            type GLsizei)
     OPENGLENTRY external('glDeleteLists');

 dcl glDeleteTextures
     entry (type GLsizei,
            (*) type GLuint byaddr nonasgn)
     OPENGLENTRY external('glDeleteTextures');

 dcl glDepthFunc
     entry (type GLenum)
     OPENGLENTRY external('glDepthFunc');

 dcl glDepthMask
     entry (type GLboolean)
     OPENGLENTRY external('glDepthMask');

 dcl glDepthRange
     entry (type GLclampd,
            type GLclampd)
     OPENGLENTRY external('glDepthRange');

 dcl glDisable
     entry (type GLenum)
     OPENGLENTRY external('glDisable');

 dcl glDisableClientState
     entry (type GLenum )
     OPENGLENTRY external('glDisableClientState');

 dcl glDrawArrays
     entry (type GLenum,
            type GLint,
            type GLsizei)
     OPENGLENTRY external('glDrawArrays');

 dcl glDrawBuffer
     entry (type GLenum)
     OPENGLENTRY external('glDrawBuffer');

 dcl glDrawElements
     entry (type GLenum,
            type GLsizei,
            type GLenum,
            pointer)
     OPENGLENTRY external('glDrawElements');

 dcl glDrawPixels
     entry (type GLsizei,
            type GLsizei,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glDrawPixels');

 dcl glEdgeFlag
     entry (type GLboolean)
     OPENGLENTRY external('glEdgeFlag');

 dcl glEdgeFlagPointer
     entry (type GLsizei,
            pointer)
     OPENGLENTRY external('glEdgeFlagPointer');

 dcl glEdgeFlagv
     entry ((1) type GLboolean byaddr nonasgn)
     OPENGLENTRY external('glEdgeFlagv');

 dcl glEnable
     entry (type GLenum )
     OPENGLENTRY external('glEnable');

 dcl glEnableClientState
     entry (type GLenum )
     OPENGLENTRY external('glEnableClientState');

 dcl glEnd
     entry ()
     OPENGLENTRY external('glEnd');

 dcl glEndList
     entry ()
     OPENGLENTRY external('glEndList');

 dcl glEvalCoord1d
     entry (type GLdouble )
     OPENGLENTRY external('glEvalCoord1d');

 dcl glEvalCoord1dv
     entry ((1) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glEvalCoord1dv');

 dcl glEvalCoord1f
     entry (type GLfloat )
     OPENGLENTRY external('glEvalCoord1f');

 dcl glEvalCoord1fv
     entry ((1) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glEvalCoord1fv');

 dcl glEvalCoord2d
     entry (type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glEvalCoord2d');

 dcl glEvalCoord2dv
     entry ((2) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glEvalCoord2dv');

 dcl glEvalCoord2f
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glEvalCoord2f');

 dcl glEvalCoord2fv
     entry ((2) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glEvalCoord2fv');

 dcl glEvalMesh1
     entry (type GLenum,
            type GLint,
            type GLint)
     OPENGLENTRY external('glEvalMesh1');

 dcl glEvalMesh2
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glEvalMesh2');

 dcl glEvalPoint1
     entry (type GLint)
     OPENGLENTRY external('glEvalPoint1');

 dcl glEvalPoint2
     entry (type GLint,
            type GLint)
     OPENGLENTRY external('glEvalPoint2');

 dcl glFeedbackBuffer
     entry (type GLsizei,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glFeedbackBuffer');

 dcl glFinish
     entry ()
     OPENGLENTRY external('glFinish');

 dcl glFlush
     entry ()
     OPENGLENTRY external('glFlush');

 dcl glFogf
     entry (type GLenum,
            type GLfloat)
     OPENGLENTRY external('glFogf');

 dcl glFogfv
     entry (type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glFogfv');

 dcl glFogi
     entry (type GLenum,
            type GLint)
     OPENGLENTRY external('glFogi');

 dcl glFogiv
     entry (type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glFogiv');

 dcl glFrontFace
     entry (type GLenum )
     OPENGLENTRY external('glFrontFace');

 dcl glFrustum
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glFrustum');

 dcl glGenLists
     entry (type GLsizei)
     returns (type GLuint byvalue optional)
     OPENGLENTRY external('glGenLists');

 dcl glGenTextures
     entry (type GLsizei,
            (*) type GLuint byaddr)
     OPENGLENTRY external('glGenTextures');

 dcl glGetBooleanv
     entry (type GLenum,
            (*) type GLboolean byaddr)
     OPENGLENTRY external('glGetBooleanv');

 dcl glGetClipPlane
     entry (type GLenum,
            (4) type GLdouble byaddr)
     OPENGLENTRY external('glGetClipPlane');

 dcl glGetDoublev
     entry (type GLenum,
            (*) type GLdouble byaddr)
     OPENGLENTRY external('glGetDoublev');

 dcl glGetError
     entry ()
     returns (type GLenum byvalue optional)
     OPENGLENTRY external('glGetError');

 dcl glGetFloatv
     entry (type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetFloatv');

 dcl glGetIntegerv
     entry (type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetIntegerv');

 dcl glGetLightfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetLightfv');

 dcl glGetLightiv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetLightiv');

 dcl glGetMapdv
     entry (type GLenum,
            type GLenum,
            (*) type GLdouble byaddr)
     OPENGLENTRY external('glGetMapdv');

 dcl glGetMapfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetMapfv');

 dcl glGetMapiv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetMapiv');

 dcl glGetMaterialfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetMaterialfv');

 dcl glGetMaterialiv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetMaterialiv');

 dcl glGetPixelMapfv
     entry (type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetPixelMapfv');

 dcl glGetPixelMapuiv
     entry (type GLenum,
            (*) type GLuint byaddr)
     OPENGLENTRY external('glGetPixelMapuiv');

 dcl glGetPixelMapusv
     entry (type GLenum,
            (*) type GLushort byaddr)
     OPENGLENTRY external('glGetPixelMapusv');

 dcl glGetPointerv
     entry (type GLenum,
            pointer byaddr)
     OPENGLENTRY external('glGetPointerv');

 dcl glGetPolygonStipple
     entry ((*) type GLubyte byaddr)
     OPENGLENTRY external('glGetPolygonStipple');

 dcl glGetString
     entry (type GLenum)
     returns (pointer byvalue optional) /* to char(*) varz */
     OPENGLENTRY external('glGetString');

 dcl glGetTexEnvfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetTexEnvfv');

 dcl glGetTexEnviv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetTexEnviv');

 dcl glGetTexGendv
     entry (type GLenum,
            type GLenum,
            (*) type GLdouble byaddr)
     OPENGLENTRY external('glGetTexGendv');

 dcl glGetTexGenfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetTexGenfv');

 dcl glGetTexGeniv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetTexGeniv');

 dcl glGetTexImage
     entry (type GLenum,
            type GLint,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glGetTexImage');

 dcl glGetTexLevelParameterfv
     entry (type GLenum,
            type GLint,
            type GLenum,
            type GLfloat byaddr)
     OPENGLENTRY external('glGetTexLevelParameterfv');

 dcl glGetTexLevelParameteriv
     entry (type GLenum,
            type GLint,
            type GLenum,
            type GLint byaddr)
     OPENGLENTRY external('glGetTexLevelParameteriv');

 dcl glGetTexParameterfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr)
     OPENGLENTRY external('glGetTexParameterfv');

 dcl glGetTexParameteriv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr)
     OPENGLENTRY external('glGetTexParameteriv');

 dcl glHint
     entry (type GLenum,
            type GLenum)
     OPENGLENTRY external('glHint');

 dcl glIndexMask
     entry (type GLuint )
     OPENGLENTRY external('glIndexMask');

 dcl glIndexPointer
     entry (type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glIndexPointer');

 dcl glIndexd
     entry (type GLdouble)
     OPENGLENTRY external('glIndexd');

 dcl glIndexdv
     entry ((1) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glIndexdv');

 dcl glIndexf
     entry (type GLfloat )
     OPENGLENTRY external('glIndexf');

 dcl glIndexfv
     entry ((1) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glIndexfv');

 dcl glIndexi
     entry (type GLint)
     OPENGLENTRY external('glIndexi');

 dcl glIndexiv
     entry ((1) type GLint byaddr nonasgn)
     OPENGLENTRY external('glIndexiv');

 dcl glIndexs
     entry (type GLshort )
     OPENGLENTRY external('glIndexs');

 dcl glIndexsv
     entry ((1) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glIndexsv');

 dcl glIndexub
     entry (type GLubyte)
     OPENGLENTRY external('glIndexub');

 dcl glIndexubv
     entry ((1) type GLubyte byaddr nonasgn)
     OPENGLENTRY external('glIndexubv');

 dcl glInitNames
     entry ()
     OPENGLENTRY external('glInitNames');

 dcl glInterleavedArrays
     entry (type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glInterleavedArrays');

 dcl glIsEnabled
     entry (type GLenum)
     returns (type GLboolean byvalue optional)
     OPENGLENTRY external('glIsEnabled');

 dcl glIsList
     entry (type GLuint)
     returns (type GLboolean byvalue optional)
     OPENGLENTRY external('glIsList');

 dcl glIsTexture
     entry (type GLuint)
     returns (type GLboolean byvalue optional)
     OPENGLENTRY external('glIsTexture');

 dcl glLightModelf
     entry (type GLenum,
            type GLfloat)
     OPENGLENTRY external('glLightModelf');

 dcl glLightModelfv
     entry (type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glLightModelfv');

 dcl glLightModeli
     entry (type GLenum,
            type GLint)
     OPENGLENTRY external('glLightModeli');

 dcl glLightModeliv
     entry (type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glLightModeliv');

 dcl glLightf
     entry (type GLenum,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('glLightf');

 dcl glLightfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glLightfv');

 dcl glLighti
     entry (type GLenum,
            type GLenum,
            type GLint)
     OPENGLENTRY external('glLighti');

 dcl glLightiv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glLightiv');

 dcl glLineStipple
     entry (type GLint,
            type GLushort)
     OPENGLENTRY external('glLineStipple');

 dcl glLineWidth
     entry (type GLfloat)
     OPENGLENTRY external('glLineWidth');

 dcl glListBase
     entry (type GLuint)
     OPENGLENTRY external('glListBase');

 dcl glLoadIdentity
     entry ()
     OPENGLENTRY external('glLoadIdentity');

 dcl glLoadMatrixd
     entry ((4, 4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glLoadMatrixd');

 dcl glLoadMatrixf
     entry ((4, 4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glLoadMatrixf');

 dcl glLoadName
     entry (type GLuint)
     OPENGLENTRY external('glLoadName');

 dcl glLogicOp
     entry (type GLenum)
     OPENGLENTRY external('glLogicOp');

 dcl glMap1d
     entry (type GLenum,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint,
            (*) type GLdouble byaddr nonasgn) /* pass (1,*) if 2d */
     OPENGLENTRY external('glMap1d');

 dcl glMap1f
     entry (type GLenum,
            type GLfloat,
            type GLfloat,
            type GLint,
            type GLint,
            (*) type GLfloat byaddr nonasgn) /* pass (1,*) if 2d */
     OPENGLENTRY external('glMap1f');

 dcl glMap2d
     entry (type GLenum,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint,
            (*) type GLdouble byaddr nonasgn) /* pass (1,*) if 2d */
     OPENGLENTRY external('glMap2d');

 dcl glMap2f
     entry (type GLenum,
            type GLfloat,
            type GLfloat,
            type GLint,
            type GLint,
            type GLfloat,
            type GLfloat,
            type GLint,
            type GLint,
            (*) type GLfloat byaddr nonasgn) /* pass (1,*) if 2d */
     OPENGLENTRY external('glMap2f');

 dcl glMapGrid1d
     entry (type GLint,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glMapGrid1d');

 dcl glMapGrid1f
     entry (type GLint,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glMapGrid1f');

 dcl glMapGrid2d
     entry (type GLint,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glMapGrid2d');

 dcl glMapGrid2f
     entry (type GLint,
            type GLfloat,
            type GLfloat,
            type GLint,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glMapGrid2f');

 dcl glMaterialf
     entry (type GLenum,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('glMaterialf');

 dcl glMaterialfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glMaterialfv');

 dcl glMateriali
     entry (type GLenum,
            type GLenum,
            type GLint)
     OPENGLENTRY external('glMateriali');

 dcl glMaterialiv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glMaterialiv');

 dcl glMatrixMode
     entry (type GLenum)
     OPENGLENTRY external('glMatrixMode');

 dcl glMultMatrixd
     entry ((4,4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glMultMatrixd');


 dcl glMultMatrixf
     entry ((4,4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glMultMatrixf');

 dcl glNewList
     entry (type GLuint,
            type GLenum)
     OPENGLENTRY external('glNewList');

 dcl glNormal3b
     entry (type GLbyte,
            type GLbyte,
            type GLbyte)
     OPENGLENTRY external('glNormal3b');

 dcl glNormal3bv
     entry ((3) type GLbyte byaddr nonasgn)
     OPENGLENTRY external('glNormal3bv');

 dcl glNormal3d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glNormal3d');

 dcl glNormal3dv
     entry ((3) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glNormal3dv');

 dcl glNormal3f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glNormal3f');

 dcl glNormal3fv
     entry ((3) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glNormal3fv');

 dcl glNormal3i
     entry (type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glNormal3i');

 dcl glNormal3iv
     entry ((3) type GLint byaddr nonasgn)
     OPENGLENTRY external('glNormal3iv');

 dcl glNormal3s
     entry (type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glNormal3s');

 dcl glNormal3sv
     entry ((3) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glNormal3sv');

 dcl glNormalPointer
     entry (type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glNormalPointer');

 dcl glOrtho
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glOrtho');

 dcl glPassThrough
     entry (type GLfloat)
     OPENGLENTRY external('glPassThrough');

 dcl glPixelMapfv
     entry (type GLenum,
            type GLsizei,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glPixelMapfv');

 dcl glPixelMapuiv
     entry (type GLenum,
            type GLsizei,
            (*) type GLuint byaddr nonasgn)
     OPENGLENTRY external('glPixelMapuiv');

 dcl glPixelMapusv
     entry (type GLenum,
            type GLsizei,
            (*) type GLushort byaddr nonasgn)
     OPENGLENTRY external('glPixelMapusv');

 dcl glPixelStoref
     entry (type GLenum,
            type GLfloat)
     OPENGLENTRY external('glPixelStoref');

 dcl glPixelStorei
     entry (type GLenum,
            type GLint)
     OPENGLENTRY external('glPixelStorei');

 dcl glPixelTransferf
     entry (type GLenum,
            type GLfloat)
     OPENGLENTRY external('glPixelTransferf');

 dcl glPixelTransferi
     entry (type GLenum,
            type GLint)
     OPENGLENTRY external('glPixelTransferi');

 dcl glPixelZoom
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glPixelZoom');

 dcl glPointSize
     entry (type GLfloat)
     OPENGLENTRY external('glPointSize');

 dcl glPolygonMode
     entry (type GLenum,
            type GLenum)
     OPENGLENTRY external('glPolygonMode');

 dcl glPolygonOffset
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glPolygonOffset');

 dcl glPolygonStipple
     entry ((*) type GLubyte byaddr nonasgn)
     OPENGLENTRY external('glPolygonStipple');

 dcl glPopAttrib
     entry ()
     OPENGLENTRY external('glPopAttrib');

 dcl glPopClientAttrib
     entry ()
     OPENGLENTRY external('glPopClientAttrib');

 dcl glPopMatrix
     entry ()
     OPENGLENTRY external('glPopMatrix');

 dcl glPopName
     entry ()
     OPENGLENTRY external('glPopName');

 dcl glPrioritizeTextures
     entry (type GLsizei,
            (*) type GLuint byaddr nonasgn,
            (*) type GLclampf byaddr nonasgn)
     OPENGLENTRY external('glPrioritizeTextures');

 dcl glPushAttrib
     entry (type GLbitfield)
     OPENGLENTRY external('glPushAttrib');

 dcl glPushClientAttrib
     entry (type GLbitfield)
     OPENGLENTRY external('glPushClientAttrib');

 dcl glPushMatrix
     entry ()
     OPENGLENTRY external('glPushMatrix');

 dcl glPushName
     entry (type GLuint)
     OPENGLENTRY external('glPushName');

 dcl glRasterPos2d
     entry (type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glRasterPos2d');

 dcl glRasterPos2dv
     entry ((2) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glRasterPos2dv');

 dcl glRasterPos2f
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glRasterPos2f');

 dcl glRasterPos2fv
     entry ((2) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glRasterPos2fv');

 dcl glRasterPos2i
     entry (type GLint,
            type GLint)
     OPENGLENTRY external('glRasterPos2i');

 dcl glRasterPos2iv
     entry ((2) type GLint byaddr nonasgn)
     OPENGLENTRY external('glRasterPos2iv');

 dcl glRasterPos2s
     entry (type GLshort,
            type GLshort)
     OPENGLENTRY external('glRasterPos2s');

 dcl glRasterPos2sv
     entry ((2) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glRasterPos2sv');

 dcl glRasterPos3d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glRasterPos3d');

 dcl glRasterPos3dv
     entry ((3) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glRasterPos3dv');

 dcl glRasterPos3f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glRasterPos3f');

 dcl glRasterPos3fv
     entry ((3) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glRasterPos3fv');

 dcl glRasterPos3i
     entry (type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glRasterPos3i');

 dcl glRasterPos3iv
     entry ((3) type GLint byaddr nonasgn)
     OPENGLENTRY external('glRasterPos3iv');

 dcl glRasterPos3s
     entry (type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glRasterPos3s');

 dcl glRasterPos3sv
     entry ((3) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glRasterPos3sv');

 dcl glRasterPos4d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glRasterPos4d');

 dcl glRasterPos4dv
     entry ((4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glRasterPos4dv');

 dcl glRasterPos4f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glRasterPos4f');

 dcl glRasterPos4fv
     entry ((4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glRasterPos4fv');

 dcl glRasterPos4i
     entry (type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glRasterPos4i');

 dcl glRasterPos4iv
     entry ((4) type GLint byaddr nonasgn)
     OPENGLENTRY external('glRasterPos4iv');

 dcl glRasterPos4s
     entry (type GLshort,
            type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glRasterPos4s');

 dcl glRasterPos4sv
     entry ((4) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glRasterPos4sv');

 dcl glReadBuffer
     entry (type GLenum)
     OPENGLENTRY external('glReadBuffer');

 dcl glReadPixels
     entry (type GLint,
            type GLint,
            type GLsizei,
            type GLsizei,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glReadPixels');

 dcl glRectd
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glRectd');

 dcl glRectdv
     entry ((2) type GLdouble byaddr nonasgn,
            (2) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glRectdv');

 dcl glRectf
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glRectf');

 dcl glRectfv
     entry ((2) type GLfloat byaddr nonasgn,
            (2) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glRectfv');

 dcl glRecti
     entry (type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glRecti');

 dcl glRectiv
     entry ((2) type GLint byaddr nonasgn,
            (2) type GLint byaddr nonasgn)
     OPENGLENTRY external('glRectiv');

 dcl glRects
     entry (type GLshort,
            type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glRects');

 dcl glRectsv
     entry ((2) type GLshort byaddr nonasgn,
            (2) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glRectsv');

 dcl glRenderMode
     entry (type GLenum )
     returns (type GLint byvalue optional)
     OPENGLENTRY external('glRenderMode');

 dcl glRotated
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glRotated');

 dcl glRotatef
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glRotatef');

 dcl glScaled
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glScaled');

 dcl glScalef
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glScalef');

 dcl glScissor
     entry (type GLint,
            type GLint,
            type GLsizei,
            type GLsizei)
     OPENGLENTRY external('glScissor');

 dcl glSelectBuffer
     entry (type GLsizei,
            (*) type GLuint byaddr)
     OPENGLENTRY external('glSelectBuffer');

 dcl glShadeModel
     entry (type GLenum)
     OPENGLENTRY external('glShadeModel');

 dcl glStencilFunc
     entry (type GLenum,
            type GLint,
            type GLuint)
     OPENGLENTRY external('glStencilFunc');

 dcl glStencilMask
     entry (type GLuint)
     OPENGLENTRY external('glStencilMask');

 dcl glStencilOp
     entry (type GLenum,
            type GLenum,
            type GLenum)
     OPENGLENTRY external('glStencilOp');

 dcl glTexCoord1d
     entry (type GLdouble)
     OPENGLENTRY external('glTexCoord1d');

 dcl glTexCoord1dv
     entry ((1) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glTexCoord1dv');

 dcl glTexCoord1f
     entry (type GLfloat )
     OPENGLENTRY external('glTexCoord1f');

 dcl glTexCoord1fv
     entry ((1) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexCoord1fv');

 dcl glTexCoord1i
     entry (type GLint )
     OPENGLENTRY external('glTexCoord1i');

 dcl glTexCoord1iv
     entry ((1) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexCoord1iv');

 dcl glTexCoord1s
     entry (type GLshort)
     OPENGLENTRY external('glTexCoord1s');

 dcl glTexCoord1sv
     entry ((1) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glTexCoord1sv');

 dcl glTexCoord2d
     entry (type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glTexCoord2d');

 dcl glTexCoord2dv
     entry ((2) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glTexCoord2dv');

 dcl glTexCoord2f
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glTexCoord2f');

 dcl glTexCoord2fv
     entry ((2) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexCoord2fv');

 dcl glTexCoord2i
     entry (type GLint,
            type GLint)
     OPENGLENTRY external('glTexCoord2i');

 dcl glTexCoord2iv
     entry ((2) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexCoord2iv');

 dcl glTexCoord2s
     entry (type GLshort,
            type GLshort)
     OPENGLENTRY external('glTexCoord2s');

 dcl glTexCoord2sv
     entry ((2) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glTexCoord2sv');

 dcl glTexCoord3d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glTexCoord3d');

 dcl glTexCoord3dv
     entry ((3) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glTexCoord3dv');

 dcl glTexCoord3f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glTexCoord3f');

 dcl glTexCoord3fv
     entry ((3) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexCoord3fv');

 dcl glTexCoord3i
     entry (type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glTexCoord3i');

 dcl glTexCoord3iv
     entry ((3) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexCoord3iv');

 dcl glTexCoord3s
     entry (type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glTexCoord3s');

 dcl glTexCoord3sv
     entry ((3) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glTexCoord3sv');

 dcl glTexCoord4d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glTexCoord4d');

 dcl glTexCoord4dv
     entry ((4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glTexCoord4dv');

 dcl glTexCoord4f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glTexCoord4f');

 dcl glTexCoord4fv
     entry ((4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexCoord4fv');

 dcl glTexCoord4i
     entry (type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glTexCoord4i');

 dcl glTexCoord4iv
     entry ((4) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexCoord4iv');

 dcl glTexCoord4s
     entry (type GLshort,
            type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glTexCoord4s');

 dcl glTexCoord4sv
     entry ((4) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glTexCoord4sv');

 dcl glTexCoordPointer
     entry (type GLint,
            type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glTexCoordPointer');

 dcl glTexEnvf
     entry (type GLenum,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('glTexEnvf');

 dcl glTexEnvfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexEnvfv');

 dcl glTexEnvi
     entry (type GLenum,
            type GLenum,
            type GLint)
     OPENGLENTRY external('glTexEnvi');

 dcl glTexEnviv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexEnviv');

 dcl glTexGend
     entry (type GLenum,
            type GLenum,
            type GLdouble)
     OPENGLENTRY external('glTexGend');

 dcl glTexGendv
     entry (type GLenum,
            type GLenum,
            (*) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glTexGendv');

 dcl glTexGenf
     entry (type GLenum,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('glTexGenf');

 dcl glTexGenfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexGenfv');

 dcl glTexGeni
     entry (type GLenum,
            type GLenum,
            type GLint)
     OPENGLENTRY external('glTexGeni');

 dcl glTexGeniv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexGeniv');

 dcl glTexImage1D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLsizei,
            type GLint,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glTexImage1D');

 dcl glTexImage2D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLsizei,
            type GLsizei,
            type GLint,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glTexImage2D');

 dcl glTexParameterf
     entry (type GLenum,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('glTexParameterf');

 dcl glTexParameterfv
     entry (type GLenum,
            type GLenum,
            (*) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glTexParameterfv');

 dcl glTexParameteri
     entry (type GLenum,
            type GLenum,
            type GLint)
     OPENGLENTRY external('glTexParameteri');

 dcl glTexParameteriv
     entry (type GLenum,
            type GLenum,
            (*) type GLint byaddr nonasgn)
     OPENGLENTRY external('glTexParameteriv');

 dcl glTexSubImage1D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLsizei,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glTexSubImage1D');

 dcl glTexSubImage2D
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLint,
            type GLsizei,
            type GLsizei,
            type GLenum,
            type GLenum,
            pointer)
     OPENGLENTRY external('glTexSubImage2D');

 dcl glTranslated
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glTranslated');

 dcl glTranslatef
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glTranslatef');

 dcl glVertex2d
     entry (type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glVertex2d');

 dcl glVertex2dv
     entry ((2) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glVertex2dv');

 dcl glVertex2f
     entry (type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glVertex2f');

 dcl glVertex2fv
     entry ((2) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glVertex2fv');

 dcl glVertex2i
     entry (type GLint,
            type GLint)
     OPENGLENTRY external('glVertex2i');

 dcl glVertex2iv
     entry ((2) type GLint byaddr nonasgn)
     OPENGLENTRY external('glVertex2iv');

 dcl glVertex2s
     entry (type GLshort,
            type GLshort)
     OPENGLENTRY external('glVertex2s');

 dcl glVertex2sv
     entry ((2) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glVertex2sv');

 dcl glVertex3d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glVertex3d');

 dcl glVertex3dv
     entry ((3) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glVertex3dv');

 dcl glVertex3f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glVertex3f');

 dcl glVertex3fv
     entry ((3) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glVertex3fv');

 dcl glVertex3i
     entry (type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glVertex3i');

 dcl glVertex3iv
     entry ((3) type GLint byaddr nonasgn)
     OPENGLENTRY external('glVertex3iv');

 dcl glVertex3s
     entry (type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glVertex3s');

 dcl glVertex3sv
     entry ((3) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glVertex3sv');


 dcl glVertex4d
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('glVertex4d');

 dcl glVertex4dv
     entry ((4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('glVertex4dv');

 dcl glVertex4f
     entry (type GLfloat,
            type GLfloat,
            type GLfloat,
            type GLfloat)
     OPENGLENTRY external('glVertex4f');

 dcl glVertex4fv
     entry ((4) type GLfloat byaddr nonasgn)
     OPENGLENTRY external('glVertex4fv');

 dcl glVertex4i
     entry (type GLint,
            type GLint,
            type GLint,
            type GLint)
     OPENGLENTRY external('glVertex4i');

 dcl glVertex4iv
     entry ((4) type GLint byaddr nonasgn)
     OPENGLENTRY external('glVertex4iv');

 dcl glVertex4s
     entry (type GLshort,
            type GLshort,
            type GLshort,
            type GLshort)
     OPENGLENTRY external('glVertex4s');

 dcl glVertex4sv
     entry ((4) type GLshort byaddr nonasgn)
     OPENGLENTRY external('glVertex4sv');

 dcl glVertexPointer
     entry (type GLint,
            type GLenum,
            type GLsizei,
            pointer)
     OPENGLENTRY external('glVertexPointer');

 dcl glViewport
     entry (type GLint,
            type GLint,
            type GLsizei,
            type GLsizei)
     OPENGLENTRY external('glViewport');

 /* EXT_vertex_array */

 define alias PFNGLARRAYELEMENTEXTPROC
        entry (type GLint)
        limited OPENGLENTRY;

 define alias PFNGLDRAWARRAYSEXTPROC
        entry (type GLenum,
               type GLint,
               type GLsizei)
        limited OPENGLENTRY;

 define alias PFNGLVERTEXPOINTEREXTPROC
        entry (type GLint,
               type GLenum,
               type GLsizei,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLNORMALPOINTEREXTPROC
        entry (type GLenum,
               type GLsizei,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLCOLORPOINTEREXTPROC
        entry (type GLint,
               type GLenum,
               type GLsizei,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLINDEXPOINTEREXTPROC
        entry (type GLenum,
               type GLsizei,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLTEXCOORDPOINTEREXTPROC
        entry (type GLint,
               type GLenum,
               type GLsizei,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLEDGEFLAGPOINTEREXTPROC
        entry (type GLsizei,
               type GLsizei,
               (*) type GLboolean byaddr nonasgn)
        limited OPENGLENTRY;

 define alias PFNGLGETPOINTERVEXTPROC
        entry (type GLenum,
               pointer byaddr)
        limited OPENGLENTRY;

 define alias PFNGLARRAYELEMENTARRAYEXTPROC
        entry (type GLenum,
               type GLsizei,
               pointer)
        limited OPENGLENTRY;

 /* WIN_draw_range_elements */

 define alias PFNGLDRAWRANGEELEMENTSWINPROC
        entry (type GLenum,
               type GLuint,
               type GLuint,
               type GLsizei,
               type GLenum,
               pointer)
        limited OPENGLENTRY;

 /* WIN_swap_hint */

 define alias PFNGLADDSWAPHINTRECTWINPROC
        entry (type GLint,
               type GLint,
               type GLsizei,
               type GLsizei)
        limited OPENGLENTRY;

 /* EXT_paletted_texture */

 define alias PFNGLCOLORTABLEEXTPROC
        entry (type GLenum,
               type GLenum,
               type GLsizei,
               type GLenum,
               type GLenum,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLCOLORSUBTABLEEXTPROC
        entry (type GLenum,
               type GLsizei,
               type GLsizei,
               type GLenum,
               type GLenum,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLGETCOLORTABLEEXTPROC
        entry (type GLenum,
               type GLenum,
               type GLenum,
               pointer)
        limited OPENGLENTRY;

 define alias PFNGLGETCOLORTABLEPARAMETERIVEXTPROC
        entry (type GLenum,
               type GLenum,
               (*) type GLint byaddr)
        limited OPENGLENTRY;

 define alias PFNGLGETCOLORTABLEPARAMETERFVEXTPROC
        entry (type GLenum,
               type GLenum,
               (*) type GLfloat byaddr)
        limited OPENGLENTRY;

 %end; /* __gl_h_ */
