 /* ++ BUILD Version: 0004                                            */
 /*      -- Increment this if a change has global effects             */
 /*                                                                   */
 /* Copyright (c) 1985-96, Microsoft Corporation                      */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   glu.cpy                                                         */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   Procedure declarations, constant definitions and macros         */
 /*   for the OpenGL Utility Library.                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #_glu_h__ char ext;
 %if #_glu_h__ = '' %then %do;
 %#_glu_h__ = 'Y';

 %dcl #_gl_h_ char ext;
 %if #_gl_h_ = '' %then %do;
 %include gl;
 %end;

 %dcl UNICODE char ext;

 /* Copyright 1991-1993 Silicon Graphics, Inc.                        */
 /* All Rights Reserved.                                              */
 /*                                                                   */
 /* This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics,  */
 /* Inc.                                                              */
 /* The contents of this file may not be disclosed to third parties,  */
 /* copied or duplicated in any form, in whole or in part, without    */
 /* the prior written permission of Silicon Graphics, Inc.            */
 /*                                                                   */
 /* RESTRICTED RIGHTS LEGEND:                                         */
 /* Use, duplication or disclosure by the Government is subject to    */
 /* restrictions as set forth in subdivision (c)(1)(ii) of the        */
 /* Rights in Technical Data and Computer Software clause at DFARS    */
 /* 252.227-7013, and/or in similar or successor clauses in the FAR,  */
 /* DOD or NASA FAR Supplement. Unpublished - rights reserved under   */
 /* the Copyright Laws of the United States.                          */



 /* Return the error string associated with a particular error code.  */
 /* This will return 0 for an invalid error code.                     */
 /*                                                                   */
 /* The generic function prototype that can be compiled for ANSI or   */
 /* Unicode is gluErrorStringWIN                                      */
 /*                                                                   */
 /* PL/I note: since pointers in PL/I are untyped there is no need    */
 /* for a macro, instead, we can just use a macroprocessor variable.  */

 %dcl gluErrorStringWIN char ext;
 %if UNICODE ^= '' %then %do;
 %gluErrorStringWIN = 'gluErrorUnicodeStringEXT';
 %end; %else %do;
 %gluErrorStringWIN = 'gluErrorString';
 %end;

 dcl gluErrorString
     entry (type GLenum)
     returns (pointer byvalue optional) /* to char(*) varz */
     OPENGLENTRY external('gluErrorString');

 dcl gluErrorUnicodeStringEXT
     entry (type GLenum)
     returns (pointer byvalue optional) /* to WCHAR(*) varz */
     OPENGLENTRY external('gluErrorUnicodeStringEXT');

 dcl gluGetString
     entry (type GLenum)
     returns (pointer byvalue optional)
     OPENGLENTRY external('gluGetString');

 dcl gluOrtho2D
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('gluOrtho2D');

 dcl gluPerspective
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('gluPerspective');

 dcl gluPickMatrix
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            (4) type GLint byaddr)
     OPENGLENTRY external('gluPickMatrix');

 dcl gluLookAt
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('gluLookAt');

 dcl gluProject
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            (16) type GLdouble byaddr nonasgn,
            (16) type GLdouble byaddr nonasgn,
            ( 4) type GLdouble byaddr nonasgn,
            type GLdouble byaddr,
            type GLdouble byaddr,
            type GLdouble byaddr)
     returns (fixed bin(31) byvalue optional)
     OPENGLENTRY external('gluProject');

 dcl gluUnProject
     entry (type GLdouble,
            type GLdouble,
            type GLdouble,
            (16) type GLdouble byaddr nonasgn,
            (16) type GLdouble byaddr nonasgn,
            ( 4) type GLdouble byaddr nonasgn,
            type GLdouble byaddr,
            type GLdouble byaddr,
            type GLdouble byaddr)
     returns (fixed bin(31) byvalue optional)
     OPENGLENTRY external('gluUnProject');


 dcl gluScaleImage
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLenum,
            pointer,
            type GLint,
            type GLint,
            type GLenum,
            pointer)
     returns (fixed bin(31) byvalue optional)
     OPENGLENTRY external('gluScaleImage');

 dcl gluBuild1DMipmaps
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLenum,
            type GLenum,
            pointer)
      returns (fixed bin(31) byvalue optional)
     OPENGLENTRY external('gluBuild1DMipmaps');

 dcl gluBuild2DMipmaps
     entry (type GLenum,
            type GLint,
            type GLint,
            type GLint,
            type GLenum,
            type GLenum,
            pointer)
      returns (fixed bin(31) byvalue optional)
     OPENGLENTRY external('gluBuild2DMipmaps');


 define structure
   1 GLUnurbs; /* unspecified type */

 define structure
   1 GLUquadric;  /* unspecified type */

 define structure
   1 GLUtesselator; /* unspecified type */

 /* backwards compatibility: */
 define alias GLUnurbsObj        type GLUnurbs;
 define alias GLUquadricObj      type GLUquadric;
 define alias GLUtesselatorObj   type GLUtesselator;
 define alias GLUtriangulatorObj type GLUtesselator;


 dcl gluNewQuadric
     entry ()
     returns (handle GLUquadric byvalue optional)
     OPENGLENTRY external('gluNewQuadric');

 dcl gluDeleteQuadric
     entry (handle GLUquadric)
     OPENGLENTRY external('gluDeleteQuadric');

 dcl gluQuadricNormals
     entry (handle GLUquadric,
            type GLenum)
     OPENGLENTRY external('gluQuadricNormals');

 dcl gluQuadricTexture
     entry (handle GLUquadric,
            type GLboolean)
     OPENGLENTRY external('gluQuadricTexture');

 dcl gluQuadricOrientation
     entry (handle GLUquadric,
            type GLenum)
     OPENGLENTRY external('gluQuadricOrientation');

 dcl gluQuadricDrawStyle
     entry (handle GLUquadric,
            type GLenum)
     OPENGLENTRY external('gluQuadricDrawStyle');

 dcl gluCylinder
     entry (handle GLUquadric,
            type GLdouble,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     OPENGLENTRY external('gluCylinder');

 dcl gluDisk
     entry (handle GLUquadric,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint)
     OPENGLENTRY external('gluDisk');

 dcl gluPartialDisk
     entry (handle GLUquadric,
            type GLdouble,
            type GLdouble,
            type GLint,
            type GLint,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('gluPartialDisk');

 dcl gluSphere
     entry (handle GLUquadric,
            type GLdouble,
            type GLint,
            type GLint)
     OPENGLENTRY external('gluSphere');

 dcl gluQuadricCallback
     entry (handle GLUquadric,
            type GLenum,
            entry (type GLenum)
              limited OPENGLCALLBACK optional byvalue)
     OPENGLENTRY external('gluQuadricCallback');

 dcl gluNewTess
     entry ()
     returns (handle GLUtesselator byvalue optional)
     OPENGLENTRY external('gluNewTess');

 dcl gluDeleteTess
     entry (handle GLUtesselator)
     OPENGLENTRY external('gluDeleteTess');

 dcl gluTessBeginPolygon
     entry (handle GLUtesselator,
             pointer)
     OPENGLENTRY external('gluTessBeginPolygon');

 dcl gluTessBeginContour
     entry (handle GLUtesselator)
     OPENGLENTRY external('gluTessBeginContour');

 dcl gluTessVertex
     entry (handle GLUtesselator,
            (3) type GLdouble byaddr,
            pointer)
     OPENGLENTRY external('gluTessVertex');

 dcl gluTessEndContour
     entry (handle GLUtesselator )
     OPENGLENTRY external('gluTessEndContour');

 dcl gluTessEndPolygon
     entry (handle GLUtesselator )
     OPENGLENTRY external('gluTessEndPolygon');

 dcl gluTessProperty
     entry (handle GLUtesselator,
            type GLenum,
            type GLdouble)
     OPENGLENTRY external('gluTessProperty');

 dcl gluTessNormal
     entry (handle GLUtesselator,
            type GLdouble,
            type GLdouble,
            type GLdouble)
     OPENGLENTRY external('gluTessNormal');

 dcl gluTessCallback
     entry (handle GLUtesselator,
            type GLenum,
            entry limited OPENGLCALLBACK optional byvalue)
     OPENGLENTRY external('gluTessCallback');

 dcl gluGetTessProperty
     entry (handle GLUtesselator,
            type GLenum,
            type GLdouble byaddr)
     OPENGLENTRY external('gluGetTessProperty');

 dcl gluNewNurbsRenderer
     entry ()
     returns (handle GLUnurbs byvalue optional)
     OPENGLENTRY external('gluNewNurbsRenderer');

 dcl gluDeleteNurbsRenderer
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluDeleteNurbsRenderer');

 dcl gluBeginSurface
     entry (handle GLUnurbs )
     OPENGLENTRY external('gluBeginSurface');

 dcl gluBeginCurve
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluBeginCurve');

 dcl gluEndCurve
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluEndCurve');

 dcl gluEndSurface
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluEndSurface');

 dcl gluBeginTrim
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluBeginTrim');

 dcl gluEndTrim
     entry (handle GLUnurbs)
     OPENGLENTRY external('gluEndTrim');

 dcl gluPwlCurve
     entry (handle GLUnurbs,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            type GLenum)
     OPENGLENTRY external('gluPwlCurve');

 dcl gluNurbsCurve
     entry (handle GLUnurbs,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            type GLenum)
     OPENGLENTRY external('gluNurbsCurve');

 dcl gluNurbsSurface
     entry (handle GLUnurbs,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            type GLint,
            (*) type GLfloat byaddr,
            type GLint,
            type GLint,
            type GLenum)
     OPENGLENTRY external('gluNurbsSurface');

 dcl gluLoadSamplingMatrices
     entry (handle GLUnurbs,
            (16) type GLdouble byaddr nonasgn,
            (16) type GLdouble byaddr nonasgn,
            ( 4) type GLdouble byaddr nonasgn)
     OPENGLENTRY external('gluLoadSamplingMatrices');

 dcl gluNurbsProperty
     entry (handle GLUnurbs,
            type GLenum,
            type GLfloat)
     OPENGLENTRY external('gluNurbsProperty');

 dcl gluGetNurbsProperty
     entry (handle GLUnurbs,
            type GLenum,
            type GLfloat byaddr)
     OPENGLENTRY external('gluGetNurbsProperty');

 dcl gluNurbsCallback
     entry (handle GLUnurbs,
            type GLenum,
            entry (type GLenum)
              limited OPENGLCALLBACK optional byvalue)
     OPENGLENTRY external('gluNurbsCallback');


 /****           Callback function prototypes               ****/

 /* gluQuadricCallback */
 define alias GLUquadricErrorProc
        entry (type GLenum)
        limited OPENGLCALLBACK;

 /* gluTessCallback */
 define alias GLUtessBeginProc
        entry (type GLenum)
        limited OPENGLCALLBACK;

 define alias GLUtessEdgeFlagProc
        entry (type GLboolean)
        limited OPENGLCALLBACK;

 define alias GLUtessVertexProc
        entry (pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessEndProc
        entry ()
        limited OPENGLCALLBACK;

 define alias GLUtessErrorProc
        entry (type GLenum)
        limited OPENGLCALLBACK;

 define alias GLUtessCombineProc
        entry ((3) type GLdouble byaddr,
               (4) pointer byaddr,
               (4) type GLfloat byaddr,
               pointer byaddr)
        limited OPENGLCALLBACK;

 define alias GLUtessBeginDataProc
        entry (type GLenum,
               pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessEdgeFlagDataProc
        entry (type GLboolean,
               pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessVertexDataProc
        entry (pointer,
               pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessEndDataProc
        entry (pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessErrorDataProc
        entry (type GLenum,
               pointer)
        limited OPENGLCALLBACK;

 define alias GLUtessCombineDataProc
        entry ((3) type GLdouble byaddr,
               (4) pointer byaddr,
               (4) type GLfloat byaddr,
               pointer byaddr,
               pointer)
        limited OPENGLCALLBACK;

 /* gluNurbsCallback */
 define alias GLUnurbsErrorProc
        entry (type GLenum )
        limited OPENGLCALLBACK;


 /****           Generic constants               ****/

 /* Version */
 dcl GLU_VERSION_1_1              fixed bin(31) value(1);
 dcl GLU_VERSION_1_2              fixed bin(31) value(1);

 /* Errors: (return value 0 = no error) */
 dcl GLU_INVALID_ENUM             fixed bin(31) value(100900);
 dcl GLU_INVALID_VALUE            fixed bin(31) value(100901);
 dcl GLU_OUT_OF_MEMORY            fixed bin(31) value(100902);
 dcl GLU_INCOMPATIBLE_GL_VERSION  fixed bin(31) value(100903);

 /* StringName */
 dcl GLU_VERSION                  fixed bin(31) value(100800);
 dcl GLU_EXTENSIONS               fixed bin(31) value(100801);

 /* Boolean */
 dcl GLU_TRUE                     fixed bin(31) value(GL_TRUE);
 dcl GLU_FALSE                    fixed bin(31) value(GL_FALSE);


 /****           Quadric constants               ****/

 /* QuadricNormal */
 dcl GLU_SMOOTH                   fixed bin(31) value(100000);
 dcl GLU_FLAT                     fixed bin(31) value(100001);
 dcl GLU_NONE                     fixed bin(31) value(100002);

 /* QuadricDrawStyle */
 dcl GLU_POINT                    fixed bin(31) value(100010);
 dcl GLU_LINE                     fixed bin(31) value(100011);
 dcl GLU_FILL                     fixed bin(31) value(100012);
 dcl GLU_SILHOUETTE               fixed bin(31) value(100013);

 /* QuadricOrientation */
 dcl GLU_OUTSIDE                  fixed bin(31) value(100020);
 dcl GLU_INSIDE                   fixed bin(31) value(100021);

 /* Callback types: */
 /*  GLU_ERROR                    fixed bin(31) value(100103) */


 /****           Tesselation constants           ****/

 dcl GLU_TESS_MAX_COORD           float bin(53) value(1.0d150);

 /* TessProperty */
 dcl GLU_TESS_WINDING_RULE        fixed bin(31) value(100140);
 dcl GLU_TESS_BOUNDARY_ONLY       fixed bin(31) value(100141);
 dcl GLU_TESS_TOLERANCE           fixed bin(31) value(100142);

 /* TessWinding */
 dcl GLU_TESS_WINDING_ODD         fixed bin(31) value(100130);
 dcl GLU_TESS_WINDING_NONZERO     fixed bin(31) value(100131);
 dcl GLU_TESS_WINDING_POSITIVE    fixed bin(31) value(100132);
 dcl GLU_TESS_WINDING_NEGATIVE    fixed bin(31) value(100133);
 dcl GLU_TESS_WINDING_ABS_GEQ_TWO fixed bin(31) value(100134);

 /* TessCallback */
 dcl GLU_TESS_BEGIN               fixed bin(31) value(100100);
     /* type GLUtessBeginProc  */
 dcl GLU_TESS_VERTEX              fixed bin(31) value(100101);
     /* type GLUtessVertexProc */
 dcl GLU_TESS_END                 fixed bin(31) value(100102);
     /* type GLUtessEndProc */
 dcl GLU_TESS_ERROR               fixed bin(31) value(100103);
     /* type GLUtessErrorProc */
 dcl GLU_TESS_EDGE_FLAG           fixed bin(31) value(100104);
     /* type GLUtessEdgeFlagProc  */
 dcl GLU_TESS_COMBINE             fixed bin(31) value(100105);
     /* type GLUtessCombineProc */
 dcl GLU_TESS_BEGIN_DATA          fixed bin(31) value(100106);
     /* type GLUtessBeginDataProc */
 dcl GLU_TESS_VERTEX_DATA         fixed bin(31) value(100107);
     /* type GLUtessVertexDataProc */
 dcl GLU_TESS_END_DATA            fixed bin(31) value(100108);
     /* type GLUtessEndDataProc */
 dcl GLU_TESS_ERROR_DATA          fixed bin(31) value(100109);
     /* type GLUtessErrorDataProc */
 dcl GLU_TESS_EDGE_FLAG_DATA      fixed bin(31) value(100110);
     /* type GLUtessEdgeFlagDataProc */
 dcl GLU_TESS_COMBINE_DATA        fixed bin(31) value(100111);
     /* type GLUtessCombineDataProc */

 /* TessError */
 dcl GLU_TESS_ERROR1              fixed bin(31) value(100151);
 dcl GLU_TESS_ERROR2              fixed bin(31) value(100152);
 dcl GLU_TESS_ERROR3              fixed bin(31) value(100153);
 dcl GLU_TESS_ERROR4              fixed bin(31) value(100154);
 dcl GLU_TESS_ERROR5              fixed bin(31) value(100155);
 dcl GLU_TESS_ERROR6              fixed bin(31) value(100156);
 dcl GLU_TESS_ERROR7              fixed bin(31) value(100157);
 dcl GLU_TESS_ERROR8              fixed bin(31) value(100158);

 dcl GLU_TESS_MISSING_BEGIN_POLYGON
     fixed bin(31) value(GLU_TESS_ERROR1);
 dcl GLU_TESS_MISSING_BEGIN_CONTOUR
     fixed bin(31) value(GLU_TESS_ERROR2);
 dcl GLU_TESS_MISSING_END_POLYGON
     fixed bin(31) value(GLU_TESS_ERROR3);
 dcl GLU_TESS_MISSING_END_CONTOUR
     fixed bin(31) value(GLU_TESS_ERROR4);
 dcl GLU_TESS_COORD_TOO_LARGE
     fixed bin(31) value(GLU_TESS_ERROR5);
 dcl GLU_TESS_NEED_COMBINE_CALLBACK
     fixed bin(31) value(GLU_TESS_ERROR6);

 /****           NURBS constants                 ****/

 /* NurbsProperty */
 dcl GLU_AUTO_LOAD_MATRIX         fixed bin(31) value(100200);
 dcl GLU_CULLING                  fixed bin(31) value(100201);
 dcl GLU_SAMPLING_TOLERANCE       fixed bin(31) value(100203);
 dcl GLU_DISPLAY_MODE             fixed bin(31) value(100204);
 dcl GLU_PARAMETRIC_TOLERANCE     fixed bin(31) value(100202);
 dcl GLU_SAMPLING_METHOD          fixed bin(31) value(100205);
 dcl GLU_U_STEP                   fixed bin(31) value(100206);
 dcl GLU_V_STEP                   fixed bin(31) value(100207);

 /* NurbsSampling */
 dcl GLU_PATH_LENGTH              fixed bin(31) value(100215);
 dcl GLU_PARAMETRIC_ERROR         fixed bin(31) value(100216);
 dcl GLU_DOMAIN_DISTANCE          fixed bin(31) value(100217);


 /* NurbsTrim */
 dcl GLU_MAP1_TRIM_2              fixed bin(31) value(100210);
 dcl GLU_MAP1_TRIM_3              fixed bin(31) value(100211);

 /* NurbsDisplay */
 /*  GLU_FILL                     fixed bin(31) value(100012) */
 dcl GLU_OUTLINE_POLYGON          fixed bin(31) value(100240);
 dcl GLU_OUTLINE_PATCH            fixed bin(31) value(100241);

 /* NurbsCallback */
 /*  GLU_ERROR                    fixed bin(31) value(100103) */

 /* NurbsErrors */
 dcl GLU_NURBS_ERROR1             fixed bin(31) value(100251);
 dcl GLU_NURBS_ERROR2             fixed bin(31) value(100252);
 dcl GLU_NURBS_ERROR3             fixed bin(31) value(100253);
 dcl GLU_NURBS_ERROR4             fixed bin(31) value(100254);
 dcl GLU_NURBS_ERROR5             fixed bin(31) value(100255);
 dcl GLU_NURBS_ERROR6             fixed bin(31) value(100256);
 dcl GLU_NURBS_ERROR7             fixed bin(31) value(100257);
 dcl GLU_NURBS_ERROR8             fixed bin(31) value(100258);
 dcl GLU_NURBS_ERROR9             fixed bin(31) value(100259);
 dcl GLU_NURBS_ERROR10            fixed bin(31) value(100260);
 dcl GLU_NURBS_ERROR11            fixed bin(31) value(100261);
 dcl GLU_NURBS_ERROR12            fixed bin(31) value(100262);
 dcl GLU_NURBS_ERROR13            fixed bin(31) value(100263);
 dcl GLU_NURBS_ERROR14            fixed bin(31) value(100264);
 dcl GLU_NURBS_ERROR15            fixed bin(31) value(100265);
 dcl GLU_NURBS_ERROR16            fixed bin(31) value(100266);
 dcl GLU_NURBS_ERROR17            fixed bin(31) value(100267);
 dcl GLU_NURBS_ERROR18            fixed bin(31) value(100268);
 dcl GLU_NURBS_ERROR19            fixed bin(31) value(100269);
 dcl GLU_NURBS_ERROR20            fixed bin(31) value(100270);
 dcl GLU_NURBS_ERROR21            fixed bin(31) value(100271);
 dcl GLU_NURBS_ERROR22            fixed bin(31) value(100272);
 dcl GLU_NURBS_ERROR23            fixed bin(31) value(100273);
 dcl GLU_NURBS_ERROR24            fixed bin(31) value(100274);
 dcl GLU_NURBS_ERROR25            fixed bin(31) value(100275);
 dcl GLU_NURBS_ERROR26            fixed bin(31) value(100276);
 dcl GLU_NURBS_ERROR27            fixed bin(31) value(100277);
 dcl GLU_NURBS_ERROR28            fixed bin(31) value(100278);
 dcl GLU_NURBS_ERROR29            fixed bin(31) value(100279);
 dcl GLU_NURBS_ERROR30            fixed bin(31) value(100280);
 dcl GLU_NURBS_ERROR31            fixed bin(31) value(100281);
 dcl GLU_NURBS_ERROR32            fixed bin(31) value(100282);
 dcl GLU_NURBS_ERROR33            fixed bin(31) value(100283);
 dcl GLU_NURBS_ERROR34            fixed bin(31) value(100284);
 dcl GLU_NURBS_ERROR35            fixed bin(31) value(100285);
 dcl GLU_NURBS_ERROR36            fixed bin(31) value(100286);
 dcl GLU_NURBS_ERROR37            fixed bin(31) value(100287);

 /****         Backwards compatibility for old tesselator         ****/

 dcl gluBeginPolygon
     entry (handle GLUtesselator)
     OPENGLENTRY external('gluBeginPolygon');

 dcl gluNextContour
     entry (handle GLUtesselator,
            type GLenum)
     OPENGLENTRY external('gluNextContour');

 dcl gluEndPolygon
     entry (handle GLUtesselator)
     OPENGLENTRY external('gluEndPolygon');

 /* Contours types -- obsolete! */
 dcl GLU_CW                     fixed bin(31) value(100120);
 dcl GLU_CCW                    fixed bin(31) value(100121);
 dcl GLU_INTERIOR               fixed bin(31) value(100122);
 dcl GLU_EXTERIOR               fixed bin(31) value(100123);
 dcl GLU_UNKNOWN                fixed bin(31) value(100124);

 /* Names without "TESS_" prefix */
 dcl GLU_BEGIN                  fixed bin(31) value(GLU_TESS_BEGIN);
 dcl GLU_VERTEX                 fixed bin(31) value(GLU_TESS_VERTEX);
 dcl GLU_END                    fixed bin(31) value(GLU_TESS_END);
 dcl GLU_ERROR                  fixed bin(31) value(GLU_TESS_ERROR);
 dcl GLU_EDGE_FLAG              fixed bin(31) value(GLU_TESS_EDGE_FLAG);

 %end; /* __glu_h__ */
