 /*********************************************************************/
 /*      imm.cpy - Input Method Manager definitions                   */
 /*                                                                   */
 /*      Copyright (c) 1993-1998  Microsoft Corporation               */
 /*********************************************************************/

 %dcl #IMM_ char ext;
 %if #IMM_ = '' %then %do;
 %#IMM_ = 'Y';

 %dcl #IMM_SDK_DEFINED_ char ext;
 %if #IMM_SDK_DEFINED_ = '' %then %do;
 %#IMM_SDK_DEFINED_ = 'Y';

 %dcl UNICODE char ext;
 %dcl WINVER fixed ext;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;

 %if WINVER >= 1034 %then %do;
 DECLARE_HANDLE (HIMC);
 DECLARE_HANDLE (HIMCC);
 %end; %else %do;
 define alias HIMC type DWORD;
 define alias HIMCC type DWORD;
 %end; /* WINVER >= 0x040A */

 define alias LPHKL  pointer;
 /* define alias LPUINT pointer -- not used here, and conflicts */

 define structure
   1 COMPOSITIONFORM,
     2 dwStyle      type DWORD,
     2 ptCurrentPos type POINT,
     2 rcArea       type RECT;

 define alias  PCOMPOSITIONFORM handle COMPOSITIONFORM;
 define alias NPCOMPOSITIONFORM handle COMPOSITIONFORM;
 define alias LPCOMPOSITIONFORM handle COMPOSITIONFORM;


 define structure
   1 CANDIDATEFORM,
     2 dwIndex type DWORD,
     2 dwStyle type DWORD,
     2 ptCurrentPos type POINT,
     2 rcArea type RECT;

 define alias  PCANDIDATEFORM handle CANDIDATEFORM;
 define alias NPCANDIDATEFORM handle CANDIDATEFORM;
 define alias LPCANDIDATEFORM handle CANDIDATEFORM;


 define structure
   1 CANDIDATELIST,
     2 dwSize       type DWORD,
     2 dwStyle      type DWORD,
     2 dwCount      type DWORD,
     2 dwSelection  type DWORD,
     2 dwPageStart  type DWORD,
     2 dwPageSize   type DWORD,
     2 dwOffset (1) type DWORD;

 define alias  PCANDIDATELIST handle CANDIDATELIST;
 define alias NPCANDIDATELIST handle CANDIDATELIST;
 define alias LPCANDIDATELIST handle CANDIDATELIST;

 define structure
   1 REGISTERWORDA,
     2 lpReading type LPSTR,
     2 lpWord    type LPSTR;

 define alias  PREGISTERWORDA handle REGISTERWORDA;
 define alias NPREGISTERWORDA handle REGISTERWORDA;
 define alias LPREGISTERWORDA handle REGISTERWORDA;

 define structure
   1 REGISTERWORDW,
     2 lpReading type LPWSTR,
     2 lpWord    type LPWSTR;
 define alias  PREGISTERWORDW handle REGISTERWORDW;
 define alias NPREGISTERWORDW handle REGISTERWORDW;
 define alias LPREGISTERWORDW handle REGISTERWORDW;

 %if UNICODE ^= '' %then %do;
 define alias   REGISTERWORD type REGISTERWORDW;
 define alias  PREGISTERWORD type PREGISTERWORDW;
 define alias NPREGISTERWORD type NPREGISTERWORDW;
 define alias LPREGISTERWORD type LPREGISTERWORDW;
 %end; %else %do;
 define alias   REGISTERWORD type REGISTERWORDA;
 define alias  PREGISTERWORD type PREGISTERWORDA;
 define alias NPREGISTERWORD type NPREGISTERWORDA;
 define alias LPREGISTERWORD type LPREGISTERWORDA;
 %end; /* UNICODE */

 %if WINVER >= 1034 %then %do;
 define structure
   1 RECONVERTSTRING,
     2 dwSize            type DWORD,
     2 dwVersion         type DWORD,
     2 dwStrLen          type DWORD,
     2 dwStrOffset       type DWORD,
     2 dwCompStrLen      type DWORD,
     2 dwCompStrOffset   type DWORD,
     2 dwTargetStrLen    type DWORD,
     2 dwTargetStrOffset type DWORD;

 define alias  PRECONVERTSTRING handle RECONVERTSTRING;
 define alias NPRECONVERTSTRING handle RECONVERTSTRING;
 define alias LPRECONVERTSTRING handle RECONVERTSTRING;

 %end; /* WINVER >= 0x040A */

 dcl STYLE_DESCRIPTION_SIZE fixed bin(31) value(32);

 define structure
   1 STYLEBUFA,
     2 dwStyle       type DWORD,
     2 szDescription char (STYLE_DESCRIPTION_SIZE-1) varz;

 define alias  PSTYLEBUFA handle STYLEBUFA;
 define alias NPSTYLEBUFA handle STYLEBUFA;
 define alias LPSTYLEBUFA handle STYLEBUFA;

 define structure
   1 STYLEBUFW,
     2 dwStyle       type DWORD,
     2 szDescription WCHAR (STYLE_DESCRIPTION_SIZE-1) varz;

 define alias  PSTYLEBUFW handle STYLEBUFW;
 define alias NPSTYLEBUFW handle STYLEBUFW;
 define alias LPSTYLEBUFW handle STYLEBUFW;
 %if UNICODE ^= '' %then %do;
 define alias   STYLEBUF type STYLEBUFW;
 define alias  PSTYLEBUF type PSTYLEBUFW;
 define alias NPSTYLEBUF type NPSTYLEBUFW;
 define alias LPSTYLEBUF type LPSTYLEBUFW;
 %end; %else %do;
 define alias   STYLEBUF type STYLEBUFA;
 define alias  PSTYLEBUF type PSTYLEBUFA;
 define alias NPSTYLEBUF type NPSTYLEBUFA;
 define alias LPSTYLEBUF type LPSTYLEBUFA;
 %end; /* UNICODE */


 %if WINVER >= 1034 %then %do;

 dcl IMEMENUITEM_STRING_SIZE fixed bin(31) value(80);

 define structure
   1 IMEMENUITEMINFOA,
     2 cbSize        type UINT,
     2 fType         type UINT,
     2 fState        type UINT,
     2 wID           type UINT,
     2 hbmpChecked   type HBITMAP,
     2 hbmpUnchecked type HBITMAP,
     2 dwItemData    type DWORD,
     2 szString      char (IMEMENUITEM_STRING_SIZE-1) varz,
     2 hbmpItem      type HBITMAP;
 define alias  PIMEMENUITEMINFOA handle IMEMENUITEMINFOA;
 define alias NPIMEMENUITEMINFOA handle IMEMENUITEMINFOA;
 define alias LPIMEMENUITEMINFOA handle IMEMENUITEMINFOA;

 define structure
   1 IMEMENUITEMINFOW,
     2 cbSize        type UINT,
     2 fType         type UINT,
     2 fState        type UINT,
     2 wID           type UINT,
     2 hbmpChecked   type HBITMAP,
     2 hbmpUnchecked type HBITMAP,
     2 dwItemData    type DWORD,
     2 szString      WCHAR (IMEMENUITEM_STRING_SIZE-1) varz,
     2 hbmpItem      type HBITMAP;
 define alias  PIMEMENUITEMINFOW handle IMEMENUITEMINFOW;
 define alias NPIMEMENUITEMINFOW handle IMEMENUITEMINFOW;
 define alias LPIMEMENUITEMINFOW handle IMEMENUITEMINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   IMEMENUITEMINFO type IMEMENUITEMINFOW;
 define alias  PIMEMENUITEMINFO type PIMEMENUITEMINFOW;
 define alias NPIMEMENUITEMINFO type NPIMEMENUITEMINFOW;
 define alias LPIMEMENUITEMINFO type LPIMEMENUITEMINFOW;
 %end; %else %do;
 define alias   IMEMENUITEMINFO type IMEMENUITEMINFOA;
 define alias  PIMEMENUITEMINFO type PIMEMENUITEMINFOA;
 define alias NPIMEMENUITEMINFO type NPIMEMENUITEMINFOA;
 define alias LPIMEMENUITEMINFO type LPIMEMENUITEMINFOA;
 %end; /* UNICODE */

 define structure
   1 IMECHARPOSITION,
     2 dwSize      type DWORD,
     2 dwCharPos   type DWORD,
     2 pt          type POINT,
     2 cLineHeight type UINT,
     2 rcDocument  type RECT;
 define alias  PIMECHARPOSITION handle IMECHARPOSITION;
 define alias NPIMECHARPOSITION handle IMECHARPOSITION;
 define alias LPIMECHARPOSITION handle IMECHARPOSITION;

 define alias IMCENUMPROC
        entry (type HIMC,
               type LPARAM)
        returns (type BOOL byvalue optional)
        limited CALLBACK;

 %end; /* WINVER >= 0x040A */

 /* prototype of IMM API */

 dcl ImmInstallIMEA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     returns (type HKL byvalue optional)
     WINAPI external('ImmInstallIMEA');
 dcl ImmInstallIMEW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type HKL byvalue optional)
     WINAPI external('ImmInstallIMEW');

 %dcl ImmInstallIME char ext;
 %if UNICODE ^= '' %then %do;
   %ImmInstallIME='ImmInstallIMEW';
 %end; %else %do;
   %ImmInstallIME='ImmInstallIMEA';
 %end; /* !UNICODE */

 dcl ImmGetDefaultIMEWnd
     entry (type HWND )
     returns (type HWND byvalue optional)
     WINAPI external('ImmGetDefaultIMEWnd');

 dcl ImmGetDescriptionA
     entry (type HKL,
            char (*) varz byaddr,
            type UINT)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetDescriptionA');
 dcl ImmGetDescriptionW
     entry (type HKL,
            WCHAR (*) varz byaddr,
            type UINT)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetDescriptionW');

 %dcl ImmGetDescription char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetDescription='ImmGetDescriptionW';
 %end; %else %do;
   %ImmGetDescription='ImmGetDescriptionA';
 %end; /* !UNICODE */

 dcl ImmGetIMEFileNameA
     entry (type HKL,
            char (*) varz byaddr,
            type UINT)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetIMEFileNameA');
 dcl ImmGetIMEFileNameW
     entry (type HKL,
            WCHAR (*) varz byaddr,
            type UINT)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetIMEFileNameW');

 %dcl ImmGetIMEFileName char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetIMEFileName='ImmGetIMEFileNameW';
 %end; %else %do;
   %ImmGetIMEFileName='ImmGetIMEFileNameA';
 %end; /* !UNICODE */

 dcl ImmGetProperty
     entry (type HKL,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetProperty');

 dcl ImmIsIME
     entry (type HKL )
     returns (type BOOL byvalue optional)
     WINAPI external('ImmIsIME');

 dcl ImmSimulateHotKey
     entry (type HWND,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSimulateHotKey');

 dcl ImmCreateContext
     entry ()
     returns (type HIMC byvalue optional)
     WINAPI external('ImmCreateContext');
 dcl ImmDestroyContext
     entry (type HIMC )
     returns (type BOOL byvalue optional)
     WINAPI external('ImmDestroyContext');
 dcl ImmGetContext
     entry (type HWND )
     returns (type HIMC byvalue optional)
     WINAPI external('ImmGetContext');
 dcl ImmReleaseContext
     entry (type HWND,
            type HIMC)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmReleaseContext');
 dcl ImmAssociateContext
     entry (type HWND,
            type HIMC)
     returns (type HIMC byvalue optional)
     WINAPI external('ImmAssociateContext');

 %if WINVER >= 1034 %then %do;
 dcl ImmAssociateContextEx
     entry (type HWND,
            type HIMC,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmAssociateContextEx');
 %end; /* WINVER >= 0x040A */

 dcl ImmGetCompositionStringA
     entry (type HIMC,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('ImmGetCompositionStringA');
 dcl ImmGetCompositionStringW
     entry (type HIMC,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('ImmGetCompositionStringW');

 %dcl ImmGetCompositionString char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetCompositionString='ImmGetCompositionStringW';
 %end; %else %do;
   %ImmGetCompositionString='ImmGetCompositionStringA';
 %end; /* !UNICODE */

 dcl ImmSetCompositionStringA
     entry (type HIMC,
            type DWORD,
            type LPVOID,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCompositionStringA');
 dcl ImmSetCompositionStringW
     entry (type HIMC,
            type DWORD,
            type LPVOID,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCompositionStringW');

 %dcl ImmSetCompositionString char ext;
 %if UNICODE ^= '' %then %do;
   %ImmSetCompositionString='ImmSetCompositionStringW';
 %end; %else %do;
   %ImmSetCompositionString='ImmSetCompositionStringA';
 %end; /* !UNICODE */

 dcl ImmGetCandidateListCountA
     entry (type HIMC,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetCandidateListCountA');
 dcl ImmGetCandidateListCountW
     entry (type HIMC,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetCandidateListCountW');

 %dcl ImmGetCandidateListCount char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetCandidateListCount='ImmGetCandidateListCountW';
 %end; %else %do;
   %ImmGetCandidateListCount='ImmGetCandidateListCountA';
 %end; /* !UNICODE */

 dcl ImmGetCandidateListA
     entry (type HIMC,
            type DWORD,
            type CANDIDATELIST byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetCandidateListA');
 dcl ImmGetCandidateListW
     entry (type HIMC,
            type DWORD,
            type CANDIDATELIST byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetCandidateListW');

 %dcl ImmGetCandidateList char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetCandidateList='ImmGetCandidateListW';
 %end; %else %do;
   %ImmGetCandidateList='ImmGetCandidateListA';
 %end; /* !UNICODE */

 dcl ImmGetGuideLineA
     entry (type HIMC,
            type DWORD,
            char (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetGuideLineA');
 dcl ImmGetGuideLineW
     entry (type HIMC,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetGuideLineW');

 %dcl ImmGetGuideLine char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetGuideLine='ImmGetGuideLineW';
 %end; %else %do;
   %ImmGetGuideLine='ImmGetGuideLineA';
 %end; /* !UNICODE */

 dcl ImmGetConversionStatus
     entry (type HIMC,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetConversionStatus');
 dcl ImmSetConversionStatus
     entry (type HIMC,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetConversionStatus');
 dcl ImmGetOpenStatus
     entry (type HIMC )
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetOpenStatus');
 dcl ImmSetOpenStatus
     entry (type HIMC,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetOpenStatus');

 %dcl #WINGDI_ char ext;
 %dcl NOGDI char ext;
 %if #WINGDI_ ^= '' & NOGDI = '' %then %do;
 dcl ImmGetCompositionFontA
     entry (type HIMC,
            type LOGFONTA byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetCompositionFontA');
 dcl ImmGetCompositionFontW
     entry (type HIMC,
            type LOGFONTW byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetCompositionFontW');

 %dcl ImmGetCompositionFont char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetCompositionFont='ImmGetCompositionFontW';
 %end; %else %do;
   %ImmGetCompositionFont='ImmGetCompositionFontA';
 %end; /* !UNICODE */

 dcl ImmSetCompositionFontA
     entry (type HIMC,
            type LOGFONTA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCompositionFontA');
 dcl ImmSetCompositionFontW
     entry (type HIMC,
            type LOGFONTW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCompositionFontW');

 %dcl ImmSetCompositionFont char ext;
 %if UNICODE ^= '' %then %do;
   %ImmSetCompositionFont='ImmSetCompositionFontW';
 %end; %else %do;
   %ImmSetCompositionFont='ImmSetCompositionFontA';
 %end; /* !UNICODE */
 %end; /* defined(_WINGDI_) && !defined(NOGDI) */

 dcl ImmConfigureIMEA
     entry (type HKL,
            type HWND,
            type DWORD,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmConfigureIMEA');
 dcl ImmConfigureIMEW
     entry (type HKL,
            type HWND,
            type DWORD,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmConfigureIMEW');

 %dcl ImmConfigureIME char ext;
 %if UNICODE ^= '' %then %do;
   %ImmConfigureIME='ImmConfigureIMEW';
 %end; %else %do;
   %ImmConfigureIME='ImmConfigureIMEA';
 %end; /* !UNICODE */

 dcl ImmEscapeA
     entry (type HKL,
            type HIMC,
            type UINT,
            type LPVOID)
     returns (type LRESULT byvalue optional)
     WINAPI external('ImmEscapeA');
 dcl ImmEscapeW
     entry (type HKL,
            type HIMC,
            type UINT,
            type LPVOID)
     returns (type LRESULT byvalue optional)
     WINAPI external('ImmEscapeW');

 %dcl ImmEscape char ext;
 %if UNICODE ^= '' %then %do;
   %ImmEscape='ImmEscapeW';
 %end; %else %do;
   %ImmEscape='ImmEscapeA';
 %end; /* !UNICODE */

 dcl ImmGetConversionListA
     entry (type HKL,
            type HIMC,
            char (*) varz byaddr nonasgn,
            type CANDIDATELIST byaddr,
            type DWORD,
            type UINT)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetConversionListA');
 dcl ImmGetConversionListW
     entry (type HKL,
            type HIMC,
            WCHAR (*) varz byaddr nonasgn,
            type CANDIDATELIST byaddr,
            type DWORD,
            type UINT)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetConversionListW');

 %dcl ImmGetConversionList char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetConversionList='ImmGetConversionListW';
 %end; %else %do;
   %ImmGetConversionList='ImmGetConversionListA';
 %end; /* !UNICODE */

 dcl ImmNotifyIME
     entry (type HIMC,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmNotifyIME');

 dcl ImmGetStatusWindowPos
     entry (type HIMC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetStatusWindowPos');
 dcl ImmSetStatusWindowPos
     entry (type HIMC,
            type POINT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetStatusWindowPos');
 dcl ImmGetCompositionWindow
     entry (type HIMC,
            type COMPOSITIONFORM byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetCompositionWindow');
 dcl ImmSetCompositionWindow
     entry (type HIMC,
            type COMPOSITIONFORM byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCompositionWindow');
 dcl ImmGetCandidateWindow
     entry (type HIMC,
            type DWORD,
            type CANDIDATEFORM byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmGetCandidateWindow');
 dcl ImmSetCandidateWindow
     entry (type HIMC,
            type CANDIDATEFORM byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmSetCandidateWindow');

 dcl ImmIsUIMessageA
     entry (type HWND,
            type UINT,
            type WPARAM,
            type LPARAM)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmIsUIMessageA');
 dcl ImmIsUIMessageW
     entry (type HWND,
            type UINT,
            type WPARAM,
            type LPARAM)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmIsUIMessageW');

 %dcl ImmIsUIMessage char ext;
 %if UNICODE ^= '' %then %do;
   %ImmIsUIMessage='ImmIsUIMessageW';
 %end; %else %do;
   %ImmIsUIMessage='ImmIsUIMessageA';
 %end; /* !UNICODE */


 dcl ImmGetVirtualKey
     entry (type HWND)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetVirtualKey');

 define alias REGISTERWORDENUMPROCA
        entry (type LPCSTR,
               type DWORD,
               type LPCSTR,
               type LPVOID)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 define alias REGISTERWORDENUMPROCW
        entry (type LPCWSTR,
               type DWORD,
               type LPCWSTR,
               type LPVOID)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 %if UNICODE ^= '' %then %do;
 define alias REGISTERWORDENUMPROC type REGISTERWORDENUMPROCW;
 %end; %else %do;
 define alias REGISTERWORDENUMPROC type REGISTERWORDENUMPROCA;
 %end; /* !UNICODE */

 dcl ImmRegisterWordA
     entry (type HKL,
            char (*) varz byaddr nonasgn,
            type DWORD,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmRegisterWordA');
 dcl ImmRegisterWordW
     entry (type HKL,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmRegisterWordW');

 %dcl ImmRegisterWord char ext;
 %if UNICODE ^= '' %then %do;
   %ImmRegisterWord='ImmRegisterWordW';
 %end; %else %do;
   %ImmRegisterWord='ImmRegisterWordA';
 %end; /* !UNICODE */

 dcl ImmUnregisterWordA
     entry (type HKL,
            char (*) varz byaddr nonasgn,
            type DWORD,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmUnregisterWordA');
 dcl ImmUnregisterWordW
     entry (type HKL,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmUnregisterWordW');

 %dcl ImmUnregisterWord char ext;
 %if UNICODE ^= '' %then %do;
   %ImmUnregisterWord='ImmUnregisterWordW';
 %end; %else %do;
   %ImmUnregisterWord='ImmUnregisterWordA';
 %end; /* !UNICODE */

 dcl ImmGetRegisterWordStyleA
     entry (type HKL,
            type UINT,
            type STYLEBUFA byaddr)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetRegisterWordStyleA');
 dcl ImmGetRegisterWordStyleW
     entry (type HKL,
            type UINT,
            type STYLEBUFW byaddr)
     returns (type UINT byvalue optional)
     WINAPI external('ImmGetRegisterWordStyleW');

 %dcl ImmGetRegisterWordStyle char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetRegisterWordStyle='ImmGetRegisterWordStyleW';
 %end; %else %do;
   %ImmGetRegisterWordStyle='ImmGetRegisterWordStyleA';
 %end; /* !UNICODE */

 dcl ImmEnumRegisterWordA
     entry (type HKL,
            type REGISTERWORDENUMPROCA,
            char (*) varz byaddr nonasgn,
            type DWORD,
            char (*) varz byaddr nonasgn,
            type LPVOID)
     returns (type UINT byvalue optional)
     WINAPI external('ImmEnumRegisterWordA');
 dcl ImmEnumRegisterWordW
     entry (type HKL,
            type REGISTERWORDENUMPROCW,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type LPVOID)
     returns (type UINT byvalue optional)
     WINAPI external('ImmEnumRegisterWordW');

 %dcl ImmEnumRegisterWord char ext;
 %if UNICODE ^= '' %then %do;
   %ImmEnumRegisterWord='ImmEnumRegisterWordW';
 %end;%else %do;
   %ImmEnumRegisterWord='ImmEnumRegisterWordA';
 %end; /* !UNICODE */

 %if WINVER >= 1034 %then %do;
 dcl ImmDisableIME
     entry (type DWORD )
     returns (type BOOL byvalue optional)
     WINAPI external('ImmDisableIME');
 dcl ImmEnumInputContext
     entry (type DWORD,
            type IMCENUMPROC,
            type LPARAM)
     returns (type BOOL byvalue optional)
     WINAPI external('ImmEnumInputContext');
 dcl ImmGetImeMenuItemsA
     entry (type HIMC,
            type DWORD,
            type DWORD,
            type IMEMENUITEMINFOA byaddr,
            type IMEMENUITEMINFOA byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetImeMenuItemsA');
 dcl ImmGetImeMenuItemsW
     entry (type HIMC,
            type DWORD,
            type DWORD,
            type IMEMENUITEMINFOW byaddr,
            type IMEMENUITEMINFOW byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('ImmGetImeMenuItemsW');

 %dcl ImmGetImeMenuItems char ext;
 %if UNICODE ^= '' %then %do;
   %ImmGetImeMenuItems='ImmGetImeMenuItemsW';
 %end; %else %do;
   %ImmGetImeMenuItems='ImmGetImeMenuItemsA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x040A */

 /* wParam for WM_IME_CONTROL */
 dcl IMC_GETCANDIDATEPOS            type WPARAM value('0007'xu);
 dcl IMC_SETCANDIDATEPOS            type WPARAM value('0008'xu);
 dcl IMC_GETCOMPOSITIONFONT         type WPARAM value('0009'xu);
 dcl IMC_SETCOMPOSITIONFONT         type WPARAM value('000A'xu);
 dcl IMC_GETCOMPOSITIONWINDOW       type WPARAM value('000B'xu);
 dcl IMC_SETCOMPOSITIONWINDOW       type WPARAM value('000C'xu);
 dcl IMC_GETSTATUSWINDOWPOS         type WPARAM value('000F'xu);
 dcl IMC_SETSTATUSWINDOWPOS         type WPARAM value('0010'xu);
 dcl IMC_CLOSESTATUSWINDOW          type WPARAM value('0021'xu);
 dcl IMC_OPENSTATUSWINDOW           type WPARAM value('0022'xu);


 /* dwAction for ImmNotifyIME */
 dcl NI_OPENCANDIDATE               type DWORD value('0010'xu);
 dcl NI_CLOSECANDIDATE              type DWORD value('0011'xu);
 dcl NI_SELECTCANDIDATESTR          type DWORD value('0012'xu);
 dcl NI_CHANGECANDIDATELIST         type DWORD value('0013'xu);
 dcl NI_FINALIZECONVERSIONRESULT    type DWORD value('0014'xu);
 dcl NI_COMPOSITIONSTR              type DWORD value('0015'xu);
 dcl NI_SETCANDIDATE_PAGESTART      type DWORD value('0016'xu);
 dcl NI_SETCANDIDATE_PAGESIZE       type DWORD value('0017'xu);
 dcl NI_IMEMENUSELECTED             type DWORD value('0018'xu);

 /* lParam for WM_IME_SETCONTEXT */
 dcl ISC_SHOWUICANDIDATEWINDOW      type LPARAM value('00000001'xn);
 dcl ISC_SHOWUICOMPOSITIONWINDOW    type LPARAM value('80000000'xn);
 dcl ISC_SHOWUIGUIDELINE            type LPARAM value('40000000'xn);
 dcl ISC_SHOWUIALLCANDIDATEWINDOW   type LPARAM value('0000000F'xn);
 dcl ISC_SHOWUIALL                  type LPARAM value('C000000F'xn);


 /* dwIndex for ImmNotifyIME/NI_COMPOSITIONSTR */
 dcl CPS_COMPLETE                   type DWORD value('0001'xu);
 dcl CPS_CONVERT                    type DWORD value('0002'xu);
 dcl CPS_REVERT                     type DWORD value('0003'xu);
 dcl CPS_CANCEL                     type DWORD value('0004'xu);

 /* the modifiers of hot key - see winuser.cpy */
 /* dcl MOD_ALT                     type DWORD value('0001'xu) */
 /* dcl MOD_CONTROL                 type DWORD value('0002'xu) */
 /* dcl MOD_SHIFT                   type DWORD value('0004'xu) */

 dcl MOD_LEFT                       type DWORD value('8000'xu);
 dcl MOD_RIGHT                      type DWORD value('4000'xu);

 dcl MOD_ON_KEYUP                   type DWORD value('0800'xu);
 dcl MOD_IGNORE_ALL_MODIFIER        type DWORD value('0400'xu);

 /* Windows for Simplified Chinese Edition hot key ID from 0x10-0x2F */
 dcl IME_CHOTKEY_IME_NONIME_TOGGLE  type DWORD value('10'xu);
 dcl IME_CHOTKEY_SHAPE_TOGGLE       type DWORD value('11'xu);
 dcl IME_CHOTKEY_SYMBOL_TOGGLE      type DWORD value('12'xu);

 /* Windows for Japanese Edition hot key ID from 0x30 - 0x4F */
 dcl IME_JHOTKEY_CLOSE_OPEN         type DWORD value('30'xu);

 /* Windows for Korean Edition hot key ID from 0x50 - 0x6F */
 dcl IME_KHOTKEY_SHAPE_TOGGLE       type DWORD value('50'xu);
 dcl IME_KHOTKEY_HANJACONVERT       type DWORD value('51'xu);
 dcl IME_KHOTKEY_ENGLISH            type DWORD value('52'xu);

 /* Windows for Traditional Chinese Edition hot key ID from 0x70-0x8F */
 dcl IME_THOTKEY_IME_NONIME_TOGGLE  type DWORD value('70'xu);
 dcl IME_THOTKEY_SHAPE_TOGGLE       type DWORD value('71'xu);
 dcl IME_THOTKEY_SYMBOL_TOGGLE      type DWORD value('72'xu);

 /* direct switch hot key ID from 0x100 - 0x11F */
 dcl IME_HOTKEY_DSWITCH_FIRST       type DWORD value('100'xu);
 dcl IME_HOTKEY_DSWITCH_LAST        type DWORD value('11F'xu);

 /* IME private hot key from 0x200 - 0x21F */
 dcl IME_HOTKEY_PRIVATE_FIRST       type DWORD value('200'xu);
 dcl IME_ITHOTKEY_RESEND_RESULTSTR  type DWORD value('200'xu);
 dcl IME_ITHOTKEY_PREVIOUS_COMPOSITION type DWORD value('201'xu);
 dcl IME_ITHOTKEY_UISTYLE_TOGGLE    type DWORD value('202'xu);
 dcl IME_ITHOTKEY_RECONVERTSTRING   type DWORD value('203'xu);
 dcl IME_HOTKEY_PRIVATE_LAST        type DWORD value('21F'xu);


 /* parameter of ImmGetCompositionString */
 dcl GCS_COMPREADSTR                type DWORD value('0001'xu);
 dcl GCS_COMPREADATTR               type DWORD value('0002'xu);
 dcl GCS_COMPREADCLAUSE             type DWORD value('0004'xu);
 dcl GCS_COMPSTR                    type DWORD value('0008'xu);
 dcl GCS_COMPATTR                   type DWORD value('0010'xu);
 dcl GCS_COMPCLAUSE                 type DWORD value('0020'xu);
 dcl GCS_CURSORPOS                  type DWORD value('0080'xu);
 dcl GCS_DELTASTART                 type DWORD value('0100'xu);
 dcl GCS_RESULTREADSTR              type DWORD value('0200'xu);
 dcl GCS_RESULTREADCLAUSE           type DWORD value('0400'xu);
 dcl GCS_RESULTSTR                  type DWORD value('0800'xu);
 dcl GCS_RESULTCLAUSE               type DWORD value('1000'xu);

 /* style bit flags for WM_IME_COMPOSITION */
 dcl CS_INSERTCHAR                  type DWORD value('2000'xu);
 dcl CS_NOMOVECARET                 type DWORD value('4000'xu);

 /* IME version constants */
 dcl IMEVER_0310                    type DWORD value('0003000A'xu);
 dcl IMEVER_0400                    type DWORD value('00040000'xu);


 /* IME property bits */
 dcl IME_PROP_AT_CARET              type DWORD value('00010000'xu);
 dcl IME_PROP_SPECIAL_UI            type DWORD value('00020000'xu);
 dcl IME_PROP_CANDLIST_START_FROM_1 type DWORD value('00040000'xu);
 dcl IME_PROP_UNICODE               type DWORD value('00080000'xu);
 dcl IME_PROP_COMPLETE_ON_UNSELECT  type DWORD value('00100000'xu);


 /* IME UICapability bits */
 dcl UI_CAP_2700                    type DWORD value('00000001'xu);
 dcl UI_CAP_ROT90                   type DWORD value('00000002'xu);
 dcl UI_CAP_ROTANY                  type DWORD value('00000004'xu);

 /* ImmSetCompositionString Capability bits */
 dcl SCS_CAP_COMPSTR                type DWORD value('00000001'xu);
 dcl SCS_CAP_MAKEREAD               type DWORD value('00000002'xu);
 dcl SCS_CAP_SETRECONVERTSTRING     type DWORD value('00000004'xu);


 /* IME WM_IME_SELECT inheritance Capability bits */
 dcl SELECT_CAP_CONVERSION          type DWORD value('00000001'xu);
 dcl SELECT_CAP_SENTENCE            type DWORD value('00000002'xu);


 /* ID for deIndex of ImmGetGuideLine */
 dcl GGL_LEVEL                      type DWORD value('00000001'xu);
 dcl GGL_INDEX                      type DWORD value('00000002'xu);
 dcl GGL_STRING                     type DWORD value('00000003'xu);
 dcl GGL_PRIVATE                    type DWORD value('00000004'xu);


 /* ID for dwLevel of GUIDELINE Structure */
 dcl GL_LEVEL_NOGUIDELINE           type DWORD value('00000000'xu);
 dcl GL_LEVEL_FATAL                 type DWORD value('00000001'xu);
 dcl GL_LEVEL_ERROR                 type DWORD value('00000002'xu);
 dcl GL_LEVEL_WARNING               type DWORD value('00000003'xu);
 dcl GL_LEVEL_INFORMATION           type DWORD value('00000004'xu);


 /* ID for dwIndex of GUIDELINE Structure */
 dcl GL_ID_UNKNOWN                  type DWORD value('00000000'xu);
 dcl GL_ID_NOMODULE                 type DWORD value('00000001'xu);
 dcl GL_ID_NODICTIONARY             type DWORD value('00000010'xu);
 dcl GL_ID_CANNOTSAVE               type DWORD value('00000011'xu);
 dcl GL_ID_NOCONVERT                type DWORD value('00000020'xu);
 dcl GL_ID_TYPINGERROR              type DWORD value('00000021'xu);
 dcl GL_ID_TOOMANYSTROKE            type DWORD value('00000022'xu);
 dcl GL_ID_READINGCONFLICT          type DWORD value('00000023'xu);
 dcl GL_ID_INPUTREADING             type DWORD value('00000024'xu);
 dcl GL_ID_INPUTRADICAL             type DWORD value('00000025'xu);
 dcl GL_ID_INPUTCODE                type DWORD value('00000026'xu);
 dcl GL_ID_INPUTSYMBOL              type DWORD value('00000027'xu);
 dcl GL_ID_CHOOSECANDIDATE          type DWORD value('00000028'xu);
 dcl GL_ID_REVERSECONVERSION        type DWORD value('00000029'xu);
 dcl GL_ID_PRIVATE_FIRST            type DWORD value('00008000'xu);
 dcl GL_ID_PRIVATE_LAST             type DWORD value('0000FFFF'xu);


 /* ID for dwIndex of ImmGetProperty */
 dcl IGP_GETIMEVERSION              type DWORD value(iunsigned(-4));
 dcl IGP_PROPERTY                   type DWORD value('00000004'xu);
 dcl IGP_CONVERSION                 type DWORD value('00000008'xu);
 dcl IGP_SENTENCE                   type DWORD value('0000000c'xu);
 dcl IGP_UI                         type DWORD value('00000010'xu);
 dcl IGP_SETCOMPSTR                 type DWORD value('00000014'xu);
 dcl IGP_SELECT                     type DWORD value('00000018'xu);

 dcl SCS_SETSTR               type DWORD value (ior (GCS_COMPREADSTR,
                                                     GCS_COMPSTR));
 dcl SCS_CHANGEATTR           type DWORD value (ior (GCS_COMPREADATTR,
                                                     GCS_COMPATTR));
 dcl SCS_CHANGECLAUSE         type DWORD value (ior (GCS_COMPREADCLAUSE,
                                                     GCS_COMPCLAUSE));

 dcl SCS_SETRECONVERTSTRING         type DWORD value('00010000'xu);
 dcl SCS_QUERYRECONVERTSTRING       type DWORD value('00020000'xu);

 /* attribute for COMPOSITIONSTRING Structure */
 dcl ATTR_INPUT                     type DWORD value('00'xu);
 dcl ATTR_TARGET_CONVERTED          type DWORD value('01'xu);
 dcl ATTR_CONVERTED                 type DWORD value('02'xu);
 dcl ATTR_TARGET_NOTCONVERTED       type DWORD value('03'xu);
 dcl ATTR_INPUT_ERROR               type DWORD value('04'xu);
 dcl ATTR_FIXEDCONVERTED            type DWORD value('05'xu);

 /* bit field for IMC_SETCOMPOSITIONWINDOW, IMC_SETCANDIDATEWINDOW */
 dcl CFS_DEFAULT                    type DWORD value('0000'xu);
 dcl CFS_RECT                       type DWORD value('0001'xu);
 dcl CFS_POINT                      type DWORD value('0002'xu);
 dcl CFS_FORCE_POSITION             type DWORD value('0020'xu);
 dcl CFS_CANDIDATEPOS               type DWORD value('0040'xu);
 dcl CFS_EXCLUDE                    type DWORD value('0080'xu);

 /* conversion direction for ImmGetConversionList */
 dcl GCL_CONVERSION                 type DWORD value('0001'xu);
 dcl GCL_REVERSECONVERSION          type DWORD value('0002'xu);
 dcl GCL_REVERSE_LENGTH             type DWORD value('0003'xu);

 /* bit field for conversion mode */
 dcl IME_CMODE_ALPHANUMERIC         type DWORD value('0000'xu);
 dcl IME_CMODE_NATIVE               type DWORD value('0001'xu);
 dcl IME_CMODE_CHINESE              type DWORD value(IME_CMODE_NATIVE);
 /* IME_CMODE_HANGEUL is old name of IME_CMODE_HANGUL. */
 /* It will be gone eventually. */
 dcl IME_CMODE_HANGEUL              type DWORD value(IME_CMODE_NATIVE);
 dcl IME_CMODE_HANGUL               type DWORD value(IME_CMODE_NATIVE);
 dcl IME_CMODE_JAPANESE             type DWORD value(IME_CMODE_NATIVE);
 dcl IME_CMODE_KATAKANA             type DWORD value('0002'xu);
 /* only effect under IME_CMODE_NATIVE */
 dcl IME_CMODE_LANGUAGE             type DWORD value('0003'xu);
 dcl IME_CMODE_FULLSHAPE            type DWORD value('0008'xu);
 dcl IME_CMODE_ROMAN                type DWORD value('0010'xu);
 dcl IME_CMODE_CHARCODE             type DWORD value('0020'xu);
 dcl IME_CMODE_HANJACONVERT         type DWORD value('0040'xu);
 dcl IME_CMODE_SOFTKBD              type DWORD value('0080'xu);
 dcl IME_CMODE_NOCONVERSION         type DWORD value('0100'xu);
 dcl IME_CMODE_EUDC                 type DWORD value('0200'xu);
 dcl IME_CMODE_SYMBOL               type DWORD value('0400'xu);
 dcl IME_CMODE_FIXED                type DWORD value('0800'xu);

 /* bit field for sentence mode */
 dcl IME_SMODE_NONE                 type DWORD value('0000'xu);
 dcl IME_SMODE_PLAURALCLAUSE        type DWORD value('0001'xu);
 dcl IME_SMODE_SINGLECONVERT        type DWORD value('0002'xu);
 dcl IME_SMODE_AUTOMATIC            type DWORD value('0004'xu);
 dcl IME_SMODE_PHRASEPREDICT        type DWORD value('0008'xu);
 dcl IME_SMODE_CONVERSATION         type DWORD value('0010'xu);

 /* style of candidate */
 dcl IME_CAND_UNKNOWN               type DWORD value('0000'xu);
 dcl IME_CAND_READ                  type DWORD value('0001'xu);
 dcl IME_CAND_CODE                  type DWORD value('0002'xu);
 dcl IME_CAND_MEANING               type DWORD value('0003'xu);
 dcl IME_CAND_RADICAL               type DWORD value('0004'xu);
 dcl IME_CAND_STROKE                type DWORD value('0005'xu);

 /* wParam of report message WM_IME_NOTIFY */
 dcl IMN_CLOSESTATUSWINDOW          type WPARAM value('0001'xu);
 dcl IMN_OPENSTATUSWINDOW           type WPARAM value('0002'xu);
 dcl IMN_CHANGECANDIDATE            type WPARAM value('0003'xu);
 dcl IMN_CLOSECANDIDATE             type WPARAM value('0004'xu);
 dcl IMN_OPENCANDIDATE              type WPARAM value('0005'xu);
 dcl IMN_SETCONVERSIONMODE          type WPARAM value('0006'xu);
 dcl IMN_SETSENTENCEMODE            type WPARAM value('0007'xu);
 dcl IMN_SETOPENSTATUS              type WPARAM value('0008'xu);
 dcl IMN_SETCANDIDATEPOS            type WPARAM value('0009'xu);
 dcl IMN_SETCOMPOSITIONFONT         type WPARAM value('000A'xu);
 dcl IMN_SETCOMPOSITIONWINDOW       type WPARAM value('000B'xu);
 dcl IMN_SETSTATUSWINDOWPOS         type WPARAM value('000C'xu);
 dcl IMN_GUIDELINE                  type WPARAM value('000D'xu);
 dcl IMN_PRIVATE                    type WPARAM value('000E'xu);

 %if WINVER >= 1034 %then %do;
 /* wParam of report message WM_IME_REQUEST */
 dcl IMR_COMPOSITIONWINDOW          type WPARAM value('0001'xu);
 dcl IMR_CANDIDATEWINDOW            type WPARAM value('0002'xu);
 dcl IMR_COMPOSITIONFONT            type WPARAM value('0003'xu);
 dcl IMR_RECONVERTSTRING            type WPARAM value('0004'xu);
 dcl IMR_CONFIRMRECONVERTSTRING     type WPARAM value('0005'xu);
 dcl IMR_QUERYCHARPOSITION          type WPARAM value('0006'xu);
 dcl IMR_DOCUMENTFEED               type WPARAM value('0007'xu);
 %end; /* WINVER >= 0x040A */

 /* error code of ImmGetCompositionString */
 dcl IMM_ERROR_NODATA               type LONG value(-1);
 dcl IMM_ERROR_GENERAL              type LONG value(-2);


 /* dialog mode of ImmConfigureIME */
 dcl IME_CONFIG_GENERAL             type DWORD value(1);
 dcl IME_CONFIG_REGISTERWORD        type DWORD value(2);
 dcl IME_CONFIG_SELECTDICTIONARY    type DWORD value(3);


 /* flags for ImmEscape */
 dcl IME_ESC_QUERY_SUPPORT          type DWORD value('0003'xu);
 dcl IME_ESC_RESERVED_FIRST         type DWORD value('0004'xu);
 dcl IME_ESC_RESERVED_LAST          type DWORD value('07FF'xu);
 dcl IME_ESC_PRIVATE_FIRST          type DWORD value('0800'xu);
 dcl IME_ESC_PRIVATE_LAST           type DWORD value('0FFF'xu);

 dcl IME_ESC_SEQUENCE_TO_INTERNAL   type DWORD value('1001'xu);
 dcl IME_ESC_GET_EUDC_DICTIONARY    type DWORD value('1003'xu);
 dcl IME_ESC_SET_EUDC_DICTIONARY    type DWORD value('1004'xu);
 dcl IME_ESC_MAX_KEY                type DWORD value('1005'xu);
 dcl IME_ESC_IME_NAME               type DWORD value('1006'xu);
 dcl IME_ESC_SYNC_HOTKEY            type DWORD value('1007'xu);
 dcl IME_ESC_HANJA_MODE             type DWORD value('1008'xu);
 dcl IME_ESC_AUTOMATA               type DWORD value('1009'xu);
 dcl IME_ESC_PRIVATE_HOTKEY         type DWORD value('100a'xu);
 dcl IME_ESC_GETHELPFILENAME        type DWORD value('100b'xu);
 /* style of word registration */
 dcl IME_REGWORD_STYLE_EUDC         type DWORD value('00000001'xu);
 dcl IME_REGWORD_STYLE_USER_FIRST   type DWORD value('80000000'xu);
 dcl IME_REGWORD_STYLE_USER_LAST    type DWORD value('FFFFFFFF'xu);


 %if WINVER >= 1034 %then %do;

 /* dwFlags for ImmAssociateContextEx */
 dcl IACE_CHILDREN                  type DWORD value('0001'xu);
 dcl IACE_DEFAULT                   type DWORD value('0010'xu);
 dcl IACE_IGNORENOCONTEXT           type DWORD value('0020'xu);

 /* dwFlags for ImmGetImeMenuItems */
 dcl IGIMIF_RIGHTMENU               type DWORD value('0001'xu);

 /* dwType for ImmGetImeMenuItems */
 dcl IGIMII_CMODE                   type DWORD value('0001'xu);
 dcl IGIMII_SMODE                   type DWORD value('0002'xu);
 dcl IGIMII_CONFIGURE               type DWORD value('0004'xu);
 dcl IGIMII_TOOLS                   type DWORD value('0008'xu);
 dcl IGIMII_HELP                    type DWORD value('0010'xu);
 dcl IGIMII_OTHER                   type DWORD value('0020'xu);
 dcl IGIMII_INPUTTOOLS              type DWORD value('0040'xu);

 /* fType of IMEMENUITEMINFO structure */
 dcl IMFT_RADIOCHECK                type UINT value('00001'xu);
 dcl IMFT_SEPARATOR                 type UINT value('00002'xu);
 dcl IMFT_SUBMENU                   type UINT value('00004'xu);

 /* fState of IMEMENUITEMINFO structure */
 dcl IMFS_GRAYED                    type UINT value(MFS_GRAYED);
 dcl IMFS_DISABLED                  type UINT value(MFS_DISABLED);
 dcl IMFS_CHECKED                   type UINT value(MFS_CHECKED);
 dcl IMFS_HILITE                    type UINT value(MFS_HILITE);
 dcl IMFS_ENABLED                   type UINT value(MFS_ENABLED);
 dcl IMFS_UNCHECKED                 type UINT value(MFS_UNCHECKED);
 dcl IMFS_UNHILITE                  type UINT value(MFS_UNHILITE);
 dcl IMFS_DEFAULT                   type UINT value(MFS_DEFAULT);

 %end; /* WINVER >= 0x040A */

 /* type of soft keyboard */
 /* for Windows Tranditional Chinese Edition */
 dcl SOFTKEYBOARD_TYPE_T1           type DWORD value('0001'xu);
 /* for Windows Simplified Chinese Edition */
 dcl SOFTKEYBOARD_TYPE_C1           type DWORD value('0002'xu);

 %end; /* _IMM_SDK_DEFINED_ */
 %end; /* _IMM_ */
