 /* ++ BUILD Version: 0002                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1991-1999 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmaccess.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes, and         */
 /*   definitions for the NetUser, NetUserModals, NetGroup,           */
 /*   NetAccess, and NetLogon API.                                    */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*  You must include NETCONS.CPY before this file, since this file   */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */


 /* User Class */


 %dcl #LMUSER_ char ext;
 %if #LMUSER_ = '' %then %do;
 %#LMUSER_ = 'Y';

 %dcl NETCONS_INCLUDED char ext;
 %if NETCONS_INCLUDED = '' %then %do;
 %include lmcons; /* unfortunately created a dependence on this */
 %end;

 /* Function Prototypes - User */

 dcl NetUserAdd
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserAdd');

 dcl NetUserEnum
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserEnum');

 dcl NetUserGetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserGetInfo');

 dcl NetUserSetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserSetInfo');

 dcl NetUserDel
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserDel');

 dcl NetUserGetGroups
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserGetGroups');

 dcl NetUserSetGroups
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserSetGroups');

 dcl NetUserGetLocalGroups
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserGetLocalGroups');

 dcl NetUserModalsGet
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserModalsGet');

 dcl NetUserModalsSet
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserModalsSet');

 dcl NetUserChangePassword
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUserChangePassword');


 /*  Data Structures - User */

 define structure
   1 USER_INFO_0,
     2 usri0_name type LPWSTR;
 define alias  PUSER_INFO_0 handle USER_INFO_0;
 define alias LPUSER_INFO_0 handle USER_INFO_0;

 define structure
   1 USER_INFO_1,
     2 usri1_name         type LPWSTR,
     2 usri1_password     type LPWSTR,
     2 usri1_password_age type DWORD,
     2 usri1_priv         type DWORD,
     2 usri1_home_dir     type LPWSTR,
     2 usri1_comment      type LPWSTR,
     2 usri1_flags        type DWORD,
     2 usri1_script_path  type LPWSTR;
 define alias  PUSER_INFO_1 handle USER_INFO_1;
 define alias LPUSER_INFO_1 handle USER_INFO_1;

 define structure
   1 USER_INFO_2,
     2 usri2_name           type LPWSTR,
     2 usri2_password       type LPWSTR,
     2 usri2_password_age   type DWORD,
     2 usri2_priv           type DWORD,
     2 usri2_home_dir       type LPWSTR,
     2 usri2_comment        type LPWSTR,
     2 usri2_flags          type DWORD,
     2 usri2_script_path    type LPWSTR,
     2 usri2_auth_flags     type DWORD,
     2 usri2_full_name      type LPWSTR,
     2 usri2_usr_comment    type LPWSTR,
     2 usri2_parms          type LPWSTR,
     2 usri2_workstations   type LPWSTR,
     2 usri2_last_logon     type DWORD,
     2 usri2_last_logoff    type DWORD,
     2 usri2_acct_expires   type DWORD,
     2 usri2_max_storage    type DWORD,
     2 usri2_units_per_week type DWORD,
     2 usri2_logon_hours    type PBYTE,
     2 usri2_bad_pw_count   type DWORD,
     2 usri2_num_logons     type DWORD,
     2 usri2_logon_server   type LPWSTR,
     2 usri2_country_code   type DWORD,
     2 usri2_code_page      type DWORD;
 define alias  PUSER_INFO_2 handle USER_INFO_2;
 define alias LPUSER_INFO_2 handle USER_INFO_2;

 define structure
   1 USER_INFO_3,
     2 usri3_name             type LPWSTR,
     2 usri3_password         type LPWSTR,
     2 usri3_password_age     type DWORD,
     2 usri3_priv             type DWORD,
     2 usri3_home_dir         type LPWSTR,
     2 usri3_comment          type LPWSTR,
     2 usri3_flags            type DWORD,
     2 usri3_script_path      type LPWSTR,
     2 usri3_auth_flags       type DWORD,
     2 usri3_full_name        type LPWSTR,
     2 usri3_usr_comment      type LPWSTR,
     2 usri3_parms            type LPWSTR,
     2 usri3_workstations     type LPWSTR,
     2 usri3_last_logon       type DWORD,
     2 usri3_last_logoff      type DWORD,
     2 usri3_acct_expires     type DWORD,
     2 usri3_max_storage      type DWORD,
     2 usri3_units_per_week   type DWORD,
     2 usri3_logon_hours      type PBYTE,
     2 usri3_bad_pw_count     type DWORD,
     2 usri3_num_logons       type DWORD,
     2 usri3_logon_server     type LPWSTR,
     2 usri3_country_code     type DWORD,
     2 usri3_code_page        type DWORD,
     2 usri3_user_id          type DWORD,
     2 usri3_primary_group_id type DWORD,
     2 usri3_profile          type LPWSTR,
     2 usri3_home_dir_drive   type LPWSTR,
     2 usri3_password_expired type DWORD;
 define alias  PUSER_INFO_3 handle USER_INFO_3;
 define alias LPUSER_INFO_3 handle USER_INFO_3;

 define structure
   1 USER_INFO_10,
     2 usri10_name        type LPWSTR,
     2 usri10_comment     type LPWSTR,
     2 usri10_usr_comment type LPWSTR,
     2 usri10_full_name   type LPWSTR;
 define alias  PUSER_INFO_10 handle USER_INFO_10;
 define alias LPUSER_INFO_10 handle USER_INFO_10;

 define structure
   1 USER_INFO_11,
     2 usri11_name           type LPWSTR,
     2 usri11_comment        type LPWSTR,
     2 usri11_usr_comment    type LPWSTR,
     2 usri11_full_name      type LPWSTR,
     2 usri11_priv           type DWORD,
     2 usri11_auth_flags     type DWORD,
     2 usri11_password_age   type DWORD,
     2 usri11_home_dir       type LPWSTR,
     2 usri11_parms          type LPWSTR,
     2 usri11_last_logon     type DWORD,
     2 usri11_last_logoff    type DWORD,
     2 usri11_bad_pw_count   type DWORD,
     2 usri11_num_logons     type DWORD,
     2 usri11_logon_server   type LPWSTR,
     2 usri11_country_code   type DWORD,
     2 usri11_workstations   type LPWSTR,
     2 usri11_max_storage    type DWORD,
     2 usri11_units_per_week type DWORD,
     2 usri11_logon_hours    type PBYTE,
     2 usri11_code_page      type DWORD;
 define alias  PUSER_INFO_11 handle USER_INFO_11;
 define alias LPUSER_INFO_11 handle USER_INFO_11;

 define structure
   1 USER_INFO_20,
     2 usri20_name      type LPWSTR,
     2 usri20_full_name type LPWSTR,
     2 usri20_comment   type LPWSTR,
     2 usri20_flags     type DWORD,
     2 usri20_user_id   type DWORD;
 define alias  PUSER_INFO_20 handle USER_INFO_20;
 define alias LPUSER_INFO_20 handle USER_INFO_20;

 define structure
   1 USER_INFO_21,
     2 usri21_password (ENCRYPTED_PWLEN) type BYTE;
 define alias  PUSER_INFO_21 handle USER_INFO_21;
 define alias LPUSER_INFO_21 handle USER_INFO_21;

 define structure
   1 USER_INFO_22,
     2 usri22_name           type LPWSTR,
     2 usri22_password (ENCRYPTED_PWLEN) type BYTE,
     2 usri22_password_age   type DWORD,
     2 usri22_priv           type DWORD,
     2 usri22_home_dir       type LPWSTR,
     2 usri22_comment        type LPWSTR,
     2 usri22_flags          type DWORD,
     2 usri22_script_path    type LPWSTR,
     2 usri22_auth_flags     type DWORD,
     2 usri22_full_name      type LPWSTR,
     2 usri22_usr_comment    type LPWSTR,
     2 usri22_parms          type LPWSTR,
     2 usri22_workstations   type LPWSTR,
     2 usri22_last_logon     type DWORD,
     2 usri22_last_logoff    type DWORD,
     2 usri22_acct_expires   type DWORD,
     2 usri22_max_storage    type DWORD,
     2 usri22_units_per_week type DWORD,
     2 usri22_logon_hours    type PBYTE,
     2 usri22_bad_pw_count   type DWORD,
     2 usri22_num_logons     type DWORD,
     2 usri22_logon_server   type LPWSTR,
     2 usri22_country_code   type DWORD,
     2 usri22_code_page      type DWORD;
 define alias  PUSER_INFO_22 handle USER_INFO_22;
 define alias LPUSER_INFO_22 handle USER_INFO_22;

 define structure
   1 USER_INFO_1003,
     2 usri1003_password type LPWSTR;
 define alias  PUSER_INFO_1003 handle USER_INFO_1003;
 define alias LPUSER_INFO_1003 handle USER_INFO_1003;

 define structure
   1 USER_INFO_1005,
     2 usri1005_priv     type DWORD;
 define alias  PUSER_INFO_1005 handle USER_INFO_1005;
 define alias LPUSER_INFO_1005 handle USER_INFO_1005;

 define structure
   1 USER_INFO_1006,
     2 usri1006_home_dir type LPWSTR;
 define alias  PUSER_INFO_1006 handle USER_INFO_1006;
 define alias LPUSER_INFO_1006 handle USER_INFO_1006;

 define structure
   1 USER_INFO_1007,
     2 usri1007_comment type LPWSTR;
 define alias  PUSER_INFO_1007 handle USER_INFO_1007;
 define alias LPUSER_INFO_1007 handle USER_INFO_1007;

 define structure
   1 USER_INFO_1008,
     2 usri1008_flags   type DWORD;
 define alias  PUSER_INFO_1008 handle USER_INFO_1008;
 define alias LPUSER_INFO_1008 handle USER_INFO_1008;

 define structure
   1 USER_INFO_1009,
     2 usri1009_script_path type LPWSTR;
 define alias  PUSER_INFO_1009 handle USER_INFO_1009;
 define alias LPUSER_INFO_1009 handle USER_INFO_1009;

 define structure
   1 USER_INFO_1010,
     2 usri1010_auth_flags type DWORD;
 define alias  PUSER_INFO_1010 handle USER_INFO_1010;
 define alias LPUSER_INFO_1010 handle USER_INFO_1010;

 define structure
   1 USER_INFO_1011,
     2 usri1011_full_name type LPWSTR;
 define alias  PUSER_INFO_1011 handle USER_INFO_1011;
 define alias LPUSER_INFO_1011 handle USER_INFO_1011;

 define structure
   1 USER_INFO_1012,
     2 usri1012_usr_comment type LPWSTR;
 define alias  PUSER_INFO_1012 handle USER_INFO_1012;
 define alias LPUSER_INFO_1012 handle USER_INFO_1012;

 define structure
   1 USER_INFO_1013,
     2 usri1013_parms type LPWSTR;
 define alias  PUSER_INFO_1013 handle USER_INFO_1013;
 define alias LPUSER_INFO_1013 handle USER_INFO_1013;

 define structure
   1 USER_INFO_1014,
     2 usri1014_workstations type LPWSTR;
 define alias  PUSER_INFO_1014 handle USER_INFO_1014;
 define alias LPUSER_INFO_1014 handle USER_INFO_1014;

 define structure
   1 USER_INFO_1017,
     2 usri1017_acct_expires type DWORD;
 define alias  PUSER_INFO_1017 handle USER_INFO_1017;
 define alias LPUSER_INFO_1017 handle USER_INFO_1017;

 define structure
   1 USER_INFO_1018,
     2 usri1018_max_storage type DWORD;
 define alias  PUSER_INFO_1018 handle USER_INFO_1018;
 define alias LPUSER_INFO_1018 handle USER_INFO_1018;

 define structure
   1 USER_INFO_1020,
     2 usri1020_units_per_week type DWORD,
     2 usri1020_logon_hours    type LPBYTE;
 define alias  PUSER_INFO_1020 handle USER_INFO_1020;
 define alias LPUSER_INFO_1020 handle USER_INFO_1020;

 define structure
   1 USER_INFO_1023,
     2 usri1023_logon_server type LPWSTR;
 define alias  PUSER_INFO_1023 handle USER_INFO_1023;
 define alias LPUSER_INFO_1023 handle USER_INFO_1023;

 define structure
   1 USER_INFO_1024,
     2 usri1024_country_code type DWORD;
 define alias  PUSER_INFO_1024 handle USER_INFO_1024;
 define alias LPUSER_INFO_1024 handle USER_INFO_1024;

 define structure
   1 USER_INFO_1025,
     2 usri1025_code_page type DWORD;
 define alias  PUSER_INFO_1025 handle USER_INFO_1025;
 define alias LPUSER_INFO_1025 handle USER_INFO_1025;

 define structure
   1 USER_INFO_1051,
     2 usri1051_primary_group_id type DWORD;
 define alias  PUSER_INFO_1051 handle USER_INFO_1051;
 define alias LPUSER_INFO_1051 handle USER_INFO_1051;

 define structure
   1 USER_INFO_1052,
     2 usri1052_profile type LPWSTR;
 define alias  PUSER_INFO_1052 handle USER_INFO_1052;
 define alias LPUSER_INFO_1052 handle USER_INFO_1052;

 define structure
   1 USER_INFO_1053,
     2 usri1053_home_dir_drive type LPWSTR;
 define alias  PUSER_INFO_1053 handle USER_INFO_1053;
 define alias LPUSER_INFO_1053 handle USER_INFO_1053;


 /*  Data Structures - User Modals */

 define structure
   1 USER_MODALS_INFO_0,
     2 usrmod0_min_passwd_len    type DWORD,
     2 usrmod0_max_passwd_age    type DWORD,
     2 usrmod0_min_passwd_age    type DWORD,
     2 usrmod0_force_logoff      type DWORD,
     2 usrmod0_password_hist_len type DWORD;
 define alias  PUSER_MODALS_INFO_0 handle USER_MODALS_INFO_0;
 define alias LPUSER_MODALS_INFO_0 handle USER_MODALS_INFO_0;

 define structure
   1 USER_MODALS_INFO_1,
     2 usrmod1_role    type DWORD,
     2 usrmod1_primary type LPWSTR;
 define alias  PUSER_MODALS_INFO_1 handle USER_MODALS_INFO_1;
 define alias LPUSER_MODALS_INFO_1 handle USER_MODALS_INFO_1;

 define structure
   1 USER_MODALS_INFO_2,
     2 usrmod2_domain_name type LPWSTR,
     2 usrmod2_domain_id   type PSID;
 define alias  PUSER_MODALS_INFO_2 handle USER_MODALS_INFO_2;
 define alias LPUSER_MODALS_INFO_2 handle USER_MODALS_INFO_2;

 define structure
   1 USER_MODALS_INFO_3,
     2 usrmod3_lockout_duration           type DWORD,
     2 usrmod3_lockout_observation_window type DWORD,
     2 usrmod3_lockout_threshold          type DWORD;
 define alias  PUSER_MODALS_INFO_3 handle USER_MODALS_INFO_3;
 define alias LPUSER_MODALS_INFO_3 handle USER_MODALS_INFO_3;

 define structure
   1 USER_MODALS_INFO_1001,
     2 usrmod1001_min_passwd_len type DWORD;
 define alias  PUSER_MODALS_INFO_1001 handle USER_MODALS_INFO_1001;
 define alias LPUSER_MODALS_INFO_1001 handle USER_MODALS_INFO_1001;

 define structure
   1 USER_MODALS_INFO_1002,
     2 usrmod1002_max_passwd_age type DWORD;
 define alias  PUSER_MODALS_INFO_1002 handle USER_MODALS_INFO_1002;
 define alias LPUSER_MODALS_INFO_1002 handle USER_MODALS_INFO_1002;

 define structure
   1 USER_MODALS_INFO_1003,
     2 usrmod1003_min_passwd_age type DWORD;
 define alias  PUSER_MODALS_INFO_1003 handle USER_MODALS_INFO_1003;
 define alias LPUSER_MODALS_INFO_1003 handle USER_MODALS_INFO_1003;

 define structure
   1 USER_MODALS_INFO_1004,
     2 usrmod1004_force_logoff type DWORD;
 define alias  PUSER_MODALS_INFO_1004 handle USER_MODALS_INFO_1004;
 define alias LPUSER_MODALS_INFO_1004 handle USER_MODALS_INFO_1004;

 define structure
   1 USER_MODALS_INFO_1005,
     2 usrmod1005_password_hist_len type DWORD;
 define alias  PUSER_MODALS_INFO_1005 handle USER_MODALS_INFO_1005;
 define alias LPUSER_MODALS_INFO_1005 handle USER_MODALS_INFO_1005;

 define structure
   1 USER_MODALS_INFO_1006,
     2 usrmod1006_role type DWORD;
 define alias  PUSER_MODALS_INFO_1006 handle USER_MODALS_INFO_1006;
 define alias LPUSER_MODALS_INFO_1006 handle USER_MODALS_INFO_1006;

 define structure
   1 USER_MODALS_INFO_1007,
     2 usrmod1007_primary type LPWSTR;
 define alias  PUSER_MODALS_INFO_1007 handle USER_MODALS_INFO_1007;
 define alias LPUSER_MODALS_INFO_1007 handle USER_MODALS_INFO_1007;


 /* Special Values and Constants - User */

 /*  Bit masks for field usriX_flags of USER_INFO_X (X = 0/1). */

/* Bit  masks for field usriX_flags of USER_INFO_X (X = 0/1). */

 dcl UF_SCRIPT                           type DWORD value('0001'xu);
dcl UF_ACCOUNTDISABLE                   type DWORD value('0002'xu);
dcl UF_HOMEDIR_REQUIRED                 type DWORD value('0008'xu);
dcl UF_LOCKOUT                          type DWORD value('0010'xu);
dcl UF_PASSWD_NOTREQD                   type DWORD value('0020'xu);
dcl UF_PASSWD_CANT_CHANGE               type DWORD value('0040'xu);
dcl UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED  type DWORD value('0080'xu);


/* Account  type bits as part of usri_flags. */

dcl UF_TEMP_DUPLICATE_ACCOUNT           type DWORD value('0100'xu);
dcl UF_NORMAL_ACCOUNT                   type DWORD value('0200'xu);
dcl UF_INTERDOMAIN_TRUST_ACCOUNT        type DWORD  value('0800'xu);
dcl UF_WORKSTATION_TRUST_ACCOUNT        type DWORD  value('1000'xu);
dcl UF_SERVER_TRUST_ACCOUNT             type DWORD value('2000'xu);

dcl UF_MACHINE_ACCOUNT_MASK             type DWORD
        value (ior (UF_INTERDOMAIN_TRUST_ACCOUNT,
                    UF_WORKSTATION_TRUST_ACCOUNT,
                    UF_SERVER_TRUST_ACCOUNT));

dcl UF_ACCOUNT_TYPE_MASK                type DWORD
        value (ior (UF_TEMP_DUPLICATE_ACCOUNT,
                    UF_NORMAL_ACCOUNT,
                    UF_INTERDOMAIN_TRUST_ACCOUNT,
                    UF_WORKSTATION_TRUST_ACCOUNT,
                    UF_SERVER_TRUST_ACCOUNT));

dcl UF_DONT_EXPIRE_PASSWD               type DWORD value( '10000'xu);
dcl UF_MNS_LOGON_ACCOUNT                type DWORD value( '20000'xu);
dcl UF_SMARTCARD_REQUIRED               type DWORD value( '40000'xu);
dcl UF_TRUSTED_FOR_DELEGATION           type DWORD value( '80000'xu);
dcl UF_NOT_DELEGATED                    type DWORD value('100000'xu);
dcl UF_USE_DES_KEY_ONLY                 type DWORD value('200000'xu);
dcl UF_DONT_REQUIRE_PREAUTH             type DWORD value('400000'xu);



dcl UF_SETTABLE_BITS                    type DWORD
        value (ior (UF_SCRIPT,
                    UF_ACCOUNTDISABLE,
                    UF_LOCKOUT,
                    UF_HOMEDIR_REQUIRED,
                    UF_PASSWD_NOTREQD,
                    UF_PASSWD_CANT_CHANGE,
                    UF_ACCOUNT_TYPE_MASK,
                    UF_DONT_EXPIRE_PASSWD,
                    UF_MNS_LOGON_ACCOUNT,
                    UF_ENCRYPTED_TEXT_PASSWORD_ALLOWED,
                    UF_SMARTCARD_REQUIRED,
                    UF_TRUSTED_FOR_DELEGATION,
                    UF_NOT_DELEGATED,
                    UF_USE_DES_KEY_ONLY,
                    UF_DONT_REQUIRE_PREAUTH));


/* bit  masks for the NetUserEnum filter parameter. */

dcl FILTER_TEMP_DUPLICATE_ACCOUNT       type DWORD value('0001'xu);
dcl FILTER_NORMAL_ACCOUNT               type DWORD value('0002'xu);
/* dcl  FILTER_PROXY_ACCOUNT            type DWORD value('0004'xu) */
dcl FILTER_INTERDOMAIN_TRUST_ACCOUNT    type DWORD value('0008'xu);
dcl FILTER_WORKSTATION_TRUST_ACCOUNT    type DWORD value('0010'xu);
dcl FILTER_SERVER_TRUST_ACCOUNT         type DWORD value('0020'xu);


/* bit  masks for the NetUserGetLocalGroups flags */

dcl LG_INCLUDE_INDIRECT type DWORD value('0001'xu);


 /*  Bit masks for field usri2_auth_flags of USER_INFO_2. */

 dcl AF_OP_PRINT         type DWORD value('1'xu);
 dcl AF_OP_COMM          type DWORD value('2'xu);
 dcl AF_OP_SERVER        type DWORD value('4'xu);
 dcl AF_OP_ACCOUNTS      type DWORD value('8'xu);
 dcl AF_SETTABLE_BITS    type DWORD value(ior(AF_OP_PRINT,
                                              AF_OP_COMM,
                                              AF_OP_SERVER,
                                              AF_OP_ACCOUNTS));

 /*  UAS role manifests under NETLOGON */

 dcl UAS_ROLE_STANDALONE         type DWORD value(0);
 dcl UAS_ROLE_MEMBER             type DWORD value(1);
 dcl UAS_ROLE_BACKUP             type DWORD value(2);
 dcl UAS_ROLE_PRIMARY            type DWORD value(3);


 /*  Values for ParmError for NetUserSetInfo. */

 dcl USER_NAME_PARMNUM           fixed bin(31) value( 1);
 dcl USER_PASSWORD_PARMNUM       fixed bin(31) value( 3);
 dcl USER_PASSWORD_AGE_PARMNUM   fixed bin(31) value( 4);
 dcl USER_PRIV_PARMNUM           fixed bin(31) value( 5);
 dcl USER_HOME_DIR_PARMNUM       fixed bin(31) value( 6);
 dcl USER_COMMENT_PARMNUM        fixed bin(31) value( 7);
 dcl USER_FLAGS_PARMNUM          fixed bin(31) value( 8);
 dcl USER_SCRIPT_PATH_PARMNUM    fixed bin(31) value( 9);
 dcl USER_AUTH_FLAGS_PARMNUM     fixed bin(31) value(10);
 dcl USER_FULL_NAME_PARMNUM      fixed bin(31) value(11);
 dcl USER_USR_COMMENT_PARMNUM    fixed bin(31) value(12);
 dcl USER_PARMS_PARMNUM          fixed bin(31) value(13);
 dcl USER_WORKSTATIONS_PARMNUM   fixed bin(31) value(14);
 dcl USER_LAST_LOGON_PARMNUM     fixed bin(31) value(15);
 dcl USER_LAST_LOGOFF_PARMNUM    fixed bin(31) value(16);
 dcl USER_ACCT_EXPIRES_PARMNUM   fixed bin(31) value(17);
 dcl USER_MAX_STORAGE_PARMNUM    fixed bin(31) value(18);
 dcl USER_UNITS_PER_WEEK_PARMNUM fixed bin(31) value(19);
 dcl USER_LOGON_HOURS_PARMNUM    fixed bin(31) value(20);
 dcl USER_PAD_PW_COUNT_PARMNUM   fixed bin(31) value(21);
 dcl USER_NUM_LOGONS_PARMNUM     fixed bin(31) value(22);
 dcl USER_LOGON_SERVER_PARMNUM   fixed bin(31) value(23);
 dcl USER_COUNTRY_CODE_PARMNUM   fixed bin(31) value(24);
 dcl USER_CODE_PAGE_PARMNUM      fixed bin(31) value(25);
 dcl USER_PRIMARY_GROUP_PARMNUM  fixed bin(31) value(51);
 dcl USER_PROFILE                fixed bin(31) value(52);
     /* ?? Delete when convenient */
 dcl USER_PROFILE_PARMNUM        fixed bin(31) value(52);
 dcl USER_HOME_DIR_DRIVE_PARMNUM fixed bin(31) value(53);


 /* the new infolevel counterparts of the old info level + parmnum */

 dcl USER_NAME_INFOLEVEL           fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_NAME_PARMNUM);
 dcl USER_PASSWORD_INFOLEVEL       fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PASSWORD_PARMNUM);
 dcl USER_PASSWORD_AGE_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PASSWORD_AGE_PARMNUM);
 dcl USER_PRIV_INFOLEVEL           fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PRIV_PARMNUM);
 dcl USER_HOME_DIR_INFOLEVEL       fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_HOME_DIR_PARMNUM);
 dcl USER_COMMENT_INFOLEVEL        fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_COMMENT_PARMNUM);
 dcl USER_FLAGS_INFOLEVEL          fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_FLAGS_PARMNUM);
 dcl USER_SCRIPT_PATH_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_SCRIPT_PATH_PARMNUM);
 dcl USER_AUTH_FLAGS_INFOLEVEL     fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_AUTH_FLAGS_PARMNUM);
 dcl USER_FULL_NAME_INFOLEVEL      fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_FULL_NAME_PARMNUM);
 dcl USER_USR_COMMENT_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_USR_COMMENT_PARMNUM);
 dcl USER_PARMS_INFOLEVEL          fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PARMS_PARMNUM);
 dcl USER_WORKSTATIONS_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_WORKSTATIONS_PARMNUM);
 dcl USER_LAST_LOGON_INFOLEVEL     fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_LAST_LOGON_PARMNUM);
 dcl USER_LAST_LOGOFF_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_LAST_LOGOFF_PARMNUM);
 dcl USER_ACCT_EXPIRES_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_ACCT_EXPIRES_PARMNUM);
 dcl USER_MAX_STORAGE_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_MAX_STORAGE_PARMNUM);
 dcl USER_UNITS_PER_WEEK_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_UNITS_PER_WEEK_PARMNUM);
 dcl USER_LOGON_HOURS_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_LOGON_HOURS_PARMNUM);
 dcl USER_PAD_PW_COUNT_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PAD_PW_COUNT_PARMNUM);
 dcl USER_NUM_LOGONS_INFOLEVEL     fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_NUM_LOGONS_PARMNUM);
 dcl USER_LOGON_SERVER_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_LOGON_SERVER_PARMNUM);
 dcl USER_COUNTRY_CODE_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_COUNTRY_CODE_PARMNUM);
 dcl USER_CODE_PAGE_INFOLEVEL      fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_CODE_PAGE_PARMNUM);
 dcl USER_PRIMARY_GROUP_INFOLEVEL  fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_PRIMARY_GROUP_PARMNUM);
 /* dcl USER_POSIX_ID_INFOLEVEL       fixed bin(31)
       value(PARMNUM_BASE_INFOLEVEL + USER_POSIX_ID_PARMNUM) */
 dcl USER_HOME_DIR_DRIVE_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + USER_HOME_DIR_DRIVE_PARMNUM);

 /*  For SetInfo call (parmnum 0) when password change not required */

/* For SetInfo call (parmnum 0) when password  change not required */

dcl NULL_USERSETINFO_PASSWD   char value('  ');

dcl TIMEQ_FOREVER             type DWORD
                               value(iunsigned (bin (-1, 31)));
dcl USER_MAXSTORAGE_UNLIMITED type DWORD
                               value(iunsigned (bin (-1, 31)));
dcl USER_NO_LOGOFF            type DWORD
                               value(iunsigned (bin (-1, 31)));
dcl UNITS_PER_DAY             type DWORD value(24);
dcl UNITS_PER_WEEK            type DWORD value(UNITS_PER_DAY * 7);

/* Privilege levels (USER_INFO_X field  usriX_priv (X = 0/1)). */

dcl USER_PRIV_MASK            type DWORD value('3'xu);
dcl USER_PRIV_GUEST           type DWORD value(0);
dcl USER_PRIV_USER            type DWORD value(1);
dcl USER_PRIV_ADM             type DWORD value(2);

/* user modals related defaults  */

dcl MAX_PASSWD_LEN            fixed bin(15) value(PWLEN);
dcl DEF_MIN_PWLEN             fixed bin(15) value(6);
dcl DEF_PWUNIQUENESS          fixed bin(15) value(5);
dcl DEF_MAX_PWHIST            fixed bin(15) value(8);

dcl DEF_MAX_PWAGE             type DWORD
                               value(TIMEQ_FOREVER);  /* forever */
dcl DEF_MIN_PWAGE             type DWORD
                               value(0);              /* 0 days */
dcl DEF_FORCE_LOGOFF          type DWORD
                               value('ffffffff'xu);   /* never */
dcl DEF_MAX_BADPW             type DWORD
                               value(0);              /* no limit */
dcl ONE_DAY                   type DWORD
                               value(01*24*3600);     /* 01 day */


 /* User Logon Validation (codes returned) */

 dcl VALIDATED_LOGON           fixed bin(31) value(0);
 dcl PASSWORD_EXPIRED          fixed bin(31) value(2);
 dcl NON_VALIDATED_LOGON       fixed bin(31) value(3);

 dcl VALID_LOGOFF              fixed bin(31) value(1);


 /* parmnum manifests for user modals */

 dcl MODALS_MIN_PASSWD_LEN_PARMNUM    fixed bin(31) value(1);
 dcl MODALS_MAX_PASSWD_AGE_PARMNUM    fixed bin(31) value(2);
 dcl MODALS_MIN_PASSWD_AGE_PARMNUM    fixed bin(31) value(3);
 dcl MODALS_FORCE_LOGOFF_PARMNUM      fixed bin(31) value(4);
 dcl MODALS_PASSWD_HIST_LEN_PARMNUM   fixed bin(31) value(5);
 dcl MODALS_ROLE_PARMNUM              fixed bin(31) value(6);
 dcl MODALS_PRIMARY_PARMNUM           fixed bin(31) value(7);
 dcl MODALS_DOMAIN_NAME_PARMNUM       fixed bin(31) value(8);
 dcl MODALS_DOMAIN_ID_PARMNUM         fixed bin(31) value(9);
 dcl MODALS_LOCKOUT_DURATION_PARMNUM  fixed bin(31) value(10);
 dcl MODALS_LOCKOUT_OBSERVATION_WINDOW_PARMNUM
                                      fixed bin(31) value(11);
 dcl MODALS_LOCKOUT_THRESHOLD_PARMNUM fixed bin(31) value(12);

 /* the new infolevel counterparts of the old info level + parmnum */

 dcl MODALS_MIN_PASSWD_LEN_INFOLEVEL  fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_MIN_PASSWD_LEN_PARMNUM);
 dcl MODALS_MAX_PASSWD_AGE_INFOLEVEL  fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_MAX_PASSWD_AGE_PARMNUM);
 dcl MODALS_MIN_PASSWD_AGE_INFOLEVEL  fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_MIN_PASSWD_AGE_PARMNUM);
 dcl MODALS_FORCE_LOGOFF_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_FORCE_LOGOFF_PARMNUM);
 dcl MODALS_PASSWD_HIST_LEN_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_PASSWD_HIST_LEN_PARMNUM);
 dcl MODALS_ROLE_INFOLEVEL            fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_ROLE_PARMNUM);
 dcl MODALS_PRIMARY_INFOLEVEL         fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_PRIMARY_PARMNUM);
 dcl MODALS_DOMAIN_NAME_INFOLEVEL     fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_DOMAIN_NAME_PARMNUM);
 dcl MODALS_DOMAIN_ID_INFOLEVEL       fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + MODALS_DOMAIN_ID_PARMNUM);

 %end; /* _LMUSER_ */

 /* Group Class */

 %dcl #LMGROUP_ char ext;
 %if #LMGROUP_ = '' %then %do;
 %#LMGROUP_ = 'Y';

 /* Function Prototypes */

 dcl NetGroupAdd
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupAdd');

 dcl NetGroupAddUser
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupAddUser');

 dcl NetGroupEnum
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD_PTR byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupEnum');

 dcl NetGroupGetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupGetInfo');

 dcl NetGroupSetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupSetInfo');

 dcl NetGroupDel
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupDel');

 dcl NetGroupDelUser
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupDelUser');

 dcl NetGroupGetUsers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD_PTR byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupGetUsers');

 dcl NetGroupSetUsers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGroupSetUsers');

 /*  Data Structures - Group */

 define structure
   1 GROUP_INFO_0,
     2 grpi0_name type LPWSTR;
 define alias  PGROUP_INFO_0 handle GROUP_INFO_0;
 define alias LPGROUP_INFO_0 handle GROUP_INFO_0;

 define structure
   1 GROUP_INFO_1,
     2 grpi1_name       type LPWSTR,
     2 grpi1_comment    type LPWSTR;
 define alias  PGROUP_INFO_1 handle GROUP_INFO_1;
 define alias LPGROUP_INFO_1 handle GROUP_INFO_1;

 define structure
   1 GROUP_INFO_2,
     2 grpi2_name       type LPWSTR,
     2 grpi2_comment    type LPWSTR,
     2 grpi2_group_id   type DWORD,
     2 grpi2_attributes type DWORD;
 define alias PGROUP_INFO_2 handle GROUP_INFO_2;

 define structure
   1 GROUP_INFO_1002,
     2 grpi1002_comment type LPWSTR;
 define alias LPGROUP_INFO_1002 handle GROUP_INFO_1002;

 define structure
   1 GROUP_INFO_1005,
     2 grpi1005_attributes type DWORD;
 define alias  PGROUP_INFO_1005 handle GROUP_INFO_1005;
 define alias LPGROUP_INFO_1005 handle GROUP_INFO_1005;


 define structure
   1 GROUP_USERS_INFO_0,
     2 grui0_name type LPWSTR;
 define alias  PGROUP_USERS_INFO_0 handle GROUP_USERS_INFO_0;
 define alias LPGROUP_USERS_INFO_0 handle GROUP_USERS_INFO_0;

 define structure
   1 GROUP_USERS_INFO_1,
     2 grui1_name type LPWSTR,
     2 grui1_attributes type DWORD;
 define alias  PGROUP_USERS_INFO_1 handle GROUP_USERS_INFO_1;
 define alias LPGROUP_USERS_INFO_1 handle GROUP_USERS_INFO_1;



 /* Special Values and Constants - Group */

 dcl GROUPIDMASK type DWORD value('8000'xu);
 /* MSB set if uid refers to a group */


 /* Predefined group for all normal users, administrators and guests */
 /* LOCAL is a special group for pinball local security.             */

 dcl GROUP_SPECIALGRP_USERS  WCHAR value('USERS');
 dcl GROUP_SPECIALGRP_ADMINS WCHAR value('ADMINS');
 dcl GROUP_SPECIALGRP_GUESTS WCHAR value('GUESTS');
 dcl GROUP_SPECIALGRP_LOCAL  WCHAR value('LOCAL');


 /* parmnum manifests for SetInfo calls (only comment is settable) */

 dcl GROUP_ALL_PARMNUM        fixed bin(31) value(0);
 dcl GROUP_NAME_PARMNUM       fixed bin(31) value(1);
 dcl GROUP_COMMENT_PARMNUM    fixed bin(31) value(2);
 dcl GROUP_ATTRIBUTES_PARMNUM fixed bin(31) value(3);


 /* the new infolevel counterparts of the old info level + parmnum */

 dcl GROUP_ALL_INFOLEVEL        fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + GROUP_ALL_PARMNUM);
 dcl GROUP_NAME_INFOLEVEL       fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + GROUP_NAME_PARMNUM);
 dcl GROUP_COMMENT_INFOLEVEL    fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + GROUP_COMMENT_PARMNUM);
 dcl GROUP_ATTRIBUTES_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + GROUP_ATTRIBUTES_PARMNUM);
 /* dcl GROUP_POSIX_ID_INFOLEVEL   fixed bin(31)
        value(PARMNUM_BASE_INFOLEVEL + GROUP_POSIX_ID_PARMNUM) */

 %end; /* _LMGROUP_ */

 /* LocalGroup Class */

 %dcl #LMLOCALGROUP_ char ext;
 %if #LMLOCALGROUP_ = '' %then %do;
 %#LMLOCALGROUP_ = 'Y';

 /* Function Prototypes */

 dcl NetLocalGroupAdd
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupAdd');

 dcl NetLocalGroupAddMember
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type PSID)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupAddMember');

 dcl NetLocalGroupEnum
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD_PTR byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupEnum');

 dcl NetLocalGroupGetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupGetInfo');

 dcl NetLocalGroupSetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupSetInfo');

 dcl NetLocalGroupDel
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupDel');

 dcl NetLocalGroupDelMember
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type PSID)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupDelMember');

 dcl NetLocalGroupGetMembers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD_PTR byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupGetMembers');

 dcl NetLocalGroupSetMembers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupSetMembers');

 dcl NetLocalGroupAddMembers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupAddMembers');

 dcl NetLocalGroupDelMembers
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetLocalGroupDelMembers');


 /*  Data Structures - LocalGroup */

 define structure
   1 LOCALGROUP_INFO_0,
     2 lgrpi0_name type LPWSTR;
 define alias  PLOCALGROUP_INFO_0 handle LOCALGROUP_INFO_0;
 define alias LPLOCALGROUP_INFO_0 handle LOCALGROUP_INFO_0;

 define structure
   1 LOCALGROUP_INFO_1,
     2 lgrpi1_name    type LPWSTR,
     2 lgrpi1_comment type LPWSTR;
 define alias  PLOCALGROUP_INFO_1 handle LOCALGROUP_INFO_1;
 define alias LPLOCALGROUP_INFO_1 handle LOCALGROUP_INFO_1;

 define structure
   1 LOCALGROUP_INFO_1002,
     2 lgrpi1002_comment type LPWSTR;
 define alias  PLOCALGROUP_INFO_1002 handle LOCALGROUP_INFO_1002;
 define alias LPLOCALGROUP_INFO_1002 handle LOCALGROUP_INFO_1002;

 define structure
   1 LOCALGROUP_MEMBERS_INFO_0,
     2 lgrmi0_sid type PSID;
 define alias  PLOCALGROUP_MEMBERS_INFO_0
              handle LOCALGROUP_MEMBERS_INFO_0;
 define alias LPLOCALGROUP_MEMBERS_INFO_0
              handle LOCALGROUP_MEMBERS_INFO_0;

 define structure
   1 LOCALGROUP_MEMBERS_INFO_1,
     2 lgrmi1_sid      type PSID,
     2 lgrmi1_sidusage type SID_NAME_USE,
     2 lgrmi1_name     type LPWSTR;
 define alias  PLOCALGROUP_MEMBERS_INFO_1
              handle LOCALGROUP_MEMBERS_INFO_1;
 define alias LPLOCALGROUP_MEMBERS_INFO_1
              handle LOCALGROUP_MEMBERS_INFO_1;

 define structure
   1 LOCALGROUP_MEMBERS_INFO_2,
     2 lgrmi2_sid           type PSID,
     2 lgrmi2_sidusage      type SID_NAME_USE,
     2 lgrmi2_domainandname type LPWSTR;
 define alias  PLOCALGROUP_MEMBERS_INFO_2
              handle LOCALGROUP_MEMBERS_INFO_2;
 define alias LPLOCALGROUP_MEMBERS_INFO_2
              handle LOCALGROUP_MEMBERS_INFO_2;

 define structure
   1 LOCALGROUP_MEMBERS_INFO_3,
     2 lgrmi3_domainandname type LPWSTR;
 define alias  PLOCALGROUP_MEMBERS_INFO_3
              handle LOCALGROUP_MEMBERS_INFO_3;
 define alias LPLOCALGROUP_MEMBERS_INFO_3
              handle LOCALGROUP_MEMBERS_INFO_3;

 define structure
   1 LOCALGROUP_USERS_INFO_0,
     2 lgrui0_name type LPWSTR;
 define alias  PLOCALGROUP_USERS_INFO_0 handle LOCALGROUP_USERS_INFO_0;
 define alias LPLOCALGROUP_USERS_INFO_0 handle LOCALGROUP_USERS_INFO_0;


 dcl LOCALGROUP_NAME_PARMNUM    fixed bin(31) value(1);
 dcl LOCALGROUP_COMMENT_PARMNUM fixed bin(31) value(2);


 /* Display Information APIs */

 dcl NetQueryDisplayInformation
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr,
            type PVOID byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetQueryDisplayInformation');

 dcl NetGetDisplayInformationIndex
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGetDisplayInformationIndex');


 /* QueryDisplayInformation levels */

 define structure
   1 NET_DISPLAY_USER,
     2 usri1_name       type LPWSTR,
     2 usri1_comment    type LPWSTR,
     2 usri1_flags      type DWORD,
     2 usri1_full_name  type LPWSTR,
     2 usri1_user_id    type DWORD,
     2 usri1_next_index type DWORD;
 define alias PNET_DISPLAY_USER handle NET_DISPLAY_USER;

 define structure
   1 NET_DISPLAY_MACHINE,
     2 usri2_name       type LPWSTR,
     2 usri2_comment    type LPWSTR,
     2 usri2_flags      type DWORD,
     2 usri2_user_id    type DWORD,
     2 usri2_next_index type DWORD;
 define alias PNET_DISPLAY_MACHINE handle NET_DISPLAY_MACHINE;

 define structure
   1 NET_DISPLAY_GROUP,
     2 grpi3_name       type LPWSTR,
     2 grpi3_comment    type LPWSTR,
     2 grpi3_group_id   type DWORD,
     2 grpi3_attributes type DWORD,
     2 grpi3_next_index type DWORD;
 define alias PNET_DISPLAY_GROUP handle NET_DISPLAY_GROUP;

 %end; /* _LMLOCALGROUP_ */


 /* Access Class */

 %dcl #LMACCESS_ char ext;
 %if #LMACCESS_ = '' %then %do;
 %#LMACCESS_ = 'Y';


 /* Function Prototypes - Access */

 /* The NetAccess APIs are only available to downlevel */

 %dcl NetAccessAdd char ext;
 %NetAccessAdd='RxNetAccessAdd';

 dcl NetAccessAdd
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessAdd');

 %dcl NetAccessEnum char ext;
 %NetAccessEnum='RxNetAccessEnum';

 dcl NetAccessEnum
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessEnum');

 %dcl NetAccessGetInfo char ext;
 %NetAccessGetInfo='RxNetAccessGetInfo';

 dcl NetAccessGetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessGetInfo');

 %dcl NetAccessSetInfo char ext;
 %NetAccessSetInfo='RxNetAccessSetInfo';

 dcl NetAccessSetInfo
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessSetInfo');

 %dcl NetAccessDel char ext;
 %NetAccessDel='RxNetAccessDel';

 dcl NetAccessDel
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessDel');

 %dcl NetAccessGetUserPerms char ext;
 %NetAccessGetUserPerms='RxNetAccessGetUserPerms';

 dcl NetAccessGetUserPerms
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('RxNetAccessGetUserPerms');

 /* Data Structures - Access */

 define structure
   1 ACCESS_INFO_0,
     2 acc0_resource_name type LPWSTR;
 define alias  PACCESS_INFO_0 handle ACCESS_INFO_0;
 define alias LPACCESS_INFO_0 handle ACCESS_INFO_0;

 define structure
   1 ACCESS_INFO_1,
     2 acc1_resource_name type LPWSTR,
     2 acc1_attr          type DWORD,
     2 acc1_count         type DWORD;
 define alias  PACCESS_INFO_1 handle ACCESS_INFO_1;
 define alias LPACCESS_INFO_1 handle ACCESS_INFO_1;

 define structure
   1 ACCESS_INFO_1002,
     2 acc1002_attr type DWORD;
 define alias  PACCESS_INFO_1002 handle ACCESS_INFO_1002;
 define alias LPACCESS_INFO_1002 handle ACCESS_INFO_1002;


 define structure
   1 ACCESS_LIST,
     2 acl_ugname type LPWSTR,
     2 acl_access type DWORD;
 define alias  PACCESS_LIST handle ACCESS_LIST;
 define alias LPACCESS_LIST handle ACCESS_LIST;


 /* Special Values and Constants - Access */

 /* Maximum number of permission entries for each resource. */

 dcl MAXPERMENTRIES        fixed bin(31) value(64);


 /*  Bit values for the access permissions. ACCESS_ALL is a handy */
 /*  way to specify maximum permissions. These are used in        */
 /*  acl_access field of access_list structures.                  */

 dcl ACCESS_NONE           fixed bin(31) value(0);

 dcl ACCESS_READ           fixed bin(31) value('01'xn);
 dcl ACCESS_WRITE          fixed bin(31) value('02'xn);
 dcl ACCESS_CREATE         fixed bin(31) value('04'xn);
 dcl ACCESS_EXEC           fixed bin(31) value('08'xn);
 dcl ACCESS_DELETE         fixed bin(31) value('10'xn);
 dcl ACCESS_ATRIB          fixed bin(31) value('20'xn);
 dcl ACCESS_PERM           fixed bin(31) value('40'xn);

 dcl ACCESS_ALL            fixed bin(31) value (ior (ACCESS_READ,
                                                     ACCESS_WRITE,
                                                     ACCESS_CREATE,
                                                     ACCESS_EXEC,
                                                     ACCESS_DELETE,
                                                     ACCESS_ATRIB,
                                                     ACCESS_PERM));

 dcl ACCESS_GROUP          fixed bin(31) value('8000'xn);

 /* Bit values for the acc1_attr field of the ACCESS_INFO_1 structure.*/

 dcl ACCESS_AUDIT          fixed bin(31) value('1'xn);

 dcl ACCESS_SUCCESS_OPEN   fixed bin(31) value('10'xn);
 dcl ACCESS_SUCCESS_WRITE  fixed bin(31) value('20'xn);
 dcl ACCESS_SUCCESS_DELETE fixed bin(31) value('40'xn);
 dcl ACCESS_SUCCESS_ACL    fixed bin(31) value('80'xn);
 dcl ACCESS_SUCCESS_MASK   fixed bin(31) value('F0'xn);

 dcl ACCESS_FAIL_OPEN      fixed bin(31) value('100'xn);
 dcl ACCESS_FAIL_WRITE     fixed bin(31) value('200'xn);
 dcl ACCESS_FAIL_DELETE    fixed bin(31) value('400'xn);
 dcl ACCESS_FAIL_ACL       fixed bin(31) value('800'xn);
 dcl ACCESS_FAIL_MASK      fixed bin(31) value('F00'xn);

 dcl ACCESS_FAIL_SHIFT     fixed bin(31) value(4);


 /* Parmnum value for NetAccessSetInfo. */

 dcl ACCESS_RESOURCE_NAME_PARMNUM fixed bin(31) value(1);
 dcl ACCESS_ATTR_PARMNUM          fixed bin(31) value(2);
 dcl ACCESS_COUNT_PARMNUM         fixed bin(31) value(3);
 dcl ACCESS_ACCESS_LIST_PARMNUM   fixed bin(31) value(4);


 /* the new infolevel counterparts of the old info level + parmnum */

 dcl ACCESS_RESOURCE_NAME_INFOLEVEL fixed bin(31)
       value(PARMNUM_BASE_INFOLEVEL + ACCESS_RESOURCE_NAME_PARMNUM);
 dcl ACCESS_ATTR_INFOLEVEL          fixed bin(31)
       value(PARMNUM_BASE_INFOLEVEL + ACCESS_ATTR_PARMNUM);
 dcl ACCESS_COUNT_INFOLEVEL         fixed bin(31)
       value(PARMNUM_BASE_INFOLEVEL + ACCESS_COUNT_PARMNUM);
 dcl ACCESS_ACCESS_LIST_INFOLEVEL   fixed bin(31)
       value(PARMNUM_BASE_INFOLEVEL + ACCESS_ACCESS_LIST_PARMNUM);


 /* ACCESS_LETTERS defines a letter for each bit position in */
 /* the acl_access field of struct access_list.  Note that some */
 /* bits have a corresponding letter of ' ' (space). */

 dcl ACCESS_LETTERS char value('RWCXDAP         ');

 %end; /* _LMACCESS_ */


 /* Domain Class */

 %dcl #LMDOMAIN_ char ext;
 %if #LMDOMAIN_ = '' %then %do;
 %#LMDOMAIN_ = 'Y';

 /* Function Prototypes - Domain */

 dcl NetGetDCName
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGetDCName');

 dcl NetGetAnyDCName
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGetAnyDCName');


 dcl I_NetLogonControl
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_NetLogonControl');

 dcl I_NetLogonControl2
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('I_NetLogonControl2');

 %dcl #NTDEF_ char ext;
 %if #NTDEF_ = '' %then %do;
 %dcl #NTSTATUS_ char ext;
 %if #NTSTATUS_ = '' %then %do;
 %#NTSTATUS_ = 'Y';
 define alias NTSTATUS  type LONG;
 define alias PNTSTATUS pointer;
 %end;
 %end;

 /* MS doesn't specify NET_API_FUNCTION - but what else can it be? */
 dcl NetEnumerateTrustedDomains
     entry (WCHAR (*) varz byaddr optional,
            type LPWSTR byaddr)
     returns (type NTSTATUS byvalue optional)
     NET_API_FUNCTION external('NetEnumerateTrustedDomains');


 /* Special Values and Constants - Domain */

 /* FunctionCode values for I_NetLogonControl. */

 /* NOTE : if you change the following NETLOGON_CONTROL_* values, */
 /* change them in net\svcdlls\logonsrv\logon.idl file also.      */


 dcl NETLOGON_CONTROL_QUERY               type DWORD value(1);
     /* No-op: just query */
 dcl NETLOGON_CONTROL_REPLICATE           type DWORD value(2);
     /* Force replicate on BDC */
 dcl NETLOGON_CONTROL_SYNCHRONIZE         type DWORD value(3);
     /* Force synchronize on BDC */
 dcl NETLOGON_CONTROL_PDC_REPLICATE       type DWORD value(4);
     /* Force PDC to broadcast change */
 dcl NETLOGON_CONTROL_REDISCOVER          type DWORD value(5);
     /* Force to re-discover trusted domain DCs */
 dcl NETLOGON_CONTROL_TC_QUERY            type DWORD value(6);
     /* Query status of specified trusted channel status */
 dcl NETLOGON_CONTROL_TRANSPORT_NOTIFY    type DWORD value(7);
     /* Notify netlogon that a new transport has come online */
 dcl NETLOGON_CONTROL_FIND_USER           type DWORD value(8);
     /* Find named user in a trusted domain */
 dcl NETLOGON_CONTROL_CHANGE_PASSWORD     type DWORD value(9);
     /*Change machine password on a secure channel to a trusted domain*/

 /* Debug function codes */

 dcl NETLOGON_CONTROL_UNLOAD_NETLOGON_DLL type DWORD value('FFFB'xu);
 dcl NETLOGON_CONTROL_BACKUP_CHANGE_LOG   type DWORD value('FFFC'xu);
 dcl NETLOGON_CONTROL_TRUNCATE_LOG        type DWORD value('FFFD'xu);
 dcl NETLOGON_CONTROL_SET_DBFLAG          type DWORD value('FFFE'xu);
 dcl NETLOGON_CONTROL_BREAKPOINT          type DWORD value('FFFF'xu);


 /* Query level 1 for I_NetLogonControl */

 define structure
   1 NETLOGON_INFO_1,
     2 netlog1_flags                 type DWORD,
     2 netlog1_pdc_connection_status type NET_API_STATUS;
 define alias PNETLOGON_INFO_1 handle NETLOGON_INFO_1;

 define structure
   1 NETLOGON_INFO_2,
     2 netlog2_flags                 type DWORD,
     2 netlog2_pdc_connection_status type NET_API_STATUS,
     2 netlog2_trusted_dc_name       type LPWSTR,
     2 netlog2_tc_connection_status  type NET_API_STATUS;
 define alias PNETLOGON_INFO_2 handle NETLOGON_INFO_2;

 define structure
   1 NETLOGON_INFO_3,
     2 netlog3_flags          type DWORD,
     2 netlog3_logon_attempts type DWORD,
     2 netlog3_reserved1      type DWORD,
     2 netlog3_reserved2      type DWORD,
     2 netlog3_reserved3      type DWORD,
     2 netlog3_reserved4      type DWORD,
     2 netlog3_reserved5      type DWORD;
 define alias PNETLOGON_INFO_3 handle NETLOGON_INFO_3;

 define structure
   1 NETLOGON_INFO_4,
     2 netlog4_trusted_dc_name     type LPWSTR,
     2 netlog4_trusted_domain_name type LPWSTR;
 define alias PNETLOGON_INFO_4 handle NETLOGON_INFO_4;


 /* Values of netlog1_flags */

 dcl NETLOGON_REPLICATION_NEEDED      type DWORD value('01'xu);
     /* Database is out of date */
 dcl NETLOGON_REPLICATION_IN_PROGRESS type DWORD value('02'xu);
     /* Replication is happening now */
 dcl NETLOGON_FULL_SYNC_REPLICATION   type DWORD value('04'xu);
     /* full sync replication required/progress */
 dcl NETLOGON_REDO_NEEDED             type DWORD value('08'xu);
     /* Redo of previous replication needed */
 dcl NETLOGON_HAS_IP                  type DWORD value('10'xu);
     /* The trusted domain DC has an IP address */
 dcl NETLOGON_HAS_TIMESERV            type DWORD value('20'xu);
     /* The trusted domain DC runs the Windows Time Service */

 %end; /* _LMDOMAIN_ */
