 /* ++ BUILD Version: 0001                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1990 - 1998 Microsoft Corporation                       */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmshare.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the API function prototypes and data        */
 /*   structures for the following groups of NT API functions:        */
 /*       NetShare                                                    */
 /*       NetSession                                                  */
 /*       NetFile                                                     */
 /*       NetConnection                                               */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include windef.cpy and lmcons.cpy before this file.    */
 /*                                                                   */
 /* --                                                                */


 /* SHARE API */


 %dcl #LMSHARE_ char ext;
 %if #LMSHARE_ = '' %then %do;
 %#LMSHARE_ = 'Y';

 /* Function Prototypes - Share */

 dcl NetShareAdd
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareAdd');

 dcl NetShareEnum
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareEnum');

 dcl NetShareEnumSticky
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareEnumSticky');

 dcl NetShareGetInfo
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareGetInfo');

 dcl NetShareSetInfo
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareSetInfo');

 dcl NetShareDel
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareDel');

 dcl NetShareDelSticky
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareDelSticky');

 dcl NetShareCheck
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetShareCheck');


 /* Data Structures - Share */

 define structure
   1 SHARE_INFO_0,
     2 shi0_netname      type LPTSTR;
 define alias  PSHARE_INFO_0 handle SHARE_INFO_0;
 define alias LPSHARE_INFO_0 handle SHARE_INFO_0;

 define structure
   1 SHARE_INFO_1,
     2 shi1_netname      type LPTSTR,
     2 shi1_type         type DWORD,
     2 shi1_remark       type LPTSTR;
 define alias  PSHARE_INFO_1 handle SHARE_INFO_1;
 define alias LPSHARE_INFO_1 handle SHARE_INFO_1;

 define structure
   1 SHARE_INFO_2,
     2 shi2_netname      type LPTSTR,
     2 shi2_type         type DWORD,
     2 shi2_remark       type LPTSTR,
     2 shi2_permissions  type DWORD,
     2 shi2_max_uses     type DWORD,
     2 shi2_current_uses type DWORD,
     2 shi2_path         type LPTSTR,
     2 shi2_passwd       type LPTSTR;
 define alias  PSHARE_INFO_2 handle SHARE_INFO_2;
 define alias LPSHARE_INFO_2 handle SHARE_INFO_2;

 define structure
   1 SHARE_INFO_501,
     2 shi501_netname    type LPTSTR,
     2 shi501_type       type DWORD,
     2 shi501_remark     type LPTSTR,
     2 shi501_flags      type DWORD;
 define alias  PSHARE_INFO_501 handle SHARE_INFO_501;
 define alias LPSHARE_INFO_501 handle SHARE_INFO_501;

 define structure
   1 SHARE_INFO_502,
     2 shi502_netname             type LPTSTR,
     2 shi502_type                type DWORD,
     2 shi502_remark              type LPTSTR,
     2 shi502_permissions         type DWORD,
     2 shi502_max_uses            type DWORD,
     2 shi502_current_uses        type DWORD,
     2 shi502_path                type LPTSTR,
     2 shi502_passwd              type LPTSTR,
     2 shi502_reserved            type DWORD,
     2 shi502_security_descriptor type PSECURITY_DESCRIPTOR;
 define alias  PSHARE_INFO_502 handle SHARE_INFO_502;
 define alias LPSHARE_INFO_502 handle SHARE_INFO_502;

 define structure
   1 SHARE_INFO_1004,
     2 shi1004_remark   type LPTSTR;
 define alias  PSHARE_INFO_1004 handle SHARE_INFO_1004;
 define alias LPSHARE_INFO_1004 handle SHARE_INFO_1004;

 define structure
   1 SHARE_INFO_1005,
     2 shi1005_flags    type DWORD;
 define alias  PSHARE_INFO_1005 handle SHARE_INFO_1005;
 define alias LPSHARE_INFO_1005 handle SHARE_INFO_1005;

 define structure
   1 SHARE_INFO_1006,
     2 shi1006_max_uses type DWORD;
 define alias  PSHARE_INFO_1006 handle SHARE_INFO_1006;
 define alias LPSHARE_INFO_1006 handle SHARE_INFO_1006;

 define structure
   1 SHARE_INFO_1007,
     2 shi1007_flags                  type DWORD,
     2 shi1007_AlternateDirectoryName type LPTSTR;
 define alias  PSHARE_INFO_1007 handle SHARE_INFO_1007;
 define alias LPSHARE_INFO_1007 handle SHARE_INFO_1007;

 define structure
   1 SHARE_INFO_1501,
     2 shi1501_reserved            type DWORD,
     2 shi1501_security_descriptor type PSECURITY_DESCRIPTOR;
 define alias  PSHARE_INFO_1501 handle SHARE_INFO_1501;
 define alias LPSHARE_INFO_1501 handle SHARE_INFO_1501;


 /* Special Values and Constants - Share */

 /* Values for parm_err parameter. */

 dcl SHARE_NETNAME_PARMNUM      fixed bin(31) value(1);
 dcl SHARE_TYPE_PARMNUM         fixed bin(31) value(3);
 dcl SHARE_REMARK_PARMNUM       fixed bin(31) value(4);
 dcl SHARE_PERMISSIONS_PARMNUM  fixed bin(31) value(5);
 dcl SHARE_MAX_USES_PARMNUM     fixed bin(31) value(6);
 dcl SHARE_CURRENT_USES_PARMNUM fixed bin(31) value(7);
 dcl SHARE_PATH_PARMNUM         fixed bin(31) value(8);
 dcl SHARE_PASSWD_PARMNUM       fixed bin(31) value(9);
 dcl SHARE_FILE_SD_PARMNUM      fixed bin(31) value(501);

 /* Single-field infolevels for NetShareSetInfo. */

 dcl SHARE_REMARK_INFOLEVEL   fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + SHARE_REMARK_PARMNUM);
 dcl SHARE_MAX_USES_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + SHARE_MAX_USES_PARMNUM);
 dcl SHARE_FILE_SD_INFOLEVEL  fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + SHARE_FILE_SD_PARMNUM);

 dcl SHI1_NUM_ELEMENTS fixed bin(31) value(4);
 dcl SHI2_NUM_ELEMENTS fixed bin(31) value(10);


 /* Share types (shi1_type and shi2_type fields). */

 dcl STYPE_DISKTREE         type DWORD value(0);
 dcl STYPE_PRINTQ           type DWORD value(1);
 dcl STYPE_DEVICE           type DWORD value(2);
 dcl STYPE_IPC              type DWORD value(3);

 dcl STYPE_SPECIAL          type DWORD value('80000000'xu);

 dcl SHI_USES_UNLIMITED     type DWORD value(iunsigned(bin(-1,31)));

 /* Flags values for the 501, 1005, and 1007 infolevels */

 dcl SHI1005_FLAGS_DFS      type DWORD value('01'xu);
     /* Share is in the DFS */
 dcl SHI1005_FLAGS_DFS_ROOT type DWORD value('02'xu);
     /* Share is root of DFS */

 dcl COW_PERMACHINE         type DWORD value('04'xu);
     /* Share data is per-machine data */
 dcl COW_PERUSER            type DWORD value('08'xu);
     /* Share data is per-user data */

 dcl CSC_CACHEABLE          type DWORD value('10'xu);
     /* Client can cache files for off-line access */
 dcl CSC_NOFLOWOPS          type DWORD value('20'xu);
     /* Client need not flow operations to the server */
 dcl CSC_AUTO_INWARD        type DWORD value('40'xu);
     /* Auto inward propagation (server->client) w/o UI */
 dcl CSC_AUTO_OUTWARD       type DWORD value('80'xu);
     /* Auto outward propagation(client->server) w/o UI */

 /* The subset of 1005 and 1007 infolevel flags */
 /* that can be set via the API                 */

 dcl SHI1005_VALID_FLAGS_SET type DWORD value (ior(CSC_CACHEABLE,
                                                   CSC_NOFLOWOPS,
                                                   CSC_AUTO_INWARD,
                                                   CSC_AUTO_OUTWARD,
                                                   COW_PERMACHINE,
                                                   COW_PERUSER));
 dcl SHI1007_VALID_FLAGS_SET type DWORD value(SHI1005_VALID_FLAGS_SET);

 %end; /* _LMSHARE_ */

 /* SESSION API */

 %dcl #LMSESSION_ char ext;
 %if #LMSESSION_ = '' %then %do;
 %#LMSESSION_ = 'Y';

 /* Function Prototypes Session */

 dcl NetSessionEnum
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetSessionEnum');

 dcl NetSessionDel
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            WCHAR(*) varz byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetSessionDel');

 dcl NetSessionGetInfo
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            WCHAR(*) varz byaddr,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetSessionGetInfo');


 /* Data Structures - Session */

 define structure
   1 SESSION_INFO_0,
     2 sesi0_cname       type LPTSTR;/* client name (no backslashes) */
 define alias  PSESSION_INFO_0 handle SESSION_INFO_0;
 define alias LPSESSION_INFO_0 handle SESSION_INFO_0;

 define structure
   1 SESSION_INFO_1,
     2 sesi1_cname       type LPTSTR,/* client name (no backslashes) */
     2 sesi1_username    type LPTSTR,
     2 sesi1_num_opens   type DWORD,
     2 sesi1_time        type DWORD,
     2 sesi1_idle_time   type DWORD,
     2 sesi1_user_flags  type DWORD;
 define alias  PSESSION_INFO_1 handle SESSION_INFO_1;
 define alias LPSESSION_INFO_1 handle SESSION_INFO_1;

 define structure
   1 SESSION_INFO_2,
     2 sesi2_cname       type LPTSTR,/* client name (no backslashes) */
     2 sesi2_username    type LPTSTR,
     2 sesi2_num_opens   type DWORD,
     2 sesi2_time        type DWORD,
     2 sesi2_idle_time   type DWORD,
     2 sesi2_user_flags  type DWORD,
     2 sesi2_cltype_name type LPTSTR;
 define alias  PSESSION_INFO_2 handle SESSION_INFO_2;
 define alias LPSESSION_INFO_2 handle SESSION_INFO_2;

 define structure
   1 SESSION_INFO_10,
     2 sesi10_cname      type LPTSTR,/* client name (no backslashes) */
     2 sesi10_username   type LPTSTR,
     2 sesi10_time       type DWORD,
     2 sesi10_idle_time  type DWORD;
 define alias  PSESSION_INFO_10 handle SESSION_INFO_10;
 define alias LPSESSION_INFO_10 handle SESSION_INFO_10;

 define structure
   1 SESSION_INFO_502,
     2 sesi502_cname       type LPTSTR,/* client name (no backslashes)*/
     2 sesi502_username    type LPTSTR,
     2 sesi502_num_opens   type DWORD,
     2 sesi502_time        type DWORD,
     2 sesi502_idle_time   type DWORD,
     2 sesi502_user_flags  type DWORD,
     2 sesi502_cltype_name type LPTSTR,
     2 sesi502_transport   type LPTSTR;
 define alias  PSESSION_INFO_502 handle SESSION_INFO_502;
 define alias LPSESSION_INFO_502 handle SESSION_INFO_502;


 /* Special Values and Constants - Session */

 /* Bits defined in sesi1_user_flags. */

 dcl SESS_GUEST         type DWORD value('00000001'xu);
     /* session is logged on as a guest */
 dcl SESS_NOENCRYPTION  type DWORD value('00000002'xu);
     /* session is not using encryption */

 dcl SESI1_NUM_ELEMENTS fixed bin(31) value(8);
 dcl SESI2_NUM_ELEMENTS fixed bin(31) value(9);

 %end; /* _LMSESSION_ */


 /* CONNECTION API */

 %dcl #LMCONNECTION_ char ext;
 %if #LMCONNECTION_ = '' %then %do;
 %#LMCONNECTION_ = 'Y';

 /* Function Prototypes - CONNECTION */

 dcl NetConnectionEnum
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetConnectionEnum');

 /* Data Structures - CONNECTION */


 define structure
   1 CONNECTION_INFO_0,
     2 coni0_id        type DWORD;
 define alias  PCONNECTION_INFO_0 handle CONNECTION_INFO_0;
 define alias LPCONNECTION_INFO_0 handle CONNECTION_INFO_0;

 define structure
   1 CONNECTION_INFO_1,
     2 coni1_id        type DWORD,
     2 coni1_type      type DWORD,
     2 coni1_num_opens type DWORD,
     2 coni1_num_users type DWORD,
     2 coni1_time      type DWORD,
     2 coni1_username  type LPTSTR,
     2 coni1_netname   type LPTSTR;
 define alias  PCONNECTION_INFO_1 handle CONNECTION_INFO_1;
 define alias LPCONNECTION_INFO_1 handle CONNECTION_INFO_1;

 %end; /* _LMCONNECTION_ */


 /* FILE API */

 %dcl #LMFILE_ char ext;
 %if #LMFILE_ = '' %then %do;
 %#LMFILE_ = 'Y';

 /* Function Prototypes - FILE */

 dcl NetFileClose
     entry (WCHAR(*) varz byaddr optional,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetFileClose');

 dcl NetFileEnum
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetFileEnum');

 dcl NetFileGetInfo
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetFileGetInfo');


 /* Data Structures - File */

 /* File APIs are available at information levels 2 & 3 only. */
 /* Levels 0 & 1 are not supported.                           */


 define structure
   1 FILE_INFO_2,
     2 fi2_id type DWORD;
 define alias  PFILE_INFO_2 handle FILE_INFO_2;
 define alias LPFILE_INFO_2 handle FILE_INFO_2;

 define structure
   1 FILE_INFO_3,
     2 fi3_id type DWORD,
     2 fi3_permissions type DWORD,
     2 fi3_num_locks   type DWORD,
     2 fi3_pathname    type LPTSTR,
     2 fi3_username    type LPTSTR;
 define alias  PFILE_INFO_3 handle FILE_INFO_3;
 define alias LPFILE_INFO_3 handle FILE_INFO_3;


 /* Special Values and Constants - File */

 /* bit values for permissions */

 dcl PERM_FILE_READ   type DWORD value('1'xu);
     /* user has read access */
 dcl PERM_FILE_WRITE  type DWORD value('2'xu);
     /* user has write access */
 dcl PERM_FILE_CREATE type DWORD value('4'xu);
     /* user has create access */

 %end; /* _LMFILE_ */
