 /* +---------------------------------------------------------------- */
 /*                                                                   */
 /* Microsoft Windows                                                 */
 /*                                                                   */
 /* Copyright (c) Microsoft Corporation 1991-1999                     */
 /*                                                                   */
 /* File:      Security.cpy                                           */
 /*                                                                   */
 /* Contents:  Toplevel include file for security aware components    */
 /*                                                                   */
 /*                                                                   */
 /* History:   06 Aug 92  RichardW  Created                           */
 /*            23 Sep 92  PeterWi   Add security object include files */
 /*                                                                   */
 /* ----------------------------------------------------------------- */

 /* This file will go out and pull in all the header files that you   */
 /* need, based on defines that you issue. The following macros are   */
 /* used.                                                             */
 /*                                                                   */
 /* SECURITY_KERNEL      Use the kernel interface, not the usermode   */
 /*                                                                   */

 /* These are name that can be used to refer to the builtin packages */

 %dcl SECURITY_WIN32 char ext;
 %dcl SECURITY_KERNEL char ext;

 %if SECURITY_KERNEL = '' %then %do;
 %SECURITY_WIN32 = 'Y'; /* 16-bit security is not supported in PL/I */
 %end;

 %dcl UNICODE char ext;

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 dcl NTLMSP_NAME_A char  value('NTLM');
 dcl NTLMSP_NAME   TCHAR value('NTLM');

 %dcl MICROSOFT_KERBEROS_NAME_DEFINED char ext;
 %if MICROSOFT_KERBEROS_NAME_DEFINED = '' %then %do;
 %MICROSOFT_KERBEROS_NAME_DEFINED = 'Y';
 dcl MICROSOFT_KERBEROS_NAME_A char  value('Kerberos');
 dcl MICROSOFT_KERBEROS_NAME_W TCHAR value('Kerberos');
 %dcl WIN32_CHICAGO char ext;
 %if WIN32_CHICAGO ^= '' %then %do;
 dcl MICROSOFT_KERBEROS_NAME char  value(MICROSOFT_KERBEROS_NAME_A);
 %end; %else %do;
 dcl MICROSOFT_KERBEROS_NAME TCHAR value(MICROSOFT_KERBEROS_NAME_W);
 %end;
 %end; /* MICROSOFT_KERBEROS_NAME_DEFINED */

 dcl NEGOSSP_NAME_W TCHAR value('Negotiate');
 dcl NEGOSSP_NAME_A char  value('Negotiate');

 %if UNICODE ^= '' %then %do;
 dcl NEGOSSP_NAME TCHAR value(NEGOSSP_NAME_W);
 %end; %else %do;
 dcl NEGOSSP_NAME  char value(NEGOSSP_NAME_A);
 %end;


 /* Include the master SSPI header file */
 %include sspi;

 %if (SECURITY_WIN32 ^= '') | (SECURITY_KERNEL ^= '') %then %do;
 %include secext;
 %end;

