 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQL.CPY                                      */
 /*                                                                  */
 /*  NAME - SQL.CPY                                                  */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT    product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT   product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               System Constants                                   */
 /*               National Language Support Information              */
 /*               SQLCA / SQLDA Constants                            */
 /*               Interface to BINDER and PRECOMPILER                */
 /*               Error Message Retrieval Interface                  */
 /*               Authorization Constants                            */
 /*                                                                  */
 /*  Operating System = Windows                                      */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 %dcl SQL_H_SQL char ext;
 %if SQL_H_SQL = '' %then %do;
 %SQL_H_SQL = 'Y';


 /* Note: char defaults to 'char'.  See sqlsystm.h for details.       */

 %dcl SQL_H_SQLSYSTM char ext;
 %if SQL_H_SQLSYSTM = '' %then %do;
 %include sqlsystm; /* System dependent defines  */
 %end;

 %dcl #SQLCA_T_INC char ext;
 %if #SQLCA_T_INC = '' %then %do;
 %include sqlca_t; /* Required include file    */
 %end;


 /* Release Identifier Constants */

 dcl SQL_RELPRE6 fixed bin (31) value(0);      /* Pre Version 6.1.0.0 */
 dcl SQL_REL6100 fixed bin (31) value(6010000); /* V6.1.0.0           */
 dcl SQL_REL7100 fixed bin (31) value(7010000); /* V7.1.0.0           */
 dcl SQL_REL7102 fixed bin (31) value(7010200); /* V7.1.2.0           */
 dcl SQL_REL7103 fixed bin (31) value(7020000); /* V7.1.3.0 => V7.2   */
 dcl SQL_REL7200 fixed bin (31) value(7020100); /* V7.2.0.0           */
 dcl SQL_REL7201 fixed bin (31) value(7020200); /* V7.2.1.0           */
 dcl SQL_REL7204 fixed bin (31) value(7020400); /* V7.2.4.0           */
 dcl SQL_FUTUREL fixed bin (31) value(9999999); /* Future Release     */

 /* System Constants                                                 */

 %dcl #SQL_RC_OK char ext;
 %if #SQL_RC_OK = '' %then %do;
 %#SQL_RC_OK = 'Y';
 dcl SQL_RC_OK fixed bin (31) value(0);  /* successful execution     */
 %end;

 dcl SQL_KEYPMAX          fixed bin(31) value(16);
                              /* Maximum nbr of key parts in Index   */
 dcl SQL_KEYLMAX          fixed bin(31) value(1024);
                              /* Maximum key length                  */
 dcl SQL_SORTFLDLMT       fixed bin(31) value(32677);
                              /* Maximum size of field for sort      */
 dcl SQL_MAXRECL_4K       fixed bin(31) value(4005);
                              /* Maximum record length on a 4K page  */
 dcl SQL_MAXRECL_8K       fixed bin(31) value(8101);
                              /* Maximum record length on a 8K page  */
 dcl SQL_MAXRECL          fixed bin(31) value(32677);
                              /* Maximum record length               */
 dcl SQL_MAXTABLES        fixed bin(31) value(15);
                              /* Maximum nbr of tables in a SELECT   */
 dcl SQL_MAXVARS_STMT     fixed bin(31) value(32767);
                              /* Maximum nbr of Host Vars per stmt   */
 dcl SQL_MAXCOLS          fixed bin(31) value(3000);
                              /* Internal max nbr of columns in a    */
                              /* table                               */
 dcl SQL_MAXCOLS_EXT      fixed bin(31) value(1012);
                              /* External max nbr of columns in a    */
                              /* table                               */
 dcl SQL_MAXSEL_ITEMS     fixed bin(31) value(1012);
                              /* Maximum nbr of items in a SELECT    */
 dcl SQL_MAXPARMS         fixed bin(31) value(90);
                              /* Maximum nbr of parms in a function  */
 dcl SQL_MAX_STMT_SIZ     fixed bin(31) value(65535);
                              /* Maximum statement size              */

 dcl SQL_SMALL_LENGTH     fixed bin(31) value(2);
                              /* Size of a SMALLINT                  */
 dcl SQL_MAXSMALLVAL      fixed bin(15) value(32767);
                              /* Maximum value of a SMALLINT         */
 dcl SQL_MINSMALLVAL      fixed bin(15) value(-SQL_MAXSMALLVAL-1);
                              /* Minimum value of a SMALLINT         */
 dcl SQL_INT_LENGTH       fixed bin(31) value(4);
                              /* Size of an INTEGER                  */
 dcl SQL_MAXINTVAL        fixed bin(31) value(2147483647);
                              /* Maximum value of an INTEGER         */
 dcl SQL_MININTVAL        fixed bin(31) value(-SQL_MAXINTVAL-1);
                              /* Minimum value of an INTEGER         */
 dcl SQL_BIGINT_LENGTH    fixed bin(31) value(8);
                              /*           Size of a BIGINT          */
 dcl SQL_MAXBIGINTVAL     fixed bin(63) value('7FFFFFFFFFFFFFFF'xn);
                  /* Maximum value of a BIGINT (9223372036854775807) */
 dcl SQL_MINBIGINTVAL     fixed bin(63) value(-SQL_MAXBIGINTVAL-1);
                              /* Minimum value of a BIGINT           */

 dcl SQL_FLOAT_LENGTH     fixed bin(31) value(8);
                              /* Size of a FLOAT                     */
 dcl SQL_FLOAT4_LENGTH    fixed bin(31) value(4);
                              /* Size of a 4-byte FLOAT              */
 dcl SQL_MAXSFLTPREC      fixed bin(31) value(24);
                              /* Maximum prec for small float        */
 dcl SQL_MINSFLTPREC      fixed bin(31) value(1);
                              /* Minimum prec for small float        */
 dcl SQL_MAXFLOATPREC     fixed bin(31) value(53);
                              /* Minimum prec for any float          */
 dcl SQL_DEFDEC_PRECISION fixed bin(31) value(5);
                              /* Default precision for DECIMAL       */
 dcl SQL_DEFDEC_SCALE     fixed bin(31) value(0);
                              /* Default scale for DECIMAL           */
 dcl SQL_MAXDECIMAL       fixed bin(31) value(31);
                              /* Maximum scale/prec. for DECIMAL     */
 dcl SQL_DEFCHAR          fixed bin(31) value(1);
                              /* Default length for a CHAR           */
 dcl SQL_DEFWCHAR         fixed bin(31) value(1);
                              /* Default length for a graphic        */
 dcl SQL_MAXCHAR          fixed bin(31) value(254);
                              /* Maximum length of a CHAR            */
 dcl SQL_MAXLSTR          fixed bin(31) value(255);
                              /* Maximum length of an LSTRING        */
 dcl SQL_MAXVCHAR         fixed bin(31) value(SQL_MAXRECL-5);
                              /* Maximum length of a VARCHAR         */
 dcl SQL_MAXVGRAPH        fixed bin(31) value(SQL_MAXVCHAR/2);
                              /* Maximum length of a VARGRAPHIC      */
 dcl SQL_MAXBLOB          fixed bin(31) value(2147483647);
                              /* Max. length of a BLOB host var      */
 dcl SQL_MAXCLOB          fixed bin(31) value(2147483647);
                              /* Max. length of a CLOB host var      */
 dcl SQL_MAXDBCLOB        fixed bin(31) value(1073741823);
                              /* Max. length of an DBCLOB host var   */
 dcl SQL_LOBLOCATOR_LEN   fixed bin(31) value(4);
                              /* Length of a LOB locator host var    */
 dcl SQL_LOBFILE_LEN      fixed bin(31) value(267);
                              /* Length of a LOB file host var       */
 dcl SQL_VCHAROH          fixed bin(31) value(4);
                              /* Overhead for VARCHAR in record      */
 dcl SQL_LONGMAX          fixed bin(31) value(32700);
                              /* Maximum length of a LONG VARCHAR    */
 dcl SQL_LONGGRMAX        fixed bin(31) value(16350);
                              /* Max. length of a LONG VARGRAPHIC    */
 dcl SQL_LVCHAROH         fixed bin(31) value(24);
                              /* Overhead for LONG VARCHAR in record */
 dcl SQL_LOBCHAROH        fixed bin(31) value(312);
                              /* Overhead for LOB in record          */
 dcl SQL_BLOB_MAXLEN      fixed bin(31) value(2147483647);
                              /* BLOB maximum length, in bytes       */
 dcl SQL_CLOB_MAXLEN      fixed bin(31) value(2147483647);
                              /* CLOB maximum length, in chars       */
 dcl SQL_DBCLOB_MAXLEN    fixed bin(31) value(1073741823);
                              /* maxlen for dbcs lobs                */
 dcl SQL_TIME_LENGTH      fixed bin(31) value(3);
                              /* Size of a TIME field                */
 dcl SQL_TIME_STRLEN      fixed bin(31) value(8);
                              /* Size of a TIME field output         */
 dcl SQL_TIME_MINSTRLEN   fixed bin(31) value(5);
                              /* Size of a non-USA TIME field        */
                              /* output without seconds              */
 dcl SQL_DATE_LENGTH      fixed bin(31) value(4);
                              /* Size of a DATE field                */
 dcl SQL_DATE_STRLEN      fixed bin(31) value(10);
                              /* Size of a DATE field output         */
 dcl SQL_STAMP_LENGTH     fixed bin(31) value(10);
                              /* Size of a TIMESTAMP field           */
 dcl SQL_STAMP_STRLEN     fixed bin(31) value(26);
                              /* Size of a TIMESTAMP field output    */
 dcl SQL_STAMP_MINSTRLEN  fixed bin(31) value(19);
                              /* Size of a TIMESTAMP field output    */
                              /* without microseconds                */
 dcl SQL_BOOLEAN_LENGTH   fixed bin(31) value(1);
                              /* Size of a BOOLEAN field             */
 dcl SQL_DATALINK_LENGTH  fixed bin(31) value(254);
                              /* Size of a DATALINK field            */
 dcl SQL_IND_LENGTH       fixed bin(31) value(2);
                              /* Size of an indicator value          */

 dcl SQL_MAX_PNAME_LENGTH      fixed bin(31) value(254);
                              /* Max size of Stored Proc Name        */
 dcl SQL_MAX_IDENT             fixed bin(31) value(128);
                              /* Maximum length of Identifer         */
 dcl SQL_LG_IDENT              fixed bin(31) value(18);
                              /* Maximum length of Long Identifer    */
 dcl SQL_SH_IDENT              fixed bin(31) value(8);
                              /* Maximum length of Short Identifer   */
 dcl SQL_MN_IDENT              fixed bin(31) value(1);
                              /* Minimum length of Identifiers       */
 dcl SQL_MAX_VAR_NAME          fixed bin(31) value(255);
                              /* Max size of Host Variable Name      */
 dcl SQL_PDB_MAP_SIZE          fixed bin(31) value(4096);
                              /* Number of partitions in a pmap      */
 dcl SQL_MAX_NUM_PART_KEYS     fixed bin(31) value(500);
                              /* Max # of Partition Keys             */
 dcl SQL_ZONEDDECIMAL_FORMAT   fixed bin(31) value('20'xn);
                              /* decimal columns for sqlugrpn are    */
                              /* in zoneddecimal format              */
 dcl SQL_IMPLIEDDECIMAL_FORMAT fixed bin(31) value('10'xn);
                              /* decimal columns for sqlugrpn are    */
                              /* in implieddecimal format            */
 dcl SQL_BINARYNUMERICS_FORMAT fixed bin(31) value('4'xn);
                              /* numeric columns for sqlugrpn are    */
                              /* in binary format                    */
 dcl SQL_PACKEDDECIMAL_FORMAT  fixed bin(31) value('8'xn);
                              /* decimal columns for sqlugrpn are    */
                              /* in packeddecimal format             */
 dcl SQL_CHARSTRING_FORMAT     fixed bin(31) value('0'xn);
                              /* numeric/decimal columns for sqlugrpn*/
                              /* are in character string format      */
 dcl SQL_KILO_VALUE            fixed bin(31) value(1024);
                              /* # of bytes in a kilobyte            */
 dcl SQL_MEGA_VALUE            fixed bin(31) value(1048576);
                              /* # of bytes in a megabyte            */
 dcl SQL_GIGA_VALUE            fixed bin(31) value(1073741824);
                              /* # of bytes in a gigabyte            */

 dcl SQLB_MAX_CONTAIN_NAME_SZ  fixed bin(31) value(256);
                              /* size of container name for api's    */
                              /* (includes 1 byte for C NULL         */
                              /* terminator)                         */

 /* System types */
 define alias SQL_PDB_NODE_TYPE fixed bin (15) signed;
                              /* Datatype of PDB node                */
 define alias SQL_PDB_PORT_TYPE fixed bin (31);
                              /* Datatype of PDB port                */
 dcl SQL_PDB_MAX_NUM_NODE       fixed bin(31) value(1000);
                              /* limit for max. # of nodes           */

 /* information related to logical node name */
 dcl SQL_PDB_NODE_NUM_DIGIT     fixed bin(31) value(4);
                              /* no. of digits for node number in    */
                              /* node name                           */
 dcl SQL_PDB_NODE_NAME_LEN      fixed bin(31) value(8);
                              /* length of logical node name         */

 SQL_NODE_NUM_TO_NAME: proc (name_p, node_num)
                       options (inline) internal;
   dcl name_p   char (*) varz byaddr,
       node_num fixed bin (15) byvalue;
   dcl (copy, edit) builtin;
   name_p = 'NODE' || edit (node_num,
                            copy ('9', SQL_PDB_NODE_NUM_DIGIT));
 end SQL_NODE_NUM_TO_NAME;

 /* Codepages */
 dcl SQL_CP_367   fixed bin(16) unsigned value(367);
                              /* Codepage 367 - EUC single byte      */
 dcl SQL_CP_437   fixed bin(16) unsigned value(437);
                              /* Codepage 437 - US, Europe           */
 dcl SQL_CP_737   fixed bin(16) unsigned value(737);
                              /* Codepage 737 - WIN Greece           */
 dcl SQL_CP_806   fixed bin(16) unsigned value(806);
                              /* Codepage 806 - ISCII, India         */
 dcl SQL_CP_813   fixed bin(16) unsigned value(813);
                              /* Codepage 813 - AIX Greece           */
 dcl SQL_CP_819   fixed bin(16) unsigned value(819);
                              /* Codepage 819 - ISO 8859-1           */
 dcl SQL_CP_850   fixed bin(16) unsigned value(850);
                              /* Codepage 850 - International PC     */
 dcl SQL_CP_855   fixed bin(16) unsigned value(855);
                              /* Codepage 855 - OS2 Cyrillic         */
 dcl SQL_CP_852   fixed bin(16) unsigned value(852);
                              /* Codepage 852 - OS2 Latin2           */
 dcl SQL_CP_856   fixed bin(16) unsigned value(856);
                              /* Codepage 856 - Hebrew               */
 dcl SQL_CP_857   fixed bin(16) unsigned value(857);
                              /* Codepage 857 - OS2 Turkey           */
 dcl SQL_CP_860   fixed bin(16) unsigned value(860);
                              /* Codepage 860 - Portuguese           */
 dcl SQL_CP_862   fixed bin(16) unsigned value(862);
                              /* Codepage 862 - OS2 Hebrew           */
 dcl SQL_CP_863   fixed bin(16) unsigned value(863);
                              /* Codepage 863 - Canadian-French      */
 dcl SQL_CP_864   fixed bin(16) unsigned value(864);
                              /* Codepage 863 - OS2 Arabic           */
 dcl SQL_CP_865   fixed bin(16) unsigned value(865);
                              /* Codepage 865 - Norway, Denmark      */
 dcl SQL_CP_866   fixed bin(16) unsigned value(866);
                              /* Codepage 866 - Russia               */
 dcl SQL_CP_869   fixed bin(16) unsigned value(869);
                              /* Codepage 869 - OS2 Greece           */
 dcl SQL_CP_874   fixed bin(16) unsigned value(874);
                              /* Codepage 874 - OS2/AIX Thailand     */
 dcl SQL_CP_891   fixed bin(16) unsigned value(891);
                              /* Codepage 891 - Korean               */
 dcl SQL_CP_897   fixed bin(16) unsigned value(897);
                              /* Codepage 897 - Japanese             */
 dcl SQL_CP_903   fixed bin(16) unsigned value(903);
                              /* Codepage 903 - Chinese              */
 dcl SQL_CP_904   fixed bin(16) unsigned value(904);
                              /* Codepage 904 - Taiwan               */
 dcl SQL_CP_912   fixed bin(16) unsigned value(912);
                              /* Codepage 912 - AIX Latin2           */
 dcl SQL_CP_915   fixed bin(16) unsigned value(915);
                              /* Codepage 915 - AIX Cyrillic         */
 dcl SQL_CP_916   fixed bin(16) unsigned value(916);
                              /* Codepage 916 - AIX Hebrew           */
 dcl SQL_CP_920   fixed bin(16) unsigned value(920);
                              /* Codepage 920 - AIX Turkey           */
 dcl SQL_CP_921   fixed bin(16) unsigned value(921);
                              /* Codepage 921 - Latvia, Lithuania    */
 dcl SQL_CP_922   fixed bin(16) unsigned value(922);
                              /* Codepage 922 - Estonia              */
 dcl SQL_CP_1004  fixed bin(16) unsigned value(1004);
                              /* Codepage 1004 - MS-WINDOWS          */
 dcl SQL_CP_1040  fixed bin(16) unsigned value(1040);
                              /* Codepage 1040 - Extended Korean     */
 dcl SQL_CP_1041  fixed bin(16) unsigned value(1041);
                              /* Codepage 1041 - Extended Japanese   */
 dcl SQL_CP_1042  fixed bin(16) unsigned value(1042);
                              /* Codepage 1042 - Extended Chinese    */
 dcl SQL_CP_1043  fixed bin(16) unsigned value(1043);
                              /* Codepage 1043 - Extended Taiwan     */
 dcl SQL_CP_1046  fixed bin(16) unsigned value(1046);
                              /* Codepage 1046 - AIX Arabic          */
 dcl SQL_CP_1051  fixed bin(16) unsigned value(1051);
                              /* Codepage 1051 - HP Roman8           */
 dcl SQL_CP_1088  fixed bin(16) unsigned value(1088);
                              /* Codepage 1088 - Korea Std           */
 dcl SQL_CP_1089  fixed bin(16) unsigned value(1089);
                              /* Codepage 1089 - AIX Arabic          */
 dcl SQL_CP_1114  fixed bin(16) unsigned value(1114);
                              /* Codepage 1114 - Taiwan Big-5        */
 dcl SQL_CP_1115  fixed bin(16) unsigned value(1115);
                              /* Codepage 1115 - China GB            */
 dcl SQL_CP_1124  fixed bin(16) unsigned value(1124);
                              /* Codepage 1124 - AIX Ukraine         */
 dcl SQL_CP_1125  fixed bin(16) unsigned value(1125);
                              /* Codepage 1125 - OS/2 Ukraine        */
 dcl SQL_CP_1126  fixed bin(16) unsigned value(1126);
                              /* Codepage 1126 - Windows Korean Std  */
 dcl SQL_CP_1131  fixed bin(16) unsigned value(1131);
                              /* Codepage 1131 - OS/2 Belarus        */
 dcl SQL_CP_1163  fixed bin(16) unsigned value(1163);
                              /* Codepage 1163 - Vietnamese          */
 dcl SQL_CP_1250  fixed bin(16) unsigned value(1250);
                              /* Codepage 1250 - Windows Latin-2     */
 dcl SQL_CP_1251  fixed bin(16) unsigned value(1251);
                              /* Codepage 1251 - Windows Cyrillic    */
 dcl SQL_CP_1252  fixed bin(16) unsigned value(1252);
                              /* Codepage 1252 - Windows Latin-1     */
 dcl SQL_CP_1253  fixed bin(16) unsigned value(1253);
                              /* Codepage 1253 - Windows Greek       */
 dcl SQL_CP_1254  fixed bin(16) unsigned value(1254);
                              /* Codepage 1254 - Windows Turkish     */
 dcl SQL_CP_1255  fixed bin(16) unsigned value(1255);
                              /* Codepage 1255 - Windows Hebrew      */
 dcl SQL_CP_1256  fixed bin(16) unsigned value(1256);
                              /* Codepage 1256 - Windows Arabic      */
 dcl SQL_CP_1258  fixed bin(16) unsigned value(1258);
                              /* Codepage 1258 - Windows Vietnamese  */
 dcl SQL_CP_1275  fixed bin(16) unsigned value(1275);
                              /* Codepage 1275 - Mac Latin-1         */
 dcl SQL_CP_1280  fixed bin(16) unsigned value(1280);
                              /* Codepage 1280 - Mac Greek           */
 dcl SQL_CP_1281  fixed bin(16) unsigned value(1281);
                              /* Codepage 1281 - Mac Turkish         */
 dcl SQL_CP_1282  fixed bin(16) unsigned value(1282);
                              /* Codepage 1282 - Mac Latin-2         */
 dcl SQL_CP_1283  fixed bin(16) unsigned value(1283);
                              /* Codepage 1283 - Mac Cyrillic        */
 dcl SQL_CP_62208 fixed bin(16) unsigned value(62208);
                              /* CCSID xF300, (CP856, ST4)           */
 dcl SQL_CP_62209 fixed bin(16) unsigned value(62209);
                              /* CCSID xF301, (CP862, ST4)           */
 dcl SQL_CP_62210 fixed bin(16) unsigned value(62210);
                              /* CCSID xF302, (CP916, ST4)           */
 dcl SQL_CP_62213 fixed bin(16) unsigned value(62213);
                              /* CCSID xF305, (CP862, ST5)           */
 dcl SQL_CP_62220 fixed bin(16) unsigned value(62220);
                              /* CCSID xF30C, (CP856, ST6)           */
 dcl SQL_CP_62221 fixed bin(16) unsigned value(62221);
                              /* CCSID xF30D, (CP862, ST6)           */
 dcl SQL_CP_62222 fixed bin(16) unsigned value(62222);
                              /* CCSID xF30E, (CP916, ST6)           */
 dcl SQL_CP_62223 fixed bin(16) unsigned value(62223);
                              /* CCSID xF30F, (CP1255, ST6)          */
 dcl SQL_CP_62225 fixed bin(16) unsigned value(62225);
                              /* CCSID xF311, (CP864, ST6)           */
 dcl SQL_CP_62226 fixed bin(16) unsigned value(62226);
                              /* CCSID xF312, (CP1046, ST6)          */
 dcl SQL_CP_62227 fixed bin(16) unsigned value(62227);
                              /* CCSID xF313, (CP1089, ST6)          */
 dcl SQL_CP_62228 fixed bin(16) unsigned value(62228);
                              /* CCSID xF314, (CP1256, ST6)          */
 dcl SQL_CP_62230 fixed bin(16) unsigned value(62230);
                              /* CCSID xF316, (CP856, ST8)           */
 dcl SQL_CP_62231 fixed bin(16) unsigned value(62231);
                              /* CCSID xF317, (CP862, ST8)           */
 dcl SQL_CP_62232 fixed bin(16) unsigned value(62232);
                              /* CCSID xF318, (CP916, ST8)           */
 dcl SQL_CP_62236 fixed bin(16) unsigned value(62236);
                              /* CCSID xF31C, (CP856, ST10)          */
 dcl SQL_CP_62238 fixed bin(16) unsigned value(62238);
                              /* CCSID xF31E, (CP916, ST10)          */
 dcl SQL_CP_62239 fixed bin(16) unsigned value(62239);
                              /* CCSID xF31F, (CP1255, ST10)         */
 dcl SQL_CP_62241 fixed bin(16) unsigned value(62241);
                              /* CCSID xF321, (CP856, ST11)          */
 dcl SQL_CP_62242 fixed bin(16) unsigned value(62242);
                              /* CCSID xF322, (CP862, ST11)          */
 dcl SQL_CP_62243 fixed bin(16) unsigned value(62243);
                              /* CCSID xF323, (CP916, ST11)          */
 dcl SQL_CP_62244 fixed bin(16) unsigned value(62244);
                              /* CCSID xF324, (CP1255, ST11)         */

 /* DBCS Codepages */
 dcl SQL_CP_926   fixed bin(16) unsigned value(926);
                              /* Codepage 926 - Korean               */
 dcl SQL_CP_951   fixed bin(16) unsigned value(951);
                              /* Codepage 951 - New Korean           */
 dcl SQL_CP_301   fixed bin(16) unsigned value(301);
                              /* Codepage 301 - Japanese             */
 dcl SQL_CP_928   fixed bin(16) unsigned value(928);
                              /* Codepage 928 - Chinese              */
 dcl SQL_CP_927   fixed bin(16) unsigned value(927);
                              /* Codepage 927 - Taiwan               */
 dcl SQL_CP_941   fixed bin(16) unsigned value(941);
                              /* Codepage 941 - Japanese             */
 dcl SQL_CP_947   fixed bin(16) unsigned value(947);
                              /* Codepage 947 - Taiwan Big-5         */
 dcl SQL_CP_971   fixed bin(16) unsigned value(971);
                              /* Codepage 971 - Korean 5601          */
 dcl SQL_CP_1351  fixed bin(16) unsigned value(1351);
                              /* Codepage 1351 - Japanese            */
 dcl SQL_CP_1362  fixed bin(16) unsigned value(1362);
                              /* Codepage 1362 - Korean Windows      */
 dcl SQL_CP_1380  fixed bin(16) unsigned value(1380);
                              /* Codepage 1380 - China GB            */
 dcl SQL_CP_1382  fixed bin(16) unsigned value(1382);
                              /* Codepage 1382 - Simp Chinese GB     */
 dcl SQL_CP_1385 fixed bin(16) unsigned value(1385);
                              /* Codepage 1385 - Simp Chinese GBK    */
 dcl SQL_CP_13488 fixed bin(16) unsigned value(13488);
                              /* Codepage 13488 - UCS-2              */
 dcl SQL_CP_1200  fixed bin(16) unsigned value(1200);
                              /* Codepage 1200 - UCS-2               */

 /* Combined Codepages */
 dcl SQL_CP_934   fixed bin(16) unsigned value(934);
                              /* Codepage 891 + 926 - Korean         */
 dcl SQL_CP_949   fixed bin(16) unsigned value(949);
                              /* CP 1088 + 951 - Korean Std          */
 dcl SQL_CP_932   fixed bin(16) unsigned value(932);
                              /* Codepage 897 + 301 - Japanese       */
 dcl SQL_CP_936   fixed bin(16) unsigned value(936);
                              /* Codepage 903 + 928 - Chinese        */
 dcl SQL_CP_938   fixed bin(16) unsigned value(938);
                              /* Codepage 904 + 927 - Taiwan         */
 dcl SQL_CP_944   fixed bin(16) unsigned value(944);
                              /* Codepage 1040 + 926 - Ext.Korean    */
 dcl SQL_CP_942   fixed bin(16) unsigned value(942);
                              /* Codepage 1041 + 301 - Ext.Japanese  */
 dcl SQL_CP_943   fixed bin(16) unsigned value(943);
                              /* Codepage 1041 + 941 - Ext.Japanese  */
 dcl SQL_CP_946   fixed bin(16) unsigned value(946);
                              /* Codepage 1042 + 928 - Ext.Chinese   */
 dcl SQL_CP_948   fixed bin(16) unsigned value(948);
                              /* Codepage 1043 + 927 - Ext.Taiwan    */
 dcl SQL_CP_950   fixed bin(16) unsigned value(950);
                              /* Codepage 1114 + 947 - Taiwan Big5   */
 dcl SQL_CP_954   fixed bin(16) unsigned value(954);
                              /* Codepage 954 + 13488 - euc Japan    */
 dcl SQL_CP_964   fixed bin(16) unsigned value(964);
                              /* Codepage 964 + 13488 - euc Taiwan   */
 dcl SQL_CP_970   fixed bin(16) unsigned value(970);
                              /* Codepage  367 + 971 - Korean 5601   */
 dcl SQL_CP_1363  fixed bin(16) unsigned value(1363);
                              /* Codepage 1363 - Korean Windows      */
 dcl SQL_CP_1381  fixed bin(16) unsigned value(1381);
                              /* Codepage 1115 +1380 - China GB      */
 dcl SQL_CP_1383  fixed bin(16) unsigned value(1383);
                              /* Codepage  367 +1382 - Chinese GB    */
 dcl SQL_CP_1386  fixed bin(16) unsigned value(1386);
                              /* Codepage  1114 +1385 - Chinese GBK  */
 dcl SQL_CP_5488  fixed bin(16) unsigned value(5488);
                              /* Codepage  1200 + 1208 - Chinese     */
                              /* GB18030                             */
 dcl SQL_CP_1394  fixed bin(16) unsigned value(1394);
                              /* Codepage 1200 + 1208 - Japanese     */
                              /* Shift_JISX0213                      */
 dcl SQL_CP_5039  fixed bin(16) unsigned value(5039);
                              /* Codepage  1041 + 1351 - Japanese    */
 dcl SQL_CP_1208  fixed bin(16) unsigned value(1208);
                              /* Codepage  1208 + 1200 - UTF-8       */

 /* Datastream Types */
 dcl SQL_SBC_PC   fixed bin(31) value(0);
                              /* Single byte PC                      */
 dcl SQL_JPN_PC   fixed bin(31) value(1);
                              /* Japanese-PC                         */
 dcl SQL_CHN_PC   fixed bin(31) value(2);
                              /* Chinese-PC                          */
 dcl SQL_KOR_PC   fixed bin(31) value(3);
                              /* Korean-PC                           */
 dcl SQL_KSC_PC   fixed bin(31) value(4);
                              /* New Korean-PC                       */
 dcl SQL_KR5_PC   fixed bin(31) value(5);
                              /* Korean 5601                         */
 dcl SQL_TWN_PC   fixed bin(31) value(6);
                              /* Taiwan Big-5                        */
 dcl SQL_CGB_PC   fixed bin(31) value(7);
                              /* China GB                            */
 dcl SQL_CGBA_PC  fixed bin(31) value(8);
                              /* China GB on AIX                     */
 dcl SQL_EUCJP_PC fixed bin(31) value(9);
                              /* Japan euc                           */
 dcl SQL_EUCTW_PC fixed bin(31) value(10);
                              /* Taiwan euc                          */
 dcl SQL_UCS2_PC  fixed bin(31) value(11);
                              /* UCS-2                               */
 dcl SQL_KSC2_PC  fixed bin(31) value(12);
                              /* Korean Windows                      */
 dcl SQL_CGBK_PC  fixed bin(31) value(13);
                              /* China GBK                           */
 dcl SQL_UTF8_PC  fixed bin(31) value(14);
                              /* UTF-8                               */
 dcl SQL_UNKN_PC  fixed bin(31) value(255);
                              /* Unknown                             */

 /* AIX codeset & locale lengths */
 dcl SQL_CODESET_LEN fixed bin(31) value(9);
 dcl SQL_LOCALE_LEN  fixed bin(31) value(5);

 /* SQLCA Constants              */
 %dcl #SQL_RC_INVALID_SQLCA char ext;
 %if #SQL_RC_INVALID_SQLCA = '' %then %do;
 %#SQL_RC_INVALID_SQLCA = 'Y';
 dcl SQL_RC_INVALID_SQLCA fixed bin (31) value (-1); /* invalid sqlca */
 %end;

 /* Size of SQLCA                */
 %dcl SQLCA_SIZE char ext;
 %SQLCA_SIZE='stg(sqlca)'; /* SQLCA is not a type here! */

 /* SQL Error message token delimiter */

 dcl SQL_ERRMC_PRES char value('FF'x); /* delimiter for string entry */

 /* Offset in SQLERRD - Diagnostic information */
 dcl SQL_ERRD_RC          fixed bin(31) value(0);
                              /* return code                         */
 dcl SQL_ERRD_REAS        fixed bin(31) value(1);
                              /* reason code                         */
 dcl SQL_ERRD_CNT         fixed bin(31) value(2);
                              /* nbr rows inserted/updated/deleted   */
 dcl SQL_ERRD_OPT_CARD    fixed bin(31) value(2);
                              /* optimizer estimate of # rows        */
 dcl SQL_ERRD_OPTM        fixed bin(31) value(3);
                              /* obsolete -- do not use --           */
 dcl SQL_ERRD_OPT_TOTCOST fixed bin(31) value(3);
                              /* optimzer estimate of total cost     */
 dcl SQL_ERRD_DCNT        fixed bin(31) value(4);
                              /* nbr of cascaded deletes/updates     */
 dcl SQL_ERRD_LINE        fixed bin(31) value(4);
                              /* line number for recompile error     */
 dcl SQL_ERRD_AUTHTYPE    fixed bin(31) value(4);
                              /* authentication type returned for    */
                              /* CONNECT/ATTACH                      */
 dcl SQL_ERRD_DIAG        fixed bin(31) value(5);
                              /* diagnostics                         */

 /* Indexes in SQLWARN - Warning flags  */
 dcl SQL_WARN_ANY         fixed bin(31) value(0);
                              /* composite - set if any warnings     */
 dcl SQL_WARN_TRUNC       fixed bin(31) value(1);
                              /* string column truncated             */
 dcl SQL_WARN_NUL         fixed bin(31) value(2);
                              /* null values eliminated              */
 dcl SQL_WARN_MISM        fixed bin(31) value(3);
                              /* nbr of columns/host vars mismatch   */
 dcl SQL_WARN_ALLR        fixed bin(31) value(4);
                              /* no WHERE clause in update/delete    */
 dcl SQL_WARN_DATE        fixed bin(31) value(6);
                              /* date has been truncated             */
 dcl SQL_WARN_SUB         fixed bin(31) value(8);
                              /* character conversion substitution   */
 dcl SQL_WARN_NUL2        fixed bin(31) value(9);
                              /* arithmetic error nulls eliminated   */
 dcl SQL_WARN_SQLCA       fixed bin(31) value(10);
                              /* SQLCA conversion error              */

 /* Values for Warning flags in SQLWARN */
                              /* warning indicator                   */
 dcl SQL_WARNING          char value('W');
                              /* null terminator truncated warning   */
 dcl SQL_NULL_TRN         char value('N');
                              /* truncation warning with             */
                              /* application context length          */
                              /* returned in sqlind                  */
 dcl SQL_TRN_APP_LEN      char value('X');
                              /* no warning indicator                */
 dcl SQL_NO_WARN          char value(' ');

 /* SQLDA Constants */

 /* Increment for type with null indicator */
 dcl SQL_TYP_NULINC       fixed bin(31) value(1);

 /* Variable Types */
 /* DATE                                */
 dcl SQL_TYP_DATE    fixed bin(31) value(384);
 dcl SQL_TYP_NDATE   fixed bin(31) value(SQL_TYP_DATE+SQL_TYP_NULINC);

 /* TIME                                */
 dcl SQL_TYP_TIME    fixed bin(31) value(388);
 dcl SQL_TYP_NTIME   fixed bin(31) value(SQL_TYP_TIME+SQL_TYP_NULINC);

 /* TIMESTAMP                           */
 dcl SQL_TYP_STAMP   fixed bin(31) value(392);
 dcl SQL_TYP_NSTAMP  fixed bin(31) value(SQL_TYP_STAMP+SQL_TYP_NULINC);

 /* DATALINK                            */
 dcl SQL_TYP_DATALINK fixed bin(31) value(396);
 dcl SQL_TYP_NDATALINK
                  fixed bin(31) value(SQL_TYP_DATALINK+SQL_TYP_NULINC);

 /* C NUL-terminated graphic str        */
 dcl SQL_TYP_CGSTR   fixed bin(31) value(400);
 dcl SQL_TYP_NCGSTR  fixed bin(31) value(SQL_TYP_CGSTR+SQL_TYP_NULINC);

 /* BLOB - varying length string        */
 dcl SQL_TYP_BLOB    fixed bin(31) value(404);
 dcl SQL_TYP_NBLOB   fixed bin(31) value(SQL_TYP_BLOB+SQL_TYP_NULINC);

 /* CLOB - varying length string        */
 dcl SQL_TYP_CLOB    fixed bin(31) value(408);
 dcl SQL_TYP_NCLOB   fixed bin(31) value(SQL_TYP_CLOB+SQL_TYP_NULINC);

 /* DBCLOB - varying length string      */
 dcl SQL_TYP_DBCLOB  fixed bin(31) value(412);
 dcl SQL_TYP_NDBCLOB fixed bin(31) value(SQL_TYP_DBCLOB+SQL_TYP_NULINC);

 /* VARCHAR(i) - varying length string (2 byte length) */
 dcl SQL_TYP_VARCHAR fixed bin(31) value(448);
 dcl SQL_TYP_NVARCHAR
                    fixed bin(31) value(SQL_TYP_VARCHAR+SQL_TYP_NULINC);

 /* CHAR(i) - fixed length string       */
 dcl SQL_TYP_CHAR    fixed bin(31) value(452);
 dcl SQL_TYP_NCHAR   fixed bin(31) value(SQL_TYP_CHAR+SQL_TYP_NULINC);

 /* LONG VARCHAR - varying length string */
 dcl SQL_TYP_LONG    fixed bin(31) value(456);
 dcl SQL_TYP_NLONG   fixed bin(31) value(SQL_TYP_LONG+SQL_TYP_NULINC);

 /* varying length string for C (null terminated) */
 dcl SQL_TYP_CSTR    fixed bin(31) value(460);
 dcl SQL_TYP_NCSTR   fixed bin(31) value(SQL_TYP_CSTR+SQL_TYP_NULINC);

 /* VARGRAPHIC(i) - varying length graphic string (2 byte length) */
 dcl SQL_TYP_VARGRAPH fixed bin(31) value(464);
 dcl SQL_TYP_NVARGRAPH
                  fixed bin(31) value(SQL_TYP_VARGRAPH+SQL_TYP_NULINC);

 /* GRAPHIC(i) - fixed length graphic string */
 dcl SQL_TYP_GRAPHIC fixed bin(31) value(468);
 dcl SQL_TYP_NGRAPHIC
                   fixed bin(31) value(SQL_TYP_GRAPHIC+SQL_TYP_NULINC);

 /* LONG VARGRAPHIC(i) - varying length graphic string */
 dcl SQL_TYP_LONGRAPH fixed bin(31) value(472);
 dcl SQL_TYP_NLONGRAPH
                  fixed bin(31) value(SQL_TYP_LONGRAPH+SQL_TYP_NULINC);

 /* varying length string for Pascal (1-byte length) */
 dcl SQL_TYP_LSTR    fixed bin(31) value(476);
 dcl SQL_TYP_NLSTR   fixed bin(31) value(SQL_TYP_LSTR+SQL_TYP_NULINC);

 /* FLOAT - 8-byte floating point       */
 dcl SQL_TYP_FLOAT   fixed bin(31) value(480);
 dcl SQL_TYP_NFLOAT  fixed bin(31) value(SQL_TYP_FLOAT+SQL_TYP_NULINC);

 /* DECIMAL (m,n)                       */
 dcl SQL_TYP_DECIMAL fixed bin(31) value(484);
 dcl SQL_TYP_NDECIMAL
                   fixed bin(31) value(SQL_TYP_DECIMAL+SQL_TYP_NULINC);

 /* Zoned Decimal -> DECIMAL (m,n)      */
 dcl SQL_TYP_ZONED   fixed bin(31) value(488);
 dcl SQL_TYP_NZONED  fixed bin(31) value(SQL_TYP_ZONED+SQL_TYP_NULINC);

 /* BIGINT - 8-byte signed integer      */
 dcl SQL_TYP_BIGINT  fixed bin(31) value(492);
 dcl SQL_TYP_NBIGINT fixed bin(31) value(SQL_TYP_BIGINT+SQL_TYP_NULINC);

 /* INTEGER - 4-byte signed integer     */
 dcl SQL_TYP_INTEGER fixed bin(31) value(496);
 dcl SQL_TYP_NINTEGER
                   fixed bin(31) value(SQL_TYP_INTEGER+SQL_TYP_NULINC);

 /* SMALLINT - 2-byte signed integer    */
 dcl SQL_TYP_SMALL   fixed bin(31) value(500);
 dcl SQL_TYP_NSMALL  fixed bin(31) value(SQL_TYP_SMALL+SQL_TYP_NULINC);

 /* NUMERIC -> DECIMAL (m,n)            */
 dcl SQL_TYP_NUMERIC fixed bin(31) value(504);
 dcl SQL_TYP_NNUMERIC
                   fixed bin(31) value(SQL_TYP_NUMERIC+SQL_TYP_NULINC);

 /* Obsolete Value                      */
 dcl SQL_TYP_BLOB_FILE_OBSOLETE    fixed bin(31) value(804);
 dcl SQL_TYP_NBLOB_FILE_OBSOLETE   fixed bin(31)
                    value(SQL_TYP_BLOB_FILE_OBSOLETE+SQL_TYP_NULINC);

 /* Obsolete Value                      */
 dcl SQL_TYP_CLOB_FILE_OBSOLETE    fixed bin(31) value(808);
 dcl SQL_TYP_NCLOB_FILE_OBSOLETE   fixed bin(31)
                    value(SQL_TYP_CLOB_FILE_OBSOLETE+SQL_TYP_NULINC);

 /* Obsolete Value                      */
 dcl SQL_TYP_DBCLOB_FILE_OBSOLETE  fixed bin(31) value(812);
 dcl SQL_TYP_NDBCLOB_FILE_OBSOLETE fixed bin(31)
                    value(SQL_TYP_DBCLOB_FILE_OBSOLETE+SQL_TYP_NULINC);

 /* BLOB File - Binary Large Object File */
 dcl SQL_TYP_BLOB_FILE     fixed bin(31) value(916);
 dcl SQL_TYP_NBLOB_FILE
                 fixed bin(31) value(SQL_TYP_BLOB_FILE+SQL_TYP_NULINC);

 /* CLOB File - Char Large Object File  */
 dcl SQL_TYP_CLOB_FILE     fixed bin(31) value(920);
 dcl SQL_TYP_NCLOB_FILE
                 fixed bin(31) value(SQL_TYP_CLOB_FILE+SQL_TYP_NULINC);

 /* DBCLOB File - Double Byte Char Large Object File */
 dcl SQL_TYP_DBCLOB_FILE   fixed bin(31) value(924);
 dcl SQL_TYP_NDBCLOB_FILE
               fixed bin(31) value(SQL_TYP_DBCLOB_FILE+SQL_TYP_NULINC);

 /* BLOB locator                        */
 dcl SQL_TYP_BLOB_LOCATOR  fixed bin(31) value(960);
 dcl SQL_TYP_NBLOB_LOCATOR
              fixed bin(31) value(SQL_TYP_BLOB_LOCATOR+SQL_TYP_NULINC);

 /* CLOB locator                        */
 dcl SQL_TYP_CLOB_LOCATOR  fixed bin(31) value(964);
 dcl SQL_TYP_NCLOB_LOCATOR
              fixed bin(31) value(SQL_TYP_CLOB_LOCATOR+SQL_TYP_NULINC);

 /* DBCLOB locator                      */
 dcl SQL_TYP_DBCLOB_LOCATOR fixed bin(31) value(968);
 dcl SQL_TYP_NDBCLOB_LOCATOR
            fixed bin(31) value(SQL_TYP_DBCLOB_LOCATOR+SQL_TYP_NULINC);

 dcl SQL_LOBTOKEN_LEN      fixed bin(31) value(SQL_LOBLOCATOR_LEN);
 dcl SQL_TYP_BLOB_TOKEN    fixed bin(31) value(SQL_TYP_BLOB_LOCATOR);
 dcl SQL_TYP_NBLOB_TOKEN   fixed bin(31) value(SQL_TYP_NBLOB_LOCATOR);
 dcl SQL_TYP_CLOB_TOKEN    fixed bin(31) value(SQL_TYP_CLOB_LOCATOR);
 dcl SQL_TYP_NCLOB_TOKEN   fixed bin(31) value(SQL_TYP_NCLOB_LOCATOR);
 dcl SQL_TYP_DBCLOB_TOKEN  fixed bin(31) value(SQL_TYP_DBCLOB_LOCATOR);
 dcl SQL_TYP_NDBCLOB_TOKEN fixed bin(31) value(SQL_TYP_NDBCLOB_LOCATOR);
 dcl SQL_NCLOB_MAXLEN      fixed bin(31) value(SQL_DBCLOB_MAXLEN);
 dcl SQL_LOBHANDLE_LEN     fixed bin(31) value(SQL_LOBTOKEN_LEN);
 dcl SQL_TYP_BLOB_HANDLE   fixed bin(31) value(SQL_TYP_BLOB_TOKEN);
 dcl SQL_TYP_NBLOB_HANDLE  fixed bin(31) value(SQL_TYP_NBLOB_TOKEN);
 dcl SQL_TYP_CLOB_HANDLE   fixed bin(31) value(SQL_TYP_CLOB_TOKEN);
 dcl SQL_TYP_NCLOB_HANDLE  fixed bin(31) value(SQL_TYP_NCLOB_TOKEN);
 dcl SQL_TYP_DBCLOB_HANDLE fixed bin(31) value(SQL_TYP_DBCLOB_TOKEN);
 dcl SQL_TYP_NDBCLOB_HANDLE fixed bin(31) value(SQL_TYP_NDBCLOB_TOKEN);

 /* Values for 30th byte of sqlname */
 dcl SQL_SQLNAME_SYSGEN     char value('FF'x);
                                    /* sqlname is system generated   */
 dcl SQL_SQLNAME_NOT_SYSGEN char value('00'x);
                                    /* sqlname is directly derived   */
                                    /* from a single column or       */
                                    /* specified in the AS clause    */

 /* Return Codes for sqlabndx and sqlaprep */
 dcl SQLA_RC_OPT_IGNORED    fixed bin(31) value(20);
                              /* The option(s) specified are not     */
                              /* supported by the target  database   */
                              /* and will be ignored                 */
 dcl SQLA_RC_BINDWARN        fixed bin(31) value(25);
                              /* Bind execution succeeded with       */
                              /* warnings.                           */
 dcl SQLA_RC_PREPWARN        fixed bin(31) value(25);
                              /* Precompilation succeeded with       */
                              /* warnings.                           */
 dcl SQLA_RC_BINDERROR       fixed bin (31) value(-1);
                              /* Bind execution failed               */
 dcl SQLA_RC_PREPERROR       fixed bin (31) value(-1);
                              /* Precompilation failed               */
 dcl SQLA_RC_BAD_BINDNAME    fixed bin (31) value(-2);
                              /* Invalid bind file                   */
 dcl SQLA_RC_BAD_DBNAME      fixed bin (31) value(-3);
                              /* Invalid database                    */
 dcl SQLA_RC_BAD_MSGNAME     fixed bin (31) value(-5);
                              /* Invalid message file                */
 dcl SQLA_RC_BAD_FORMAT      fixed bin (31) value(-6);
                              /* Invalid format                      */
 dcl SQLA_RC_OPEN_ERROR      fixed bin (31) value(-31);
                              /* Error opening list file             */
 dcl SQLA_RC_MFILE_OPEN_ERR  fixed bin (31) value(-35);
                              /* Error opening message file          */
 dcl SQLA_RC_FILE_NAME_BAD   fixed bin (31) value(-36);
                              /* Source file name is invalid         */
 dcl SQLA_RC_BAD_BNDFILE     fixed bin (31) value(-39);
                              /* Bind file corrupted                 */
 dcl SQLA_RC_LIST_ERROR      fixed bin (31) value(-40);
                              /* Bind list errors                    */
 dcl SQLA_RC_INTERRUPT       fixed bin (31) value(-94);
                              /* Interrupt                           */
 dcl SQLA_RC_OSERROR         fixed bin (31) value(-1086);
                              /* System error                        */
 dcl SQLA_RC_PREP_BIND_BUSY  fixed bin (31) value(-1392);
                              /* Prep/Bind already in use            */
 dcl SQLA_RC_OPTION_LEN_BAD  fixed bin (31) value(-4903);
                              /* Invalid parm. length                */
 dcl SQLA_RC_OPTION_PTR_BAD  fixed bin (31) value(-4904);
                              /* Invalid parm. ptr                   */
 dcl SQLA_RC_OPTION_SIZE_BAD fixed bin (31) value(-4905);
                              /* Invalid parm. size                  */
 dcl SQLA_RC_OPTION_DATA_BAD fixed bin (31) value(-4917);
                              /* Invalid parm. data                  */
 dcl SQLA_RC_OPTION_INVALID  fixed bin (31) value(-4930);
                              /* Invalid option or option value      */
 dcl SQLA_RC_SDK_LICENSE     fixed bin (31) value(-8005);
                              /* No SDK/6000 license                 */

 /* Values used for the date/time format parameter of sqlabind()    */
 /* ** OBSOLETE   */

 dcl SQL_FMT_DEF char value("DEF");
                              /* FORMAT = Default for Country Code   */
 dcl SQL_FMT_USA char value("USA");
                              /* FORMAT = USA                        */
 dcl SQL_FMT_EUR char value("EUR");
                              /* FORMAT = EUR                        */
 dcl SQL_FMT_ISO char value("ISO");
                              /* FORMAT = ISO                        */
 dcl SQL_FMT_JIS char value("JIS");
                              /* FORMAT = JIS                        */
 dcl SQL_FMT_LOC char value("LOC");
                              /* FORMAT = LOCAL                      */

 /* The size of a date/time format buffer */
 dcl SQL_FMT_LENGTH fixed bin(31) value(3);

 /* Structures used system wide           */

 define structure
   1 sqlchar,                /* General-purpose VARCHAR for casting  */
     2 length fixed bin(15),
     2 data   char(1);       /* REFER */


 define structure
   1 sqlgraphic,             /* General-purpose VARGRAPHIC for casting*/
     2 length fixed bin(15),
     2 data   graphic (1);   /* REFER */


 define structure
   1 sqllob,                 /* General-purpose LOB for casting       */
     2 length unsigned fixed bin(32),
     2 data   char(1);       /* REFER */


 define structure
   1 sqldbclob,              /* General-purpose DBCLOB for casting   */
     2 length unsigned fixed bin(32),
     2 data   graphic (1);   /* REFER */


 define structure
   1 sqlfile,                /* File reference structure for LOBs   */
     2 name_length  unsigned fixed bin(32),
     2 data_length  unsigned fixed bin(32),
     2 file_options unsigned fixed bin(32),
     2 name         char(254) varz;


 /* Values used for file_options in the sqlfile structure */
 dcl SQL_FILE_READ            fixed bin(31) value(2);
                              /* Input file to read from             */
 dcl SQL_FILE_CREATE          fixed bin(31) value(8);
                              /* Output file - new file to be        */
                              /* created                             */
 dcl SQL_FILE_OVERWRITE       fixed bin(31) value(16);
                              /* Output file - overwrite existing    */
                              /* file or create a new file if it     */
                              /* doesn't exist                       */
 dcl SQL_FILE_APPEND          fixed bin(31) value(32);
                              /* Output file - append to an          */
                              /* existing file or create a new file  */
                              /* if it doesn't exist                 */

 /* Structure used to store binder options when calling sqlabndr() */
 /* or sqlabndx() or to store precompile options when calling      */
 /* sqlaprep().                                                    */

 %dcl SQL_BIND_OPTS char ext;
 %if SQL_BIND_OPTS = '' %then %do;

 define structure
   1 sqloptheader,                    /* Header for sqlopt structure */
                                      /* Number of options allocated */
      2 allocated unsigned fixed bin(32),
      2 used      unsigned fixed bin(32);  /* Number of options used */


 define structure
   1 sqloptions,                      /* bind/prep option          */
      2 type   unsigned fixed bin(32),  /* Type of bind/prep option  */
      2 val    unsigned fixed bin(32);  /* Value of bind/prep option */

 define structure
   1 sqlopt,
     2 header type sqloptheader,      /* Header for sqlopt structure */
                                      /* Array of bind/prep options  */
     2 option (1) type sqloptions;    /* REFER (header.used)         */


 %SQL_BIND_OPTS = 'Y';
 %end;

 define alias sqlbindopt type sqloptions;

 /* Values used for option[n].type in the sqloptions structure */
 /* of sqlabndx() and sqlaprep().                              */
 dcl SQL_DATETIME_OPT         fixed bin(31) value(1);
                              /* Option for date/time format - bind  */
                              /* and precompile option               */
 dcl SQL_STANDARDS_OPT        fixed bin(31) value(2);
                              /* Option for standards level          */
                              /* compliance - precompile option      */
                              /* only                                */
 dcl SQL_ISO_OPT              fixed bin(31) value(4);
                              /* Option for isolation level - bind   */
                              /* and precompile option               */
 dcl SQL_BLOCK_OPT            fixed bin(31) value(5);
                              /* Option for record blocking - bind   */
                              /* and precompile option               */
 dcl SQL_GRANT_OPT            fixed bin(31) value(6);
                              /* Option for granting privileges -    */
                              /* bind option only                    */
 dcl SQL_FLAG_OPT             fixed bin(31) value(8);
                              /* Option for the Flagger -            */
                              /* precompile option only              */
 dcl SQL_GRANT_USER_OPT       fixed bin(31) value(9);
                              /* Option for granting privileges to   */
                              /* a user - bind option only           */
 dcl SQL_GRANT_GROUP_OPT      fixed bin(31) value(10);
                              /* Option for granting privileges to   */
                              /* a group - bind option only          */
 dcl SQL_CNULREQD_OPT         fixed bin(31) value(11);
                              /* Option for adding NULLs to strings  */
                              /* - bind option only                  */
 dcl SQL_GENERIC_OPT          fixed bin(31) value(12);
                              /* Generic option for DRDA servers -   */
                              /* bind option only                    */
 dcl SQL_DEFERRED_PREPARE_OPT fixed bin(31) value(15);
                              /* Option for Deferred Prepare -       */
                              /* precompile option only              */
 dcl SQL_CONNECT_OPT          fixed bin(31) value(16);
                              /* Specifies whether one or multiple   */
                              /* connections are allowed             */
                              /* similtaneously within a unit of     */
                              /* work.                               */
 dcl SQL_RULES_OPT            fixed bin(31) value(17);
                              /* Specifies the set of rules used     */
                              /* for connection to multiple          */
                              /* databases within a single unit of   */
                              /* work                                */
 dcl SQL_DISCONNECT_OPT       fixed bin(31) value(18);
                              /* Specifies which of multiple         */
                              /* databases connected to will be      */
                              /* disconnected when a COMMIT or       */
                              /* ROLLBACK is issued.                 */
 dcl SQL_SYNCPOINT_OPT        fixed bin(31) value(19);
                              /* Specifies what syncpoint option     */
                              /* (for example one phase or two       */
                              /* phase) will be used                 */
 dcl SQL_BIND_OPT             fixed bin(31) value(20);
                              /* Option to create a bind file -      */
                              /* precompile option only              */
 dcl SQL_SAA_OPT              fixed bin(31) value(21);
                              /* Option specifies SAA/non-SAA        */
                              /* compatibility - FORTRAN precompile  */
                              /* option only                         */
 dcl SQL_PKG_OPT              fixed bin(31) value(23);
                              /* Option to create a package with a   */
                              /* specific name - precompile option   */
                              /* only                                */
 dcl SQL_OPTIM_OPT            fixed bin(31) value(24);
                              /* Option to specify SQLDA             */
                              /* optimization - precompile option    */
                              /* only                                */
 dcl SQL_SYNTAX_OPT           fixed bin(31) value(25);
                              /* Option to not create a package or   */
                              /* bind file - precompile option only  */
 dcl SQL_SQLERROR_OPT         fixed bin(31) value(SQL_SYNTAX_OPT);
                              /* Indicates under what                */
                              /* conditions a package will be be     */
                              /* created - bind and precompile       */
                              /* option                              */
 dcl SQL_LINEMACRO_OPT        fixed bin(31) value(26);
                              /* Option to suppress #line macro      */
                              /* generation in modified source file  */
                              /* - C precompile option only          */
 dcl SQL_NO_OPT               fixed bin(31) value(27);
                              /* 'No-op' option - ignore this entry  */
                              /* in the option array - bind and      */
                              /* precompile option                   */
 dcl SQL_LEVEL_OPT            fixed bin(31) value(30);
                              /* Level of a module - precompile      */
                              /* option only                         */
 dcl SQL_COLLECTION_OPT       fixed bin(31) value(31);
                              /* Package collection identifier -     */
                              /* precompile option only              */
 dcl SQL_VERSION_OPT          fixed bin(31) value(32);
                              /* Package version identifier -        */
                              /* precompile option only              */
 dcl SQL_OWNER_OPT            fixed bin(31) value(33);
                              /* Package owner authorization         */
                              /* identifier - bind and precompile    */
                              /* option                              */
 dcl SQL_SCHEMA_OPT           fixed bin(31) value(SQL_OWNER_OPT);
                              /* Synonym for owner - bind and        */
                              /* precompile option                   */
 dcl SQL_QUALIFIER_OPT        fixed bin(31) value(34);
                              /* Authorization identifier that is    */
                              /* to be used as a qualifier for       */
                              /* unqualified objects - bind and      */
                              /* precompile option                   */
 dcl SQL_CATALOG_OPT          fixed bin(31) value(SQL_QUALIFIER_OPT);
                              /* Synonym for qualifier -             */
                              /* bind and precompile option          */
 dcl SQL_TEXT_OPT             fixed bin(31) value(35);
                              /* Package description - bind and      */
                              /* precompile option                   */
 dcl SQL_VALIDATE_OPT         fixed bin(31) value(40);
                              /* Indicates when object validation    */
                              /* occurs - bind and precompile        */
                              /* option                              */
 dcl SQL_EXPLAIN_OPT          fixed bin(31) value(41);
                              /* Determines whether information      */
                              /* will be produced about how the SQL  */
                              /* statements in a package will be     */
                              /* executed - bind and precompile      */
                              /* option                              */
 dcl SQL_ACTION_OPT           fixed bin(31) value(42);
                              /* Indicates whether a package is to   */
                              /* be added or replaced - bind and     */
                              /* precompile option                   */
 dcl SQL_REPLVER_OPT          fixed bin(31) value(44);
                              /* Replaces a specific version of a    */
                              /* package - bind and precompile       */
                              /* option                              */
 dcl SQL_RETAIN_OPT           fixed bin(31) value(45);
                              /* Indicates whether EXECUTE           */
                              /* authorities are to be preserved     */
                              /* when a package is replaced - bind   */
                              /* and precompile option               */
 dcl SQL_RELEASE_OPT          fixed bin(31) value(46);
                              /* Indicates whether resources are     */
                              /* released at each COMMIT or when     */
                              /* the application  terminates - bind  */
                              /* and precompile option               */
 dcl SQL_DEGREE_OPT           fixed bin(31) value(47);
                              /* Specifies whether or not the query  */
                              /* is executed using I/O parallelism   */
                              /*  bind and precompile option         */
 dcl SQL_STRDEL_OPT           fixed bin(31) value(50);
                              /* Designates whether an apostrophe    */
                              /* or quote will be used as a string   */
                              /* delimiter - bind and precompile     */
                              /* option                              */
 dcl SQL_DECDEL_OPT           fixed bin(31) value(51);
                              /* Designates whether a period or      */
                              /* comma will be used as a decimal     */
                              /* point indicator - bind and          */
                              /* precompile option                   */
 dcl SQL_CHARSUB_OPT          fixed bin(31) value(55);
                              /* Designates default character        */
                              /* subtype that is to be used for      */
                              /* column definitions in the CREATE    */
                              /* and ALTER TABLE SQL statements -    */
                              /* bind and precompile option          */
 dcl SQL_CCSIDS_OPT           fixed bin(31) value(56);
                              /* Designates what CCSID will be used  */
                              /* for single byte characters for      */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
 dcl SQL_CCSIDM_OPT           fixed bin(31) value(57);
                              /* Designates what CCSID will be used  */
                              /* for mixed byte characters for       */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
 dcl SQL_CCSIDG_OPT           fixed bin(31) value(58);
                              /* Designates what CCSID will be used  */
                              /* for double byte characters for      */
                              /* character column definitions        */
                              /* without a specific CCSID clause in  */
                              /* the CREATE and ALTER TABLE SQL      */
                              /* statements - bind and precompile    */
                              /* option                              */
 dcl SQL_DEC_OPT              fixed bin(31) value(59);
                              /* Specifies maximum precision to be   */
                              /* used in decimal arithmetic          */
                              /* operations - bind and precompile    */
                              /* option                              */
 dcl SQL_WCHAR_OPT            fixed bin(31) value(60);
                              /* Specifies handling of graphic       */
                              /* vars. - precompile only             */
 dcl SQL_DYNAMICRULES_OPT     fixed bin(31) value(61);
                              /* Specifies which authorization       */
                              /* identifier to use when dynamic SQL  */
                              /* in a package is executed. Owner of  */
                              /* package or authid executing         */
                              /* package - bind and precompile       */
                              /* option                              */
 dcl SQL_INSERT_OPT           fixed bin(31) value(62);
                              /* Buffers VALUE inserts - bind and    */
                              /* precompile option for DB2/PE        */
                              /* servers only                        */
 dcl SQL_EXPLSNAP_OPT         fixed bin(31) value(63);
                              /* Capture explain snapshot - bind     */
                              /* and precompile option               */
 dcl SQL_FUNCTION_PATH        fixed bin(31) value(64);
                              /* Path for user-defined function      */
                              /* resolution - bind and precompile    */
                              /* option                              */
 dcl SQL_SQLWARN_OPT          fixed bin(31) value(65);
                              /* Disable prepare-time SQL warnings   */
                              /*  bind and precompile option         */
 dcl SQL_QUERYOPT_OPT         fixed bin(31) value(66);
                              /* Set query optimization class -      */
                              /* bind and precompile option          */
 dcl SQL_TARGET_OPT           fixed bin(31) value(67);
                              /* Target compiler - precompile        */
                              /* option                              */
 dcl SQL_PREP_OUTPUT_OPT      fixed bin(31) value(68);
                              /* Name of precompiler output file -   */
                              /* precompile option                   */
 dcl SQL_PREPROCESSOR_OPT     fixed bin(31) value(69);
                              /* Preprocessor command - precompile   */
                              /* option only                         */
 dcl SQL_RESOLVE_OPT          fixed bin(31) value(70);
                              /* Indicates whether function and      */
                              /* type resolution should or should    */
                              /* not use conservative binding        */
                              /* semantics - rebind option only      */
 dcl SQL_CLIPKG_OPT           fixed bin(31) value(71);
                              /* CLIPKG option - bind option only    */
 dcl SQL_FEDERATED_OPT        fixed bin(31) value(72);
                              /* FEDERATED option - bind and         */
                              /* precompile option                   */
 dcl SQL_TRANSFORMGROUP_OPT   fixed bin(31) value(73);
                              /* Transform Group - precompile and    */
                              /* bind option                         */
 dcl SQL_LONGERROR_OPT        fixed bin(31) value(74);
                              /* Option to treat long host variable  */
                              /* declarations as errors -            */
                              /* precompile option only              */
 dcl SQL_DECTYPE_OPT          fixed bin(31) value(75);
                              /* DECTYPE Option to convert decimals  */
                              /*  precompile option only             */
 dcl SQL_PSM_OPT              fixed bin(31) value(76);
                              /* PSM option - bind option            */

 dcl SQL_NUM_OPTS             fixed bin(31) value(76);
                              /* # of PREP/BIND/REBIND options       */

 /* Values used for option[n].val when option[n].type is       */
 /* SQL_DATETIME_OPT. These can also be used for the date/time */
 /* format parameter of sqlabind().                            */

 dcl SQL_DATETIME_DEF         fixed bin(31) value(48);
                              /* FORMAT = Default for Country Code   */
 dcl SQL_DATETIME_USA         fixed bin(31) value(49);
                              /* FORMAT = USA                        */
 dcl SQL_DATETIME_EUR         fixed bin(31) value(50);
                              /* FORMAT = EUR                        */
 dcl SQL_DATETIME_ISO         fixed bin(31) value(51);
                              /* FORMAT = ISO                        */
 dcl SQL_DATETIME_JIS         fixed bin(31) value(52);
                              /* FORMAT = JIS                        */
 dcl SQL_DATETIME_LOC         fixed bin(31) value(53);
                              /* FORMAT = LOCAL                      */

 /* The following constants are here for backwards compatbility with */
 /* earlier releases. */

 dcl SQL_FRMT_OPT             fixed bin(31) value(SQL_DATETIME_OPT);
 dcl SQL_FMT_0                fixed bin(31) value(SQL_DATETIME_DEF);
 dcl SQL_FMT_1                fixed bin(31) value(SQL_DATETIME_USA);
 dcl SQL_FMT_2                fixed bin(31) value(SQL_DATETIME_EUR);
 dcl SQL_FMT_3                fixed bin(31) value(SQL_DATETIME_ISO);
 dcl SQL_FMT_4                fixed bin(31) value(SQL_DATETIME_JIS);
 dcl SQL_FMT_5                fixed bin(31) value(SQL_DATETIME_LOC);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_STANDARDS_OPT.    */
 dcl SQL_SAA_COMP             fixed bin(31) value(0);
                              /* SAA Level 1 Database CPI            */
 dcl SQL_MIA_COMP             fixed bin(31) value(1);
                              /* MIA                                 */
 dcl SQL_SQL92E_COMP          fixed bin(31) value(2);
                              /* SQL92 Entry                         */

 /* Values used for option[n].val when option[n].type is   */
 /* SQL_ISO_OPT */
 dcl SQL_REP_READ             fixed bin(31) value(0);
                              /* Repeatable read level               */
 dcl SQL_CURSOR_STAB          fixed bin(31) value(1);
                              /* Cursor stability level              */
 dcl SQL_UNCOM_READ           fixed bin(31) value(2);
                              /* Uncommitted read level              */
 dcl SQL_READ_STAB            fixed bin(31) value(3);
                              /* Read stability level                */
 dcl SQL_NO_COMMIT            fixed bin(31) value(4);
                              /* No Commit level      l              */

 /* Values used for option[n].val when option[n].type is     */
 /* SQL_BLOCK_OPT */
 dcl SQL_BL_UNAMBIG           fixed bin(31) value(0);
                              /* Block Unambiguous cursors           */
 dcl SQL_BL_ALL               fixed bin(31) value(1);
                              /* Block All cursors                   */
 dcl SQL_NO_BL                fixed bin(31) value(2);
                              /* Block No cursors                    */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_FLAG_OPT */
 dcl SQL_MVSDB2V23_SYNTAX     fixed bin(31) value(4);
                              /* Flagger check against MVS           */
 dcl SQL_MVSDB2V31_SYNTAX     fixed bin(31) value(5);
                              /* DB2 V2.3, V3.1 or V4.1 SQL          */
 dcl SQL_MVSDB2V41_SYNTAX     fixed bin(31) value(6);
                              /* syntax                              */
 dcl SQL_SQL92E_SYNTAX        fixed bin(31) value(7);
                              /* FIPS flagger SQL92E syntax          */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_CNULREQD_OPT      */
 dcl SQL_CNULREQD_NO          fixed bin(31) value(0);
                              /* C NULL value not required           */
 dcl SQL_CNULREQD_YES         fixed bin(31) value(1);
                              /* C NULL value required               */

 /* Maximum sqlchar length for option[n].val when option[n].type is   */
 /* SQL_GENERIC_OPT                                                   */
 dcl SQL_MAX_GENERIC          fixed bin(31) value(1023);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_SAA_OPT. */
 dcl SQL_SAA_NO               fixed bin(31) value(0);
                              /* SQLCA definition not SAA            */
                              /* compatible                          */
 dcl SQL_SAA_YES              fixed bin(31) value(1);
                              /* SQLCA definition is SAA compatible  */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_OPTIM_OPT.         */
 dcl SQL_DONT_OPTIMIZE        fixed bin(31) value(0);
                              /* Do not optimize SQLDA               */
                              /* initialization                      */
 dcl SQL_OPTIMIZE             fixed bin(31) value(1);
                              /* Optimize SQLDA initialization       */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SYNTAX_OPT .       */
 dcl SQL_NO_SYNTAX_CHECK      fixed bin(31) value(0);
                              /* Create a package and/or a bind      */
                              /* file                                */
 dcl SQL_SYNTAX_CHECK         fixed bin(31) value(1);
                              /* Do not create a package or bind     */
                              /* file                                */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_LINEMACRO_OPT.    */
 dcl SQL_NO_LINE_MACROS       fixed bin(31) value(0);
                              /* Do not generate #line macros in     */
                              /* modified source file                */
 dcl SQL_LINE_MACROS          fixed bin(31) value(1);
                              /* Generate #line macros in modified   */
                              /* source file                         */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_WCHAR_OPT.        */
 dcl SQL_WCHAR_NOCONVERT      fixed bin(31) value(0);
                              /* graphic variable not converted      */
 dcl SQL_WCHAR_CONVERT        fixed bin(31) value(1);
                              /* graphic variable converted          */

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_LEVEL_OPT*/
 dcl SQL_MAX_LEVEL            fixed bin(31) value(8);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_CONNECT_OPT       */
 dcl SQL_DEFERRED_PREPARE_YES fixed bin(31) value(1);
                              /* Dynamic SQL statements will be      */
                              /* chained.                            */
 dcl SQL_DEFERRED_PREPARE_NO  fixed bin(31) value(2);
                              /* Dynamic SQL statements will not be  */
                              /* chained.                            */
 dcl SQL_DEFERRED_PREPARE_ALL fixed bin(31) value(3);
                              /* Dynamic SQL statements will be      */
                              /* chained in all cases.  The          */
                              /* application must not allocate host  */
                              /* vars a FETCH SQLDA until after the  */
                              /* OPEN statement for the cursor.      */

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_COLLECTION_OPT */
 dcl SQL_MAX_COLLECTION       fixed bin(31) value(30);

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_VERSION_OPT*/
 dcl SQL_MAX_VERSION          fixed bin(31) value(254);

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_OWNER_OPT*/
 dcl SQL_MAX_OWNER            fixed bin(31) value(30);

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_SCHEMA_OPT*/
 dcl SQL_MAX_SCHEMA           fixed bin(31) value(SQL_MAX_OWNER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_QUALIFIER_OPT*/
 dcl SQL_MAX_QUALIFIER        fixed bin(31) value(30);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_CATALOG_OPT*/
 dcl SQL_MAX_CATALOG          fixed bin(31) value(SQL_MAX_QUALIFIER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_TEXT_OPT */
 dcl SQL_MAX_TEXT             fixed bin(31) value(255);
 /* Maximum sqlchar length for option[n].val when option[n].type is  */
 /* SQL_PREPROCESSOR_OPT                                             */
 dcl SQL_MAX_PREPROCESSOR     fixed bin(31) value(1024);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_VALIDATE_OPT      */
 dcl SQL_VALIDATE_BIND        fixed bin(31) value(0);
                              /* Validate objects during BIND        */
 dcl SQL_VALIDATE_RUN         fixed bin(31) value(1);
                              /* Validate objects during execution   */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_EXPLAIN_OPT       */
 dcl SQL_EXPLAIN_NO           fixed bin(31) value(0);
                              /* No Explain output saved             */
 dcl SQL_EXPLAIN_YES          fixed bin(31) value(1);
                              /* Explain output saved                */
 dcl SQL_EXPLAIN_ALL          fixed bin(31) value(2);
                              /* Explain output saved for all        */
                              /* static and dynamic statements       */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_ACTION_OPT         */
 dcl SQL_ACTION_ADD           fixed bin(31) value(0);
                              /* Package is to be added              */
 dcl SQL_ACTION_REPLACE       fixed bin(31) value(1);
                              /* Package is to be replaced           */

 /* Max/Min value of CLIPKG for option[n].val when option[n].type is */
 /* SQL_CLIPKG_OPT                                                   */
 dcl SQL_MIN_CLIPKG           fixed bin(31) value(3);
 dcl SQL_MAX_CLIPKG           fixed bin(31) value(30);

 /* Maximum sqlchar length for option[n].val when option[n].type */
 /* is SQL_REPLVER_OPT*/
 dcl SQL_MAX_REPLVER          fixed bin(31) value(254);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SQLERROR_OPT      */
 dcl SQL_SQLERROR_NOPACKAGE   fixed bin(31) value(SQL_NO_SYNTAX_CHECK);
                              /* Do not create a                     */
                              /* package if errors are encountered   */
 dcl SQL_SQLERROR_CHECK       fixed bin(31) value(SQL_SYNTAX_CHECK);
                              /* Do not create a package    */
 dcl SQL_SQLERROR_CONTINUE    fixed bin(31) value(2);
                              /* Create a package even if errors     */
                              /* are encountered                     */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_RETAIN_OPT        */
 dcl SQL_RETAIN_NO            fixed bin(31) value(0);
                              /* Do not preserve EXECUTE             */
                              /* authorities when a package is       */
                              /* replaced                            */
 dcl SQL_RETAIN_YES           fixed bin(31) value(1);
                              /* Preserve EXECUTE authorities when   */
                              /* a package is replaced               */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_RELEASE_OPT       */
 dcl SQL_RELEASE_COMMIT       fixed bin(31) value(0);
                              /* Release resources at COMMIT         */
 dcl SQL_RELEASE_DEALLOCATE   fixed bin(31) value(1);
                              /* Release resources when the program  */
                              /* terminates                          */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_STRDEL_OPT        */
 dcl SQL_STRDEL_APOSTROPHE    fixed bin(31) value(0);
                              /* Apostrophe string delimiter         */
 dcl SQL_STRDEL_QUOTE         fixed bin(31) value(1);
                              /* Quote string delimiter              */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DECDEL_OPT         */
 dcl SQL_DECDEL_PERIOD        fixed bin(31) value(0);
                              /* Period is used as a decimal point   */
                              /* indicator in decimal and floating   */
                              /* point literals                      */
 dcl SQL_DECDEL_COMMA         fixed bin(31) value(1);
                              /* Comma is used as a decimal point    */
                              /* indicator in decimal and floating   */
                              /* point literals                      */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_CHARSUB_OPT       */
 dcl SQL_CHARSUB_DEFAULT      fixed bin(31) value(0);
                              /* Use the target system defined       */
                              /* default for all new character       */
                              /* columns for which an explicit       */
                              /* subtype is not specified            */
 dcl SQL_CHARSUB_BIT          fixed bin(31) value(1);
                              /* Use the BIT character subtype for   */
                              /* all new character columns for       */
                              /* which an explicit subtype is not    */
                              /* specified                           */
 dcl SQL_CHARSUB_SBCS         fixed bin(31) value(2);
                              /* Use the SBCS character subtype for  */
                              /* all new character columns for       */
                              /* which an explicit subtype is not    */
                              /* specified                           */
 dcl SQL_CHARSUB_MIXED        fixed bin(31) value(3);
                              /* Use the mixed character subtype     */
                              /* for all new character columns for   */
                              /* which an explicit subtype is not    */
                              /* specified                           */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DEC_OPT */
 dcl SQL_DEC_15               fixed bin(31) value(15);
                              /* 15 bit precision is used in         */
                              /* decimal arithmetic operations       */
 dcl SQL_DEC_31               fixed bin(31) value(31);
                              /* 31 bit precision is used in         */
                              /* decimal arithmetic operations       */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DEGREE_OPT         */
 dcl SQL_DEGREE_1             fixed bin(31) value(1);
                              /* Prohibits parallel I/O operations   */
 dcl SQL_DEGREE_ANY           fixed bin(31) value(0);
                              /* Allows the target database system   */
                              /* to determine the degree of          */
                              /* parallel I/O operations             */
 dcl SQL_MAX_DEGREE_VAL       fixed bin(31) value(32767);
                              /* Maximum value                       */

 /* The next four option values (for CONNECT type, SQLRULES, */
 /*  DISCONNECT and SYNCPOINT) are used not only by the precompiler */
 /*  but also by the sqlesetc and sqleqryc APIs. */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_CONNECT_OPT       */
 dcl SQL_CONNECT_1            fixed bin(31) value(1);
                              /* Indicates that only one connection  */
                              /* to a database can exist at any      */
                              /* given time.                         */
 dcl SQL_CONNECT_2            fixed bin(31) value(2);
                              /* Indicates that multiple             */
                              /* connections can exist               */
                              /* simultaneously, with one being      */
                              /* active and the others dormant.      */

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_RULES_OPT*/
 dcl SQL_RULES_DB2            fixed bin(31) value(1);
                              /* Indicates that CONNECT TO can be    */
                              /* used to make a dormant connection   */
                              /* the current connection.             */
 dcl SQL_RULES_STD            fixed bin(31) value(2);
                              /* Indicates that CONNECT TO is not    */
                              /* valid for making a dormant          */
                              /* connection current, and SET         */
                              /* CONNECTION must be used instead.    */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DISCONNECT_OPT    */
 dcl SQL_DISCONNECT_EXPL      fixed bin(31) value(1);
                              /* Indicates that all connections      */
                              /* marked by the RELEASE statement     */
                              /* will be the only connections        */
                              /* released when a COMMIT is issued.   */
 dcl SQL_DISCONNECT_COND      fixed bin(31) value(2);
                              /* Indicates that all connections      */
                              /* that do not have open WITH HOLD     */
                              /* cursors will be the only            */
                              /* connections released when a COMMIT  */
                              /* is issued.                          */
 dcl SQL_DISCONNECT_AUTO      fixed bin(31) value(3);
                              /* Indicates that all connections      */
                              /* will be released when a COMMIT is   */
                              /* issued.                             */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_SYNCPOINT_OPT     */
 dcl SQL_SYNC_ONEPHASE        fixed bin(31) value(1);
                              /* Do not use a transaction manager    */
                              /* to perform two phase commit, but    */
                              /* enforce that there is only one      */
                              /* database is updated when multiple   */
                              /* databases are accessed within a     */
                              /* single transaction.                 */
 dcl SQL_SYNC_TWOPHASE        fixed bin(31) value(2);
                              /* Use a transaction manager to        */
                              /* coordinate two phase commit.        */
 dcl SQL_SYNC_NONE            fixed bin(31) value(0);
                              /* No update enforcement or two phase  */
                              /* commit protocol will be used.       */

 /* The next option value (for SQL_CONNECT_NODE) is used only by the  */
 /*  sqlesetc and sqleqryc APIs.                                      */
 dcl SQL_CONN_CATALOG_NODE    fixed bin(31) value('fffe'xn);
                              /* Connect to the catalog node         */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DYNAMICRULES_OPT  */
 dcl SQL_DYNAMICRULES_RUN     fixed bin(31) value(0);
                              /* Dynamic SQL in package will use     */
                              /* authid of person running the        */
                              /* package                             */
 dcl SQL_DYNAMICRULES_BIND    fixed bin(31) value(1);
                              /* Dynamic SQL in package will use     */
                              /* authid of person who owns the       */
                              /* package                             */
 dcl SQL_DYNAMICRULES_INVOKE  fixed bin(31) value(2);
                              /* Dynamic SQL in UDF or stored        */
                              /* procedure will use authid of        */
                              /* invoker of UDF or stored procedure  */
 dcl SQL_DYNAMICRULES_DEFINE  fixed bin(31) value(3);
                              /* Dynamic SQL in UDF or stored        */
                              /* procedure will use authid of        */
                              /* definer of UDF or stored procedure  */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_INSERT_OPT         */
 dcl SQL_INSERT_DEF           fixed bin(31) value(0);
                              /* Do not buffer VALUE inserts         */
 dcl SQL_INSERT_BUF           fixed bin(31) value(1);
                              /* Buffer VALUE inserts                */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_EXPLSNAP_OPT      */
 dcl SQL_EXPLSNAP_NO          fixed bin(31) value(0);
                              /* No Explain snapshot saved           */
 dcl SQL_EXPLSNAP_YES         fixed bin(31) value(1);
                              /* Explain snapshot saved              */
 dcl SQL_EXPLSNAP_ALL         fixed bin(31) value(2);
                              /* Explain snapshot saved for all      */
                              /* static and dynamic statements       */

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_FUNCTION_PATH */
 dcl SQL_MAX_FUNCPATH         fixed bin(31) value(254);

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_SQLWARN_OPT       */
 dcl SQL_SQLWARN_NO           fixed bin(31) value(0);
                              /* Suppress prepare-time warning       */
                              /* SQLCODEs                            */
 dcl SQL_SQLWARN_YES          fixed bin(31) value(1);
                              /* Permit prepare-time warning         */
                              /* SQLCODEs                            */

 /* Values used for option[n].val when option[n].type is  */
 /* SQL_QUERYOPT_OPT      */
 dcl SQL_QUERYOPT_0           fixed bin(31) value(0);
                              /* Class 0 query optimization          */
 dcl SQL_QUERYOPT_1           fixed bin(31) value(1);
                              /* Class 1 query optimization          */
 dcl SQL_QUERYOPT_2           fixed bin(31) value(2);
                              /* Class 2 query optimization          */
 dcl SQL_QUERYOPT_3           fixed bin(31) value(3);
                              /* Class 3 query optimization          */
 dcl SQL_QUERYOPT_5           fixed bin(31) value(5);
                              /* Class 5 query optimization          */
 dcl SQL_QUERYOPT_7           fixed bin(31) value(7);
                              /* Class 7 query optimization          */
 dcl SQL_QUERYOPT_9           fixed bin(31) value(9);
                              /* Class 9 query optimization          */

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQL_TARGET_OPT*/
 dcl SQL_MAX_TARGET_LEN       fixed bin(31) value(32);

 /* Values used for option[n].val when option[n].type is */
 /* SQL_RESOLVE_OPT                                      */
 dcl SQL_RESOLVE_ANY          fixed bin(31) value(0);
                              /* Conservative binding semantics are  */
                              /* not used                            */
 dcl SQL_RESOLVE_CONSERVATIVE fixed bin(31) value(1);
                              /* Conservative binding semantics are  */
                              /* used                                */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_FEDERATED_OPT     */
 dcl SQL_FEDERATED_NO         fixed bin(31) value(0);
                              /* Federated systems are not           */
                              /* supported                           */
 dcl SQL_FEDERATED_YES        fixed bin(31) value(1);
                              /* Federated systems are supported     */
 /* Values used for option[n].val when option[n].type is */
 /* SQL_PSM_OPT           */
 dcl SQL_PSM_NO               fixed bin(31) value(0);
                              /* PSM no                              */
 dcl SQL_PSM_YES              fixed bin(31) value(1);
                              /* PSM yes                             */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_LONGERROR_OPT.    */
 dcl SQL_LONGERROR_NO         fixed bin(31) value(0);
                              /* Do not generate errors for the use  */
                              /* of long host variable declarations  */
 dcl SQL_LONGERROR_YES        fixed bin(31) value(1);
                              /* Generate errors for the use of      */
                              /* long host variable declarations     */

 /* Values used for option[n].val when option[n].type is */
 /* SQL_DECTYPE_OPT.      */
 dcl SQL_DECTYPE_NOCONVERT    fixed bin(31) value(0);
                              /* Decimal type not converted          */
 dcl SQL_DECTYPE_CONVERT      fixed bin(31) value(1);
                              /* Decimal type converted              */

 /* Binder Interface Parameters/Return Codes */

 dcl sqlabndx                      /* Bind                            */
     entry (char(*) varz byaddr,   /* bind file name                  */
            char(*) varz byaddr,   /* message file                    */
            handle sqlopt,         /* bind options                    */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlabndx');

 dcl sqlarbnd                      /* Rebind                          */
     entry (char(*) varz byaddr,   /* package name                    */
            pointer,               /* SQLCA                           */
            handle sqlopt)         /* rebind options                  */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlarbnd');

 dcl sqlaprep                      /* Precompile Program              */
     entry (char(*) varz byaddr,   /* source file name                */
            char(*) varz byaddr,   /* message file name               */
            handle sqlopt,         /* precompile options              */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlaprep');

 /* Generic Interfaces to the Binder and Precompiler */

 dcl sqlgbndx                      /* Bind                            */
     entry (fixed bin(16) unsigned,/* message file name length        */
            fixed bin(16) unsigned,/* bind file name length           */
            pointer,               /* SQLCA                           */
            handle sqlopt,         /* binder options                  */
            char(*) varz byaddr,   /* message file                    */
            char(*) varz byaddr)   /* bind file name                  */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgbndx');

 dcl sqlgrbnd                      /* Rebind                          */
     entry (fixed bin(16) unsigned,/* package name length             */
            char(*) varz byaddr,   /* package name                    */
            pointer,               /* SQLCA                           */
            handle sqlopt)         /* rebind options                  */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgrbnd');

 dcl sqlgprep                      /* Precompile Program              */
     entry (fixed bin(16) unsigned,/* message file name length        */
            fixed bin(16) unsigned,/* source file name length         */
            pointer,               /* SQLCA                           */
            handle sqlopt,         /* precompile options              */
            char(*) varz byaddr,   /* message file name               */
            char(*) varz byaddr)   /* source file name                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgprep');

 /* Application Context apis */


 dcl SQL_CTX_ORIGINAL              fixed bin(31) value(0);
                                   /* serial access                   */
 dcl SQL_CTX_MULTI_MANUAL          fixed bin(31) value(1);
                                   /* concurrent access               */

 dcl sqleSetTypeCtx                /* Set Application Context         */
     entry (fixed bin (31))        /* options                         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleSetTypeCtx');


 dcl SQL_CTX_BEGIN_ALL             fixed bin(31) value(0);
                                   /* create & attach                 */
 dcl SQL_CTX_CREATE_ONLY           fixed bin(31) value(1);
                                   /* create only                     */

 dcl sqleBeginCtx                  /* Create Application Context      */
     entry (pointer byaddr,        /* pointer to ctx                  */
            fixed bin(31),         /* lOptions                        */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleBeginCtx');


 dcl SQL_CTX_END_ALL               fixed bin(31) value(0);
                                   /* detach & free                   */
 dcl SQL_CTX_FREE_ONLY             fixed bin(31) value(1);
                                   /* free only                       */

 dcl sqleEndCtx                    /* Destroy Application Context     */
     entry (pointer byaddr,        /* pointer to ctx                  */
            fixed bin(31),         /* lOptions                        */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleEndCtx');

 dcl sqleAttachToCtx               /* Attach to Application Context   */
     entry (pointer,               /* pointer to ctx                  */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleAttachToCtx');

 dcl sqleDetachFromCtx             /* Detach Application Context      */
     entry (pointer,               /* pointer to ctx                  */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleDetachFromCtx');

 dcl sqleGetCurrentCtx             /* Get Current Application Context */
     entry (pointer byaddr,        /* pointer to ctx                  */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleGetCurrentCtx');

 dcl sqleInterruptCtx              /* Interrupt Context               */
     entry (pointer,               /* pointer to ctx                  */
            pointer,               /* reserved                        */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleInterruptCtx');


 /* Error/SQLSTATE Message Retrieval Interface Parameters/Return */
 /* Codes */

 /* Get Error Message Macro */
 sqlaintp: proc (msgbuf, bufsize, linesize, sqlcaptr)
           returns (byvalue optional type SQL_API_RC)
           options (inline) internal;
   dcl msgbuf   char(*) varz byaddr,   /* buffer for message text     */
       bufsize  fixed bin(15) byvalue, /* buffer size                 */
       linesize fixed bin(15) byvalue, /* line width                  */
       sqlcaptr pointer byvalue;       /* SQLCA                       */
   return (sqlaintp_api (msgbuf, bufsize, linesize,
                         'db2sql.mo', sqlcaptr));
 end sqlaintp;

 dcl sqlaintp_api                  /* Get Error Message               */
     entry (char(*) varz byaddr,   /* buffer for message text         */
            fixed bin(15),         /* buffer size                     */
            fixed bin(15),         /* line width                      */
            char(*) varz byaddr,   /* message file                    */
            pointer)               /* SQLCA                           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlaintp_api');

 /* Generic Interface to Error Message Retrieval */
 dcl sqlgintp                      /* Get Error Message               */
     entry (fixed bin(15),         /* buffer size                     */
            fixed bin(15),         /* line width                      */
            pointer,               /* SQLCA                           */
            char(*) varz byaddr)   /* buffer                          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgintp');

 dcl sqlogstt                      /* Sqlstate Message Retrieval      */
     entry (char(*) varz byaddr,   /* buffer for message text         */
            fixed bin(15),         /* buffer size                     */
            fixed bin(15),         /* line width                      */
            char(*) varz byaddr)   /* sqlstate                        */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlogstt');

 /* Generic Interface to SQLSTATE Message Retrieval */

 dcl sqlggstt                      /* Sqlstate Message Retrieval      */
     entry (fixed bin(15),         /* buffer size                     */
            fixed bin(15),         /* line width                      */
            char(*) varz byaddr,   /* sqlstate                        */
            char(*) varz byaddr)   /* buffer                          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggstt');

 /* Return Codes for sqlaintp/sqlogstt */
 dcl SQLA_ERR_BADCC           fixed bin(31) value(-1);
                              /* insufficient memory for msg file    */
 dcl SQLA_ERR_NOCOD           fixed bin(31) value(-2);
                              /* no error code in SQLCA              */
 dcl SQLA_ERR_NOMSG           fixed bin(31) value(-3);
                              /* message file inaccessible or        */
                              /* incorrect                           */
 dcl SQLA_ERR_BADLL           fixed bin(31) value(-4);
                              /* specified line length negative      */
 dcl SQLA_ERR_BADCA           fixed bin(31) value(-5);
                              /* invalid sqlca/buffer addr/length    */

 /* Administrative/Database Authorizations returned from  */
 /* Get Administrative Authorizations function            */
 /* Authorizations granted explicitly to user */
 dcl SQL_SYSADM               fixed bin(31) value('1'xn);
                              /* SYSADM Authority                    */
 dcl SQL_DBADM                fixed bin(31) value('2'xn);
                              /* DBADM Authority                     */
 dcl SQL_CREATETAB            fixed bin(31) value('4'xn);
                              /* CREATETAB Privilege                 */
 dcl SQL_BINDADD              fixed bin(31) value('8'xn);
                              /* BINDADD Privilege                   */
 dcl SQL_CONNECT              fixed bin(31) value('10'xn);
                              /* CONNECT Privilege                   */
 dcl SQL_CREATE_NOT_FENC      fixed bin(31) value('20'xn);
                              /* CREATE_NOT_FENCED Privilege         */
 dcl SQL_SYSCTRL              fixed bin(31) value('40'xn);
                              /* SYSCTRL Authority                   */
 dcl SQL_SYSMAINT             fixed bin(31) value('80'xn);
                              /* SYSMAINT Authority                  */
 dcl SQL_IMPLICIT_SCHEMA      fixed bin(31) value('10000'xn);
                              /* IMPLICIT_SCHEMA Privilege           */
 dcl SQL_LOAD                 fixed bin(31) value('20000'xn);
                              /* LOAD Privilege                      */

 /* Composite of authorizations granted explicitly to user, */
 /* to groups of which user is a member, and to PUBLIC      */
 dcl SQL_SYSADM_GRP           fixed bin(31)
                              value(raise2 (SQL_SYSADM, 8));
 dcl SQL_DBADM_GRP            fixed bin(31)
                              value(raise2 (SQL_DBADM, 8));
 dcl SQL_CREATETAB_GRP        fixed bin(31)
                              value(raise2 (SQL_CREATETAB, 8));
 dcl SQL_BINDADD_GRP          fixed bin(31)
                              value(raise2 (SQL_BINDADD, 8));
 dcl SQL_CONNECT_GRP          fixed bin(31)
                              value(raise2 (SQL_CONNECT, 8));
 dcl SQL_CREATE_NOT_FENC_GRP  fixed bin(31)
                              value(raise2 (SQL_CREATE_NOT_FENC, 8));
 dcl SQL_SYSCTRL_GRP          fixed bin(31)
                              value(raise2 (SQL_SYSCTRL, 8));
 dcl SQL_SYSMAINT_GRP         fixed bin(31)
                              value(raise2 (SQL_SYSMAINT, 8));
 dcl SQL_IMPLICIT_SCHEMA_GRP  fixed bin(31)
                              value(raise2 (SQL_IMPLICIT_SCHEMA, 8));
 dcl SQL_LOAD_GRP             fixed bin(31)
                              value(raise2 (SQL_LOAD, 8));

 /* Table/View Authorizations/Dependencies Bit definitions in */
 /* SYSTABAUTH.TABAUTH and SYSPLANDEP.TABAUTH                 */
 dcl SQL_TAB_CTL              fixed bin(31) value('1'xn);
                              /* Control Authority                   */
 dcl SQL_TAB_ALT              fixed bin(31) value('2'xn);
                              /* Alter Privilege                     */
 dcl SQL_TAB_DEL              fixed bin(31) value('4'xn);
                              /* Delete Privilege/Dependency         */
 dcl SQL_TAB_IDX              fixed bin(31) value('8'xn);
                              /* Index Privilege                     */
 dcl SQL_TAB_INS              fixed bin(31) value('10'xn);
                              /* Insert Privilege/Dependency         */
 dcl SQL_TAB_SEL              fixed bin(31) value('20'xn);
                              /* Select Privilege/Dependency         */
 dcl SQL_TAB_UPD              fixed bin(31) value('40'xn);
                              /* Update Privilege/Dependency         */
 dcl SQL_TAB_REF              fixed bin(31) value('80'xn);
                              /* Reference Privilege                 */
 dcl SQL_TAB_KEY              fixed bin(31) value('2000'xn);
                              /* Key Dependency                      */
 dcl SQL_TAB_CAS              fixed bin(31) value('4000'xn);
                              /* Cascade Dependency                  */

 /* Bit definitions for SYSTABAUTH.TABAUTH indicating the specified  */
 /* table or view privilege is grantable.                            */
 dcl SQL_TAB_ALT_G            fixed bin(31) value('200'xn);
                              /* Alter Privilege Grantable           */
 dcl SQL_TAB_DEL_G            fixed bin(31) value('400'xn);
                              /* Delete Privilege Grantable          */
 dcl SQL_TAB_IDX_G            fixed bin(31) value('800'xn);
                              /* Index Privilege Grantable           */
 dcl SQL_TAB_INS_G            fixed bin(31) value('1000'xn);
                              /* Insert Privilege Grantable          */
 dcl SQL_TAB_SEL_G            fixed bin(31) value('2000'xn);
                              /* Select Privilege Grantable          */
 dcl SQL_TAB_UPD_G            fixed bin(31) value('4000'xn);
                              /* Update Privilege Grantable          */
 dcl SQL_TAB_REF_G            fixed bin(31) value('8000'xn);
                              /* References Privilege Grantable      */

 /* Definitions for application remote interface */
 dcl SQLZ_DISCONNECT_PROC     fixed bin(31) value(1);
                              /* Unload Progam                       */
 dcl SQLZ_HOLD_PROC           fixed bin(31) value(2);
                              /* Keep program loaded                 */

 /********************************************************************/
 /*                                                                  */
 /* The following functions and symbols are obsolete and may not be  */
 /* supported in future releases. The obsolete functions are provided*/
 /* for backward compatibility and exported from DB2API.LIB. All     */
 /* applications should be migrated to use new APIs.                 */
 /********************************************************************/
 dcl SQLA_RC_BAD_PASSWD       fixed bin(31) value(-4);
                              /* Invalid password                    */
 dcl SQL_MAXSTMTS             fixed bin(31) value(32767);
                              /* Maximum statements (see SQL         */
                              /* reference)                          */
 dcl SQL_MAXVARS              fixed bin(31) value(32767);
                              /* Maximum host variables per          */
                              /* precompile unit (see SQL            */
                              /* reference)                          */

 %end; /* SQL_H_SQL */
