 /*+----------------------------------------------------------------- */
 /*                                                                   */
 /*  Microsoft Windows                                                */
 /*  Copyright (C) Microsoft Corporation, 1992-1999.                  */
 /*                                                                   */
 /*  File:       winefs.cpy                                           */
 /*                                                                   */
 /*  Contents:   EFS Data and prototypes.                             */
 /*                                                                   */
 /*------------------------------------------------------------------ */

 %dcl #_WINEFS_H__ char ext;
 %if #_WINEFS_H__ = '' %then %do;
 %#_WINEFS_H__ = 'Y';

 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
 %include winbase;
 %end;


 /*------------------------------------------------------------------ */
 /*                                                                   */
 /*                                                                   */
 /*                          Data Structures                          */
 /*                                                                   */
 /*                                                                   */
 /*------------------------------------------------------------------ */


 /*------------------------------------------------------------------ */
 /*  Encoded Certificate                                              */
 /*------------------------------------------------------------------ */


 define structure
   1 CERTIFICATE_BLOB,
     2 dwCertEncodingType type DWORD,
     2 cbData             type DWORD,
     2 pbData             type PBYTE;

 define alias PEFS_CERTIFICATE_BLOB handle CERTIFICATE_BLOB;


 /*------------------------------------------------------------------ */
 /*  Certificate Hash                                                 */
 /*------------------------------------------------------------------ */

 define structure
   1 EFS_HASH_BLOB,
     2 cbData type DWORD,
     2 pbData type PBYTE;

 define alias PEFS_HASH_BLOB handle EFS_HASH_BLOB;



 /*------------------------------------------------------------------ */
 /* Input to add a user to an encrypted file                          */
 /*------------------------------------------------------------------ */


 define structure
   1 ENCRYPTION_CERTIFICATE,
     2 cbTotalLength type DWORD,
     2 pUserSid      handle SID,
     2 pCertBlob     type PEFS_CERTIFICATE_BLOB;

 define alias PENCRYPTION_CERTIFICATE handle ENCRYPTION_CERTIFICATE;

 dcl MAX_SID_SIZE fixed bin(31) value(256);


 define structure
   1 ENCRYPTION_CERTIFICATE_HASH,
     2 cbTotalLength        type DWORD,
     2 pUserSid             handle SID,
     2 pHash                type PEFS_HASH_BLOB,
     2 lpDisplayInformation type LPWSTR;

 define alias PENCRYPTION_CERTIFICATE_HASH
        handle ENCRYPTION_CERTIFICATE_HASH;



 define structure
   1 ENCRYPTION_CERTIFICATE_HASH_LIST,
     2 nCert_Hash type DWORD,
     2 pUsers     pointer; /* to (*) PENCRYPTION_CERTIFICATE_HASH */

 define alias PENCRYPTION_CERTIFICATE_HASH_LIST
        handle ENCRYPTION_CERTIFICATE_HASH_LIST;



 define structure
   1 ENCRYPTION_CERTIFICATE_LIST,
     2 nUsers     type DWORD,
     2 pUsers     pointer; /* to (*) PENCRYPTION_CERTIFICATE */

 define alias PENCRYPTION_CERTIFICATE_LIST
        handle ENCRYPTION_CERTIFICATE_LIST;



 /*------------------------------------------------------------------ */
 /*                                                                   */
 /*                                                                   */
 /*                               Prototypes                          */
 /*                                                                   */
 /*                                                                   */
 /*------------------------------------------------------------------ */


 dcl QueryUsersOnEncryptedFile
     entry (WCHAR(*) varz byaddr nonasgn,
            type PENCRYPTION_CERTIFICATE_HASH_LIST byaddr)
     returns (type DWORD byvalue optional)
     WINADVAPI WINAPI external('QueryUsersOnEncryptedFile');


 dcl QueryRecoveryAgentsOnEncryptedFile
     entry (WCHAR(*) varz byaddr nonasgn,
            type PENCRYPTION_CERTIFICATE_HASH_LIST byaddr)
     returns (type DWORD byvalue optional)
     WINADVAPI WINAPI external('QueryRecoveryAgentsOnEncryptedFile');


 dcl RemoveUsersFromEncryptedFile
     entry (WCHAR(*) varz byaddr nonasgn,
            type ENCRYPTION_CERTIFICATE_HASH_LIST byaddr)
     returns (type DWORD byvalue optional)
     WINADVAPI WINAPI external('RemoveUsersFromEncryptedFile');

 dcl AddUsersToEncryptedFile
     entry (WCHAR(*) varz byaddr nonasgn,
            type ENCRYPTION_CERTIFICATE_LIST byaddr)
     returns (type DWORD byvalue optional)
     WINADVAPI WINAPI external('AddUsersToEncryptedFile');

 dcl SetUserFileEncryptionKey
     entry (type ENCRYPTION_CERTIFICATE byaddr)
     returns (type DWORD byvalue optional)
     WINADVAPI WINAPI external('SetUserFileEncryptionKey');


 dcl FreeEncryptionCertificateHashList
     entry (type PENCRYPTION_CERTIFICATE_HASH_LIST) /* from above */
     WINADVAPI WINAPI external('FreeEncryptionCertificateHashList');

 dcl EncryptionDisable
     entry (WCHAR(*) varz byaddr nonasgn,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI external('EncryptionDisable');

 %end; /* __WINEFS_H__ */
