 /* $XConsortium: keysymdef.h,v 1.15 93/04/02 10:57:36 rws Exp $      */
 /*********************************************************************/
 /* Copyright 1987 by Digital Equipment Corporation, Maynard,         */
 /* Massachusetts, and the Massachusetts Institute of Technology,     */
 /* Cambridge, Massachusetts.                                         */
 /*                                                                   */
 /*                       All Rights Reserved                         */
 /*                                                                   */
 /* Permission to use, copy, modify, and distribute this software and */
 /* its documentation for any purpose and without fee is hereby       */
 /* granted, provided that the above copyright notice appear in all   */
 /* copies and that both that copyright notice and this permission    */
 /* notice appear in supporting documentation, and that the names of  */
 /* Digital or MIT not be used in advertising or publicity pertaining */
 /* to distribution of the software without specific, written prior   */
 /* permission.                                                       */
 /*                                                                   */
 /* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,    */
 /* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,  */
 /* IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR  */
 /* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM    */
 /* LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,   */
 /* NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN         */
 /* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.          */
 /*********************************************************************/

 dcl XK_VoidSymbol fixed bin(31) value('FFFFFF'xn); /* void symbol */

 %dcl XK_MISCELLANY char ext;
 %if XK_MISCELLANY ^= '' %then %do;
 /* TTY Functions, cleverly chosen to map to ascii, for convenience   */
 /* of programming, but could have been arbitrary (at the cost of     */
 /* lookup tables in client code.                                     */

 dcl XK_BackSpace   fixed bin(31) value('FF08'xn); /* back-space/char */
 dcl XK_Tab         fixed bin(31) value('FF09'xn);
 dcl XK_Linefeed    fixed bin(31) value('FF0A'xn); /* Linefeed, LF */
 dcl XK_Clear       fixed bin(31) value('FF0B'xn);
 dcl XK_Return      fixed bin(31) value('FF0D'xn); /* Return, enter */
 dcl XK_Pause       fixed bin(31) value('FF13'xn); /* Pause, hold */
 dcl XK_Scroll_Lock fixed bin(31) value('FF14'xn);
 dcl XK_Sys_Req     fixed bin(31) value('FF15'xn);
 dcl XK_Escape      fixed bin(31) value('FF1B'xn);
 dcl XK_Delete      fixed bin(31) value('FFFF'xn); /* Delete, rubout */


 /* International & multi-key character composition */

 dcl XK_Multi_key   fixed bin(31) value('FF20'xn);
 /* Multi-key character compose */

 /* Japanese keyboard support */

 dcl XK_Kanji             fixed bin(31) value('FF21'xn);
                          /* Kanji, Kanji convert */
 dcl XK_Muhenkan          fixed bin(31) value('FF22'xn);
                          /* Cancel Conversion */
 dcl XK_Henkan_Mode       fixed bin(31) value('FF23'xn);
                          /* Start/Stop Conversion */
 dcl XK_Henkan            fixed bin(31) value('FF23'xn);
                          /* Alias for Henkan_Mode */
 dcl XK_Romaji            fixed bin(31) value('FF24'xn);
                          /* to Romaji */
 dcl XK_Hiragana          fixed bin(31) value('FF25'xn);
                          /* to Hiragana */
 dcl XK_Katakana          fixed bin(31) value('FF26'xn);
                          /* to Katakana */
 dcl XK_Hiragana_Katakana fixed bin(31) value('FF27'xn);
                          /* Hiragana/Katakana toggle */
 dcl XK_Zenkaku           fixed bin(31) value('FF28'xn);
                          /* to Zenkaku */
 dcl XK_Hankaku           fixed bin(31) value('FF29'xn);
                          /* to Hankaku */
 dcl XK_Zenkaku_Hankaku   fixed bin(31) value('FF2A'xn);
                          /* Zenkaku/Hankaku toggle */
 dcl XK_Touroku           fixed bin(31) value('FF2B'xn);
                          /* Add to Dictionary */
 dcl XK_Massyo            fixed bin(31) value('FF2C'xn);
                          /* Delete from Dictionary */
 dcl XK_Kana_Lock         fixed bin(31) value('FF2D'xn);
                          /* Kana Lock */
 dcl XK_Kana_Shift        fixed bin(31) value('FF2E'xn);
                          /* Kana Shift */
 dcl XK_Eisu_Shift        fixed bin(31) value('FF2F'xn);
                          /* Alphanumeric Shift */
 dcl XK_Eisu_toggle       fixed bin(31) value('FF30'xn);
                          /* Alphanumeric toggle */

 /* Cursor control & motion */

 dcl XK_Home      fixed bin(31) value('FF50'xn);
 dcl XK_Left      fixed bin(31) value('FF51'xn); /* Left, left arrow */
 dcl XK_Up        fixed bin(31) value('FF52'xn); /* Up, up arrow */
 dcl XK_Right     fixed bin(31) value('FF53'xn); /* Right, right arrow*/
 dcl XK_Down      fixed bin(31) value('FF54'xn); /* Down, down arrow */
 dcl XK_Prior     fixed bin(31) value('FF55'xn); /* Prior, previous */
 dcl XK_Page_Up   fixed bin(31) value('FF55'xn);
 dcl XK_Next      fixed bin(31) value('FF56'xn); /* Next */
 dcl XK_Page_Down fixed bin(31) value('FF56'xn);
 dcl XK_End       fixed bin(31) value('FF57'xn); /* EOL */
 dcl XK_Begin     fixed bin(31) value('FF58'xn); /* BOL */


 /* Misc Functions */

 dcl XK_Select  fixed bin(31) value('FF60'xn); /* Select, mark */
 dcl XK_Print   fixed bin(31) value('FF61'xn);
 dcl XK_Execute fixed bin(31) value('FF62'xn); /* Execute, run, do */
 dcl XK_Insert  fixed bin(31) value('FF63'xn); /* Insert, insert here */
 dcl XK_Undo    fixed bin(31) value('FF65'xn); /* Undo, oops */
 dcl XK_Redo    fixed bin(31) value('FF66'xn); /* redo, again */
 dcl XK_Menu    fixed bin(31) value('FF67'xn);
 dcl XK_Find    fixed bin(31) value('FF68'xn); /* Find, search */
 dcl XK_Cancel  fixed bin(31) value('FF69'xn);
                      /* Cancel, stop, abort, exit */
 dcl XK_Help    fixed bin(31) value('FF6A'xn); /* Help, ? */
 dcl XK_Break   fixed bin(31) value('FF6B'xn);
 dcl XK_Mode_switch   fixed bin(31) value('FF7E'xn);
                      /* Character set switch */
 dcl XK_script_switch fixed bin(31) value('FF7E'xn);
                      /* Alias for mode_switch */
 dcl XK_Num_Lock      fixed bin(31) value('FF7F'xn);

 /* Keypad Functions, keypad numbers cleverly chosen to map to ascii */

 dcl XK_KP_Space     fixed bin(31) value('FF80'xn); /* space */
 dcl XK_KP_Tab       fixed bin(31) value('FF89'xn);
 dcl XK_KP_Enter     fixed bin(31) value('FF8D'xn); /* enter */
 dcl XK_KP_F1        fixed bin(31) value('FF91'xn); /* PF1, KP_A, ... */
 dcl XK_KP_F2        fixed bin(31) value('FF92'xn);
 dcl XK_KP_F3        fixed bin(31) value('FF93'xn);
 dcl XK_KP_F4        fixed bin(31) value('FF94'xn);
 dcl XK_KP_Home      fixed bin(31) value('FF95'xn);
 dcl XK_KP_Left      fixed bin(31) value('FF96'xn);
 dcl XK_KP_Up        fixed bin(31) value('FF97'xn);
 dcl XK_KP_Right     fixed bin(31) value('FF98'xn);
 dcl XK_KP_Down      fixed bin(31) value('FF99'xn);
 dcl XK_KP_Prior     fixed bin(31) value('FF9A'xn);
 dcl XK_KP_Page_Up   fixed bin(31) value('FF9A'xn);
 dcl XK_KP_Next      fixed bin(31) value('FF9B'xn);
 dcl XK_KP_Page_Down fixed bin(31) value('FF9B'xn);
 dcl XK_KP_End       fixed bin(31) value('FF9C'xn);
 dcl XK_KP_Begin     fixed bin(31) value('FF9D'xn);
 dcl XK_KP_Insert    fixed bin(31) value('FF9E'xn);
 dcl XK_KP_Delete    fixed bin(31) value('FF9F'xn);
 dcl XK_KP_Equal     fixed bin(31) value('FFBD'xn); /* equals */
 dcl XK_KP_Multiply  fixed bin(31) value('FFAA'xn);
 dcl XK_KP_Add       fixed bin(31) value('FFAB'xn);
 dcl XK_KP_Separator fixed bin(31) value('FFAC'xn);
                     /* separator, often comma */
 dcl XK_KP_Subtract  fixed bin(31) value('FFAD'xn);
 dcl XK_KP_Decimal   fixed bin(31) value('FFAE'xn);
 dcl XK_KP_Divide    fixed bin(31) value('FFAF'xn);

 dcl XK_KP_0 fixed bin(31) value('FFB0'xn);
 dcl XK_KP_1 fixed bin(31) value('FFB1'xn);
 dcl XK_KP_2 fixed bin(31) value('FFB2'xn);
 dcl XK_KP_3 fixed bin(31) value('FFB3'xn);
 dcl XK_KP_4 fixed bin(31) value('FFB4'xn);
 dcl XK_KP_5 fixed bin(31) value('FFB5'xn);
 dcl XK_KP_6 fixed bin(31) value('FFB6'xn);
 dcl XK_KP_7 fixed bin(31) value('FFB7'xn);
 dcl XK_KP_8 fixed bin(31) value('FFB8'xn);
 dcl XK_KP_9 fixed bin(31) value('FFB9'xn);



 /* Auxilliary Functions; note the duplicate definitions for left and */
 /* right function keys;  Sun keyboards and a few other manufactures  */
 /* have such function key groups on the left and/or right sides of   */
 /* the keyboard.                                                     */
 /* We've not found a keyboard with more than 35 function keys total. */

 dcl XK_F1  fixed bin(31) value('FFBE'xn);
 dcl XK_F2  fixed bin(31) value('FFBF'xn);
 dcl XK_F3  fixed bin(31) value('FFC0'xn);
 dcl XK_F4  fixed bin(31) value('FFC1'xn);
 dcl XK_F5  fixed bin(31) value('FFC2'xn);
 dcl XK_F6  fixed bin(31) value('FFC3'xn);
 dcl XK_F7  fixed bin(31) value('FFC4'xn);
 dcl XK_F8  fixed bin(31) value('FFC5'xn);
 dcl XK_F9  fixed bin(31) value('FFC6'xn);
 dcl XK_F10 fixed bin(31) value('FFC7'xn);
 dcl XK_F11 fixed bin(31) value('FFC8'xn);
 dcl XK_L1  fixed bin(31) value('FFC8'xn);
 dcl XK_F12 fixed bin(31) value('FFC9'xn);
 dcl XK_L2  fixed bin(31) value('FFC9'xn);
 dcl XK_F13 fixed bin(31) value('FFCA'xn);
 dcl XK_L3  fixed bin(31) value('FFCA'xn);
 dcl XK_F14 fixed bin(31) value('FFCB'xn);
 dcl XK_L4  fixed bin(31) value('FFCB'xn);
 dcl XK_F15 fixed bin(31) value('FFCC'xn);
 dcl XK_L5  fixed bin(31) value('FFCC'xn);
 dcl XK_F16 fixed bin(31) value('FFCD'xn);
 dcl XK_L6  fixed bin(31) value('FFCD'xn);
 dcl XK_F17 fixed bin(31) value('FFCE'xn);
 dcl XK_L7  fixed bin(31) value('FFCE'xn);
 dcl XK_F18 fixed bin(31) value('FFCF'xn);
 dcl XK_L8  fixed bin(31) value('FFCF'xn);
 dcl XK_F19 fixed bin(31) value('FFD0'xn);
 dcl XK_L9  fixed bin(31) value('FFD0'xn);
 dcl XK_F20 fixed bin(31) value('FFD1'xn);
 dcl XK_L10 fixed bin(31) value('FFD1'xn);
 dcl XK_F21 fixed bin(31) value('FFD2'xn);
 dcl XK_R1  fixed bin(31) value('FFD2'xn);
 dcl XK_F22 fixed bin(31) value('FFD3'xn);
 dcl XK_R2  fixed bin(31) value('FFD3'xn);
 dcl XK_F23 fixed bin(31) value('FFD4'xn);
 dcl XK_R3  fixed bin(31) value('FFD4'xn);
 dcl XK_F24 fixed bin(31) value('FFD5'xn);
 dcl XK_R4  fixed bin(31) value('FFD5'xn);
 dcl XK_F25 fixed bin(31) value('FFD6'xn);
 dcl XK_R5  fixed bin(31) value('FFD6'xn);
 dcl XK_F26 fixed bin(31) value('FFD7'xn);
 dcl XK_R6  fixed bin(31) value('FFD7'xn);
 dcl XK_F27 fixed bin(31) value('FFD8'xn);
 dcl XK_R7  fixed bin(31) value('FFD8'xn);
 dcl XK_F28 fixed bin(31) value('FFD9'xn);
 dcl XK_R8  fixed bin(31) value('FFD9'xn);
 dcl XK_F29 fixed bin(31) value('FFDA'xn);
 dcl XK_R9  fixed bin(31) value('FFDA'xn);
 dcl XK_F30 fixed bin(31) value('FFDB'xn);
 dcl XK_R10 fixed bin(31) value('FFDB'xn);
 dcl XK_F31 fixed bin(31) value('FFDC'xn);
 dcl XK_R11 fixed bin(31) value('FFDC'xn);
 dcl XK_F32 fixed bin(31) value('FFDD'xn);
 dcl XK_R12 fixed bin(31) value('FFDD'xn);
 dcl XK_F33 fixed bin(31) value('FFDE'xn);
 dcl XK_R13 fixed bin(31) value('FFDE'xn);
 dcl XK_F34 fixed bin(31) value('FFDF'xn);
 dcl XK_R14 fixed bin(31) value('FFDF'xn);
 dcl XK_F35 fixed bin(31) value('FFE0'xn);
 dcl XK_R15 fixed bin(31) value('FFE0'xn);

 /* Modifiers */

 dcl XK_Shift_L    fixed bin(31) value('FFE1'xn); /* Left shift */
 dcl XK_Shift_R    fixed bin(31) value('FFE2'xn); /* Right shift */
 dcl XK_Control_L  fixed bin(31) value('FFE3'xn); /* Left control */
 dcl XK_Control_R  fixed bin(31) value('FFE4'xn); /* Right control */
 dcl XK_Caps_Lock  fixed bin(31) value('FFE5'xn); /* Caps lock */
 dcl XK_Shift_Lock fixed bin(31) value('FFE6'xn); /* Shift lock */

 dcl XK_Meta_L     fixed bin(31) value('FFE7'xn); /* Left meta */
 dcl XK_Meta_R     fixed bin(31) value('FFE8'xn); /* Right meta */
 dcl XK_Alt_L      fixed bin(31) value('FFE9'xn); /* Left alt */
 dcl XK_Alt_R      fixed bin(31) value('FFEA'xn); /* Right alt */
 dcl XK_Super_L    fixed bin(31) value('FFEB'xn); /* Left super */
 dcl XK_Super_R    fixed bin(31) value('FFEC'xn); /* Right super */
 dcl XK_Hyper_L    fixed bin(31) value('FFED'xn); /* Left hyper */
 dcl XK_Hyper_R    fixed bin(31) value('FFEE'xn); /* Right hyper */

 %end; /* XK_MISCELLANY */

 /* Latin 1, Byte 3 = 0 */
 %dcl XK_LATIN1 char ext;
 %if XK_LATIN1 ^= '' %then %do;

 dcl XK_space          fixed bin(31) value('020'xn);
 dcl XK_exclam         fixed bin(31) value('021'xn);
 dcl XK_quotedbl       fixed bin(31) value('022'xn);
 dcl XK_numbersign     fixed bin(31) value('023'xn);
 dcl XK_dollar         fixed bin(31) value('024'xn);
 dcl XK_percent        fixed bin(31) value('025'xn);
 dcl XK_ampersand      fixed bin(31) value('026'xn);
 dcl XK_apostrophe     fixed bin(31) value('027'xn);
 dcl XK_quoteright     fixed bin(31) value('027'xn); /* deprecated */
 dcl XK_parenleft      fixed bin(31) value('028'xn);
 dcl XK_parenright     fixed bin(31) value('029'xn);
 dcl XK_asterisk       fixed bin(31) value('02a'xn);
 dcl XK_plus           fixed bin(31) value('02b'xn);
 dcl XK_comma          fixed bin(31) value('02c'xn);
 dcl XK_minus          fixed bin(31) value('02d'xn);
 dcl XK_period         fixed bin(31) value('02e'xn);
 dcl XK_slash          fixed bin(31) value('02f'xn);
 dcl XK_0              fixed bin(31) value('030'xn);
 dcl XK_1              fixed bin(31) value('031'xn);
 dcl XK_2              fixed bin(31) value('032'xn);
 dcl XK_3              fixed bin(31) value('033'xn);
 dcl XK_4              fixed bin(31) value('034'xn);
 dcl XK_5              fixed bin(31) value('035'xn);
 dcl XK_6              fixed bin(31) value('036'xn);
 dcl XK_7              fixed bin(31) value('037'xn);
 dcl XK_8              fixed bin(31) value('038'xn);
 dcl XK_9              fixed bin(31) value('039'xn);
 dcl XK_colon          fixed bin(31) value('03a'xn);
 dcl XK_semicolon      fixed bin(31) value('03b'xn);
 dcl XK_less           fixed bin(31) value('03c'xn);
 dcl XK_equal          fixed bin(31) value('03d'xn);
 dcl XK_greater        fixed bin(31) value('03e'xn);
 dcl XK_question       fixed bin(31) value('03f'xn);
 dcl XK_at             fixed bin(31) value('040'xn);
 dcl XK_A$             fixed bin(31) value('041'xn); /* was XK_A */
 dcl XK_B$             fixed bin(31) value('042'xn); /* was XK_B */
 dcl XK_C$             fixed bin(31) value('043'xn); /* was XK_C */
 dcl XK_D$             fixed bin(31) value('044'xn); /* was XK_D */
 dcl XK_E$             fixed bin(31) value('045'xn); /* was XK_E */
 dcl XK_F$             fixed bin(31) value('046'xn); /* was XK_F */
 dcl XK_G$             fixed bin(31) value('047'xn); /* was XK_G */
 dcl XK_H$             fixed bin(31) value('048'xn); /* was XK_H */
 dcl XK_I$             fixed bin(31) value('049'xn); /* was XK_I */
 dcl XK_J$             fixed bin(31) value('04a'xn); /* was XK_J */
 dcl XK_K$             fixed bin(31) value('04b'xn); /* was XK_K */
 dcl XK_L$             fixed bin(31) value('04c'xn); /* was XK_L */
 dcl XK_M$             fixed bin(31) value('04d'xn); /* was XK_M */
 dcl XK_N$             fixed bin(31) value('04e'xn); /* was XK_N */
 dcl XK_O$             fixed bin(31) value('04f'xn); /* was XK_O */
 dcl XK_P$             fixed bin(31) value('050'xn); /* was XK_P */
 dcl XK_Q$             fixed bin(31) value('051'xn); /* was XK_Q */
 dcl XK_R$             fixed bin(31) value('052'xn); /* was XK_R */
 dcl XK_S$             fixed bin(31) value('053'xn); /* was XK_S */
 dcl XK_T$             fixed bin(31) value('054'xn); /* was XK_T */
 dcl XK_U$             fixed bin(31) value('055'xn); /* was XK_U */
 dcl XK_V$             fixed bin(31) value('056'xn); /* was XK_V */
 dcl XK_W$             fixed bin(31) value('057'xn); /* was XK_W */
 dcl XK_X$             fixed bin(31) value('058'xn); /* was XK_X */
 dcl XK_Y$             fixed bin(31) value('059'xn); /* was XK_Y */
 dcl XK_Z$             fixed bin(31) value('05a'xn); /* was XK_Z */
 dcl XK_bracketleft    fixed bin(31) value('05b'xn);
 dcl XK_backslash      fixed bin(31) value('05c'xn);
 dcl XK_bracketright   fixed bin(31) value('05d'xn);
 dcl XK_asciicircum    fixed bin(31) value('05e'xn);
 dcl XK_underscore     fixed bin(31) value('05f'xn);
 dcl XK_grave          fixed bin(31) value('060'xn);
 dcl XK_quoteleft      fixed bin(31) value('060'xn); /* deprecated */
 dcl XK_a              fixed bin(31) value('061'xn);
 dcl XK_b              fixed bin(31) value('062'xn);
 dcl XK_c              fixed bin(31) value('063'xn);
 dcl XK_d              fixed bin(31) value('064'xn);
 dcl XK_e              fixed bin(31) value('065'xn);
 dcl XK_f              fixed bin(31) value('066'xn);
 dcl XK_g              fixed bin(31) value('067'xn);
 dcl XK_h              fixed bin(31) value('068'xn);
 dcl XK_i              fixed bin(31) value('069'xn);
 dcl XK_j              fixed bin(31) value('06a'xn);
 dcl XK_k              fixed bin(31) value('06b'xn);
 dcl XK_l              fixed bin(31) value('06c'xn);
 dcl XK_m              fixed bin(31) value('06d'xn);
 dcl XK_n              fixed bin(31) value('06e'xn);
 dcl XK_o              fixed bin(31) value('06f'xn);
 dcl XK_p              fixed bin(31) value('070'xn);
 dcl XK_q              fixed bin(31) value('071'xn);
 dcl XK_r              fixed bin(31) value('072'xn);
 dcl XK_s              fixed bin(31) value('073'xn);
 dcl XK_t              fixed bin(31) value('074'xn);
 dcl XK_u              fixed bin(31) value('075'xn);
 dcl XK_v              fixed bin(31) value('076'xn);
 dcl XK_w              fixed bin(31) value('077'xn);
 dcl XK_x              fixed bin(31) value('078'xn);
 dcl XK_y              fixed bin(31) value('079'xn);
 dcl XK_z              fixed bin(31) value('07a'xn);
 dcl XK_braceleft      fixed bin(31) value('07b'xn);
 dcl XK_bar            fixed bin(31) value('07c'xn);
 dcl XK_braceright     fixed bin(31) value('07d'xn);
 dcl XK_asciitilde     fixed bin(31) value('07e'xn);

 dcl XK_nobreakspace   fixed bin(31) value('0a0'xn);
 dcl XK_exclamdown     fixed bin(31) value('0a1'xn);
 dcl XK_cent           fixed bin(31) value('0a2'xn);
 dcl XK_sterling       fixed bin(31) value('0a3'xn);
 dcl XK_currency       fixed bin(31) value('0a4'xn);
 dcl XK_yen            fixed bin(31) value('0a5'xn);
 dcl XK_brokenbar      fixed bin(31) value('0a6'xn);
 dcl XK_section        fixed bin(31) value('0a7'xn);
 dcl XK_diaeresis      fixed bin(31) value('0a8'xn);
 dcl XK_copyright      fixed bin(31) value('0a9'xn);
 dcl XK_ordfeminine    fixed bin(31) value('0aa'xn);
 dcl XK_guillemotleft  fixed bin(31) value('0ab'xn);
                       /* left angle quotation mark */
 dcl XK_notsign        fixed bin(31) value('0ac'xn);
 dcl XK_hyphen         fixed bin(31) value('0ad'xn);
 dcl XK_registered     fixed bin(31) value('0ae'xn);
 dcl XK_macron         fixed bin(31) value('0af'xn);
 dcl XK_degree         fixed bin(31) value('0b0'xn);
 dcl XK_plusminus      fixed bin(31) value('0b1'xn);
 dcl XK_twosuperior    fixed bin(31) value('0b2'xn);
 dcl XK_threesuperior  fixed bin(31) value('0b3'xn);
 dcl XK_acute          fixed bin(31) value('0b4'xn);
 dcl XK_mu             fixed bin(31) value('0b5'xn);
 dcl XK_paragraph      fixed bin(31) value('0b6'xn);
 dcl XK_periodcentered fixed bin(31) value('0b7'xn);
 dcl XK_cedilla        fixed bin(31) value('0b8'xn);
 dcl XK_onesuperior    fixed bin(31) value('0b9'xn);
 dcl XK_masculine      fixed bin(31) value('0ba'xn);
 dcl XK_guillemotright fixed bin(31) value('0bb'xn);
                       /* right angle quotation mark */
 dcl XK_onequarter     fixed bin(31) value('0bc'xn);
 dcl XK_onehalf        fixed bin(31) value('0bd'xn);
 dcl XK_threequarters  fixed bin(31) value('0be'xn);
 dcl XK_questiondown   fixed bin(31) value('0bf'xn);
 dcl XK_Agrave$        fixed bin(31) value('0c0'xn);
 dcl XK_Aacute$        fixed bin(31) value('0c1'xn);
 dcl XK_Acircumflex$   fixed bin(31) value('0c2'xn);
 dcl XK_Atilde$        fixed bin(31) value('0c3'xn);
 dcl XK_Adiaeresis$    fixed bin(31) value('0c4'xn);
 dcl XK_Aring$         fixed bin(31) value('0c5'xn);
 dcl XK_AE$            fixed bin(31) value('0c6'xn);
 dcl XK_Ccedilla$      fixed bin(31) value('0c7'xn);
 dcl XK_Egrave$        fixed bin(31) value('0c8'xn);
 dcl XK_Eacute$        fixed bin(31) value('0c9'xn);
 dcl XK_Ecircumflex$   fixed bin(31) value('0ca'xn);
 dcl XK_Ediaeresis$    fixed bin(31) value('0cb'xn);
 dcl XK_Igrave$        fixed bin(31) value('0cc'xn);
 dcl XK_Iacute$        fixed bin(31) value('0cd'xn);
 dcl XK_Icircumflex$   fixed bin(31) value('0ce'xn);
 dcl XK_Idiaeresis$    fixed bin(31) value('0cf'xn);
 dcl XK_ETH$           fixed bin(31) value('0d0'xn);
 dcl XK_Ntilde$        fixed bin(31) value('0d1'xn);
 dcl XK_Ograve$        fixed bin(31) value('0d2'xn);
 dcl XK_Oacute$        fixed bin(31) value('0d3'xn);
 dcl XK_Ocircumflex$   fixed bin(31) value('0d4'xn);
 dcl XK_Otilde$         fixed bin(31) value('0d5'xn);
 dcl XK_Odiaeresise    fixed bin(31) value('0d6'xn);
 dcl XK_multiply       fixed bin(31) value('0d7'xn);
 dcl XK_Ooblique$      fixed bin(31) value('0d8'xn);
 dcl XK_Ugrave$        fixed bin(31) value('0d9'xn);
 dcl XK_Uacute$        fixed bin(31) value('0da'xn);
 dcl XK_Ucircumflex$   fixed bin(31) value('0db'xn);
 dcl XK_Udiaeresis$    fixed bin(31) value('0dc'xn);
 dcl XK_Yacute$        fixed bin(31) value('0dd'xn);
 dcl XK_THORN$         fixed bin(31) value('0de'xn);
 dcl XK_ssharp         fixed bin(31) value('0df'xn);
 dcl XK_agrave         fixed bin(31) value('0e0'xn);
 dcl XK_aacute         fixed bin(31) value('0e1'xn);
 dcl XK_acircumflex    fixed bin(31) value('0e2'xn);
 dcl XK_atilde         fixed bin(31) value('0e3'xn);
 dcl XK_adiaeresis     fixed bin(31) value('0e4'xn);
 dcl XK_aring          fixed bin(31) value('0e5'xn);
 dcl XK_ae             fixed bin(31) value('0e6'xn);
 dcl XK_ccedilla       fixed bin(31) value('0e7'xn);
 dcl XK_egrave         fixed bin(31) value('0e8'xn);
 dcl XK_eacute         fixed bin(31) value('0e9'xn);
 dcl XK_ecircumflex    fixed bin(31) value('0ea'xn);
 dcl XK_ediaeresis     fixed bin(31) value('0eb'xn);
 dcl XK_igrave         fixed bin(31) value('0ec'xn);
 dcl XK_iacute         fixed bin(31) value('0ed'xn);
 dcl XK_icircumflex    fixed bin(31) value('0ee'xn);
 dcl XK_idiaeresis     fixed bin(31) value('0ef'xn);
 dcl XK_eth            fixed bin(31) value('0f0'xn);
 dcl XK_ntilde         fixed bin(31) value('0f1'xn);
 dcl XK_ograve         fixed bin(31) value('0f2'xn);
 dcl XK_oacute         fixed bin(31) value('0f3'xn);
 dcl XK_ocircumflex    fixed bin(31) value('0f4'xn);
 dcl XK_otilde         fixed bin(31) value('0f5'xn);
 dcl XK_odiaeresis     fixed bin(31) value('0f6'xn);
 dcl XK_division       fixed bin(31) value('0f7'xn);
 dcl XK_oslash         fixed bin(31) value('0f8'xn);
 dcl XK_ugrave         fixed bin(31) value('0f9'xn);
 dcl XK_uacute         fixed bin(31) value('0fa'xn);
 dcl XK_ucircumflex    fixed bin(31) value('0fb'xn);
 dcl XK_udiaeresis     fixed bin(31) value('0fc'xn);
 dcl XK_yacute         fixed bin(31) value('0fd'xn);
 dcl XK_thorn          fixed bin(31) value('0fe'xn);
 dcl XK_ydiaeresis     fixed bin(31) value('0ff'xn);

 %end; /* XK_LATIN1 */

 /* Latin 2, Byte 3 = 1 */

 %dcl XK_LATIN2 char ext;
 %if XK_LATIN2 ^= '' %then %do;

 dcl XK_Aogonek$      fixed bin(31) value('1a1'xn);
 dcl XK_breve         fixed bin(31) value('1a2'xn);
 dcl XK_Lstroke$      fixed bin(31) value('1a3'xn);
 dcl XK_Lcaron$       fixed bin(31) value('1a5'xn);
 dcl XK_Sacute$       fixed bin(31) value('1a6'xn);
 dcl XK_Scaron$       fixed bin(31) value('1a9'xn);
 dcl XK_Scedilla$     fixed bin(31) value('1aa'xn);
 dcl XK_Tcaron$       fixed bin(31) value('1ab'xn);
 dcl XK_Zacute$       fixed bin(31) value('1ac'xn);
 dcl XK_Zcaron$       fixed bin(31) value('1ae'xn);
 dcl XK_Zabovedot$    fixed bin(31) value('1af'xn);
 dcl XK_aogonek       fixed bin(31) value('1b1'xn);
 dcl XK_ogonek        fixed bin(31) value('1b2'xn);
 dcl XK_lstroke       fixed bin(31) value('1b3'xn);
 dcl XK_lcaron        fixed bin(31) value('1b5'xn);
 dcl XK_sacute        fixed bin(31) value('1b6'xn);
 dcl XK_caron         fixed bin(31) value('1b7'xn);
 dcl XK_scaron        fixed bin(31) value('1b9'xn);
 dcl XK_scedilla      fixed bin(31) value('1ba'xn);
 dcl XK_tcaron        fixed bin(31) value('1bb'xn);
 dcl XK_zacute        fixed bin(31) value('1bc'xn);
 dcl XK_doubleacute   fixed bin(31) value('1bd'xn);
 dcl XK_zcaron        fixed bin(31) value('1be'xn);
 dcl XK_zabovedot     fixed bin(31) value('1bf'xn);
 dcl XK_Racute$       fixed bin(31) value('1c0'xn);
 dcl XK_Abreve$       fixed bin(31) value('1c3'xn);
 dcl XK_Lacute$       fixed bin(31) value('1c5'xn);
 dcl XK_Cacute$       fixed bin(31) value('1c6'xn);
 dcl XK_Ccaron$       fixed bin(31) value('1c8'xn);
 dcl XK_Eogonek$      fixed bin(31) value('1ca'xn);
 dcl XK_Ecaron$       fixed bin(31) value('1cc'xn);
 dcl XK_Dcaron$       fixed bin(31) value('1cf'xn);
 dcl XK_Dstroke$      fixed bin(31) value('1d0'xn);
 dcl XK_Nacute$       fixed bin(31) value('1d1'xn);
 dcl XK_Ncaron$       fixed bin(31) value('1d2'xn);
 dcl XK_Odoubleacute$ fixed bin(31) value('1d5'xn);
 dcl XK_Rcaron$       fixed bin(31) value('1d8'xn);
 dcl XK_Uring$        fixed bin(31) value('1d9'xn);
 dcl XK_Udoubleacute$ fixed bin(31) value('1db'xn);
 dcl XK_Tcedilla$     fixed bin(31) value('1de'xn);
 dcl XK_racute        fixed bin(31) value('1e0'xn);
 dcl XK_abreve        fixed bin(31) value('1e3'xn);
 dcl XK_lacute        fixed bin(31) value('1e5'xn);
 dcl XK_cacute        fixed bin(31) value('1e6'xn);
 dcl XK_ccaron        fixed bin(31) value('1e8'xn);
 dcl XK_eogonek       fixed bin(31) value('1ea'xn);
 dcl XK_ecaron        fixed bin(31) value('1ec'xn);
 dcl XK_dcaron        fixed bin(31) value('1ef'xn);
 dcl XK_dstroke       fixed bin(31) value('1f0'xn);
 dcl XK_nacute        fixed bin(31) value('1f1'xn);
 dcl XK_ncaron        fixed bin(31) value('1f2'xn);
 dcl XK_odoubleacute  fixed bin(31) value('1f5'xn);
 dcl XK_udoubleacute  fixed bin(31) value('1fb'xn);
 dcl XK_rcaron        fixed bin(31) value('1f8'xn);
 dcl XK_uring         fixed bin(31) value('1f9'xn);
 dcl XK_tcedilla      fixed bin(31) value('1fe'xn);
 dcl XK_abovedot      fixed bin(31) value('1ff'xn);

 %end; /* XK_LATIN2 */

 /* Latin 3, Byte 3 = 2 */

 %dcl XK_LATIN3 char ext;
 %if XK_LATIN3 ^= '' %then %do;

 dcl XK_Hstroke$     fixed bin(31) value('2a1'xn);
 dcl XK_Hcircumflex$ fixed bin(31) value('2a6'xn);
 dcl XK_Iabovedot$   fixed bin(31) value('2a9'xn);
 dcl XK_Gbreve$      fixed bin(31) value('2ab'xn);
 dcl XK_Jcircumflex$ fixed bin(31) value('2ac'xn);
 dcl XK_hstroke      fixed bin(31) value('2b1'xn);
 dcl XK_hcircumflex  fixed bin(31) value('2b6'xn);
 dcl XK_idotless     fixed bin(31) value('2b9'xn);
 dcl XK_gbreve       fixed bin(31) value('2bb'xn);
 dcl XK_jcircumflex  fixed bin(31) value('2bc'xn);
 dcl XK_Cabovedot$   fixed bin(31) value('2c5'xn);
 dcl XK_Ccircumflex$ fixed bin(31) value('2c6'xn);
 dcl XK_Gabovedot$   fixed bin(31) value('2d5'xn);
 dcl XK_Gcircumflex$ fixed bin(31) value('2d8'xn);
 dcl XK_Ubreve$      fixed bin(31) value('2dd'xn);
 dcl XK_Scircumflex$ fixed bin(31) value('2de'xn);
 dcl XK_cabovedot    fixed bin(31) value('2e5'xn);
 dcl XK_ccircumflex  fixed bin(31) value('2e6'xn);
 dcl XK_gabovedot    fixed bin(31) value('2f5'xn);
 dcl XK_gcircumflex  fixed bin(31) value('2f8'xn);
 dcl XK_ubreve       fixed bin(31) value('2fd'xn);
 dcl XK_scircumflex  fixed bin(31) value('2fe'xn);

 %end; /* XK_LATIN3 */


 /* Latin 4, Byte 3 = 3 */

 %dcl XK_LATIN4 char ext;
 %if XK_LATIN4 ^= '' %then %do;

 dcl XK_kra        fixed bin(31) value('3a2'xn);
 dcl XK_kappa      fixed bin(31) value('3a2'xn); /* deprecated */
 dcl XK_Rcedilla$  fixed bin(31) value('3a3'xn);
 dcl XK_Itilde$    fixed bin(31) value('3a5'xn);
 dcl XK_Lcedilla$  fixed bin(31) value('3a6'xn);
 dcl XK_Emacron$   fixed bin(31) value('3aa'xn);
 dcl XK_Gcedilla$  fixed bin(31) value('3ab'xn);
 dcl XK_Tslash$    fixed bin(31) value('3ac'xn);
 dcl XK_rcedilla   fixed bin(31) value('3b3'xn);
 dcl XK_itilde     fixed bin(31) value('3b5'xn);
 dcl XK_lcedilla   fixed bin(31) value('3b6'xn);
 dcl XK_emacron    fixed bin(31) value('3ba'xn);
 dcl XK_gcedilla   fixed bin(31) value('3bb'xn);
 dcl XK_tslash     fixed bin(31) value('3bc'xn);
 dcl XK_ENG$       fixed bin(31) value('3bd'xn);
 dcl XK_eng        fixed bin(31) value('3bf'xn);
 dcl XK_Amacron$   fixed bin(31) value('3c0'xn);
 dcl XK_Iogonek$   fixed bin(31) value('3c7'xn);
 dcl XK_Eabovedot$ fixed bin(31) value('3cc'xn);
 dcl XK_Imacron$   fixed bin(31) value('3cf'xn);
 dcl XK_Ncedilla$  fixed bin(31) value('3d1'xn);
 dcl XK_Omacron$   fixed bin(31) value('3d2'xn);
 dcl XK_Kcedilla$  fixed bin(31) value('3d3'xn);
 dcl XK_Uogonek$   fixed bin(31) value('3d9'xn);
 dcl XK_Utilde$    fixed bin(31) value('3dd'xn);
 dcl XK_Umacron$   fixed bin(31) value('3de'xn);
 dcl XK_amacron    fixed bin(31) value('3e0'xn);
 dcl XK_iogonek    fixed bin(31) value('3e7'xn);
 dcl XK_eabovedot  fixed bin(31) value('3ec'xn);
 dcl XK_imacron    fixed bin(31) value('3ef'xn);
 dcl XK_ncedilla   fixed bin(31) value('3f1'xn);
 dcl XK_omacron    fixed bin(31) value('3f2'xn);
 dcl XK_kcedilla   fixed bin(31) value('3f3'xn);
 dcl XK_uogonek    fixed bin(31) value('3f9'xn);
 dcl XK_utilde     fixed bin(31) value('3fd'xn);
 dcl XK_umacron    fixed bin(31) value('3fe'xn);

 %end; /* XK_LATIN4 */

 /* Katakana, Byte 3 = 4 */

 %dcl XK_KATAKANA char ext;
 %if XK_KATAKANA ^= '' %then %do;
 dcl XK_overline          fixed bin(31) value('47e'xn);
 dcl XK_kana_fullstop     fixed bin(31) value('4a1'xn);
 dcl XK_kana_openingbracket fixed bin(31) value('4a2'xn);
 dcl XK_kana_closingbracket fixed bin(31) value('4a3'xn);
 dcl XK_kana_comma        fixed bin(31) value('4a4'xn);
 dcl XK_kana_conjunctive  fixed bin(31) value('4a5'xn);
 dcl XK_kana_middledot    fixed bin(31) value('4a5'xn); /* deprecated */
 dcl XK_kana_WO  fixed bin(31) value('4a6'xn);
 dcl XK_kana_a   fixed bin(31) value('4a7'xn);
 dcl XK_kana_i   fixed bin(31) value('4a8'xn);
 dcl XK_kana_u   fixed bin(31) value('4a9'xn);
 dcl XK_kana_e   fixed bin(31) value('4aa'xn);
 dcl XK_kana_o   fixed bin(31) value('4ab'xn);
 dcl XK_kana_ya  fixed bin(31) value('4ac'xn);
 dcl XK_kana_yu  fixed bin(31) value('4ad'xn);
 dcl XK_kana_yo  fixed bin(31) value('4ae'xn);
 dcl XK_kana_tsu fixed bin(31) value('4af'xn);
 dcl XK_kana_tu  fixed bin(31) value('4af'xn); /* deprecated */
 dcl XK_prolongedsound    fixed bin(31) value('4b0'xn);
 dcl XK_kana_A$  fixed bin(31) value('4b1'xn); /* was XK_kana_A */
 dcl XK_kana_I$  fixed bin(31) value('4b2'xn); /* was XK_kana_I */
 dcl XK_kana_U$  fixed bin(31) value('4b3'xn); /* was XK_kana_U */
 dcl XK_kana_E$  fixed bin(31) value('4b4'xn); /* was XK_kana_E */
 dcl XK_kana_O$  fixed bin(31) value('4b5'xn); /* was XK_kana_O */
 dcl XK_kana_KA  fixed bin(31) value('4b6'xn);
 dcl XK_kana_KI  fixed bin(31) value('4b7'xn);
 dcl XK_kana_KU  fixed bin(31) value('4b8'xn);
 dcl XK_kana_KE  fixed bin(31) value('4b9'xn);
 dcl XK_kana_KO  fixed bin(31) value('4ba'xn);
 dcl XK_kana_SA  fixed bin(31) value('4bb'xn);
 dcl XK_kana_SHI fixed bin(31) value('4bc'xn);
 dcl XK_kana_SU  fixed bin(31) value('4bd'xn);
 dcl XK_kana_SE  fixed bin(31) value('4be'xn);
 dcl XK_kana_SO  fixed bin(31) value('4bf'xn);
 dcl XK_kana_TA  fixed bin(31) value('4c0'xn);
 dcl XK_kana_CHI fixed bin(31) value('4c1'xn);
 dcl XK_kana_TI  fixed bin(31) value('4c1'xn); /* deprecated */
 dcl XK_kana_TSU$ fixed bin(31) value('4c2'xn);/* was XK_kana_TSU */
 dcl XK_kana_TU$ fixed bin(31) value('4c2'xn); /* deprecated */
 dcl XK_kana_TE  fixed bin(31) value('4c3'xn);
 dcl XK_kana_TO  fixed bin(31) value('4c4'xn);
 dcl XK_kana_NA  fixed bin(31) value('4c5'xn);
 dcl XK_kana_NI  fixed bin(31) value('4c6'xn);
 dcl XK_kana_NU  fixed bin(31) value('4c7'xn);
 dcl XK_kana_NE  fixed bin(31) value('4c8'xn);
 dcl XK_kana_NO  fixed bin(31) value('4c9'xn);
 dcl XK_kana_HA  fixed bin(31) value('4ca'xn);
 dcl XK_kana_HI  fixed bin(31) value('4cb'xn);
 dcl XK_kana_FU  fixed bin(31) value('4cc'xn);
 dcl XK_kana_HU  fixed bin(31) value('4cc'xn); /* deprecated */
 dcl XK_kana_HE  fixed bin(31) value('4cd'xn);
 dcl XK_kana_HO  fixed bin(31) value('4ce'xn);
 dcl XK_kana_MA  fixed bin(31) value('4cf'xn);
 dcl XK_kana_MI  fixed bin(31) value('4d0'xn);
 dcl XK_kana_MU  fixed bin(31) value('4d1'xn);
 dcl XK_kana_ME  fixed bin(31) value('4d2'xn);
 dcl XK_kana_MO  fixed bin(31) value('4d3'xn);
 dcl XK_kana_YA$ fixed bin(31) value('4d4'xn); /* was XK_kana_YA */
 dcl XK_kana_YU$ fixed bin(31) value('4d5'xn); /* was XK_kana_YU */
 dcl XK_kana_YO$ fixed bin(31) value('4d6'xn); /* was XK_kana_YO */
 dcl XK_kana_RA  fixed bin(31) value('4d7'xn);
 dcl XK_kana_RI  fixed bin(31) value('4d8'xn);
 dcl XK_kana_RU  fixed bin(31) value('4d9'xn);
 dcl XK_kana_RE  fixed bin(31) value('4da'xn);
 dcl XK_kana_RO  fixed bin(31) value('4db'xn);
 dcl XK_kana_WA  fixed bin(31) value('4dc'xn);
 dcl XK_kana_N   fixed bin(31) value('4dd'xn);
 dcl XK_voicedsound       fixed bin(31) value('4de'xn);
 dcl XK_semivoicedsound   fixed bin(31) value('4df'xn);
 dcl XK_kana_switch       fixed bin(31) value('FF7E'xn);
                          /* Alias for mode_switch */
 %end; /* XK_KATAKANA */

 /* Arabic, Byte 3 = 5 */

 %dcl XK_ARABIC char ext;
 %if XK_ARABIC ^= '' %then %do;

 dcl XK_Arabic_comma          fixed bin(31) value('5ac'xn);
 dcl XK_Arabic_semicolon      fixed bin(31) value('5bb'xn);
 dcl XK_Arabic_question_mark  fixed bin(31) value('5bf'xn);
 dcl XK_Arabic_hamza          fixed bin(31) value('5c1'xn);
 dcl XK_Arabic_maddaonalef    fixed bin(31) value('5c2'xn);
 dcl XK_Arabic_hamzaonalef    fixed bin(31) value('5c3'xn);
 dcl XK_Arabic_hamzaonwaw     fixed bin(31) value('5c4'xn);
 dcl XK_Arabic_hamzaunderalef fixed bin(31) value('5c5'xn);
 dcl XK_Arabic_hamzaonyeh     fixed bin(31) value('5c6'xn);
 dcl XK_Arabic_alef           fixed bin(31) value('5c7'xn);
 dcl XK_Arabic_beh            fixed bin(31) value('5c8'xn);
 dcl XK_Arabic_tehmarbuta     fixed bin(31) value('5c9'xn);
 dcl XK_Arabic_teh            fixed bin(31) value('5ca'xn);
 dcl XK_Arabic_theh           fixed bin(31) value('5cb'xn);
 dcl XK_Arabic_jeem           fixed bin(31) value('5cc'xn);
 dcl XK_Arabic_hah            fixed bin(31) value('5cd'xn);
 dcl XK_Arabic_khah           fixed bin(31) value('5ce'xn);
 dcl XK_Arabic_dal            fixed bin(31) value('5cf'xn);
 dcl XK_Arabic_thal           fixed bin(31) value('5d0'xn);
 dcl XK_Arabic_ra             fixed bin(31) value('5d1'xn);
 dcl XK_Arabic_zain           fixed bin(31) value('5d2'xn);
 dcl XK_Arabic_seen           fixed bin(31) value('5d3'xn);
 dcl XK_Arabic_sheen          fixed bin(31) value('5d4'xn);
 dcl XK_Arabic_sad            fixed bin(31) value('5d5'xn);
 dcl XK_Arabic_dad            fixed bin(31) value('5d6'xn);
 dcl XK_Arabic_tah            fixed bin(31) value('5d7'xn);
 dcl XK_Arabic_zah            fixed bin(31) value('5d8'xn);
 dcl XK_Arabic_ain            fixed bin(31) value('5d9'xn);
 dcl XK_Arabic_ghain          fixed bin(31) value('5da'xn);
 dcl XK_Arabic_tatweel        fixed bin(31) value('5e0'xn);
 dcl XK_Arabic_feh            fixed bin(31) value('5e1'xn);
 dcl XK_Arabic_qaf            fixed bin(31) value('5e2'xn);
 dcl XK_Arabic_kaf            fixed bin(31) value('5e3'xn);
 dcl XK_Arabic_lam            fixed bin(31) value('5e4'xn);
 dcl XK_Arabic_meem           fixed bin(31) value('5e5'xn);
 dcl XK_Arabic_noon           fixed bin(31) value('5e6'xn);
 dcl XK_Arabic_ha             fixed bin(31) value('5e7'xn);
 dcl XK_Arabic_heh            fixed bin(31) value('5e7'xn);
                              /* deprecated */
 dcl XK_Arabic_waw            fixed bin(31) value('5e8'xn);
 dcl XK_Arabic_alefmaksura    fixed bin(31) value('5e9'xn);
 dcl XK_Arabic_yeh            fixed bin(31) value('5ea'xn);
 dcl XK_Arabic_fathatan       fixed bin(31) value('5eb'xn);
 dcl XK_Arabic_dammatan       fixed bin(31) value('5ec'xn);
 dcl XK_Arabic_kasratan       fixed bin(31) value('5ed'xn);
 dcl XK_Arabic_fatha          fixed bin(31) value('5ee'xn);
 dcl XK_Arabic_damma          fixed bin(31) value('5ef'xn);
 dcl XK_Arabic_kasra          fixed bin(31) value('5f0'xn);
 dcl XK_Arabic_shadda         fixed bin(31) value('5f1'xn);
 dcl XK_Arabic_sukun          fixed bin(31) value('5f2'xn);
 dcl XK_Arabic_switch         fixed bin(31) value('FF7E'xn);
                              /* Alias for mode_switch */
 %end; /* XK_ARABIC */

 /* Cyrillic, Byte 3 = 6 */
 %dcl XK_CYRILLIC char ext;
 %if XK_CYRILLIC ^= '' %then %do;

 dcl XK_Serbian_dje          fixed bin(31) value('6a1'xn);
 dcl XK_Macedonia_gje        fixed bin(31) value('6a2'xn);
 dcl XK_Cyrillic_io          fixed bin(31) value('6a3'xn);
 dcl XK_Ukrainian_ie         fixed bin(31) value('6a4'xn);
 dcl XK_Ukranian_je          fixed bin(31) value('6a4'xn); /* deprec. */
 dcl XK_Macedonia_dse        fixed bin(31) value('6a5'xn);
 dcl XK_Ukrainian_i          fixed bin(31) value('6a6'xn);
 dcl XK_Ukranian_i           fixed bin(31) value('6a6'xn); /* deprec. */
 dcl XK_Ukrainian_yi         fixed bin(31) value('6a7'xn);
 dcl XK_Ukranian_yi          fixed bin(31) value('6a7'xn); /* deprec. */
 dcl XK_Cyrillic_je          fixed bin(31) value('6a8'xn);
 dcl XK_Serbian_je           fixed bin(31) value('6a8'xn); /* deprec. */
 dcl XK_Cyrillic_lje         fixed bin(31) value('6a9'xn);
 dcl XK_Serbian_lje          fixed bin(31) value('6a9'xn); /* deprec. */
 dcl XK_Cyrillic_nje         fixed bin(31) value('6aa'xn);
 dcl XK_Serbian_nje          fixed bin(31) value('6aa'xn); /* deprec. */
 dcl XK_Serbian_tshe         fixed bin(31) value('6ab'xn);
 dcl XK_Macedonia_kje        fixed bin(31) value('6ac'xn);
 dcl XK_Byelorussian_shortu  fixed bin(31) value('6ae'xn);
 dcl XK_Cyrillic_dzhe        fixed bin(31) value('6af'xn);
 dcl XK_Serbian_dze          fixed bin(31) value('6af'xn); /* deprec. */
 dcl XK_numerosign           fixed bin(31) value('6b0'xn);
 dcl XK_Serbian_DJE$         fixed bin(31) value('6b1'xn);
 dcl XK_Macedonia_GJE$       fixed bin(31) value('6b2'xn);
 dcl XK_Cyrillic_IO$         fixed bin(31) value('6b3'xn);
 dcl XK_Ukrainian_IE$        fixed bin(31) value('6b4'xn);
 dcl XK_Ukranian_JE$         fixed bin(31) value('6b4'xn); /* deprec. */
 dcl XK_Macedonia_DSE$       fixed bin(31) value('6b5'xn);
 dcl XK_Ukrainian_I$         fixed bin(31) value('6b6'xn);
 dcl XK_Ukranian_I$          fixed bin(31) value('6b6'xn); /* deprec. */
 dcl XK_Ukrainian_YI$        fixed bin(31) value('6b7'xn);
 dcl XK_Ukranian_YI$         fixed bin(31) value('6b7'xn); /* deprec. */
 dcl XK_Cyrillic_JE$         fixed bin(31) value('6b8'xn);
 dcl XK_Serbian_JE$          fixed bin(31) value('6b8'xn); /* deprec. */
 dcl XK_Cyrillic_LJE$        fixed bin(31) value('6b9'xn);
 dcl XK_Serbian_LJE$         fixed bin(31) value('6b9'xn); /* deprec. */
 dcl XK_Cyrillic_NJE$        fixed bin(31) value('6ba'xn);
 dcl XK_Serbian_NJE$         fixed bin(31) value('6ba'xn); /* deprec. */
 dcl XK_Serbian_TSHE$        fixed bin(31) value('6bb'xn);
 dcl XK_Macedonia_KJE$       fixed bin(31) value('6bc'xn);
 dcl XK_Byelorussian_SHORTU$ fixed bin(31) value('6be'xn);
 dcl XK_Cyrillic_DZHE$       fixed bin(31) value('6bf'xn);
 dcl XK_Serbian_DZE$         fixed bin(31) value('6bf'xn); /* deprec. */
 dcl XK_Cyrillic_yu          fixed bin(31) value('6c0'xn);
 dcl XK_Cyrillic_a           fixed bin(31) value('6c1'xn);
 dcl XK_Cyrillic_be          fixed bin(31) value('6c2'xn);
 dcl XK_Cyrillic_tse         fixed bin(31) value('6c3'xn);
 dcl XK_Cyrillic_de          fixed bin(31) value('6c4'xn);
 dcl XK_Cyrillic_ie          fixed bin(31) value('6c5'xn);
 dcl XK_Cyrillic_ef          fixed bin(31) value('6c6'xn);
 dcl XK_Cyrillic_ghe         fixed bin(31) value('6c7'xn);
 dcl XK_Cyrillic_ha          fixed bin(31) value('6c8'xn);
 dcl XK_Cyrillic_i           fixed bin(31) value('6c9'xn);
 dcl XK_Cyrillic_shorti      fixed bin(31) value('6ca'xn);
 dcl XK_Cyrillic_ka          fixed bin(31) value('6cb'xn);
 dcl XK_Cyrillic_el          fixed bin(31) value('6cc'xn);
 dcl XK_Cyrillic_em          fixed bin(31) value('6cd'xn);
 dcl XK_Cyrillic_en          fixed bin(31) value('6ce'xn);
 dcl XK_Cyrillic_o           fixed bin(31) value('6cf'xn);
 dcl XK_Cyrillic_pe          fixed bin(31) value('6d0'xn);
 dcl XK_Cyrillic_ya          fixed bin(31) value('6d1'xn);
 dcl XK_Cyrillic_er          fixed bin(31) value('6d2'xn);
 dcl XK_Cyrillic_es          fixed bin(31) value('6d3'xn);
 dcl XK_Cyrillic_te          fixed bin(31) value('6d4'xn);
 dcl XK_Cyrillic_u           fixed bin(31) value('6d5'xn);
 dcl XK_Cyrillic_zhe         fixed bin(31) value('6d6'xn);
 dcl XK_Cyrillic_ve          fixed bin(31) value('6d7'xn);
 dcl XK_Cyrillic_softsign    fixed bin(31) value('6d8'xn);
 dcl XK_Cyrillic_yeru        fixed bin(31) value('6d9'xn);
 dcl XK_Cyrillic_ze          fixed bin(31) value('6da'xn);
 dcl XK_Cyrillic_sha         fixed bin(31) value('6db'xn);
 dcl XK_Cyrillic_e           fixed bin(31) value('6dc'xn);
 dcl XK_Cyrillic_shcha       fixed bin(31) value('6dd'xn);
 dcl XK_Cyrillic_che         fixed bin(31) value('6de'xn);
 dcl XK_Cyrillic_hardsign    fixed bin(31) value('6df'xn);
 dcl XK_Cyrillic_YU$         fixed bin(31) value('6e0'xn);
 dcl XK_Cyrillic_A$          fixed bin(31) value('6e1'xn);
 dcl XK_Cyrillic_BE$         fixed bin(31) value('6e2'xn);
 dcl XK_Cyrillic_TSE$        fixed bin(31) value('6e3'xn);
 dcl XK_Cyrillic_DE$         fixed bin(31) value('6e4'xn);
 dcl XK_Cyrillic_IE$         fixed bin(31) value('6e5'xn);
 dcl XK_Cyrillic_EF$         fixed bin(31) value('6e6'xn);
 dcl XK_Cyrillic_GHE$        fixed bin(31) value('6e7'xn);
 dcl XK_Cyrillic_HA$         fixed bin(31) value('6e8'xn);
 dcl XK_Cyrillic_I$          fixed bin(31) value('6e9'xn);
 dcl XK_Cyrillic_SHORTI$     fixed bin(31) value('6ea'xn);
 dcl XK_Cyrillic_KA$         fixed bin(31) value('6eb'xn);
 dcl XK_Cyrillic_EL$         fixed bin(31) value('6ec'xn);
 dcl XK_Cyrillic_EM$         fixed bin(31) value('6ed'xn);
 dcl XK_Cyrillic_EN$         fixed bin(31) value('6ee'xn);
 dcl XK_Cyrillic_O$          fixed bin(31) value('6ef'xn);
 dcl XK_Cyrillic_PE$         fixed bin(31) value('6f0'xn);
 dcl XK_Cyrillic_YA$         fixed bin(31) value('6f1'xn);
 dcl XK_Cyrillic_ER$         fixed bin(31) value('6f2'xn);
 dcl XK_Cyrillic_ES$         fixed bin(31) value('6f3'xn);
 dcl XK_Cyrillic_TE$         fixed bin(31) value('6f4'xn);
 dcl XK_Cyrillic_U$          fixed bin(31) value('6f5'xn);
 dcl XK_Cyrillic_ZHE$        fixed bin(31) value('6f6'xn);
 dcl XK_Cyrillic_VE$         fixed bin(31) value('6f7'xn);
 dcl XK_Cyrillic_SOFTSIGN$   fixed bin(31) value('6f8'xn);
 dcl XK_Cyrillic_YERU$       fixed bin(31) value('6f9'xn);
 dcl XK_Cyrillic_ZE$         fixed bin(31) value('6fa'xn);
 dcl XK_Cyrillic_SHA$        fixed bin(31) value('6fb'xn);
 dcl XK_Cyrillic_E$          fixed bin(31) value('6fc'xn);
 dcl XK_Cyrillic_SHCHA$      fixed bin(31) value('6fd'xn);
 dcl XK_Cyrillic_CHE$        fixed bin(31) value('6fe'xn);
 dcl XK_Cyrillic_HARDSIGN$   fixed bin(31) value('6ff'xn);

 %end; /* XK_CYRILLIC */

 /* Greek, Byte 3 = 7 */

 %dcl XK_GREEK char ext;
 %if XK_GREEK ^= '' %then %do;

 dcl XK_Greek_ALPHAaccent$          fixed bin(31) value('7a1'xn);
 dcl XK_Greek_EPSILONaccent$        fixed bin(31) value('7a2'xn);
 dcl XK_Greek_ETAaccent$            fixed bin(31) value('7a3'xn);
 dcl XK_Greek_IOTAaccent$           fixed bin(31) value('7a4'xn);
 dcl XK_Greek_IOTAdiaeresis$        fixed bin(31) value('7a5'xn);
 dcl XK_Greek_OMICRONaccent$        fixed bin(31) value('7a7'xn);
 dcl XK_Greek_UPSILONaccent$        fixed bin(31) value('7a8'xn);
 dcl XK_Greek_UPSILONdieresis$      fixed bin(31) value('7a9'xn);
 dcl XK_Greek_OMEGAaccent$          fixed bin(31) value('7ab'xn);
 dcl XK_Greek_accentdieresis        fixed bin(31) value('7ae'xn);
 dcl XK_Greek_horizbar              fixed bin(31) value('7af'xn);
 dcl XK_Greek_alphaaccent           fixed bin(31) value('7b1'xn);
 dcl XK_Greek_epsilonaccent         fixed bin(31) value('7b2'xn);
 dcl XK_Greek_etaaccent             fixed bin(31) value('7b3'xn);
 dcl XK_Greek_iotaaccent            fixed bin(31) value('7b4'xn);
 dcl XK_Greek_iotadieresis          fixed bin(31) value('7b5'xn);
 dcl XK_Greek_iotaaccentdieresis    fixed bin(31) value('7b6'xn);
 dcl XK_Greek_omicronaccent         fixed bin(31) value('7b7'xn);
 dcl XK_Greek_upsilonaccent         fixed bin(31) value('7b8'xn);
 dcl XK_Greek_upsilondieresis       fixed bin(31) value('7b9'xn);
 dcl XK_Greek_upsilonaccentdieresis fixed bin(31) value('7ba'xn);
 dcl XK_Greek_omegaaccent           fixed bin(31) value('7bb'xn);
 dcl XK_Greek_ALPHA$                fixed bin(31) value('7c1'xn);
 dcl XK_Greek_BETA$                 fixed bin(31) value('7c2'xn);
 dcl XK_Greek_GAMMA$                fixed bin(31) value('7c3'xn);
 dcl XK_Greek_DELTA$                fixed bin(31) value('7c4'xn);
 dcl XK_Greek_EPSILON$              fixed bin(31) value('7c5'xn);
 dcl XK_Greek_ZETA$                 fixed bin(31) value('7c6'xn);
 dcl XK_Greek_ETA$                  fixed bin(31) value('7c7'xn);
 dcl XK_Greek_THETA$                fixed bin(31) value('7c8'xn);
 dcl XK_Greek_IOTA$                 fixed bin(31) value('7c9'xn);
 dcl XK_Greek_KAPPA$                fixed bin(31) value('7ca'xn);
 dcl XK_Greek_LAMDA$                fixed bin(31) value('7cb'xn);
 dcl XK_Greek_LAMBDA$               fixed bin(31) value('7cb'xn);
 dcl XK_Greek_MU$                   fixed bin(31) value('7cc'xn);
 dcl XK_Greek_NU$                   fixed bin(31) value('7cd'xn);
 dcl XK_Greek_XI$                   fixed bin(31) value('7ce'xn);
 dcl XK_Greek_OMICRON$              fixed bin(31) value('7cf'xn);
 dcl XK_Greek_PI$                   fixed bin(31) value('7d0'xn);
 dcl XK_Greek_RHO$                  fixed bin(31) value('7d1'xn);
 dcl XK_Greek_SIGMA$                fixed bin(31) value('7d2'xn);
 dcl XK_Greek_TAU$                  fixed bin(31) value('7d4'xn);
 dcl XK_Greek_UPSILON$              fixed bin(31) value('7d5'xn);
 dcl XK_Greek_PHI$                  fixed bin(31) value('7d6'xn);
 dcl XK_Greek_CHI$                  fixed bin(31) value('7d7'xn);
 dcl XK_Greek_PSI$                  fixed bin(31) value('7d8'xn);
 dcl XK_Greek_OMEGA$                fixed bin(31) value('7d9'xn);
 dcl XK_Greek_alpha                 fixed bin(31) value('7e1'xn);
 dcl XK_Greek_beta                  fixed bin(31) value('7e2'xn);
 dcl XK_Greek_gamma                 fixed bin(31) value('7e3'xn);
 dcl XK_Greek_delta                 fixed bin(31) value('7e4'xn);
 dcl XK_Greek_epsilon               fixed bin(31) value('7e5'xn);
 dcl XK_Greek_zeta                  fixed bin(31) value('7e6'xn);
 dcl XK_Greek_eta                   fixed bin(31) value('7e7'xn);
 dcl XK_Greek_theta                 fixed bin(31) value('7e8'xn);
 dcl XK_Greek_iota                  fixed bin(31) value('7e9'xn);
 dcl XK_Greek_kappa                 fixed bin(31) value('7ea'xn);
 dcl XK_Greek_lamda                 fixed bin(31) value('7eb'xn);
 dcl XK_Greek_lambda                fixed bin(31) value('7eb'xn);
 dcl XK_Greek_mu                    fixed bin(31) value('7ec'xn);
 dcl XK_Greek_nu                    fixed bin(31) value('7ed'xn);
 dcl XK_Greek_xi                    fixed bin(31) value('7ee'xn);
 dcl XK_Greek_omicron               fixed bin(31) value('7ef'xn);
 dcl XK_Greek_pi                    fixed bin(31) value('7f0'xn);
 dcl XK_Greek_rho                   fixed bin(31) value('7f1'xn);
 dcl XK_Greek_sigma                 fixed bin(31) value('7f2'xn);
 dcl XK_Greek_finalsmallsigma       fixed bin(31) value('7f3'xn);
 dcl XK_Greek_tau                   fixed bin(31) value('7f4'xn);
 dcl XK_Greek_upsilon               fixed bin(31) value('7f5'xn);
 dcl XK_Greek_phi                   fixed bin(31) value('7f6'xn);
 dcl XK_Greek_chi                   fixed bin(31) value('7f7'xn);
 dcl XK_Greek_psi                   fixed bin(31) value('7f8'xn);
 dcl XK_Greek_omega                 fixed bin(31) value('7f9'xn);
 dcl XK_Greek_switch                fixed bin(31) value('FF7E'xn);
                                    /* Alias for mode_switch */
 %end; /* XK_GREEK */

 /* Technical, Byte 3 = 8 */

 %dcl XK_TECHNICAL char ext;
 %if XK_TECHNICAL ^= '' %then %do;

 dcl XK_leftradical               fixed bin(31) value('8a1'xn);
 dcl XK_topleftradical            fixed bin(31) value('8a2'xn);
 dcl XK_horizconnector            fixed bin(31) value('8a3'xn);
 dcl XK_topintegral               fixed bin(31) value('8a4'xn);
 dcl XK_botintegral               fixed bin(31) value('8a5'xn);
 dcl XK_vertconnector             fixed bin(31) value('8a6'xn);
 dcl XK_topleftsqbracket          fixed bin(31) value('8a7'xn);
 dcl XK_botleftsqbracket          fixed bin(31) value('8a8'xn);
 dcl XK_toprightsqbracket         fixed bin(31) value('8a9'xn);
 dcl XK_botrightsqbracket         fixed bin(31) value('8aa'xn);
 dcl XK_topleftparens             fixed bin(31) value('8ab'xn);
 dcl XK_botleftparens             fixed bin(31) value('8ac'xn);
 dcl XK_toprightparens            fixed bin(31) value('8ad'xn);
 dcl XK_botrightparens            fixed bin(31) value('8ae'xn);
 dcl XK_leftmiddlecurlybrace      fixed bin(31) value('8af'xn);
 dcl XK_rightmiddlecurlybrace     fixed bin(31) value('8b0'xn);
 dcl XK_topleftsummation          fixed bin(31) value('8b1'xn);
 dcl XK_botleftsummation          fixed bin(31) value('8b2'xn);
 dcl XK_topvertsummationconnector fixed bin(31) value('8b3'xn);
 dcl XK_botvertsummationconnector fixed bin(31) value('8b4'xn);
 dcl XK_toprightsummation         fixed bin(31) value('8b5'xn);
 dcl XK_botrightsummation         fixed bin(31) value('8b6'xn);
 dcl XK_rightmiddlesummation      fixed bin(31) value('8b7'xn);
 dcl XK_lessthanequal             fixed bin(31) value('8bc'xn);
 dcl XK_notequal                  fixed bin(31) value('8bd'xn);
 dcl XK_greaterthanequal          fixed bin(31) value('8be'xn);
 dcl XK_integral                  fixed bin(31) value('8bf'xn);
 dcl XK_therefore                 fixed bin(31) value('8c0'xn);
 dcl XK_variation                 fixed bin(31) value('8c1'xn);
 dcl XK_infinity                  fixed bin(31) value('8c2'xn);
 dcl XK_nabla                     fixed bin(31) value('8c5'xn);
 dcl XK_approximate               fixed bin(31) value('8c8'xn);
 dcl XK_similarequal              fixed bin(31) value('8c9'xn);
 dcl XK_ifonlyif                  fixed bin(31) value('8cd'xn);
 dcl XK_implies                   fixed bin(31) value('8ce'xn);
 dcl XK_identical                 fixed bin(31) value('8cf'xn);
 dcl XK_radical                   fixed bin(31) value('8d6'xn);
 dcl XK_includedin                fixed bin(31) value('8da'xn);
 dcl XK_includes                  fixed bin(31) value('8db'xn);
 dcl XK_intersection              fixed bin(31) value('8dc'xn);
 dcl XK_union                     fixed bin(31) value('8dd'xn);
 dcl XK_logicaland                fixed bin(31) value('8de'xn);
 dcl XK_logicalor                 fixed bin(31) value('8df'xn);
 dcl XK_partialderivative         fixed bin(31) value('8ef'xn);
 dcl XK_function                  fixed bin(31) value('8f6'xn);
 dcl XK_leftarrow                 fixed bin(31) value('8fb'xn);
 dcl XK_uparrow                   fixed bin(31) value('8fc'xn);
 dcl XK_rightarrow                fixed bin(31) value('8fd'xn);
 dcl XK_downarrow                 fixed bin(31) value('8fe'xn);

 %end; /* XK_TECHNICAL */

 /* Special, Byte 3 = 9 */

 %dcl XK_SPECIAL char ext;
 %if XK_SPECIAL ^= '' %then %do;

 dcl XK_blank          fixed bin(31) value('9df'xn);
 dcl XK_soliddiamond   fixed bin(31) value('9e0'xn);
 dcl XK_checkerboard   fixed bin(31) value('9e1'xn);
 dcl XK_ht             fixed bin(31) value('9e2'xn);
 dcl XK_ff             fixed bin(31) value('9e3'xn);
 dcl XK_cr             fixed bin(31) value('9e4'xn);
 dcl XK_lf             fixed bin(31) value('9e5'xn);
 dcl XK_nl             fixed bin(31) value('9e8'xn);
 dcl XK_vt             fixed bin(31) value('9e9'xn);
 dcl XK_lowrightcorner fixed bin(31) value('9ea'xn);
 dcl XK_uprightcorner  fixed bin(31) value('9eb'xn);
 dcl XK_upleftcorner   fixed bin(31) value('9ec'xn);
 dcl XK_lowleftcorner  fixed bin(31) value('9ed'xn);
 dcl XK_crossinglines  fixed bin(31) value('9ee'xn);
 dcl XK_horizlinescan1 fixed bin(31) value('9ef'xn);
 dcl XK_horizlinescan3 fixed bin(31) value('9f0'xn);
 dcl XK_horizlinescan5 fixed bin(31) value('9f1'xn);
 dcl XK_horizlinescan7 fixed bin(31) value('9f2'xn);
 dcl XK_horizlinescan9 fixed bin(31) value('9f3'xn);
 dcl XK_leftt          fixed bin(31) value('9f4'xn);
 dcl XK_rightt         fixed bin(31) value('9f5'xn);
 dcl XK_bott           fixed bin(31) value('9f6'xn);
 dcl XK_topt           fixed bin(31) value('9f7'xn);
 dcl XK_vertbar        fixed bin(31) value('9f8'xn);

 %end; /* XK_SPECIAL */

 /* Publishing, Byte 3 = a */

 %dcl XK_PUBLISHING char ext;
 %if XK_PUBLISHING ^= '' %then %do;

 dcl XK_emspace              fixed bin(31) value('aa1'xn);
 dcl XK_enspace              fixed bin(31) value('aa2'xn);
 dcl XK_em3space             fixed bin(31) value('aa3'xn);
 dcl XK_em4space             fixed bin(31) value('aa4'xn);
 dcl XK_digitspace           fixed bin(31) value('aa5'xn);
 dcl XK_punctspace           fixed bin(31) value('aa6'xn);
 dcl XK_thinspace            fixed bin(31) value('aa7'xn);
 dcl XK_hairspace            fixed bin(31) value('aa8'xn);
 dcl XK_emdash               fixed bin(31) value('aa9'xn);
 dcl XK_endash               fixed bin(31) value('aaa'xn);
 dcl XK_signifblank          fixed bin(31) value('aac'xn);
 dcl XK_ellipsis             fixed bin(31) value('aae'xn);
 dcl XK_doubbaselinedot      fixed bin(31) value('aaf'xn);
 dcl XK_onethird             fixed bin(31) value('ab0'xn);
 dcl XK_twothirds            fixed bin(31) value('ab1'xn);
 dcl XK_onefifth             fixed bin(31) value('ab2'xn);
 dcl XK_twofifths            fixed bin(31) value('ab3'xn);
 dcl XK_threefifths          fixed bin(31) value('ab4'xn);
 dcl XK_fourfifths           fixed bin(31) value('ab5'xn);
 dcl XK_onesixth             fixed bin(31) value('ab6'xn);
 dcl XK_fivesixths           fixed bin(31) value('ab7'xn);
 dcl XK_careof               fixed bin(31) value('ab8'xn);
 dcl XK_figdash              fixed bin(31) value('abb'xn);
 dcl XK_leftanglebracket     fixed bin(31) value('abc'xn);
 dcl XK_decimalpoint         fixed bin(31) value('abd'xn);
 dcl XK_rightanglebracket    fixed bin(31) value('abe'xn);
 dcl XK_marker               fixed bin(31) value('abf'xn);
 dcl XK_oneeighth            fixed bin(31) value('ac3'xn);
 dcl XK_threeeighths         fixed bin(31) value('ac4'xn);
 dcl XK_fiveeighths          fixed bin(31) value('ac5'xn);
 dcl XK_seveneighths         fixed bin(31) value('ac6'xn);
 dcl XK_trademark            fixed bin(31) value('ac9'xn);
 dcl XK_signaturemark        fixed bin(31) value('aca'xn);
 dcl XK_trademarkincircle    fixed bin(31) value('acb'xn);
 dcl XK_leftopentriangle     fixed bin(31) value('acc'xn);
 dcl XK_rightopentriangle    fixed bin(31) value('acd'xn);
 dcl XK_emopencircle         fixed bin(31) value('ace'xn);
 dcl XK_emopenrectangle      fixed bin(31) value('acf'xn);
 dcl XK_leftsinglequotemark  fixed bin(31) value('ad0'xn);
 dcl XK_rightsinglequotemark fixed bin(31) value('ad1'xn);
 dcl XK_leftdoublequotemark  fixed bin(31) value('ad2'xn);
 dcl XK_rightdoublequotemark fixed bin(31) value('ad3'xn);
 dcl XK_prescription         fixed bin(31) value('ad4'xn);
 dcl XK_minutes              fixed bin(31) value('ad6'xn);
 dcl XK_seconds              fixed bin(31) value('ad7'xn);
 dcl XK_latincross           fixed bin(31) value('ad9'xn);
 dcl XK_hexagram             fixed bin(31) value('ada'xn);
 dcl XK_filledrectbullet     fixed bin(31) value('adb'xn);
 dcl XK_filledlefttribullet  fixed bin(31) value('adc'xn);
 dcl XK_filledrighttribullet fixed bin(31) value('add'xn);
 dcl XK_emfilledcircle       fixed bin(31) value('ade'xn);
 dcl XK_emfilledrect         fixed bin(31) value('adf'xn);
 dcl XK_enopencircbullet     fixed bin(31) value('ae0'xn);
 dcl XK_enopensquarebullet   fixed bin(31) value('ae1'xn);
 dcl XK_openrectbullet       fixed bin(31) value('ae2'xn);
 dcl XK_opentribulletup      fixed bin(31) value('ae3'xn);
 dcl XK_opentribulletdown    fixed bin(31) value('ae4'xn);
 dcl XK_openstar             fixed bin(31) value('ae5'xn);
 dcl XK_enfilledcircbullet   fixed bin(31) value('ae6'xn);
 dcl XK_enfilledsqbullet     fixed bin(31) value('ae7'xn);
 dcl XK_filledtribulletup    fixed bin(31) value('ae8'xn);
 dcl XK_filledtribulletdown  fixed bin(31) value('ae9'xn);
 dcl XK_leftpointer          fixed bin(31) value('aea'xn);
 dcl XK_rightpointer         fixed bin(31) value('aeb'xn);
 dcl XK_club                 fixed bin(31) value('aec'xn);
 dcl XK_diamond              fixed bin(31) value('aed'xn);
 dcl XK_heart                fixed bin(31) value('aee'xn);
 dcl XK_maltesecross         fixed bin(31) value('af0'xn);
 dcl XK_dagger               fixed bin(31) value('af1'xn);
 dcl XK_doubledagger         fixed bin(31) value('af2'xn);
 dcl XK_checkmark            fixed bin(31) value('af3'xn);
 dcl XK_ballotcross          fixed bin(31) value('af4'xn);
 dcl XK_musicalsharp         fixed bin(31) value('af5'xn);
 dcl XK_musicalflat          fixed bin(31) value('af6'xn);
 dcl XK_malesymbol           fixed bin(31) value('af7'xn);
 dcl XK_femalesymbol         fixed bin(31) value('af8'xn);
 dcl XK_telephone            fixed bin(31) value('af9'xn);
 dcl XK_telephonerecorder    fixed bin(31) value('afa'xn);
 dcl XK_phonographcopyright  fixed bin(31) value('afb'xn);
 dcl XK_caret                fixed bin(31) value('afc'xn);
 dcl XK_singlelowquotemark   fixed bin(31) value('afd'xn);
 dcl XK_doublelowquotemark   fixed bin(31) value('afe'xn);
 dcl XK_cursor               fixed bin(31) value('aff'xn);
 %end; /* XK_PUBLISHING */

 /* APL, Byte 3 = b */

 %dcl XK_APL char ext;
 %if XK_APL ^= '' %then %do;

 dcl XK_leftcaret  fixed bin(31) value('ba3'xn);
 dcl XK_rightcaret fixed bin(31) value('ba6'xn);
 dcl XK_downcaret  fixed bin(31) value('ba8'xn);
 dcl XK_upcaret    fixed bin(31) value('ba9'xn);
 dcl XK_overbar    fixed bin(31) value('bc0'xn);
 dcl XK_downtack   fixed bin(31) value('bc2'xn);
 dcl XK_upshoe     fixed bin(31) value('bc3'xn);
 dcl XK_downstile  fixed bin(31) value('bc4'xn);
 dcl XK_underbar   fixed bin(31) value('bc6'xn);
 dcl XK_jot        fixed bin(31) value('bca'xn);
 dcl XK_quad       fixed bin(31) value('bcc'xn);
 dcl XK_uptack     fixed bin(31) value('bce'xn);
 dcl XK_circle     fixed bin(31) value('bcf'xn);
 dcl XK_upstile    fixed bin(31) value('bd3'xn);
 dcl XK_downshoe   fixed bin(31) value('bd6'xn);
 dcl XK_rightshoe  fixed bin(31) value('bd8'xn);
 dcl XK_leftshoe   fixed bin(31) value('bda'xn);
 dcl XK_lefttack   fixed bin(31) value('bdc'xn);
 dcl XK_righttack  fixed bin(31) value('bfc'xn);

 %end; /* XK_APL */

 /* Hebrew, Byte 3 = c */

 %dcl XK_HEBREW char ext;
 %if XK_HEBREW ^= '' %then %do;

 dcl XK_hebrew_doublelowline fixed bin(31) value('cdf'xn);
 dcl XK_hebrew_aleph     fixed bin(31) value('ce0'xn);
 dcl XK_hebrew_bet       fixed bin(31) value('ce1'xn);
 dcl XK_hebrew_beth      fixed bin(31) value('ce1'xn); /* deprecated */
 dcl XK_hebrew_gimel     fixed bin(31) value('ce2'xn);
 dcl XK_hebrew_gimmel    fixed bin(31) value('ce2'xn); /* deprecated */
 dcl XK_hebrew_dalet     fixed bin(31) value('ce3'xn);
 dcl XK_hebrew_daleth    fixed bin(31) value('ce3'xn); /* deprecated */
 dcl XK_hebrew_he        fixed bin(31) value('ce4'xn);
 dcl XK_hebrew_waw       fixed bin(31) value('ce5'xn);
 dcl XK_hebrew_zain      fixed bin(31) value('ce6'xn);
 dcl XK_hebrew_zayin     fixed bin(31) value('ce6'xn); /* deprecated */
 dcl XK_hebrew_chet      fixed bin(31) value('ce7'xn);
 dcl XK_hebrew_het       fixed bin(31) value('ce7'xn); /* deprecated */
 dcl XK_hebrew_tet       fixed bin(31) value('ce8'xn);
 dcl XK_hebrew_teth      fixed bin(31) value('ce8'xn); /* deprecated */
 dcl XK_hebrew_yod       fixed bin(31) value('ce9'xn);
 dcl XK_hebrew_finalkaph fixed bin(31) value('cea'xn);
 dcl XK_hebrew_kaph      fixed bin(31) value('ceb'xn);
 dcl XK_hebrew_lamed     fixed bin(31) value('cec'xn);
 dcl XK_hebrew_finalmem  fixed bin(31) value('ced'xn);
 dcl XK_hebrew_mem       fixed bin(31) value('cee'xn);
 dcl XK_hebrew_finalnun  fixed bin(31) value('cef'xn);
 dcl XK_hebrew_nun       fixed bin(31) value('cf0'xn);
 dcl XK_hebrew_samech    fixed bin(31) value('cf1'xn);
 dcl XK_hebrew_samekh    fixed bin(31) value('cf1'xn); /* deprecated */
 dcl XK_hebrew_ayin      fixed bin(31) value('cf2'xn);
 dcl XK_hebrew_finalpe   fixed bin(31) value('cf3'xn);
 dcl XK_hebrew_pe        fixed bin(31) value('cf4'xn);
 dcl XK_hebrew_finalzade fixed bin(31) value('cf5'xn);
 dcl XK_hebrew_finalzadi fixed bin(31) value('cf5'xn); /* deprecated */
 dcl XK_hebrew_zade      fixed bin(31) value('cf6'xn);
 dcl XK_hebrew_zadi      fixed bin(31) value('cf6'xn); /* deprecated */
 dcl XK_hebrew_qoph      fixed bin(31) value('cf7'xn);
 dcl XK_hebrew_kuf       fixed bin(31) value('cf7'xn); /* deprecated */
 dcl XK_hebrew_resh      fixed bin(31) value('cf8'xn);
 dcl XK_hebrew_shin      fixed bin(31) value('cf9'xn);
 dcl XK_hebrew_taw       fixed bin(31) value('cfa'xn);
 dcl XK_hebrew_taf       fixed bin(31) value('cfa'xn); /* deprecated */
 dcl XK_Hebrew_switch    fixed bin(31) value('FF7E'xn);
                         /* Alias for mode_switch */
 %end; /* XK_HEBREW */

