#********************************************************************/
#*                                                                  */
#*    Licensed Materials - Property of IBM                          */
#*    5639-A83, 5639-A24 (C) Copyright IBM Corp. 1992,1996.         */
#*    All Rights Reserved.                                          */
#*    US Government Users Restricted Rights-- Use, duplication or   */
#*    disclosure restricted by GSA ADP Schedule Contract with       */
#*    IBM Corp.                                                     */
#*                                                                  */
#*  DISCLAIMER OF WARRANTIES                                        */
#*    The following enclosed code is sample code created by IBM   */
#*    Corporation. This sample code is not part of any standard     */
#*    IBM product and is provided to you solely for the purpose of  */
#*    assisting you in the development of your applications.  The   */
#*    code is provided "AS IS", without warranty of any kind.       */
#*    IBM shall not be liable for any damages arising out of your   */
#*    use of the sample code, even if IBM has been advised of the   */
#*    possibility of such damages.                                  */
#*                                                                  */
#*                                                                  */
#* Build ILC test of Common Data Types between C Set/2 and PL/I.    */
#* The C function CSPLICS dynamically loads and calls the PL/I      */
#* procedure CSPLICSP.PLI which in turn loads and calls another C   */
#* function CSPLICSC.C.  This file builds all the necessary files.  */
#*                                                                  */
#*  CSPLICS.C    is compiled and linked as an EXE.                  */
#*  CSPLICSP.PLI is compiled and linked as a DLL by the same name.  */
#*  CSPLICSC.C   is compiled and linked as a DLL by the same name.  */
#*                                                                  */
#* Syntax:   BLDCSPCS                                               */
#*                                                                  */
#********************************************************************/

CCPARMS1   = /Q /C /Sd /Ss /Ls /Fl
CCPARMS2   = /Q /C /Sd /Ss /Ls /Ge-
ILINKPARMS1 = /se:200 /debug /noe
ILINKPARMS2 = /noe /debug /stack:5000000
ERASE      = ERASE

.SUFFIXES:
.SUFFIXES: .pli .cpy .mac .inc .c .h

ALL: csplics.exe \
     csplicsp.dll \
     csplicsc.dll

# Dependencies
#
csplics.exe : csplics.c
  ICC $(CCPARMS1) csplics.c
  ILINK csplics.obj $(ILINKPARMS2)

csplicsp.dll : csplicsp.pli
  PLI  csplicsp.pli ( xinfo(def)
  ILIB /geni csplicsp.def
  ILINK csplicsp.obj $(ILINKPARMS1) /dll csplicsp.exp

csplicsc.dll : csplicsc.c
   ICC $(CCPARMS2) csplicsc.c
   ILIB /geni csplicsc.def
   ILINK csplicsc.obj $(ILINKPARMS1) /dll csplicsc.exp


clean:
  $(ERASE) csplics.obj
  $(ERASE) csplicsc.obj
  $(ERASE) cs2plcsp.obj
  $(ERASE) csplics.exe
  $(ERASE) csplicsc.dll
  $(ERASE) csplicsp.dll

