 /*********************************************************************/
 /*                                                                   */
 /* wingdi.cpy -- GDI procedure declarations, constant definitions    */
 /*               and macros                                          */
 /*                                                                   */
 /* Copyright (c) 1985-1999, Microsoft Corp. All rights reserved.     */
 /*                                                                   */
 /*********************************************************************/

 %dcl #WINGDI_ char ext;
 %if #WINGDI_ = '' %then %do;
 %#WINGDI_ = 'Y';

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = 'Y' %then %do;
   %note ('WinUser should be included AFTER WinGDI, not before it', 4);
 %end;

 %dcl #INC_WINDOWSX char ext;
 %if #INC_WINDOWSX = 'Y' %then %do;
   %note ('WindowsX should be included AFTER WinGDI, not before it', 4);
 %end;

 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
 %include winbase;
 %end;

 /* Define API decoration for direct importing of DLL references. */
 %dcl WINGDIAPI char ext;
 %WINGDIAPI = '';

 /* Define API decoration for direct importing of DLL references. */
 %dcl WINSPOOLAPI char ext;
 %WINSPOOLAPI = '';

 %dcl NOMETAFILE   char ext;
 %dcl NOTEXTMETRIC char ext;


 %dcl WINVER fixed ext;
 %if WINVER = 0 %then %do;
 %WINVER = 1280; /* version 5.0 */
 %end; /* WINVER */

 %dcl #WIN32_WINNT   fixed ext;

 %dcl UNICODE char ext;

 %dcl NOGDI char ext;
 %if NOGDI = '' %then %do;

 %dcl NORASTEROPS char ext;
 %if NORASTEROPS = '' %then %do;

 /* Binary raster ops */
 dcl R2_BLACK       fixed bin(31) value( 1); /*  0       */
 dcl R2_NOTMERGEPEN fixed bin(31) value( 2); /* DPon     */
 dcl R2_MASKNOTPEN  fixed bin(31) value( 3); /* DPna     */
 dcl R2_NOTCOPYPEN  fixed bin(31) value( 4); /* PN       */
 dcl R2_MASKPENNOT  fixed bin(31) value( 5); /* PDna     */
 dcl R2_NOT         fixed bin(31) value( 6); /* Dn       */
 dcl R2_XORPEN      fixed bin(31) value( 7); /* DPx      */
 dcl R2_NOTMASKPEN  fixed bin(31) value( 8); /* DPan     */
 dcl R2_MASKPEN     fixed bin(31) value( 9); /* DPa      */
 dcl R2_NOTXORPEN   fixed bin(31) value(10); /* DPxn     */
 dcl R2_NOP         fixed bin(31) value(11); /* D        */
 dcl R2_MERGENOTPEN fixed bin(31) value(12); /* DPno     */
 dcl R2_COPYPEN     fixed bin(31) value(13); /* P        */
 dcl R2_MERGEPENNOT fixed bin(31) value(14); /* PDno     */
 dcl R2_MERGEPEN    fixed bin(31) value(15); /* DPo      */
 dcl R2_WHITE       fixed bin(31) value(16); /*  1       */
 dcl R2_LAST        fixed bin(31) value(16);

     /* Ternary raster operations */
 dcl SRCCOPY     type DWORD  value('00CC0020'xu);
     /* dest = source                   */
 dcl SRCPAINT    type DWORD  value('00EE0086'xu);
     /* dest = source OR dest           */
 dcl SRCAND      type DWORD  value('008800C6'xu);
     /* dest = source AND dest          */
 dcl SRCINVERT   type DWORD  value('00660046'xu);
     /* dest = source XOR dest          */
 dcl SRCERASE    type DWORD  value('00440328'xu);
     /* dest = source AND (NOT dest )   */
 dcl NOTSRCCOPY  type DWORD  value('00330008'xu);
      /* dest = (NOT source)             */
 dcl NOTSRCERASE type DWORD  value('001100A6'xu);
     /* dest = (NOT src) AND (NOT dest) */
 dcl MERGECOPY   type DWORD  value('00C000CA'xu);
     /* dest = (source AND pattern)     */
 dcl MERGEPAINT  type DWORD  value('00BB0226'xu);
     /* dest = (NOT source) OR dest     */
 dcl PATCOPY     type DWORD  value('00F00021'xu);
     /* dest = pattern                  */
 dcl PATPAINT    type DWORD  value('00FB0A09'xu);
     /* dest = DPSnoo                   */
 dcl PATINVERT   type DWORD  value('005A0049'xu);
     /* dest = pattern XOR dest         */
 dcl DSTINVERT   type DWORD  value('00550009'xu);
     /* dest = (NOT dest)               */
 dcl BLACKNESS   type DWORD  value('00000042'xu);
     /* dest = BLACK                    */
 dcl WHITENESS   type DWORD  value('00FF0062'xu);
     /* dest = WHITE                    */

 %if WINVER >= 1280 %then %do;
 dcl NOMIRRORBITMAP type DWORD value ('80000000'xu);
     /* Do not Mirror the bitmap in this call*/
 dcl CAPTUREBLT     type DWORD value ('40000000'xu);
     /* Include layered windows */
 %end; /* WINVER >= 0x0500 */

 /* Quaternary raster codes */
 MAKEROP4: proc (fore, back) returns (type DWORD byvalue)
           options (inline reorder) internal;
   dcl fore type DWORD byvalue,
       back type DWORD byvalue;
  dcl (iand, ior, raise2) builtin;
   return (ior (iand (raise2 (back, 8), 'FF000000'xu), fore));
 end MAKEROP4;

 %end; /* NORASTEROPS */

 dcl GDI_ERROR  fixed bin(31) value('FFFFFFFF'xn);
 dcl HGDI_ERROR type HANDLE   value(ptrvalue(-1));

 /* Region Flags */
 dcl ERROR         fixed bin(31) value(0);
 dcl NULLREGION    fixed bin(31) value(1);
 dcl SIMPLEREGION  fixed bin(31) value(2);
 dcl COMPLEXREGION fixed bin(31) value(3);
 dcl RGN_ERROR     fixed bin(31) value(ERROR);

 /* CombineRgn() Styles */
 dcl RGN_AND       fixed bin(31) value(1);
 dcl RGN_OR        fixed bin(31) value(2);
 dcl RGN_XOR       fixed bin(31) value(3);
 dcl RGN_DIFF      fixed bin(31) value(4);
 dcl RGN_COPY      fixed bin(31) value(5);
 dcl RGN_MIN       fixed bin(31) value(RGN_AND);
 dcl RGN_MAX       fixed bin(31) value(RGN_COPY);

 /* StretchBlt() Modes */
 dcl BLACKONWHITE        fixed bin(31) value(1);
 dcl WHITEONBLACK        fixed bin(31) value(2);
 dcl COLORONCOLOR        fixed bin(31) value(3);
 dcl HALFTONE            fixed bin(31) value(4);
 dcl MAXSTRETCHBLTMODE   fixed bin(31) value(4);


 %if WINVER >= 1024 %then %do;
 /* New StretchBlt() Modes */
 dcl STRETCH_ANDSCANS    fixed bin(31) value(BLACKONWHITE);
 dcl STRETCH_ORSCANS     fixed bin(31) value(WHITEONBLACK);
 dcl STRETCH_DELETESCANS fixed bin(31) value(COLORONCOLOR);
 dcl STRETCH_HALFTONE    fixed bin(31) value(HALFTONE);
 %end; /* WINVER >= 0x0400 */

 /* PolyFill() Modes */
 dcl ALTERNATE     fixed bin(31) value(1);
 dcl WINDING       fixed bin(31) value(2);
 dcl POLYFILL_LAST fixed bin(31) value(2);

 /* Layout Orientation Options */
 %if WINVER >= 1280 %then %do;
 dcl LAYOUT_RTL                        type DWORD value('00000001'xu);
     /* Right to left */
 dcl LAYOUT_BTT                        type DWORD value('00000002'xu);
     /* Bottom to top */
 dcl LAYOUT_VBH                        type DWORD value('00000004'xu);
     /* Vertical before horizontal */
 dcl LAYOUT_ORIENTATIONMASK            type DWORD
     value(ior(LAYOUT_RTL, LAYOUT_BTT, LAYOUT_VBH));
 dcl LAYOUT_BITMAPORIENTATIONPRESERVED type DWORD
     value('00000008'xu);
 %end; /* WINVER >= 0x0500 */

 /* Text Alignment Options */
 dcl TA_NOUPDATECP fixed bin(31) value(0);
 dcl TA_UPDATECP   fixed bin(31) value(1);

 dcl TA_LEFT       fixed bin(31) value(0);
 dcl TA_RIGHT      fixed bin(31) value(2);
 dcl TA_CENTER     fixed bin(31) value(6);

 dcl TA_TOP        fixed bin(31) value(0);
 dcl TA_BOTTOM     fixed bin(31) value(8);
 dcl TA_BASELINE   fixed bin(31) value(24);

 %if WINVER >= 1024 %then %do;
 dcl TA_RTLREADING fixed bin(31) value(256);
 dcl TA_MASK       fixed bin(31)
     value(TA_BASELINE + TA_CENTER + TA_UPDATECP + TA_RTLREADING);
 %end; %else %do;
 dcl TA_MASK       fixed bin(31)
     value(TA_BASELINE + TA_CENTER + TA_UPDATECP);
 %end;

 dcl VTA_BASELINE  fixed bin(31) value(TA_BASELINE);
 dcl VTA_LEFT      fixed bin(31) value(TA_BOTTOM);
 dcl VTA_RIGHT     fixed bin(31) value(TA_TOP);
 dcl VTA_CENTER    fixed bin(31) value(TA_CENTER);
 dcl VTA_BOTTOM    fixed bin(31) value(TA_RIGHT);
 dcl VTA_TOP       fixed bin(31) value(TA_LEFT);

 dcl ETO_OPAQUE         fixed bin(15) value('0002'xn);
 dcl ETO_CLIPPED        fixed bin(15) value('0004'xn);

 %if WINVER >= 1024 %then %do;
 dcl ETO_GLYPH_INDEX    fixed bin(15) value('0010'xn);
 dcl ETO_RTLREADING     fixed bin(15) value('0080'xn);
 dcl ETO_NUMERICSLOCAL  fixed bin(15) value('0400'xn);
 dcl ETO_NUMERICSLATIN  fixed bin(15) value('0800'xn);
 dcl ETO_IGNORELANGUAGE fixed bin(15) value('1000'xn);
 %end; /* WINVER >= 0x0400 */

 %if #WIN32_WINNT >= 1280 %then %do;
 dcl ETO_PDY            fixed bin(15) value('2000'xn);
 %end; /* (_WIN32_WINNT >= 0x0500) */

 dcl ASPECT_FILTERING   fixed bin(15) value('0001'xn);

 /* Bounds Accumulation APIs */

 dcl DCB_RESET          fixed bin(15) value('0001'xn);
 dcl DCB_ACCUMULATE     fixed bin(15) value('0002'xn);
 dcl DCB_DIRTY          fixed bin(15) value(DCB_ACCUMULATE);
 dcl DCB_SET            fixed bin(15) value(ior (DCB_RESET,
                                                 DCB_ACCUMULATE));
 dcl DCB_ENABLE         fixed bin(15) value('0004'xn);
 dcl DCB_DISABLE        fixed bin(15) value('0008'xn);

 %if NOMETAFILE = '' %then %do;

 /* Metafile Functions */
 dcl META_SETBKCOLOR              fixed bin(15) value('0201'xn);
 dcl META_SETBKMODE               fixed bin(15) value('0102'xn);
 dcl META_SETMAPMODE              fixed bin(15) value('0103'xn);
 dcl META_SETROP2                 fixed bin(15) value('0104'xn);
 dcl META_SETRELABS               fixed bin(15) value('0105'xn);
 dcl META_SETPOLYFILLMODE         fixed bin(15) value('0106'xn);
 dcl META_SETSTRETCHBLTMODE       fixed bin(15) value('0107'xn);
 dcl META_SETTEXTCHAREXTRA        fixed bin(15) value('0108'xn);
 dcl META_SETTEXTCOLOR            fixed bin(15) value('0209'xn);
 dcl META_SETTEXTJUSTIFICATION    fixed bin(15) value('020A'xn);
 dcl META_SETWINDOWORG            fixed bin(15) value('020B'xn);
 dcl META_SETWINDOWEXT            fixed bin(15) value('020C'xn);
 dcl META_SETVIEWPORTORG          fixed bin(15) value('020D'xn);
 dcl META_SETVIEWPORTEXT          fixed bin(15) value('020E'xn);
 dcl META_OFFSETWINDOWORG         fixed bin(15) value('020F'xn);
 dcl META_SCALEWINDOWEXT          fixed bin(15) value('0410'xn);
 dcl META_OFFSETVIEWPORTORG       fixed bin(15) value('0211'xn);
 dcl META_SCALEVIEWPORTEXT        fixed bin(15) value('0412'xn);
 dcl META_LINETO                  fixed bin(15) value('0213'xn);
 dcl META_MOVETO                  fixed bin(15) value('0214'xn);
 dcl META_EXCLUDECLIPRECT         fixed bin(15) value('0415'xn);
 dcl META_INTERSECTCLIPRECT       fixed bin(15) value('0416'xn);
 dcl META_ARC                     fixed bin(15) value('0817'xn);
 dcl META_ELLIPSE                 fixed bin(15) value('0418'xn);
 dcl META_FLOODFILL               fixed bin(15) value('0419'xn);
 dcl META_PIE                     fixed bin(15) value('081A'xn);
 dcl META_RECTANGLE               fixed bin(15) value('041B'xn);
 dcl META_ROUNDRECT               fixed bin(15) value('061C'xn);
 dcl META_PATBLT                  fixed bin(15) value('061D'xn);
 dcl META_SAVEDC                  fixed bin(15) value('001E'xn);
 dcl META_SETPIXEL                fixed bin(15) value('041F'xn);
 dcl META_OFFSETCLIPRGN           fixed bin(15) value('0220'xn);
 dcl META_TEXTOUT                 fixed bin(15) value('0521'xn);
 dcl META_BITBLT                  fixed bin(15) value('0922'xn);
 dcl META_STRETCHBLT              fixed bin(15) value('0B23'xn);
 dcl META_POLYGON                 fixed bin(15) value('0324'xn);
 dcl META_POLYLINE                fixed bin(15) value('0325'xn);
 dcl META_ESCAPE                  fixed bin(15) value('0626'xn);
 dcl META_RESTOREDC               fixed bin(15) value('0127'xn);
 dcl META_FILLREGION              fixed bin(15) value('0228'xn);
 dcl META_FRAMEREGION             fixed bin(15) value('0429'xn);
 dcl META_INVERTREGION            fixed bin(15) value('012A'xn);
 dcl META_PAINTREGION             fixed bin(15) value('012B'xn);
 dcl META_SELECTCLIPREGION        fixed bin(15) value('012C'xn);
 dcl META_SELECTOBJECT            fixed bin(15) value('012D'xn);
 dcl META_SETTEXTALIGN            fixed bin(15) value('012E'xn);
 dcl META_CHORD                   fixed bin(15) value('0830'xn);
 dcl META_SETMAPPERFLAGS          fixed bin(15) value('0231'xn);
 dcl META_EXTTEXTOUT              fixed bin(15) value('0a32'xn);
 dcl META_SETDIBTODEV             fixed bin(15) value('0d33'xn);
 dcl META_SELECTPALETTE           fixed bin(15) value('0234'xn);
 dcl META_REALIZEPALETTE          fixed bin(15) value('0035'xn);
 dcl META_ANIMATEPALETTE          fixed bin(15) value('0436'xn);
 dcl META_SETPALENTRIES           fixed bin(15) value('0037'xn);
 dcl META_POLYPOLYGON             fixed bin(15) value('0538'xn);
 dcl META_RESIZEPALETTE           fixed bin(15) value('0139'xn);
 dcl META_DIBBITBLT               fixed bin(15) value('0940'xn);
 dcl META_DIBSTRETCHBLT           fixed bin(15) value('0b41'xn);
 dcl META_DIBCREATEPATTERNBRUSH   fixed bin(15) value('0142'xn);
 dcl META_STRETCHDIB              fixed bin(15) value('0f43'xn);
 dcl META_EXTFLOODFILL            fixed bin(15) value('0548'xn);
 %if WINVER >= 1280 %then %do;
 dcl META_SETLAYOUT               fixed bin(15) value('0149'xn);
 %end; /* WINVER >= 0x0500 */
 dcl META_DELETEOBJECT            fixed bin(15) value('01f0'xn);
 dcl META_CREATEPALETTE           fixed bin(15) value('00f7'xn);
 dcl META_CREATEPATTERNBRUSH      fixed bin(15) value('01F9'xn);
 dcl META_CREATEPENINDIRECT       fixed bin(15) value('02FA'xn);
 dcl META_CREATEFONTINDIRECT      fixed bin(15) value('02FB'xn);
 dcl META_CREATEBRUSHINDIRECT     fixed bin(15) value('02FC'xn);
 dcl META_CREATEREGION            fixed bin(15) value('06FF'xn);

 %if WINVER >= 1024 %then %do;
 define structure
   1 DRAWPATRECT,
     2 ptPosition type POINT,
     2 ptSize     type POINT,
     2 wStyle     type WORD,
     2 wPattern   type WORD;
 define alias PDRAWPATRECT handle DRAWPATRECT;
 %end; /* WINVER >= 0x0400 */

 %end; /* NOMETAFILE */

 /* GDI Escapes */
 dcl NEWFRAME                fixed bin(31) value(1);
 dcl ABORTDOC$               fixed bin(31) value(2); /* ABORTDOC */
 dcl NEXTBAND                fixed bin(31) value(3);
 dcl SETCOLORTABLE           fixed bin(31) value(4);
 dcl GETCOLORTABLE           fixed bin(31) value(5);
 dcl FLUSHOUTPUT             fixed bin(31) value(6);
 dcl DRAFTMODE               fixed bin(31) value(7);
 dcl QUERYESCSUPPORT         fixed bin(31) value(8);
 dcl SETABORTPROC$           fixed bin(31) value(9);  /* SETABORTPROC */
 dcl STARTDOC$               fixed bin(31) value(10); /* STARTDOC */
 dcl ENDDOC$                 fixed bin(31) value(11); /* ENDDOC */
 dcl GETPHYSPAGESIZE         fixed bin(31) value(12);
 dcl GETPRINTINGOFFSET       fixed bin(31) value(13);
 dcl GETSCALINGFACTOR        fixed bin(31) value(14);
 dcl MFCOMMENT               fixed bin(31) value(15);
 dcl GETPENWIDTH             fixed bin(31) value(16);
 dcl SETCOPYCOUNT            fixed bin(31) value(17);
 dcl SELECTPAPERSOURCE       fixed bin(31) value(18);
 dcl DEVICEDATA              fixed bin(31) value(19);
 dcl PASSTHROUGH             fixed bin(31) value(19);
 dcl GETTECHNOLGY            fixed bin(31) value(20);
 dcl GETTECHNOLOGY           fixed bin(31) value(20);
 dcl SETLINECAP              fixed bin(31) value(21);
 dcl SETLINEJOIN             fixed bin(31) value(22);
 dcl SETMITERLIMIT$          fixed bin(31) value(23); /* SETMITERLIMIT*/
 dcl BANDINFO                fixed bin(31) value(24);
 dcl DRAWPATTERNRECT         fixed bin(31) value(25);
 dcl GETVECTORPENSIZE        fixed bin(31) value(26);
 dcl GETVECTORBRUSHSIZE      fixed bin(31) value(27);
 dcl ENABLEDUPLEX            fixed bin(31) value(28);
 dcl GETSETPAPERBINS         fixed bin(31) value(29);
 dcl GETSETPRINTORIENT       fixed bin(31) value(30);
 dcl ENUMPAPERBINS           fixed bin(31) value(31);
 dcl SETDIBSCALING           fixed bin(31) value(32);
 dcl EPSPRINTING             fixed bin(31) value(33);
 dcl ENUMPAPERMETRICS        fixed bin(31) value(34);
 dcl GETSETPAPERMETRICS      fixed bin(31) value(35);
 dcl POSTSCRIPT_DATA         fixed bin(31) value(37);
 dcl POSTSCRIPT_IGNORE       fixed bin(31) value(38);
 dcl MOUSETRAILS             fixed bin(31) value(39);
 dcl GETDEVICEUNITS          fixed bin(31) value(42);

 dcl GETEXTENDEDTEXTMETRICS  fixed bin(31) value(256);
 dcl GETEXTENTTABLE          fixed bin(31) value(257);
 dcl GETPAIRKERNTABLE        fixed bin(31) value(258);
 dcl GETTRACKKERNTABLE       fixed bin(31) value(259);
 dcl EXTTEXTOUT              fixed bin(31) value(512);
 dcl GETFACENAME             fixed bin(31) value(513);
 dcl DOWNLOADFACE            fixed bin(31) value(514);
 dcl ENABLERELATIVEWIDTHS    fixed bin(31) value(768);
 dcl ENABLEPAIRKERNING       fixed bin(31) value(769);
 dcl SETKERNTRACK            fixed bin(31) value(770);
 dcl SETALLJUSTVALUES        fixed bin(31) value(771);
 dcl SETCHARSET              fixed bin(31) value(772);

 dcl STRETCHBLT$             fixed bin(31) value(2048); /* STRETCHBLT */
 dcl GETSETSCREENPARAMS      fixed bin(31) value(3072);
 dcl QUERYDIBSUPPORT         fixed bin(31) value(3073);
 dcl BEGIN_PATH              fixed bin(31) value(4096);
 dcl CLIP_TO_PATH            fixed bin(31) value(4097);
 dcl END_PATH                fixed bin(31) value(4098);
 dcl EXT_DEVICE_CAPS         fixed bin(31) value(4099);
 dcl RESTORE_CTM             fixed bin(31) value(4100);
 dcl SAVE_CTM                fixed bin(31) value(4101);
 dcl SET_ARC_DIRECTION       fixed bin(31) value(4102);
 dcl SET_BACKGROUND_COLOR    fixed bin(31) value(4103);
 dcl SET_POLY_MODE           fixed bin(31) value(4104);
 dcl SET_SCREEN_ANGLE        fixed bin(31) value(4105);
 dcl SET_SPREAD              fixed bin(31) value(4106);
 dcl TRANSFORM_CTM           fixed bin(31) value(4107);
 dcl SET_CLIP_BOX            fixed bin(31) value(4108);
 dcl SET_BOUNDS              fixed bin(31) value(4109);
 dcl SET_MIRROR_MODE         fixed bin(31) value(4110);
 dcl OPENCHANNEL             fixed bin(31) value(4110);
 dcl DOWNLOADHEADER          fixed bin(31) value(4111);
 dcl CLOSECHANNEL            fixed bin(31) value(4112);
 dcl POSTSCRIPT_PASSTHROUGH  fixed bin(31) value(4115);
 dcl ENCAPSULATED_POSTSCRIPT fixed bin(31) value(4116);

 dcl POSTSCRIPT_IDENTIFY     fixed bin(31) value(4117);
     /* new escape for NT5 pscript driver */
 dcl POSTSCRIPT_INJECTION    fixed bin(31) value(4118);
     /* new escape for NT5 pscript driver */

 /* Parameters for POSTSCRIPT_IDENTIFY escape */

 dcl PSIDENT_GDICENTRIC      fixed bin(31) value(0);
 dcl PSIDENT_PSCENTRIC       fixed bin(31) value(1);

 /* Header structure for the input buffer to POSTSCRIPT_INJECTION */
 /* escape                                                        */

 define structure
   1 PSINJECTDATA,
     2 DataBytes      type DWORD,/* number of raw data bytes */
     2 InjectionPoint type DWORD,/* injection point */
     2 Flags          type DWORD,/* flags */
     2 Reserved       type DWORD;/* reserved field - must be 0 */
     /* Followed by raw data to be injected */
 define alias PPSINJECTDATA handle PSINJECTDATA;

 /* Constants for PSINJECTDATA.Flags field */

 dcl PSINJECT_APPEND  fixed bin(31) value(0);
 dcl PSINJECT_REPLACE fixed bin(31) value(1);

 /* Constants for PSINJECTDATA.InjectionPoint field */

 /* The data injected at these points coexist with the output         */
 /* emitted by the driver for the same points.                        */

 dcl PSINJECT_BEGINSTREAM     fixed bin(31) value(0);
 dcl PSINJECT_PSADOBE         fixed bin(31) value(1);
 dcl PSINJECT_COMMENTS        fixed bin(31) value(2);
 dcl PSINJECT_BEGINDEFAULTS   fixed bin(31) value(3);
 dcl PSINJECT_ENDDEFAULTS     fixed bin(31) value(4);
 dcl PSINJECT_BEGINPROLOG     fixed bin(31) value(5);
 dcl PSINJECT_ENDPROLOG       fixed bin(31) value(6);
 dcl PSINJECT_BEGINSETUP      fixed bin(31) value(7);
 dcl PSINJECT_ENDSETUP        fixed bin(31) value(8);
 dcl PSINJECT_ENDPAGECOMMENTS fixed bin(31) value(9);
 dcl PSINJECT_BEGINPAGESETUP  fixed bin(31) value(10);
 dcl PSINJECT_ENDPAGESETUP    fixed bin(31) value(11);
 dcl PSINJECT_SHOWPAGE        fixed bin(31) value(12);
 dcl PSINJECT_PAGETRAILER     fixed bin(31) value(13);
 dcl PSINJECT_TRAILER         fixed bin(31) value(14);
 dcl PSINJECT_EOF             fixed bin(31) value(15);
 dcl PSINJECT_ENDSTREAM       fixed bin(31) value(16);
 dcl PSINJECT_VMSAVE          fixed bin(31) value(17);
 dcl PSINJECT_VMRESTORE       fixed bin(31) value(18);

 /* The data injected at these points are appended to the output      */
 /* emitted by the driver for the same points. It will go into        */
 /* the document trailer section. They must be in the form of:        */
 /*     %%+ resource-type resource-names                              */

 dcl PSINJECT_DOCNEEDEDRES    fixed bin(31) value(19);
 dcl PSINJECT_DOCSUPPLIEDRES  fixed bin(31) value(20);

 /* The data injected at these points replaces the output emitted     */
 /* by the driver for the same points.                                */

 dcl PSINJECT_PAGES           fixed bin(31) value(21);
 dcl PSINJECT_PAGEORDER       fixed bin(31) value(22);
 dcl PSINJECT_ORIENTATION     fixed bin(31) value(23);
 dcl PSINJECT_BOUNDINGBOX     fixed bin(31) value(24);
 dcl PSINJECT_PAGENUMBER      fixed bin(31) value(25);
 dcl PSINJECT_PAGEBBOX        fixed bin(31) value(26);

 dcl PSINJECT_MAX             fixed bin(31) value(27);


 /* Flag returned from QUERYDIBSUPPORT */
 dcl QDI_SETDIBITS   fixed bin(31) value(1);
 dcl QDI_GETDIBITS   fixed bin(31) value(2);
 dcl QDI_DIBTOSCREEN fixed bin(31) value(4);
 dcl QDI_STRETCHDIB  fixed bin(31) value(8);

 /* Spooler Error Codes */
 dcl SP_NOTREPORTED  fixed bin(31) value('4000'xn);
 dcl SP_ERROR        fixed bin(31) value(-1);
 dcl SP_APPABORT     fixed bin(31) value(-2);
 dcl SP_USERABORT    fixed bin(31) value(-3);
 dcl SP_OUTOFDISK    fixed bin(31) value(-4);
 dcl SP_OUTOFMEMORY  fixed bin(31) value(-5);

 dcl PR_JOBSTATUS    fixed bin(31) value('0000'xn);

 /* Object Definitions for EnumObjects() */
 dcl OBJ_PEN         fixed bin(31) value(1);
 dcl OBJ_BRUSH       fixed bin(31) value(2);
 dcl OBJ_DC          fixed bin(31) value(3);
 dcl OBJ_METADC      fixed bin(31) value(4);
 dcl OBJ_PAL         fixed bin(31) value(5);
 dcl OBJ_FONT        fixed bin(31) value(6);
 dcl OBJ_BITMAP      fixed bin(31) value(7);
 dcl OBJ_REGION      fixed bin(31) value(8);
 dcl OBJ_METAFILE    fixed bin(31) value(9);
 dcl OBJ_MEMDC       fixed bin(31) value(10);
 dcl OBJ_EXTPEN      fixed bin(31) value(11);
 dcl OBJ_ENHMETADC   fixed bin(31) value(12);
 dcl OBJ_ENHMETAFILE fixed bin(31) value(13);

 /* xform stuff */
 dcl MWT_IDENTITY      fixed bin(31) value(1);
 dcl MWT_LEFTMULTIPLY  fixed bin(31) value(2);
 dcl MWT_RIGHTMULTIPLY fixed bin(31) value(3);

 dcl MWT_MIN           fixed bin(31) value(MWT_IDENTITY);
 dcl MWT_MAX           fixed bin(31) value(MWT_RIGHTMULTIPLY);

 define structure
   1 XFORM,
     2 eM11 type FLOAT,
     2 eM12 type FLOAT,
     2 eM21 type FLOAT,
     2 eM22 type FLOAT,
     2 eDx  type FLOAT,
     2 eDy  type FLOAT;
 define alias  PXFORM handle XFORM;
 define alias LPXFORM handle XFORM;

 /* Bitmap Header Definition */
 define structure
   1 BITMAP,
     2 bmType       type LONG,
     2 bmWidth      type LONG,
     2 bmHeight     type LONG,
     2 bmWidthBytes type LONG,
     2 bmPlanes     type WORD,
     2 bmBitsPixel  type WORD,
     2 bmBits       type LPVOID;
 define alias  PBITMAP handle BITMAP;
 define alias NPBITMAP handle BITMAP;
 define alias LPBITMAP handle BITMAP;

 define structure
   1 RGBTRIPLE,
     2 rgbtBlue  type BYTE,
     2 rgbtGreen type BYTE,
     2 rgbtRed   type BYTE;

 define structure
   1 RGBQUAD,
     2 rgbBlue     type BYTE,
     2 rgbGreen    type BYTE,
     2 rgbRed      type BYTE,
     2 rgbReserved type BYTE;
 define alias LPRGBQUAD handle RGBQUAD;


 %if WINVER >= 1024 %then %do;

 /* Image Color Matching color definitions */

 dcl CS_ENABLE           type DWORD value('00000001'xu);
 dcl CS_DISABLE          type DWORD value('00000002'xu);
 dcl CS_DELETE_TRANSFORM type DWORD value('00000003'xu);

 /* Logcolorspace signature */

 dcl LCS_SIGNATURE    type DWORD value (ior (isll (rank ('P'), 24),
                                             isll (rank ('S'), 16),
                                             isll (rank ('O'), 8),
                                                   rank ('C')));

 /* Logcolorspace lcsType values */

 dcl LCS_sRGB         type DWORD value (ior (isll (rank ('s'), 24),
                                             isll (rank ('R'), 16),
                                             isll (rank ('G'), 8),
                                                   rank ('B')));
 dcl LCS_WINDOWS_COLOR_SPACE
                      type DWORD value (ior (isll (rank ('W'), 24),
                                             isll (rank ('i'), 16),
                                             isll (rank ('n'), 8),
                                                   rank (' ')));
 /* Windows default color space */

 define alias LCSCSTYPE type LONG;
 dcl LCS_CALIBRATED_RGB      type LCSCSTYPE value('00000000'xu);
 dcl LCS_DEVICE_RGB          type LCSCSTYPE value('00000001'xu);
 dcl LCS_DEVICE_CMYK         type LCSCSTYPE value('00000002'xu);

 define alias LCSGAMUTMATCH type LONG;
 dcl LCS_GM_BUSINESS         type LCSGAMUTMATCH value('00000001'xu);
 dcl LCS_GM_GRAPHICS         type LCSGAMUTMATCH value('00000002'xu);
 dcl LCS_GM_IMAGES           type LCSGAMUTMATCH value('00000004'xu);
 dcl LCS_GM_ABS_COLORIMETRIC type LCSGAMUTMATCH value('00000008'xu);

 /* ICM Defines for results from CheckColorInGamut() */
 dcl CM_OUT_OF_GAMUT         fixed bin(31) value(255);
 dcl CM_IN_GAMUT             fixed bin(31) value(0);

 /* UpdateICMRegKey Constants               */
 dcl ICM_ADDPROFILE          fixed bin(31) value(1);
 dcl ICM_DELETEPROFILE       fixed bin(31) value(2);
 dcl ICM_QUERYPROFILE        fixed bin(31) value(3);
 dcl ICM_SETDEFAULTPROFILE   fixed bin(31) value(4);
 dcl ICM_REGISTERICMATCHER   fixed bin(31) value(5);
 dcl ICM_UNREGISTERICMATCHER fixed bin(31) value(6);
 dcl ICM_QUERYMATCH          fixed bin(31) value(7);

 /* Macros to retrieve CMYK values from a COLORREF */

 GetKValue: proc (cmyk) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl cmyk type COLORREF byvalue;
   dcl iand builtin;
   return (iand (cmyk, 'ff'xu));
 end GetKValue;

 GetYValue: proc (cmyk) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl cmyk type COLORREF byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (cmyk, 8), 'ff'xu));
 end GetYValue;

 GetMValue: proc (cmyk) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl cmyk type COLORREF byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (cmyk, 16), 'ff'xu));
 end GetMValue;

 GetCValue: proc (cmyk) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl cmyk type COLORREF byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (cmyk, 24), 'ff'xu));
 end GetCValue;

 CYMK: proc (c,m,y,k) returns (type COLORREF byvalue)
       options(inline reorder) internal;
   dcl (c, m, y, k) type BYTE byvalue;
   dcl (iand, ior, raise2) builtin;
   return (ior (        iand (k, 'ff'xu),
                raise2 (iand (y, 'ff'xu), 8),
                raise2 (iand (m, 'ff'xu), 16),
                raise2 (iand (c, 'ff'xu), 24)));
 end CYMK;

 define alias FXPT16DOT1    fixed bin (31);
 define alias FXPT2DOT30    fixed bin (31);
 define alias LPFXPT16DOT16 pointer;
 define alias LPFXPT2DOT30  pointer;

 /* ICM Color Definitions */
 /* The following two structures are used for defining RGB's in terms */
 /* of CIEXYZ.                                                        */

 define structure
   1 CIEXYZ,   /* Windows default color space */
     2 ciexyzX type FXPT2DOT30,
     2 ciexyzY type FXPT2DOT30,
     2 ciexyzZ type FXPT2DOT30;
 define alias LPCIEXYZ handle CIEXYZ;

 define structure
   1 CIEXYZTRIPLE,
     2 ciexyzRed   type CIEXYZ,
     2 ciexyzGreen type CIEXYZ,
     2 ciexyzBlue  type CIEXYZ;
 define alias LPCIEXYZTRIPLE handle CIEXYZTRIPLE;

 /* The next structures the logical color space. Unlike pens and    */
 /* brushes, but like palettes, there is only one way to create a   */
 /* LogColorSpace. A pointer to it must be passed, its elements     */
 /* can't be pushed as arguments.                                   */

 define structure
   1 LOGCOLORSPACEA,
     2 lcsSignature  type DWORD,
     2 lcsVersion    type DWORD,
     2 lcsSize       type DWORD,
     2 lcsCSType     type LCSCSTYPE,
     2 lcsIntent     type LCSGAMUTMATCH,
     2 lcsEndpoints  type CIEXYZTRIPLE,
     2 lcsGammaRed   type DWORD,
     2 lcsGammaGreen type DWORD,
     2 lcsGammaBlue  type DWORD,
     2 lcsFilename   char(MAX_PATH-1) varz;
 define alias LPLOGCOLORSPACEA handle LOGCOLORSPACEA;

 define structure
   1 LOGCOLORSPACEW,
     2 lcsSignature  type DWORD,
     2 lcsVersion    type DWORD,
     2 lcsSize       type DWORD,
     2 lcsCSType     type LCSCSTYPE,
     2 lcsIntent     type LCSGAMUTMATCH,
     2 lcsEndpoints  type CIEXYZTRIPLE,
     2 lcsGammaRed   type DWORD,
     2 lcsGammaGreen type DWORD,
     2 lcsGammaBlue  type DWORD,
     2 lcsFilename   WCHAR(MAX_PATH-1) varz;
 define alias LPLOGCOLORSPACEW handle LOGCOLORSPACEW;

 %if UNICODE ^= '' %then %do;
 define alias LOGCOLORSPACE   type LOGCOLORSPACEW;
 define alias LPLOGCOLORSPACE type LPLOGCOLORSPACEW;
 %end; %else %do;
 define alias LOGCOLORSPACE   type LOGCOLORSPACEA;
 define alias LPLOGCOLORSPACE type LPLOGCOLORSPACEA;
 %end; /* UNICODE */

 %end; /* WINVER >= 0x0400 */

 /* structures for defining DIBs */
 define structure
   1 BITMAPCOREHEADER,
     2 bcSize     type DWORD,/* used to get to color table */
     2 bcWidth    type WORD,
     2 bcHeight   type WORD,
     2 bcPlanes   type WORD,
     2 bcBitCount type WORD;
 define alias LPBITMAPCOREHEADER handle BITMAPCOREHEADER;
 define alias  PBITMAPCOREHEADER handle BITMAPCOREHEADER;

 define structure
   1 BITMAPINFOHEADER,
     2 biSize          type DWORD,
     2 biWidth         type LONG,
     2 biHeight        type LONG,
     2 biPlanes        type WORD,
     2 biBitCount      type WORD,
     2 biCompression   type DWORD,
     2 biSizeImage     type DWORD,
     2 biXPelsPerMeter type LONG,
     2 biYPelsPerMeter type LONG,
     2 biClrUsed       type DWORD,
     2 biClrImportant  type DWORD;
 define alias LPBITMAPINFOHEADER handle BITMAPINFOHEADER;
 define alias  PBITMAPINFOHEADER handle BITMAPINFOHEADER;


 %if WINVER >= 1024 %then %do;
 define structure
   1 BITMAPV4HEADER,
     2 bV4Size          type DWORD,
     2 bV4Width         type LONG,
     2 bV4Height        type LONG,
     2 bV4Planes        type WORD,
     2 bV4BitCount      type WORD,
     2 bV4V4Compression type DWORD,
     2 bV4SizeImage     type DWORD,
     2 bV4XPelsPerMeter type LONG,
     2 bV4YPelsPerMeter type LONG,
     2 bV4ClrUsed       type DWORD,
     2 bV4ClrImportant  type DWORD,
     2 bV4RedMask       type DWORD,
     2 bV4GreenMask     type DWORD,
     2 bV4BlueMask      type DWORD,
     2 bV4AlphaMask     type DWORD,
     2 bV4CSType        type DWORD,
     2 bV4Endpoints     type CIEXYZTRIPLE,
     2 bV4GammaRed      type DWORD,
     2 bV4GammaGreen    type DWORD,
     2 bV4GammaBlue     type DWORD;
 define alias LPBITMAPV4HEADER handle BITMAPV4HEADER;
 define alias  PBITMAPV4HEADER handle BITMAPV4HEADER;
 %end; /* WINVER >= 0x0400 */


 %if WINVER >= 1280 %then %do;
 define structure
   1 BITMAPV5HEADER,
     2 bV5Size          type DWORD,
     2 bV5Width         type LONG,
     2 bV5Height        type LONG,
     2 bV5Planes        type WORD,
     2 bV5BitCount      type WORD,
     2 bV5Compression   type DWORD,
     2 bV5SizeImage     type DWORD,
     2 bV5XPelsPerMeter type LONG,
     2 bV5YPelsPerMeter type LONG,
     2 bV5ClrUsed       type DWORD,
     2 bV5ClrImportant  type DWORD,
     2 bV5RedMask       type DWORD,
     2 bV5GreenMask     type DWORD,
     2 bV5BlueMask      type DWORD,
     2 bV5AlphaMask     type DWORD,
     2 bV5CSType        type DWORD,
     2 bV5Endpoints     type CIEXYZTRIPLE,
     2 bV5GammaRed      type DWORD,
     2 bV5GammaGreen    type DWORD,
     2 bV5GammaBlue     type DWORD,
     2 bV5Intent        type DWORD,
     2 bV5ProfileData   type DWORD,
     2 bV5ProfileSize   type DWORD,
     2 bV5Reserved      type DWORD;
 define alias LPBITMAPV5HEADER handle BITMAPV5HEADER;
 define alias  PBITMAPV5HEADER handle BITMAPV5HEADER;

 /* Values for bV5CSType */
 dcl PROFILE_LINKED   type DWORD value (ior (isll (rank ('L'), 24),
                                             isll (rank ('I'), 16),
                                             isll (rank ('N'), 8),
                                                   rank ('K')));

 dcl PROFILE_EMBEDDED type DWORD value (ior (isll (rank ('M'), 24),
                                             isll (rank ('B'), 16),
                                             isll (rank ('E'), 8),
                                                   rank ('D')));
 %end;

 /* constants for the biCompression field */
 dcl BI_RGB           type DWORD value(0);
 dcl BI_RLE8          type DWORD value(1);
 dcl BI_RLE4          type DWORD value(2);
 dcl BI_BITFIELDS     type DWORD value(3);

 define structure
   1 BITMAPINFO,
     2 bmiHeader     type BITMAPINFOHEADER,
     2 bmiColors (1) type RGBQUAD;
 define alias LPBITMAPINFO handle BITMAPINFO;
 define alias  PBITMAPINFO handle BITMAPINFO;

 define structure
   1 BITMAPCOREINFO,
     2 bmciHeader     type BITMAPCOREHEADER,
     2 bmciColors (1) type RGBTRIPLE;
 define alias LPBITMAPCOREINFO handle BITMAPCOREINFO;
 define alias  PBITMAPCOREINFO handle BITMAPCOREINFO;

 define structure
   1 BITMAPFILEHEADER unaligned,
     2 bfType      type WORD,
     2 bfSize      type DWORD,
     2 bfReserved1 type WORD,
     2 bfReserved2 type WORD,
     2 bfOffBits   type DWORD;
 define alias LPBITMAPFILEHEADER handle BITMAPFILEHEADER;
 define alias  PBITMAPFILEHEADER handle BITMAPFILEHEADER;

 MAKEPOINTS: proc (l) returns (type POINTS byvalue)
             options(inline reorder) internal;
   dcl l type DWORD byvalue;
   dcl (addr, type) builtin;
   return (type (bind (: POINTS, addr (l) :)));
 end MAKEPOINTS;

 %if WINVER >= 1024 %then %do;
 %dcl NOFONTSIG char ext;
 %if NOFONTSIG = '' %then %do;
 define structure
   1 FONTSIGNATURE,
     2 fsUsb (4) type DWORD,
     2 fsCsb (2) type DWORD;
 define alias  PFONTSIGNATURE handle FONTSIGNATURE;
 define alias LPFONTSIGNATURE handle FONTSIGNATURE;

 define structure
   1 CHARSETINFO,
     2 ciCharset type UINT,
     2 ciACP     type UINT,
     2 fs        type FONTSIGNATURE;
 define alias  PCHARSETINFO handle CHARSETINFO;
 define alias NPCHARSETINFO handle CHARSETINFO;
 define alias LPCHARSETINFO handle CHARSETINFO;

 dcl TCI_SRCCHARSET  fixed bin(31) value(1);
 dcl TCI_SRCCODEPAGE fixed bin(31) value(2);
 dcl TCI_SRCFONTSIG  fixed bin(31) value(3);

 define structure
   1 LOCALESIGNATURE,
     2 lsUsb          (4) type DWORD,
     2 lsCsbDefault   (2) type DWORD,
     2 lsCsbSupported (2) type DWORD;
 define alias  PLOCALESIGNATURE handle LOCALESIGNATURE;
 define alias LPLOCALESIGNATURE handle LOCALESIGNATURE;

 %end;
 %end; /* WINVER >= 0x0400 */

 %if NOMETAFILE = '' %then %do;

 /* Clipboard Metafile Picture Structure */
 define structure
   1 HANDLETABLE,
     2 objectHandle (1) type HGDIOBJ;
 define alias  PHANDLETABLE handle HANDLETABLE;
 define alias LPHANDLETABLE handle HANDLETABLE;

 define structure
   1 METARECORD,
     2 rdSize     type DWORD,
     2 rdFunction type WORD,
     2 rdParm (1) type WORD;
 define alias  PMETARECORD handle METARECORD;
 define alias LPMETARECORD handle METARECORD;

 define structure
   1 METAFILEPICT,
     2 mm   type LONG,
     2 xExt type LONG,
     2 yExt type LONG,
     2 hMF  type HMETAFILE;
 define alias LPMETAFILEPICT handle METAFILEPICT;

 define structure
   1 METAHEADER unaligned,
     2 mtType         type WORD,
     2 mtHeaderSize   type WORD,
     2 mtVersion      type WORD,
     2 mtSize         type DWORD,
     2 mtNoObjects    type WORD,
     2 mtMaxRecord    type DWORD,
     2 mtNoParameters type WORD;
 define alias  PMETAHEADER handle METAHEADER;
 define alias LPMETAHEADER handle METAHEADER;

 /* Enhanced Metafile structures */
 define structure
   1 ENHMETARECORD,
     2 iType     type DWORD,/* Record type EMR_XXX */
     2 nSize     type DWORD,/* Record size in bytes */
     2 dParm (1) type DWORD;/* Parameters */
 define alias  PENHMETARECORD handle ENHMETARECORD;
 define alias LPENHMETARECORD handle ENHMETARECORD;

 define structure
   1 ENHMETAHEADER,
     2 iType      type DWORD,/* Record type EMR_HEADER                */
     2 nSize      type DWORD,/* Record size in bytes. This may be     */
                             /* greater than the sizeof(ENHMETAHEADER)*/
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device  */
                             /* units                                 */
     2 rclFrame   type RECTL,/* Inclusive-inclusive Picture Frame of  */
                             /* metafile in .01 mm units              */
     2 dSignature type DWORD,/* Signature. Must be ENHMETA_SIGNATURE. */
     2 nVersion   type DWORD,/* Version number                        */
     2 nBytes     type DWORD,/* Size of the metafile in bytes         */
     2 nRecords   type DWORD,/* Number of records in the metafile     */
     2 nHandles   type WORD, /* Number of handles in the handle table */
                             /* Handle index zero is reserved.        */
     2 sReserved  type WORD, /* Reserved. Must be zero.               */
     2 nDescription   type DWORD,/* Number of chars in the unicode    */
                                 /* description string. This is 0     */
                                 /* if there is no description string */
     2 offDescription type DWORD,/* Offset to the metafile description*/
                                 /* record.This is 0 if there is no   */
                                 /* description string                */
     2 nPalEntries    type DWORD,/* Number of entries in the metafile */
                                 /* palette.                          */
     2 szlDevice      type SIZEL,/* Size of reference device in pels  */
     2 szlMillimeters type SIZEL /* Size of the reference device in   */
                                 /* millimeters                       */
 %if WINVER >= 1024 %then %do;
   , 2 cbPixelFormat  type DWORD,/* Size of PIXELFORMATDESCRIPTOR     */
                                 /* information. This is 0 if no      */
                                 /* pixel format is set               */
     2 offPixelFormat type DWORD,/* Offset to PIXELFORMATDESCRIPTOR   */
                                 /* This is 0 if no pixel format set  */
     2 bOpenGL        type DWORD /* TRUE if OpenGL commands present   */
                                 /* in the metafile, otherwise FALSE  */
 %end; /* WINVER >= 0x0400 */
 %if WINVER >= 1280 %then %do;
   , 2 szlMicrometers type SIZEL /* Size of the reference device in   */
                                 /* micrometers                       */
 %end; /* WINVER >= 0x0500 */
   ;
 define alias  PENHMETAHEADER handle ENHMETAHEADER;
 define alias LPENHMETAHEADER handle ENHMETAHEADER;

 %end; /* NOMETAFILE */

 %if NOTEXTMETRIC = '' %then %do;

 /* tmPitchAndFamily flags */
 dcl TMPF_FIXED_PITCH     type BYTE value('01'xu);
 dcl TMPF_VECTOR          type BYTE value('02'xu);
 dcl TMPF_DEVICE          type BYTE value('08'xu);
 dcl TMPF_TRUETYPE        type BYTE value('04'xu);


 /* BCHAR definition for APPs */


 %if UNICODE ^= '' %then %do;
 define alias BCHAR WCHAR;
 %end; %else %do;
 define alias BCHAR type BYTE;
 %end;

 define structure
   1 TEXTMETRICA,
     2 tmHeight           type LONG,
     2 tmAscent           type LONG,
     2 tmDescent          type LONG,
     2 tmInternalLeading  type LONG,
     2 tmExternalLeading  type LONG,
     2 tmAveCharWidth     type LONG,
     2 tmMaxCharWidth     type LONG,
     2 tmWeight           type LONG,
     2 tmOverhang         type LONG,
     2 tmDigitizedAspectX type LONG,
     2 tmDigitizedAspectY type LONG,
     2 tmFirstChar        char,
     2 tmLastChar         char,
     2 tmDefaultChar      char,
     2 tmBreakChar        char,
     2 tmItalic           type BYTE,
     2 tmUnderlined       type BYTE,
     2 tmStruckOut        type BYTE,
     2 tmPitchAndFamily   type BYTE,
     2 tmCharSet          type BYTE;
 define alias  PTEXTMETRICA handle TEXTMETRICA;
 define alias NPTEXTMETRICA handle TEXTMETRICA;
 define alias LPTEXTMETRICA handle TEXTMETRICA;

 define structure
   1 TEXTMETRICW,
     2 tmHeight           type LONG,
     2 tmAscent           type LONG,
     2 tmDescent          type LONG,
     2 tmInternalLeading  type LONG,
     2 tmExternalLeading  type LONG,
     2 tmAveCharWidth     type LONG,
     2 tmMaxCharWidth     type LONG,
     2 tmWeight           type LONG,
     2 tmOverhang         type LONG,
     2 tmDigitizedAspectX type LONG,
     2 tmDigitizedAspectY type LONG,
     2 tmFirstChar        WCHAR,
     2 tmLastChar         WCHAR,
     2 tmDefaultChar      WCHAR,
     2 tmBreakChar        WCHAR,
     2 tmItalic           type BYTE,
     2 tmUnderlined       type BYTE,
     2 tmStruckOut        type BYTE,
     2 tmPitchAndFamily   type BYTE,
     2 tmCharSet          type BYTE;
 define alias  PTEXTMETRICW handle TEXTMETRICW;
 define alias NPTEXTMETRICW handle TEXTMETRICW;
 define alias LPTEXTMETRICW handle TEXTMETRICW;

 %if UNICODE ^= '' %then %do;
 define alias   TEXTMETRIC type TEXTMETRICW;
 define alias  PTEXTMETRIC type PTEXTMETRICW;
 define alias NPTEXTMETRIC type NPTEXTMETRICW;
 define alias LPTEXTMETRIC type LPTEXTMETRICW;
 %end; %else %do;
 define alias   TEXTMETRIC type TEXTMETRICA;
 define alias  PTEXTMETRIC type PTEXTMETRICA;
 define alias NPTEXTMETRIC type NPTEXTMETRICA;
 define alias LPTEXTMETRIC type LPTEXTMETRICA;
 %end; /* UNICODE */

 /* ntmFlags field flags */
 dcl NTM_REGULAR        type DWORD value('00000040'xu);
 dcl NTM_BOLD           type DWORD value('00000020'xu);
 dcl NTM_ITALIC         type DWORD value('00000001'xu);

 dcl NTM_NONNEGATIVE_AC type DWORD value('00010000'xu);
 dcl NTM_OPENTYPE       type DWORD value('00020000'xu);
 dcl NTM_MULTIPLEMASTER type DWORD value('00040000'xu);
 dcl NTM_MM_INSTANCE    type DWORD value('00080000'xu);
 dcl NTM_TYPE1          type DWORD value('00100000'xu);
 dcl NTM_DSIG           type DWORD value('00200000'xu);

 define structure
   1 NEWTEXTMETRICA,
     2 tmHeight           type LONG,
     2 tmAscent           type LONG,
     2 tmDescent          type LONG,
     2 tmInternalLeading  type LONG,
     2 tmExternalLeading  type LONG,
     2 tmAveCharWidth     type LONG,
     2 tmMaxCharWidth     type LONG,
     2 tmWeight           type LONG,
     2 tmOverhang         type LONG,
     2 tmDigitizedAspectX type LONG,
     2 tmDigitizedAspectY type LONG,
     2 tmFirstChar        char,
     2 tmLastChar         char,
     2 tmDefaultChar      char,
     2 tmBreakChar        char,
     2 tmItalic           type BYTE,
     2 tmUnderlined       type BYTE,
     2 tmStruckOut        type BYTE,
     2 tmPitchAndFamily   type BYTE,
     2 tmCharSet          type BYTE,
     2 ntmFlags           type DWORD,
     2 ntmSizeEM          type UINT,
     2 ntmCellHeight      type UINT,
     2 ntmAvgWidth        type UINT;
 define alias  PNEWTEXTMETRICA handle NEWTEXTMETRICA;
 define alias NPNEWTEXTMETRICA handle NEWTEXTMETRICA;
 define alias LPNEWTEXTMETRICA handle NEWTEXTMETRICA;

 define structure
   1 NEWTEXTMETRICW,
     2 tmHeight           type LONG,
     2 tmAscent           type LONG,
     2 tmDescent          type LONG,
     2 tmInternalLeading  type LONG,
     2 tmExternalLeading  type LONG,
     2 tmAveCharWidth     type LONG,
     2 tmMaxCharWidth     type LONG,
     2 tmWeight           type LONG,
     2 tmOverhang         type LONG,
     2 tmDigitizedAspectX type LONG,
     2 tmDigitizedAspectY type LONG,
     2 tmFirstChar        WCHAR,
     2 tmLastChar         WCHAR,
     2 tmDefaultChar      WCHAR,
     2 tmBreakChar        WCHAR,
     2 tmItalic           type BYTE,
     2 tmUnderlined       type BYTE,
     2 tmStruckOut        type BYTE,
     2 tmPitchAndFamily   type BYTE,
     2 tmCharSet          type BYTE,
     2 ntmFlags           type DWORD,
     2 ntmSizeEM          type UINT,
     2 ntmCellHeight      type UINT,
     2 ntmAvgWidth        type UINT;
 define alias  PNEWTEXTMETRICW handle NEWTEXTMETRICW;
 define alias NPNEWTEXTMETRICW handle NEWTEXTMETRICW;
 define alias LPNEWTEXTMETRICW handle NEWTEXTMETRICW;

 %if UNICODE ^= '' %then %do;
 define alias   NEWTEXTMETRIC type   NEWTEXTMETRICW;
 define alias  PNEWTEXTMETRIC type  PNEWTEXTMETRICW;
 define alias NPNEWTEXTMETRIC type NPNEWTEXTMETRICW;
 define alias LPNEWTEXTMETRIC type LPNEWTEXTMETRICW;
 %end; %else %do;
 define alias   NEWTEXTMETRIC type   NEWTEXTMETRICA;
 define alias  PNEWTEXTMETRIC type  PNEWTEXTMETRICA;
 define alias NPNEWTEXTMETRIC type NPNEWTEXTMETRICA;
 define alias LPNEWTEXTMETRIC type LPNEWTEXTMETRICA;
 %end; /* UNICODE */


 %if WINVER >= 1024 %then %do;
 define structure
   1 NEWTEXTMETRICEXA,
     2 ntmTm      type NEWTEXTMETRICA,
     2 ntmFontSig type FONTSIGNATURE;

 define structure
   1 NEWTEXTMETRICEXW,
     2 ntmTm      type NEWTEXTMETRICW,
     2 ntmFontSig type FONTSIGNATURE;

 %if UNICODE ^= '' %then  %do;
 define alias NEWTEXTMETRICEX type NEWTEXTMETRICEXW;
 %end; %else %do;
 define alias NEWTEXTMETRICEX type NEWTEXTMETRICEXA;
 %end; /* UNICODE */
 %end; /* WINVER >= 0x0400 */

 %end; /* NOTEXTMETRIC */

 /* GDI Logical Objects: */

 /* Pel Array */
 define structure
   1 PELARRAY,
     2 paXCount type LONG,
     2 paYCount type LONG,
     2 paXExt   type LONG,
     2 paYExt   type LONG,
     2 paRGBs   type BYTE;
 define alias  PPELARRAY handle PELARRAY;
 define alias NPPELARRAY handle PELARRAY;
 define alias LPPELARRAY handle PELARRAY;

 /* Logical Brush (or Pattern) */
 define structure
   1 LOGBRUSH,
     2 lbStyle  type UINT,
     2 lbColor  type COLORREF,
     2 lbHatch  type LONG;
 define alias  PLOGBRUSH handle LOGBRUSH;
 define alias NPLOGBRUSH handle LOGBRUSH;
 define alias LPLOGBRUSH handle LOGBRUSH;

 define alias   PATTERN type   LOGBRUSH;
 define alias  PPATTERN handle PATTERN;
 define alias NPPATTERN handle PATTERN;
 define alias LPPATTERN handle PATTERN;

 /* Logical Pen */
 define structure
   1 LOGPEN,
     2 lopnStyle type UINT,
     2 lopnWidth type POINT,
     2 lopnColor type COLORREF;
 define alias  PLOGPEN handle LOGPEN;
 define alias NPLOGPEN handle LOGPEN;
 define alias LPLOGPEN handle LOGPEN;

 define structure
   1 EXTLOGPEN,
     2 elpPenStyle   type DWORD,
     2 elpWidth      type DWORD,
     2 elpBrushStyle type UINT,
     2 elpColor      type COLORREF,
     2 elpHatch      type LONG,
     2 elpNumEntries type DWORD,
     2 elpStyleEntry (1) type DWORD;
 define alias  PEXTLOGPEN handle EXTLOGPEN;
 define alias NPEXTLOGPEN handle EXTLOGPEN;
 define alias LPEXTLOGPEN handle EXTLOGPEN;

 define structure
   1 PALETTEENTRY,
     2 peRed   type BYTE,
     2 peGreen type BYTE,
     2 peBlue  type BYTE,
     2 peFlags type BYTE;
 define alias  PPALETTEENTRY handle PALETTEENTRY;
 define alias LPPALETTEENTRY handle PALETTEENTRY;

 /* Logical Palette */
 define structure
   1 LOGPALETTE,
     2 palVersion      type WORD,
     2 palNumEntries   type WORD,
     2 palPalEntry (1) type PALETTEENTRY;
 define alias  PLOGPALETTE handle LOGPALETTE;
 define alias NPLOGPALETTE handle LOGPALETTE;
 define alias LPLOGPALETTE handle LOGPALETTE;


 /* Logical Font */
 dcl LF_FACESIZE fixed bin(31) value(32);

 define structure
   1 LOGFONTA,
     2 lfHeight         type LONG,
     2 lfWidth          type LONG,
     2 lfEscapement     type LONG,
     2 lfOrientation    type LONG,
     2 lfWeight         type LONG,
     2 lfItalic         type BYTE,
     2 lfUnderline      type BYTE,
     2 lfStrikeOut      type BYTE,
     2 lfCharSet        type BYTE,
     2 lfOutPrecision   type BYTE,
     2 lfClipPrecision  type BYTE,
     2 lfQuality        type BYTE,
     2 lfPitchAndFamily type BYTE,
     2 lfFaceName       char (LF_FACESIZE-1) varz;
 define alias  PLOGFONTA handle LOGFONTA;
 define alias NPLOGFONTA handle LOGFONTA;
 define alias LPLOGFONTA handle LOGFONTA;

 define structure
   1 LOGFONTW,
     2 lfHeight         type LONG,
     2 lfWidth          type LONG,
     2 lfEscapement     type LONG,
     2 lfOrientation    type LONG,
     2 lfWeight         type LONG,
     2 lfItalic         type BYTE,
     2 lfUnderline      type BYTE,
     2 lfStrikeOut      type BYTE,
     2 lfCharSet        type BYTE,
     2 lfOutPrecision   type BYTE,
     2 lfClipPrecision  type BYTE,
     2 lfQuality        type BYTE,
     2 lfPitchAndFamily type BYTE,
     2 lfFaceName       WCHAR (LF_FACESIZE-1) varz;
 define alias  PLOGFONTW handle LOGFONTW;
 define alias NPLOGFONTW handle LOGFONTW;
 define alias LPLOGFONTW handle LOGFONTW;

 %if UNICODE ^= '' %then %do;
 define alias   LOGFONT type   LOGFONTW;
 define alias  PLOGFONT type  PLOGFONTW;
 define alias NPLOGFONT type NPLOGFONTW;
 define alias LPLOGFONT type LPLOGFONTW;
 %end; %else %do;
 define alias   LOGFONT type   LOGFONTA;
 define alias  PLOGFONT type  PLOGFONTA;
 define alias NPLOGFONT type NPLOGFONTA;
 define alias LPLOGFONT type LPLOGFONTA;
 %end; /* UNICODE */

 dcl LF_FULLFACESIZE fixed bin(31) value(64);

 /* Structure passed to FONTENUMPROC */
 define structure
   1 ENUMLOGFONTA,
     2 elfLogFont  type LOGFONTA,
     2 elfFullName char(LF_FULLFACESIZE-1) varz,
     2 elfStyle    char(LF_FACESIZE-1) varz;
 define alias LPENUMLOGFONTA handle ENUMLOGFONTA;

 /* Structure passed to FONTENUMPROC */
 define structure
   1 ENUMLOGFONTW,
     2 elfLogFont  type LOGFONTW,
     2 elfFullName WCHAR(LF_FULLFACESIZE-1) varz,
     2 elfStyle    WCHAR(LF_FACESIZE-1) varz;
 define alias LPENUMLOGFONTW handle ENUMLOGFONTW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUMLOGFONT type   ENUMLOGFONTW;
 define alias LPENUMLOGFONT type LPENUMLOGFONTW;
 %end; %else %do;
 define alias   ENUMLOGFONT type   ENUMLOGFONTA;
 define alias LPENUMLOGFONT type LPENUMLOGFONTA;
 %end; /* UNICODE */


 %if WINVER >= 1024 %then %do;
 define structure
   1 ENUMLOGFONTEXA,
     2 elfLogFont  type LOGFONTA,
     2 elfFullName char(LF_FULLFACESIZE-1) varz,
     2 elfStyle    char(LF_FACESIZE-1) varz,
     2 elfScript   char(LF_FACESIZE-1) varz;
 define alias LPENUMLOGFONTEXA handle ENUMLOGFONTEXA;

 define structure
   1 ENUMLOGFONTEXW,
     2 elfLogFont  type LOGFONTW,
     2 elfFullName WCHAR(LF_FULLFACESIZE-1)varz,
     2 elfStyle    WCHAR(LF_FACESIZE-1) varz,
     2 elfScript   WCHAR(LF_FACESIZE-1) varz;
 define alias LPENUMLOGFONTEXW handle ENUMLOGFONTEXW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUMLOGFONTEX type   ENUMLOGFONTEXW;
 define alias LPENUMLOGFONTEX type LPENUMLOGFONTEXW;
 %end; %else %do;
 define alias   ENUMLOGFONTEX type   ENUMLOGFONTEXA;
 define alias LPENUMLOGFONTEX type LPENUMLOGFONTEXA;
 %end; /* UNICODE */
 %end; /* WINVER >= 0x0400 */

 dcl OUT_DEFAULT_PRECIS        type BYTE value(0);
 dcl OUT_STRING_PRECIS         type BYTE value(1);
 dcl OUT_CHARACTER_PRECIS      type BYTE value(2);
 dcl OUT_STROKE_PRECIS         type BYTE value(3);
 dcl OUT_TT_PRECIS             type BYTE value(4);
 dcl OUT_DEVICE_PRECIS         type BYTE value(5);
 dcl OUT_RASTER_PRECIS         type BYTE value(6);
 dcl OUT_TT_ONLY_PRECIS        type BYTE value(7);
 dcl OUT_OUTLINE_PRECIS        type BYTE value(8);
 dcl OUT_SCREEN_OUTLINE_PRECIS type BYTE value(9);

 dcl CLIP_DEFAULT_PRECIS       type BYTE value(0);
 dcl CLIP_CHARACTER_PRECIS     type BYTE value(1);
 dcl CLIP_STROKE_PRECIS        type BYTE value(2);
 dcl CLIP_MASK                 type BYTE value('f'xu);
 dcl CLIP_LH_ANGLES            type BYTE value(raise2(1,4));
 dcl CLIP_TT_ALWAYS            type BYTE value(raise2(2,4));
 dcl CLIP_EMBEDDED             type BYTE value(raise2(8,4));

 dcl DEFAULT_QUALITY           type BYTE value(0);
 dcl DRAFT_QUALITY             type BYTE value(1);
 dcl PROOF_QUALITY             type BYTE value(2);

 %if WINVER >= 1024 %then %do;
 dcl NONANTIALIASED_QUALITY    type BYTE value(3);
 dcl ANTIALIASED_QUALITY       type BYTE value(4);
 %end; /* WINVER >= 0x0400 */

 %if #WIN32_WINNT >= 1280 %then %do;
 dcl CLEARTYPE_QUALITY         type BYTE value(5);
 %end; /* _WIN32_WINNT >= 0x0500 */

 dcl DEFAULT_PITCH             type BYTE value(0);
 dcl FIXED_PITCH               type BYTE value(1);
 dcl VARIABLE_PITCH            type BYTE value(2);

 %if WINVER >= 1024 %then %do;
 dcl MONO_FONT                 type BYTE value(8);
 %end; /* WINVER >= 0x0400 */

 dcl ANSI_CHARSET              type BYTE value(0);
 dcl DEFAULT_CHARSET           type BYTE value(1);
 dcl SYMBOL_CHARSET            type BYTE value(2);
 dcl SHIFTJIS_CHARSET          type BYTE value(128);
 dcl HANGEUL_CHARSET           type BYTE value(129);
 dcl HANGUL_CHARSET            type BYTE value(129);
 dcl GB2312_CHARSET            type BYTE value(134);
 dcl CHINESEBIG5_CHARSET       type BYTE value(136);
 dcl OEM_CHARSET               type BYTE value(255);

 %if WINVER >= 1024 %then %do;
 dcl JOHAB_CHARSET             type BYTE value(130);
 dcl HEBREW_CHARSET            type BYTE value(177);
 dcl ARABIC_CHARSET            type BYTE value(178);
 dcl GREEK_CHARSET             type BYTE value(161);
 dcl TURKISH_CHARSET           type BYTE value(162);
 dcl VIETNAMESE_CHARSET        type BYTE value(163);
 dcl THAI_CHARSET              type BYTE value(222);
 dcl EASTEUROPE_CHARSET        type BYTE value(238);
 dcl RUSSIAN_CHARSET           type BYTE value(204);

 dcl MAC_CHARSET               type BYTE value(77);
 dcl BALTIC_CHARSET            type BYTE value(186);

 dcl FS_LATIN1                 type LONG value('00000001'xn);
 dcl FS_LATIN2                 type LONG value('00000002'xn);
 dcl FS_CYRILLIC               type LONG value('00000004'xn);
 dcl FS_GREEK                  type LONG value('00000008'xn);
 dcl FS_TURKISH                type LONG value('00000010'xn);
 dcl FS_HEBREW                 type LONG value('00000020'xn);
 dcl FS_ARABIC                 type LONG value('00000040'xn);
 dcl FS_BALTIC                 type LONG value('00000080'xn);
 dcl FS_VIETNAMESE             type LONG value('00000100'xn);
 dcl FS_THAI                   type LONG value('00010000'xn);
 dcl FS_JISJAPAN               type LONG value('00020000'xn);
 dcl FS_CHINESESIMP            type LONG value('00040000'xn);
 dcl FS_WANSUNG                type LONG value('00080000'xn);
 dcl FS_CHINESETRAD            type LONG value('00100000'xn);
 dcl FS_JOHAB                  type LONG value('00200000'xn);
 dcl FS_SYMBOL                 type LONG value('80000000'xn);
 %end; /* WINVER >= 0x0400 */

 /* Font Families */
 dcl FF_DONTCARE               type BYTE value(raise2(0,4));
     /* Don't care or don't know. */
 dcl FF_ROMAN                  type BYTE value(raise2(1,4));
     /* Variable stroke width, serifed. */
     /* Times Roman, Century Schoolbook, etc. */
 dcl FF_SWISS                  type BYTE value(raise2(2,4));
     /* Variable stroke width, sans-serifed. */
     /* Helvetica, Swiss, etc. */
 dcl FF_MODERN                 type BYTE value(raise2(3,4));
     /* Constant stroke width, serifed or sans-serifed. */
     /* Pica, Elite, Courier, etc. */
 dcl FF_SCRIPT                 type BYTE value(raise2(4,4));
     /* Cursive, etc. */
 dcl FF_DECORATIVE             type BYTE value(raise2(5,4));
     /* Old English, etc. */

 /* Font Weights */
 dcl FW_DONTCARE               type LONG value(0);
 dcl FW_THIN                   type LONG value(100);
 dcl FW_EXTRALIGHT             type LONG value(200);
 dcl FW_LIGHT                  type LONG value(300);
 dcl FW_NORMAL                 type LONG value(400);
 dcl FW_MEDIUM                 type LONG value(500);
 dcl FW_SEMIBOLD               type LONG value(600);
 dcl FW_BOLD                   type LONG value(700);
 dcl FW_EXTRABOLD              type LONG value(800);
 dcl FW_HEAVY                  type LONG value(900);

 dcl FW_ULTRALIGHT             type LONG value(FW_EXTRALIGHT);
 dcl FW_REGULAR                type LONG value(FW_NORMAL);
 dcl FW_DEMIBOLD               type LONG value(FW_SEMIBOLD);
 dcl FW_ULTRABOLD              type LONG value(FW_EXTRABOLD);
 dcl FW_BLACK                  type LONG value(FW_HEAVY);

 dcl PANOSE_COUNT              fixed bin(31) value(10);
 dcl PAN_FAMILYTYPE_INDEX      fixed bin(31) value(0);
 dcl PAN_SERIFSTYLE_INDEX      fixed bin(31) value(1);
 dcl PAN_WEIGHT_INDEX          fixed bin(31) value(2);
 dcl PAN_PROPORTION_INDEX      fixed bin(31) value(3);
 dcl PAN_CONTRAST_INDEX        fixed bin(31) value(4);
 dcl PAN_STROKEVARIATION_INDEX fixed bin(31) value(5);
 dcl PAN_ARMSTYLE_INDEX        fixed bin(31) value(6);
 dcl PAN_LETTERFORM_INDEX      fixed bin(31) value(7);
 dcl PAN_MIDLINE_INDEX         fixed bin(31) value(8);
 dcl PAN_XHEIGHT_INDEX         fixed bin(31) value(9);

 dcl PAN_CULTURE_LATIN         fixed bin(31) value(0);

 define structure
   1 PANOSE,
     2 bFamilyType      type BYTE,
     2 bSerifStyle      type BYTE,
     2 bWeight          type BYTE,
     2 bProportion      type BYTE,
     2 bContrast        type BYTE,
     2 bStrokeVariation type BYTE,
     2 bArmStyle        type BYTE,
     2 bLetterform      type BYTE,
     2 bMidline         type BYTE,
     2 bXHeight         type BYTE;
 define alias LPPANOSE handle PANOSE;

 dcl PAN_ANY                        type BYTE value(0);
     /* Any                            */
 dcl PAN_NO_FIT                     type BYTE value(1);
     /* No Fit                         */

 dcl PAN_FAMILY_TEXT_DISPLAY        type BYTE value(2);
     /* Text and Display               */
 dcl PAN_FAMILY_SCRIPT              type BYTE value(3);
     /* Script                         */
 dcl PAN_FAMILY_DECORATIVE          type BYTE value(4);
     /* Decorative                     */
 dcl PAN_FAMILY_PICTORIAL           type BYTE value(5);
     /* Pictorial                      */

 dcl PAN_SERIF_COVE                 type BYTE value(2);
     /* Cove                           */
 dcl PAN_SERIF_OBTUSE_COVE          type BYTE value(3);
     /* Obtuse Cove                    */
 dcl PAN_SERIF_SQUARE_COVE          type BYTE value(4);
     /* Square Cove                    */
 dcl PAN_SERIF_OBTUSE_SQUARE_COVE   type BYTE value(5);
     /* Obtuse Square Cove             */
 dcl PAN_SERIF_SQUARE               type BYTE value(6);
     /* Square                         */
 dcl PAN_SERIF_THIN                 type BYTE value(7);
     /* Thin                           */
 dcl PAN_SERIF_BONE                 type BYTE value(8);
     /* Bone                           */
 dcl PAN_SERIF_EXAGGERATED          type BYTE value(9);
     /* Exaggerated                    */
 dcl PAN_SERIF_TRIANGLE             type BYTE value(10);
     /* Triangle                       */
 dcl PAN_SERIF_NORMAL_SANS          type BYTE value(11);
     /* Normal Sans                    */
 dcl PAN_SERIF_OBTUSE_SANS          type BYTE value(12);
     /* Obtuse Sans                    */
 dcl PAN_SERIF_PERP_SANS            type BYTE value(13);
     /* Prep Sans                      */
 dcl PAN_SERIF_FLARED               type BYTE value(14);
     /* Flared                         */
 dcl PAN_SERIF_ROUNDED              type BYTE value(15);
     /* Rounded                        */

 dcl PAN_WEIGHT_VERY_LIGHT          type BYTE value(2);
     /* Very Light                     */
 dcl PAN_WEIGHT_LIGHT               type BYTE value(3);
     /* Light                          */
 dcl PAN_WEIGHT_THIN                type BYTE value(4);
     /* Thin                           */
 dcl PAN_WEIGHT_BOOK                type BYTE value(5);
     /* Book                           */
 dcl PAN_WEIGHT_MEDIUM              type BYTE value(6);
     /* Medium                         */
 dcl PAN_WEIGHT_DEMI                type BYTE value(7);
     /* Demi                           */
 dcl PAN_WEIGHT_BOLD                type BYTE value(8);
     /* Bold                           */
 dcl PAN_WEIGHT_HEAVY               type BYTE value(9);
     /* Heavy                          */
 dcl PAN_WEIGHT_BLACK               type BYTE value(10);
     /* Black                          */
 dcl PAN_WEIGHT_NORD                type BYTE value(11);
     /* Nord                           */

 dcl PAN_PROP_OLD_STYLE             type BYTE value(2);
     /* Old Style                      */
 dcl PAN_PROP_MODERN                type BYTE value(3);
     /* Modern                         */
 dcl PAN_PROP_EVEN_WIDTH            type BYTE value(4);
     /* Even Width                     */
 dcl PAN_PROP_EXPANDED              type BYTE value(5);
     /* Expanded                       */
 dcl PAN_PROP_CONDENSED             type BYTE value(6);
     /* Condensed                      */
 dcl PAN_PROP_VERY_EXPANDED         type BYTE value(7);
     /* Very Expanded                  */
 dcl PAN_PROP_VERY_CONDENSED        type BYTE value(8);
     /* Very Condensed                 */
 dcl PAN_PROP_MONOSPACED            type BYTE value(9);
     /* Monospaced                     */

 dcl PAN_CONTRAST_NONE              type BYTE value(2);
     /* None                           */
 dcl PAN_CONTRAST_VERY_LOW          type BYTE value(3);
     /* Very Low                       */
 dcl PAN_CONTRAST_LOW               type BYTE value(4);
     /* Low                            */
 dcl PAN_CONTRAST_MEDIUM_LOW        type BYTE value(5);
     /* Medium Low                     */
 dcl PAN_CONTRAST_MEDIUM            type BYTE value(6);
     /* Medium                         */
 dcl PAN_CONTRAST_MEDIUM_HIGH       type BYTE value(7);
     /* Mediim High                    */
 dcl PAN_CONTRAST_HIGH              type BYTE value(8);
     /* High                           */
 dcl PAN_CONTRAST_VERY_HIGH         type BYTE value(9);
     /* Very High                      */

 dcl PAN_STROKE_GRADUAL_DIAG        type BYTE value(2);
     /* Gradual/Diagonal               */
 dcl PAN_STROKE_GRADUAL_TRAN        type BYTE value(3);
     /* Gradual/Transitional           */
 dcl PAN_STROKE_GRADUAL_VERT        type BYTE value(4);
     /* Gradual/Vertical               */
 dcl PAN_STROKE_GRADUAL_HORZ        type BYTE value(5);
     /* Gradual/Horizontal             */
 dcl PAN_STROKE_RAPID_VERT          type BYTE value(6);
     /* Rapid/Vertical                 */
 dcl PAN_STROKE_RAPID_HORZ          type BYTE value(7);
     /* Rapid/Horizontal               */
 dcl PAN_STROKE_INSTANT_VERT        type BYTE value(8);
     /* Instant/Vertical               */

 dcl PAN_STRAIGHT_ARMS_HORZ         type BYTE value(2);
     /* Straight Arms/Horizontal       */
 dcl PAN_STRAIGHT_ARMS_WEDGE        type BYTE value(3);
     /* Straight Arms/Wedge            */
 dcl PAN_STRAIGHT_ARMS_VERT         type BYTE value(4);
     /* Straight Arms/Vertical         */
 dcl PAN_STRAIGHT_ARMS_SINGLE_SERIF type BYTE value(5);
     /* Straight Arms/Single-Serif     */
 dcl PAN_STRAIGHT_ARMS_DOUBLE_SERIF type BYTE value(6);
     /* Straight Arms/Double-Serif     */
 dcl PAN_BENT_ARMS_HORZ             type BYTE value(7);
     /* Non-Straight Arms/Horizontal   */
 dcl PAN_BENT_ARMS_WEDGE            type BYTE value(8);
     /* Non-Straight Arms/Wedge        */
 dcl PAN_BENT_ARMS_VERT             type BYTE value(9);
     /* Non-Straight Arms/Vertical     */
 dcl PAN_BENT_ARMS_SINGLE_SERIF     type BYTE value(10);
     /* Non-Straight Arms/Single-Serif */
 dcl PAN_BENT_ARMS_DOUBLE_SERIF     type BYTE value(11);
     /* Non-Straight Arms/Double-Serif */

 dcl PAN_LETT_NORMAL_CONTACT        type BYTE value(2);
     /* Normal/Contact                 */
 dcl PAN_LETT_NORMAL_WEIGHTED       type BYTE value(3);
     /* Normal/Weighted                */
 dcl PAN_LETT_NORMAL_BOXED          type BYTE value(4);
     /* Normal/Boxed                   */
 dcl PAN_LETT_NORMAL_FLATTENED      type BYTE value(5);
     /* Normal/Flattened               */
 dcl PAN_LETT_NORMAL_ROUNDED        type BYTE value(6);
     /* Normal/Rounded                 */
 dcl PAN_LETT_NORMAL_OFF_CENTER     type BYTE value(7);
     /* Normal/Off Center              */
 dcl PAN_LETT_NORMAL_SQUARE         type BYTE value(8);
     /* Normal/Square                  */
 dcl PAN_LETT_OBLIQUE_CONTACT       type BYTE value(9);
     /* Oblique/Contact                */
 dcl PAN_LETT_OBLIQUE_WEIGHTED      type BYTE value(10);
     /* Oblique/Weighted               */
 dcl PAN_LETT_OBLIQUE_BOXED         type BYTE value(11);
     /* Oblique/Boxed                  */
 dcl PAN_LETT_OBLIQUE_FLATTENED     type BYTE value(12);
     /* Oblique/Flattened              */
 dcl PAN_LETT_OBLIQUE_ROUNDED       type BYTE value(13);
     /* Oblique/Rounded                */
 dcl PAN_LETT_OBLIQUE_OFF_CENTER    type BYTE value(14);
     /* Oblique/Off Center             */
 dcl PAN_LETT_OBLIQUE_SQUARE        type BYTE value(15);
     /* Oblique/Square                 */

 dcl PAN_MIDLINE_STANDARD_TRIMMED   type BYTE value(2);
     /* Standard/Trimmed               */
 dcl PAN_MIDLINE_STANDARD_POINTED   type BYTE value(3);
     /* Standard/Pointed               */
 dcl PAN_MIDLINE_STANDARD_SERIFED   type BYTE value(4);
     /* Standard/Serifed               */
 dcl PAN_MIDLINE_HIGH_TRIMMED       type BYTE value(5);
     /* High/Trimmed                   */
 dcl PAN_MIDLINE_HIGH_POINTED       type BYTE value(6);
     /* High/Pointed                   */
 dcl PAN_MIDLINE_HIGH_SERIFED       type BYTE value(7);
     /* High/Serifed                   */
 dcl PAN_MIDLINE_CONSTANT_TRIMMED   type BYTE value(8);
     /* Constant/Trimmed               */
 dcl PAN_MIDLINE_CONSTANT_POINTED   type BYTE value(9);
     /* Constant/Pointed               */
 dcl PAN_MIDLINE_CONSTANT_SERIFED   type BYTE value(10);
     /* Constant/Serifed               */
 dcl PAN_MIDLINE_LOW_TRIMMED        type BYTE value(11);
     /* Low/Trimmed                    */
 dcl PAN_MIDLINE_LOW_POINTED        type BYTE value(12);
     /* Low/Pointed                    */
 dcl PAN_MIDLINE_LOW_SERIFED        type BYTE value(13);
     /* Low/Serifed                    */

 dcl PAN_XHEIGHT_CONSTANT_SMALL     type BYTE value(2);
     /* Constant/Small                 */
 dcl PAN_XHEIGHT_CONSTANT_STD       type BYTE value(3);
     /* Constant/Standard              */
 dcl PAN_XHEIGHT_CONSTANT_LARGE     type BYTE value(4);
     /* Constant/Large                 */
 dcl PAN_XHEIGHT_DUCKING_SMALL      type BYTE value(5);
     /* Ducking/Small                  */
 dcl PAN_XHEIGHT_DUCKING_STD        type BYTE value(6);
     /* Ducking/Standard               */
 dcl PAN_XHEIGHT_DUCKING_LARGE      type BYTE value(7);
     /* Ducking/Large                  */


 dcl ELF_VENDOR_SIZE fixed bin(31) value(4);

 /* The extended logical font       */
 /* An extension of the ENUMLOGFONT */

 define structure
   1 EXTLOGFONTA,   /* Ducking/Large                  */
     2 elfLogFont   type LOGFONTA,
     2 elfFullName  char(LF_FULLFACESIZE-1) varz,
     2 elfStyle     char(LF_FACESIZE-1) varz,
     2 elfVersion   type DWORD,/* 0 for the first release of NT */
     2 elfStyleSize type DWORD,
     2 elfMatch     type DWORD,
     2 elfReserved  type DWORD,
     2 elfVendorId  char (ELF_VENDOR_SIZE-1) varz,
     2 elfCulture   type DWORD,/* 0 for Latin */
     2 elfPanose    type PANOSE;
 define alias  PEXTLOGFONTA handle EXTLOGFONTA;
 define alias NPEXTLOGFONTA handle EXTLOGFONTA;
 define alias LPEXTLOGFONTA handle EXTLOGFONTA;

 define structure
   1 EXTLOGFONTW,
     2 elfLogFont   type LOGFONTW,
     2 elfFullName  WCHAR(LF_FULLFACESIZE-1) varz,
     2 elfStyle     WCHAR(LF_FACESIZE-1) varz,
     2 elfVersion   type DWORD,/* 0 for the first release of NT */
     2 elfStyleSize type DWORD,
     2 elfMatch     type DWORD,
     2 elfReserved  type DWORD,
     2 elfVendorId  char (ELF_VENDOR_SIZE-1) varz,
     2 elfCulture   type DWORD,/* 0 for Latin */
     2 elfPanose    type PANOSE;
 define alias  PEXTLOGFONTW handle EXTLOGFONTW;
 define alias NPEXTLOGFONTW handle EXTLOGFONTW;
 define alias LPEXTLOGFONTW handle EXTLOGFONTW;

 %if UNICODE ^= '' %then %do;
 define alias   EXTLOGFONT type   EXTLOGFONTW;
 define alias  PEXTLOGFONT type  PEXTLOGFONTW;
 define alias NPEXTLOGFONT type NPEXTLOGFONTW;
 define alias LPEXTLOGFONT type LPEXTLOGFONTW;
 %end; %else %do;
 define alias   EXTLOGFONT type   EXTLOGFONTA;
 define alias  PEXTLOGFONT type  PEXTLOGFONTA;
 define alias NPEXTLOGFONT type NPEXTLOGFONTA;
 define alias LPEXTLOGFONT type LPEXTLOGFONTA;
 %end; /* UNICODE */

 dcl ELF_VERSION       type DWORD value(0);
 dcl ELF_CULTURE_LATIN type DWORD value(0);

 /* EnumFonts Masks */
 dcl RASTER_FONTTYPE   fixed bin(15) value('0001'xn);
 dcl DEVICE_FONTTYPE   fixed bin(15) value('002'xn);
 dcl TRUETYPE_FONTTYPE fixed bin(15) value('004'xn);

 RGB: proc (r,g,b) returns (type COLORREF byvalue)
                   options(inline reorder) internal;
   dcl (r, g, b) type BYTE byvalue;
   dcl (ior, raise2) builtin;
   return (ior (r, raise2 (g, 8), raise2 (b, 16)));
 end RGB;

 PALETTERGB: proc (r,g,b) returns (type COLORREF byvalue)
             options(inline reorder) internal;
   dcl (r, g, b) type BYTE byvalue;
   dcl ior builtin;
   return (ior ('02000000'xu, RGB (r, g, b)));
 end PALETTERGB;

 PALETTEINDEX: proc (i) returns (type COLORREF byvalue)
               options(inline reorder) internal;
   dcl i type WORD byvalue;
   dcl ior builtin;
   return (ior ('01000000'xu, i));
 end  PALETTEINDEX;

 /* palette entry flags */

 dcl PC_RESERVED   fixed bin(15) value('01'xn);
     /* palette index used for animation */
 dcl PC_EXPLICIT   fixed bin(15) value('02'xn);
     /* palette index is explicit to device */
 dcl PC_NOCOLLAPSE fixed bin(15) value('04'xn);
     /* do not match color to system palette */

 GetRValue: proc (rgb) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl rgb type DWORD byvalue;
   dcl ior builtin;
   return (ior (rgb, '000000ff'xn));
 end GetRValue;

 GetGValue: proc (rgb) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl rgb type DWORD byvalue;
   dcl (ior, isrl) builtin;
   return (ior (isrl (rgb, 8), '000000ff'xn));
 end GetGValue;

 GetBValue: proc (rgb) returns (type BYTE byvalue)
            options(inline reorder) internal;
   dcl rgb type DWORD byvalue;
   dcl (ior, isrl) builtin;
   return (ior (isrl (rgb, 16), '000000ff'xn));
 end GetBValue;


 /* Background Modes */
 dcl TRANSPARENT         fixed bin(31) value(1);
 dcl OPAQUE              fixed bin(31) value(2);
 dcl BKMODE_LAST         fixed bin(31) value(2);

 /* Graphics Modes */

 dcl GM_COMPATIBLE       fixed bin(31) value(1);
 dcl GM_ADVANCED         fixed bin(31) value(2);
 dcl GM_LAST             fixed bin(31) value(2);

 /* PolyDraw and GetPath point types */
 dcl PT_CLOSEFIGURE      fixed bin(15) value('01'xn);
 dcl PT_LINETO           fixed bin(15) value('02'xn);
 dcl PT_BEZIERTO         fixed bin(15) value('04'xn);
 dcl PT_MOVETO           fixed bin(15) value('06'xn);

 /* Mapping Modes */
 dcl MM_TEXT             fixed bin(31) value(1);
 dcl MM_LOMETRIC         fixed bin(31) value(2);
 dcl MM_HIMETRIC         fixed bin(31) value(3);
 dcl MM_LOENGLISH        fixed bin(31) value(4);
 dcl MM_HIENGLISH        fixed bin(31) value(5);
 dcl MM_TWIPS            fixed bin(31) value(6);
 dcl MM_ISOTROPIC        fixed bin(31) value(7);
 dcl MM_ANISOTROPIC      fixed bin(31) value(8);

 /* Min and Max Mapping Mode values */
 dcl MM_MIN              fixed bin(31) value(MM_TEXT);
 dcl MM_MAX              fixed bin(31) value(MM_ANISOTROPIC);
 dcl MM_MAX_FIXEDSCALE   fixed bin(31) value(MM_TWIPS);

 /* Coordinate Modes */
 dcl ABSOLUTE            fixed bin(31) value(1);
 dcl RELATIVE            fixed bin(31) value(2);

 /* Stock Logical Objects */
 dcl WHITE_BRUSH         fixed bin(31) value(0);
 dcl LTGRAY_BRUSH        fixed bin(31) value(1);
 dcl GRAY_BRUSH          fixed bin(31) value(2);
 dcl DKGRAY_BRUSH        fixed bin(31) value(3);
 dcl BLACK_BRUSH         fixed bin(31) value(4);
 dcl NULL_BRUSH          fixed bin(31) value(5);
 dcl HOLLOW_BRUSH        fixed bin(31) value(NULL_BRUSH);
 dcl WHITE_PEN           fixed bin(31) value(6);
 dcl BLACK_PEN           fixed bin(31) value(7);
 dcl NULL_PEN            fixed bin(31) value(8);
 dcl OEM_FIXED_FONT      fixed bin(31) value(10);
 dcl ANSI_FIXED_FONT     fixed bin(31) value(11);
 dcl ANSI_VAR_FONT       fixed bin(31) value(12);
 dcl SYSTEM_FONT         fixed bin(31) value(13);
 dcl DEVICE_DEFAULT_FONT fixed bin(31) value(14);
 dcl DEFAULT_PALETTE     fixed bin(31) value(15);
 dcl SYSTEM_FIXED_FONT   fixed bin(31) value(16);


 %if WINVER >= 1024 %then %do;
 dcl DEFAULT_GUI_FONT    fixed bin(31) value(17);
 %end; /* WINVER >= 0x0400 */


 %if #WIN32_WINNT >= 1280 %then %do;
 dcl DC_BRUSH            fixed bin(31) value(18);
 dcl DC_PEN              fixed bin(31) value(19);
 %end;

 %if #WIN32_WINNT >= 1280 %then %do;
 dcl STOCK_LAST          fixed bin(31) value(19);
 %end; %else %if WINVER >= 1024 %then %do;
 dcl STOCK_LAST          fixed bin(31) value(17);
 %end; %else %do;
 dcl STOCK_LAST          fixed bin(31) value(16);
 %end;

 dcl CLR_INVALID         type COLORREF value('FFFFFFFF'xu);

 /* Brush Styles */
 dcl BS_SOLID            fixed bin(31) value(0);
 dcl BS_NULL             fixed bin(31) value(1);
 dcl BS_HOLLOW           fixed bin(31) value(BS_NULL);
 dcl BS_HATCHED          fixed bin(31) value(2);
 dcl BS_PATTERN          fixed bin(31) value(3);
 dcl BS_INDEXED          fixed bin(31) value(4);
 dcl BS_DIBPATTERN       fixed bin(31) value(5);
 dcl BS_DIBPATTERNPT     fixed bin(31) value(6);
 dcl BS_PATTERN8X8       fixed bin(31) value(7);
 dcl BS_DIBPATTERN8X8    fixed bin(31) value(8);
 dcl BS_MONOPATTERN      fixed bin(31) value(9);

 /* Hatch Styles */
 dcl HS_HORIZONTAL       fixed bin(31) value(0); /* ----- */
 dcl HS_VERTICAL         fixed bin(31) value(1); /* ||||| */
 dcl HS_FDIAGONAL        fixed bin(31) value(2); /* \\\\\ */
 dcl HS_BDIAGONAL        fixed bin(31) value(3); /* ///// */
 dcl HS_CROSS            fixed bin(31) value(4); /* +++++ */
 dcl HS_DIAGCROSS        fixed bin(31) value(5); /* xxxxx */

 /* Pen Styles */
 dcl PS_SOLID            fixed bin(31) value(0);
 dcl PS_DASH             fixed bin(31) value(1); /* -------  */
 dcl PS_DOT              fixed bin(31) value(2); /* .......  */
 dcl PS_DASHDOT          fixed bin(31) value(3); /* _._._._  */
 dcl PS_DASHDOTDOT       fixed bin(31) value(4); /* _.._.._  */
 dcl PS_NULL             fixed bin(31) value(5);
 dcl PS_INSIDEFRAME      fixed bin(31) value(6);
 dcl PS_USERSTYLE        fixed bin(31) value(7);
 dcl PS_ALTERNATE        fixed bin(31) value(8);
 dcl PS_STYLE_MASK       fixed bin(31) value('0000000F'xn);

 dcl PS_ENDCAP_ROUND     fixed bin(31) value('00000000'xn);
 dcl PS_ENDCAP_SQUARE    fixed bin(31) value('00000100'xn);
 dcl PS_ENDCAP_FLAT      fixed bin(31) value('00000200'xn);
 dcl PS_ENDCAP_MASK      fixed bin(31) value('00000F00'xn);

 dcl PS_JOIN_ROUND       fixed bin(31) value('00000000'xn);
 dcl PS_JOIN_BEVEL       fixed bin(31) value('00001000'xn);
 dcl PS_JOIN_MITER       fixed bin(31) value('00002000'xn);
 dcl PS_JOIN_MASK        fixed bin(31) value('0000F000'xn);

 dcl PS_COSMETIC         fixed bin(31) value('00000000'xn);
 dcl PS_GEOMETRIC        fixed bin(31) value('00010000'xn);
 dcl PS_TYPE_MASK        fixed bin(31) value('000F0000'xn);

 dcl AD_COUNTERCLOCKWISE fixed bin(31) value(1);
 dcl AD_CLOCKWISE        fixed bin(31) value(2);

     /* Device Parameters for GetDeviceCaps() */
 dcl DRIVERVERSION       fixed bin(31) value(0);
     /* Device driver version                    */
 dcl TECHNOLOGY          fixed bin(31) value(2);
     /* Device classification                    */
 dcl HORZSIZE            fixed bin(31) value(4);
     /* Horizontal size in millimeters           */
 dcl VERTSIZE            fixed bin(31) value(6);
     /* Vertical size in millimeters             */
 dcl HORZRES             fixed bin(31) value(8);
     /* Horizontal width in pixels               */
 dcl VERTRES             fixed bin(31) value(10);
     /* Vertical height in pixels                */
 dcl BITSPIXEL           fixed bin(31) value(12);
     /* Number of bits per pixel                 */
 dcl PLANES              fixed bin(31) value(14);
     /* Number of planes                         */
 dcl NUMBRUSHES          fixed bin(31) value(16);
     /* Number of brushes the device has         */
 dcl NUMPENS             fixed bin(31) value(18);
     /* Number of pens the device has            */
 dcl NUMMARKERS          fixed bin(31) value(20);
     /* Number of markers the device has         */
 dcl NUMFONTS            fixed bin(31) value(22);
     /* Number of fonts the device has           */
 dcl NUMCOLORS           fixed bin(31) value(24);
     /* Number of colors the device supports     */
 dcl PDEVICESIZE         fixed bin(31) value(26);
     /* Size required for device descriptor      */
 dcl CURVECAPS           fixed bin(31) value(28);
     /* Curve capabilities                       */
 dcl LINECAPS            fixed bin(31) value(30);
     /* Line capabilities                        */
 dcl POLYGONALCAPS       fixed bin(31) value(32);
     /* Polygonal capabilities                   */
 dcl TEXTCAPS            fixed bin(31) value(34);
     /* Text capabilities                        */
 dcl CLIPCAPS            fixed bin(31) value(36);
     /* Clipping capabilities                    */
 dcl RASTERCAPS          fixed bin(31) value(38);
     /* Bitblt capabilities                      */
 dcl ASPECTX             fixed bin(31) value(40);
     /* Length of the X leg                      */
 dcl ASPECTY             fixed bin(31) value(42);
     /* Length of the Y leg                      */
 dcl ASPECTXY            fixed bin(31) value(44);
     /* Length of the hypotenuse                 */

 dcl LOGPIXELSX          fixed bin(31) value(88);
     /* Logical pixels/inch in X                 */
 dcl LOGPIXELSY          fixed bin(31) value(90);
     /* Logical pixels/inch in Y                 */

 dcl SIZEPALETTE         fixed bin(31) value(104);
     /* Number of entries in physical palette    */
 dcl NUMRESERVED         fixed bin(31) value(106);
     /* Number of reserved entries in palette    */
 dcl COLORRES            fixed bin(31) value(108);
     /* Actual color resolution                  */


 /* Printing related DeviceCaps. These replace the appropriate Escapes*/

 dcl PHYSICALWIDTH       fixed bin(31) value(110);
     /* Physical Width in device units           */
 dcl PHYSICALHEIGHT      fixed bin(31) value(111);
     /* Physical Height in device units          */
 dcl PHYSICALOFFSETX     fixed bin(31) value(112);
     /* Physical Printable Area x margin         */
 dcl PHYSICALOFFSETY     fixed bin(31) value(113);
     /* Physical Printable Area y margin         */
 dcl SCALINGFACTORX      fixed bin(31) value(114);
     /* Scaling factor x                         */
 dcl SCALINGFACTORY      fixed bin(31) value(115);
     /* Scaling factor y                         */

 /* Display driver specific */

 dcl VREFRESH            fixed bin(31) value(116);
     /* Current vertical refresh rate of the    */
     /* display device (for displays only) in Hz*/
 dcl DESKTOPVERTRES      fixed bin(31) value(117);
     /* Horizontal width of entire desktop in pixels */
 dcl DESKTOPHORZRES      fixed bin(31) value(118);
     /* Vertical height of entire desktop in pixels */
 dcl BLTALIGNMENT        fixed bin(31) value(119);
     /* Preferred blt alignment                 */

 %if WINVER >= 1280 %then %do;
 dcl SHADEBLENDCAPS      fixed bin(31) value(120);
     /* Shading and blending caps               */
 dcl COLORMGMTCAPS       fixed bin(31) value(121);
     /* Color Management caps                   */
 %end; /* WINVER >= 0x0500 */

 %dcl NOGDICAPMASKS char ext;
 %if NOGDICAPMASKS = '' %then %do;

 /* Device Capability Masks: */

 /* Device Technologies */
 dcl DT_PLOTTER          fixed bin(31) value(0);
     /* Vector plotter                   */
 dcl DT_RASDISPLAY       fixed bin(31) value(1);
     /* Raster display                   */
 dcl DT_RASPRINTER       fixed bin(31) value(2);
     /* Raster printer                   */
 dcl DT_RASCAMERA        fixed bin(31) value(3);
     /* Raster camera                    */
 dcl DT_CHARSTREAM       fixed bin(31) value(4);
     /* Character-stream, PLP            */
 dcl DT_METAFILE         fixed bin(31) value(5);
     /* Metafile, VDM                    */
 dcl DT_DISPFILE         fixed bin(31) value(6);
     /* Display-file                     */

 /* Curve Capabilities */
 dcl CC_NONE             fixed bin(31) value(0);
     /* Curves not supported             */
 dcl CC_CIRCLES          fixed bin(31) value(1);
     /* Can do circles                   */
 dcl CC_PIE              fixed bin(31) value(2);
     /* Can do pie wedges                */
 dcl CC_CHORD            fixed bin(31) value(4);
     /* Can do chord arcs                */
 dcl CC_ELLIPSES         fixed bin(31) value(8);
     /* Can do ellipese                  */
 dcl CC_WIDE             fixed bin(31) value(16);
     /* Can do wide lines                */
 dcl CC_STYLED           fixed bin(31) value(32);
     /* Can do styled lines              */
 dcl CC_WIDESTYLED       fixed bin(31) value(64);
     /* Can do wide styled lines         */
 dcl CC_INTERIORS        fixed bin(31) value(128);
     /* Can do interiors                 */
 dcl CC_ROUNDRECT        fixed bin(31) value(256);

 /* Line Capabilities */
 dcl LC_NONE             fixed bin(31) value(0);
     /* Lines not supported              */
 dcl LC_POLYLINE         fixed bin(31) value(2);
     /* Can do polylines                 */
 dcl LC_MARKER           fixed bin(31) value(4);
     /* Can do markers                   */
 dcl LC_POLYMARKER       fixed bin(31) value(8);
     /* Can do polymarkers               */
 dcl LC_WIDE             fixed bin(31) value(16);
     /* Can do wide lines                */
 dcl LC_STYLED           fixed bin(31) value(32);
     /* Can do styled lines              */
 dcl LC_WIDESTYLED       fixed bin(31) value(64);
     /* Can do wide styled lines         */
 dcl LC_INTERIORS        fixed bin(31) value(128);
     /* Can do interiors                 */

 /* Polygonal Capabilities */
 dcl PC_NONE             fixed bin(31) value(0);
     /* Polygonals not supported         */
 dcl PC_POLYGON          fixed bin(31) value(1);
     /* Can do polygons                  */
 dcl PC_RECTANGLE        fixed bin(31) value(2);
     /* Can do rectangles                */
 dcl PC_WINDPOLYGON      fixed bin(31) value(4);
     /* Can do winding polygons          */
 dcl PC_TRAPEZOID        fixed bin(31) value(4);
     /* Can do trapezoids                */
 dcl PC_SCANLINE         fixed bin(31) value(8);
     /* Can do scanlines                 */
 dcl PC_WIDE             fixed bin(31) value(16);
     /* Can do wide borders              */
 dcl PC_STYLED           fixed bin(31) value(32);
     /* Can do styled borders            */
 dcl PC_WIDESTYLED       fixed bin(31) value(64);
     /* Can do wide styled borders       */
 dcl PC_INTERIORS        fixed bin(31) value(128);
     /* Can do interiors                 */
 dcl PC_POLYPOLYGON      fixed bin(31) value(256);
     /* Can do polypolygons              */
 dcl PC_PATHS            fixed bin(31) value(512);
     /* Can do paths                     */

 /* Clipping Capabilities */
 dcl CP_NONE             fixed bin(31) value(0);
     /* No clipping of output            */
 dcl CP_RECTANGLE        fixed bin(31) value(1);
     /* Output clipped to rects          */
 dcl CP_REGION           fixed bin(31) value(2);
     /* obsolete                         */

 /* Text Capabilities */
 dcl TC_OP_CHARACTER     fixed bin(31) value('00000001'xn);
     /* Can do OutputPrecision   CHARACTER      */
 dcl TC_OP_STROKE        fixed bin(31) value('00000002'xn);
     /* Can do OutputPrecision   STROKE         */
 dcl TC_CP_STROKE        fixed bin(31) value('00000004'xn);
     /* Can do ClipPrecision     STROKE         */
 dcl TC_CR_90            fixed bin(31) value('00000008'xn);
     /* Can do CharRotAbility    90             */
 dcl TC_CR_ANY           fixed bin(31) value('00000010'xn);
     /* Can do CharRotAbility    ANY            */
 dcl TC_SF_X_YINDEP      fixed bin(31) value('00000020'xn);
     /* Can do ScaleFreedom      X_YINDEPENDENT */
 dcl TC_SA_DOUBLE        fixed bin(31) value('00000040'xn);
     /* Can do ScaleAbility      DOUBLE         */
 dcl TC_SA_INTEGER       fixed bin(31) value('00000080'xn);
     /* Can do ScaleAbility      INTEGER        */
 dcl TC_SA_CONTIN        fixed bin(31) value('00000100'xn);
     /* Can do ScaleAbility      CONTINUOUS     */
 dcl TC_EA_DOUBLE        fixed bin(31) value('00000200'xn);
     /* Can do EmboldenAbility   DOUBLE         */
 dcl TC_IA_ABLE          fixed bin(31) value('00000400'xn);
     /* Can do ItalisizeAbility  ABLE           */
 dcl TC_UA_ABLE          fixed bin(31) value('00000800'xn);
     /* Can do UnderlineAbility  ABLE           */
 dcl TC_SO_ABLE          fixed bin(31) value('00001000'xn);
     /* Can do StrikeOutAbility  ABLE           */
 dcl TC_RA_ABLE          fixed bin(31) value('00002000'xn);
     /* Can do RasterFontAble    ABLE           */
 dcl TC_VA_ABLE          fixed bin(31) value('00004000'xn);
     /* Can do VectorFontAble    ABLE           */
 dcl TC_RESERVED         fixed bin(31) value('00008000'xn);
 dcl TC_SCROLLBLT        fixed bin(31) value('00010000'xn);
     /* Don't do text scroll with blt           */

 %end; /* NOGDICAPMASKS */

 /* Raster Capabilities */
 dcl RC_NONE             fixed bin(31) value(0); /* no value in C */
 dcl RC_BITBLT           fixed bin(31) value(1);
     /* Can do standard BLT.             */
 dcl RC_BANDING          fixed bin(31) value(2);
     /* Device requires banding support  */
 dcl RC_SCALING          fixed bin(31) value(4);
     /* Device requires scaling support  */
 dcl RC_BITMAP64         fixed bin(31) value(8);
     /* Device can support >64K bitmap   */
 dcl RC_GDI20_OUTPUT     fixed bin(31) value('0010'xn);
     /* has 2.0 output calls         */
 dcl RC_GDI20_STATE      fixed bin(31) value('0020'xn);
 dcl RC_SAVEBITMAP       fixed bin(31) value('0040'xn);
 dcl RC_DI_BITMAP        fixed bin(31) value('0080'xn);
     /* supports DIB to memory       */
 dcl RC_PALETTE          fixed bin(31) value('0100'xn);
     /* supports a palette           */
 dcl RC_DIBTODEV         fixed bin(31) value('0200'xn);
     /* supports DIBitsToDevice      */
 dcl RC_BIGFONT          fixed bin(31) value('0400'xn);
     /* supports >64K fonts          */
 dcl RC_STRETCHBLT       fixed bin(31) value('0800'xn);
     /* supports StretchBlt          */
 dcl RC_FLOODFILL        fixed bin(31) value('1000'xn);
     /* supports FloodFill           */
 dcl RC_STRETCHDIB       fixed bin(31) value('2000'xn);
     /* supports StretchDIBits       */
 dcl RC_OP_DX_OUTPUT     fixed bin(31) value('4000'xn);
 dcl RC_DEVBITS          fixed bin(31) value('8000'xn);


 %if WINVER >= 1280 %then %do;
 /* Shading and blending caps                */
 dcl SB_NONE             fixed bin(31) value('00000000'xn);
 dcl SB_CONST_ALPHA      fixed bin(31) value('00000001'xn);
 dcl SB_PIXEL_ALPHA      fixed bin(31) value('00000002'xn);
 dcl SB_PREMULT_ALPHA    fixed bin(31) value('00000004'xn);

 dcl SB_GRAD_RECT        fixed bin(31) value('00000010'xn);
 dcl SB_GRAD_TRI         fixed bin(31) value('00000020'xn);

 /* Color Management caps */
 %dcl #CM_NONE char ext;
 %if #CM_NONE = '' %then %do;
 %#CM_NONE = 'Y';
 /* Potential name clash with WinCPIC, but both have same value */
 dcl CM_NONE             fixed bin(31) value('00000000'xn);
 %end;
 dcl CM_DEVICE_ICM       fixed bin(31) value('00000001'xn);
 dcl CM_GAMMA_RAMP       fixed bin(31) value('00000002'xn);
 dcl CM_CMYK_COLOR       fixed bin(31) value('00000004'xn);
 %end; /* WINVER >= 0x0500 */


 /* DIB color table identifiers */

 dcl DIB_RGB_COLORS      fixed bin(31) value(0);
     /* color table in RGBs */
 dcl DIB_PAL_COLORS      fixed bin(31) value(1);
     /* color table in palette indices */

 /* constants for Get/SetSystemPaletteUse() */

 dcl SYSPAL_ERROR        fixed bin(31) value(0);
 dcl SYSPAL_STATIC       fixed bin(31) value(1);
 dcl SYSPAL_NOSTATIC     fixed bin(31) value(2);
 dcl SYSPAL_NOSTATIC256  fixed bin(31) value(3);

 /* constants for CreateDIBitmap */
 dcl CBM_INIT            fixed bin(31) value('04'xn);
     /* initialize bitmap */

 /* ExtFloodFill style flags */
 dcl FLOODFILLBORDER     fixed bin(31) value(0);
 dcl FLOODFILLSURFACE    fixed bin(31) value(1);

 /* size of a device name string */
 %dcl CCHDEVICENAME_DEFINED char ext;
 %if CCHDEVICENAME_DEFINED = '' %then %do;
 %CCHDEVICENAME_DEFINED = 'Y';
 dcl CCHDEVICENAME       fixed bin(31) value(32);
 %end;

 /* size of a form name string */
 dcl CCHFORMNAME         fixed bin(31) value(32);


 define structure
   1 #devicemodeA,
     2 dmDeviceName       char(CCHDEVICENAME-1) varz,
     2 dmSpecVersion      type WORD,
     2 dmDriverVersion    type WORD,
     2 dmSize             type WORD,
     2 dmDriverExtra      type WORD,
     2 dmFields           type DWORD,
     2 * union,
       3 *,
         4 dmOrientation  fixed bin(15),
         4 dmPaperSize    fixed bin(15),
         4 dmPaperLength  fixed bin(15),
         4 dmPaperWidth   fixed bin(15),
       3 dmPosition       type POINTL,
     2 dmScale            fixed bin(15),
     2 dmCopies           fixed bin(15),
     2 dmDefaultSource    fixed bin(15),
     2 dmPrintQuality     fixed bin(15),
     2 dmColor            fixed bin(15),
     2 dmDuplex           fixed bin(15),
     2 dmYResolution      fixed bin(15),
     2 dmTTOption         fixed bin(15),
     2 dmCollate          fixed bin(15),
     2 dmFormName         char(CCHFORMNAME-1) varz,
     2 dmLogPixels        type WORD,
     2 dmBitsPerPel       type DWORD,
     2 dmPelsWidth        type DWORD,
     2 dmPelsHeight       type DWORD,
     2 dmDisplayFlags     type DWORD,
     2 dmDisplayFrequency type DWORD
 %if WINVER >= 1024 %then %do;
   , 2 dmICMMethod        type DWORD,
     2 dmICMIntent        type DWORD,
     2 dmMediaType        type DWORD,
     2 dmDitherType       type DWORD,
     2 dmReserved1        type DWORD,
     2 dmReserved2        type DWORD
 %if WINVER >= 1280 | #WIN32_WINNT >= 1024 %then %do;
   , 2 dmPanningWidth     type DWORD,
     2 dmPanningHeight    type DWORD
 %end;
 %end;/* WINVER >= 0x0400 */
   ;
 define alias   DEVMODEA type   #devicemodeA;
 define alias  PDEVMODEA handle #devicemodeA;
 define alias NPDEVMODEA handle #devicemodeA;
 define alias LPDEVMODEA handle #devicemodeA;

 define structure
   1 #devicemodeW,
     2 dmDeviceName       WCHAR(CCHDEVICENAME-1) varz,
     2 dmSpecVersion      type WORD,
     2 dmDriverVersion    type WORD,
     2 dmSize             type WORD,
     2 dmDriverExtra      type WORD,
     2 dmFields           type DWORD,
     2 * union,
       3 *,
         4 dmOrientation  fixed bin(15),
         4 dmPaperSize    fixed bin(15),
         4 dmPaperLength  fixed bin(15),
         4 dmPaperWidth   fixed bin(15),
       3 dmPosition       type POINTL,
     2 dmScale            fixed bin(15),
     2 dmCopies           fixed bin(15),
     2 dmDefaultSource    fixed bin(15),
     2 dmPrintQuality     fixed bin(15),
     2 dmColor            fixed bin(15),
     2 dmDuplex           fixed bin(15),
     2 dmYResolution      fixed bin(15),
     2 dmTTOption         fixed bin(15),
     2 dmCollate          fixed bin(15),
     2 dmFormName         WCHAR(CCHFORMNAME-1) varz,
     2 dmLogPixels        type WORD,
     2 dmBitsPerPel       type DWORD,
     2 dmPelsWidth        type DWORD,
     2 dmPelsHeight       type DWORD,
     2 dmDisplayFlags     type DWORD,
     2 dmDisplayFrequency type DWORD
 %if WINVER >= 1024 %then %do;
   , 2 dmICMMethod        type DWORD,
     2 dmICMIntent        type DWORD,
     2 dmMediaType        type DWORD,
     2 dmDitherType       type DWORD,
     2 dmReserved1        type DWORD,
     2 dmReserved2        type DWORD
 %if WINVER >= 1280 | #WIN32_WINNT >= 1024 %then %do;
   , 2 dmPanningWidth     type DWORD,
     2 dmPanningHeight    type DWORD
 %end;
 %end;/* WINVER >= 0x0400 */
   ;
 define alias   DEVMODEW type   #devicemodeW;
 define alias  PDEVMODEW handle #devicemodeW;
 define alias NPDEVMODEW handle #devicemodeW;
 define alias LPDEVMODEW handle #devicemodeW;

 %if UNICODE ^= '' %then %do;
 define alias   DEVMODE type DEVMODEW;
 define alias  PDEVMODE type PDEVMODEW;
 define alias NPDEVMODE type NPDEVMODEW;
 define alias LPDEVMODE type LPDEVMODEW;
 %end; %else %do;
 define alias   DEVMODE type DEVMODEA;
 define alias  PDEVMODE type PDEVMODEA;
 define alias NPDEVMODE type NPDEVMODEA;
 define alias LPDEVMODE type LPDEVMODEA;
 %end; /* UNICODE */

 /* current version of specification */
 %if WINVER >= 1280 | #WIN32_WINNT >= 1024 %then %do;
 dcl DM_SPECVERSION fixed bin(15) value('0401'xn);
 %end; %else %if WINVER >= 1024 %then %do;
 dcl DM_SPECVERSION fixed bin(15) value('0400'xn);
 %end; %else %do;
 dcl DM_SPECVERSION fixed bin(15) value('0320'xn);
 %end; /* WINVER */

 /* field selection bits */
 dcl DM_ORIENTATION                   type DWORD value('00000001'xu);
 dcl DM_PAPERSIZE                     type DWORD value('00000002'xu);
 dcl DM_PAPERLENGTH                   type DWORD value('00000004'xu);
 dcl DM_PAPERWIDTH                    type DWORD value('00000008'xu);
 dcl DM_SCALE                         type DWORD value('00000010'xu);

 %if WINVER >= 1280 %then %do;
 dcl DM_POSITION                      type DWORD value('00000020'xu);
 dcl DM_NUP                           type DWORD value('00000040'xu);
 %end; /* WINVER >= 0x0500 */
 dcl DM_COPIES                        type DWORD value('00000100'xu);
 dcl DM_DEFAULTSOURCE                 type DWORD value('00000200'xu);
 dcl DM_PRINTQUALITY                  type DWORD value('00000400'xu);
 dcl DM_COLOR                         type DWORD value('00000800'xu);
 dcl DM_DUPLEX                        type DWORD value('00001000'xu);
 dcl DM_YRESOLUTION                   type DWORD value('00002000'xu);
 dcl DM_TTOPTION                      type DWORD value('00004000'xu);
 dcl DM_COLLATE                       type DWORD value('00008000'xu);
 dcl DM_FORMNAME                      type DWORD value('00010000'xu);
 dcl DM_LOGPIXELS                     type DWORD value('00020000'xu);
 dcl DM_BITSPERPEL                    type DWORD value('00040000'xu);
 dcl DM_PELSWIDTH                     type DWORD value('00080000'xu);
 dcl DM_PELSHEIGHT                    type DWORD value('00100000'xu);
 dcl DM_DISPLAYFLAGS                  type DWORD value('00200000'xu);
 dcl DM_DISPLAYFREQUENCY              type DWORD value('00400000'xu);

 %if WINVER >= 1024 %then %do;
 dcl DM_ICMMETHOD                     type DWORD value('00800000'xu);
 dcl DM_ICMINTENT                     type DWORD value('01000000'xu);
 dcl DM_MEDIATYPE                     type DWORD value('02000000'xu);
 dcl DM_DITHERTYPE                    type DWORD value('04000000'xu);
 dcl DM_PANNINGWIDTH                  type DWORD value('08000000'xu);
 dcl DM_PANNINGHEIGHT                 type DWORD value('10000000'xu);
 %end; /* WINVER >= 0x0400 */

 /* orientation selections */
 dcl DMORIENT_PORTRAIT                fixed bin(15) value(1);
 dcl DMORIENT_LANDSCAPE               fixed bin(15) value(2);

     /* paper selections */
 dcl DMPAPER_LETTER                   fixed bin(15) value(1);
     /* Letter 8 1/2 x 11 in               */
 dcl DMPAPER_LETTERSMALL              fixed bin(15) value(2);
     /* Letter Small 8 1/2 x 11 in         */
 dcl DMPAPER_TABLOID                  fixed bin(15) value(3);
     /* Tabloid 11 x 17 in                 */
 dcl DMPAPER_LEDGER                   fixed bin(15) value(4);
     /* Ledger 17 x 11 in                  */
 dcl DMPAPER_LEGAL                    fixed bin(15) value(5);
     /* Legal 8 1/2 x 14 in                */
 dcl DMPAPER_STATEMENT                fixed bin(15) value(6);
     /* Statement 5 1/2 x 8 1/2 in         */
 dcl DMPAPER_EXECUTIVE                fixed bin(15) value(7);
     /* Executive 7 1/4 x 10 1/2 in        */
 dcl DMPAPER_A3                       fixed bin(15) value(8);
     /* A3 297 x 420 mm                    */
 dcl DMPAPER_A4                       fixed bin(15) value(9);
     /* A4 210 x 297 mm                    */
 dcl DMPAPER_A4SMALL                  fixed bin(15) value(10);
     /* A4 Small 210 x 297 mm              */
 dcl DMPAPER_A5                       fixed bin(15) value(11);
     /* A5 148 x 210 mm                    */
 dcl DMPAPER_B4                       fixed bin(15) value(12);
     /* B4 (JIS) 250 x 354                 */
 dcl DMPAPER_B5                       fixed bin(15) value(13);
     /* B5 (JIS) 182 x 257 mm              */
 dcl DMPAPER_FOLIO                    fixed bin(15) value(14);
     /* Folio 8 1/2 x 13 in                */
 dcl DMPAPER_QUARTO                   fixed bin(15) value(15);
     /* Quarto 215 x 275 mm                */
 dcl DMPAPER_10X14                    fixed bin(15) value(16);
     /* 10x14 in                           */
 dcl DMPAPER_11X17                    fixed bin(15) value(17);
     /* 11x17 in                           */
 dcl DMPAPER_NOTE                     fixed bin(15) value(18);
     /* Note 8 1/2 x 11 in                 */
 dcl DMPAPER_ENV_9                    fixed bin(15) value(19);
     /* Envelope #9 3 7/8 x 8 7/8          */
 dcl DMPAPER_ENV_10                   fixed bin(15) value(20);
     /* Envelope #10 4 1/8 x 9 1/2         */
 dcl DMPAPER_ENV_11                   fixed bin(15) value(21);
     /* Envelope #11 4 1/2 x 10 3/8        */
 dcl DMPAPER_ENV_12                   fixed bin(15) value(22);
     /* Envelope #12 4 \276 x 11           */
 dcl DMPAPER_ENV_14                   fixed bin(15) value(23);
     /* Envelope #14 5 x 11 1/2            */
 dcl DMPAPER_CSHEET                   fixed bin(15) value(24);
     /* C size sheet                       */
 dcl DMPAPER_DSHEET                   fixed bin(15) value(25);
     /* D size sheet                       */
 dcl DMPAPER_ESHEET                   fixed bin(15) value(26);
     /* E size sheet                       */
 dcl DMPAPER_ENV_DL                   fixed bin(15) value(27);
     /* Envelope DL 110 x 220mm            */
 dcl DMPAPER_ENV_C5                   fixed bin(15) value(28);
     /* Envelope C5 162 x 229 mm           */
 dcl DMPAPER_ENV_C3                   fixed bin(15) value(29);
     /* Envelope C3  324 x 458 mm          */
 dcl DMPAPER_ENV_C4                   fixed bin(15) value(30);
     /* Envelope C4  229 x 324 mm          */
 dcl DMPAPER_ENV_C6                   fixed bin(15) value(31);
     /* Envelope C6  114 x 162 mm          */
 dcl DMPAPER_ENV_C65                  fixed bin(15) value(32);
     /* Envelope C65 114 x 229 mm          */
 dcl DMPAPER_ENV_B4                   fixed bin(15) value(33);
     /* Envelope B4  250 x 353 mm          */
 dcl DMPAPER_ENV_B5                   fixed bin(15) value(34);
     /* Envelope B5  176 x 250 mm          */
 dcl DMPAPER_ENV_B6                   fixed bin(15) value(35);
     /* Envelope B6  176 x 125 mm          */
 dcl DMPAPER_ENV_ITALY                fixed bin(15) value(36);
     /* Envelope 110 x 230 mm              */
 dcl DMPAPER_ENV_MONARCH              fixed bin(15) value(37);
     /* Envelope Monarch 3.875 x 7.5 in    */
 dcl DMPAPER_ENV_PERSONAL             fixed bin(15) value(38);
     /* 6 3/4 Envelope 3 5/8 x 6 1/2 in    */
 dcl DMPAPER_FANFOLD_US               fixed bin(15) value(39);
     /* US Std Fanfold 14 7/8 x 11 in      */
 dcl DMPAPER_FANFOLD_STD_GERMAN       fixed bin(15) value(40);
     /* German Std Fanfold 8 1/2 x 12 in   */
 dcl DMPAPER_FANFOLD_LGL_GERMAN       fixed bin(15) value(41);
     /* German Legal Fanfold 8 1/2 x 13 in */

 %if WINVER >= 1024 %then %do;
 dcl DMPAPER_ISO_B4                   fixed bin(15) value(42);
     /* B4 (ISO) 250 x 353 mm              */
 dcl DMPAPER_JAPANESE_POSTCARD        fixed bin(15) value(43);
     /* Japanese Postcard 100 x 148 mm     */
 dcl DMPAPER_9X11                     fixed bin(15) value(44);
     /* 9 x 11 in                          */
 dcl DMPAPER_10X11                    fixed bin(15) value(45);
     /* 10 x 11 in                         */
 dcl DMPAPER_15X11                    fixed bin(15) value(46);
     /* 15 x 11 in                         */
 dcl DMPAPER_ENV_INVITE               fixed bin(15) value(47);
     /* Envelope Invite 220 x 220 mm       */
 dcl DMPAPER_RESERVED_48              fixed bin(15) value(48);
     /* RESERVED--DO NOT USE               */
 dcl DMPAPER_RESERVED_49              fixed bin(15) value(49);
     /* RESERVED--DO NOT USE               */
 dcl DMPAPER_LETTER_EXTRA             fixed bin(15) value(50);
     /* Letter Extra 9 \275 x 12 in        */
 dcl DMPAPER_LEGAL_EXTRA              fixed bin(15) value(51);
     /* Legal Extra 9 \275 x 15 in         */
 dcl DMPAPER_TABLOID_EXTRA            fixed bin(15) value(52);
     /* Tabloid Extra 11.69 x 18 in        */
 dcl DMPAPER_A4_EXTRA                 fixed bin(15) value(53);
     /* A4 Extra 9.27 x 12.69 in           */
 dcl DMPAPER_LETTER_TRANSVERSE        fixed bin(15) value(54);
     /* Letter Transverse 8 \275 x 11 in   */
 dcl DMPAPER_A4_TRANSVERSE            fixed bin(15) value(55);
     /* A4 Transverse 210 x 297 mm         */
 dcl DMPAPER_LETTER_EXTRA_TRANSVERSE  fixed bin(15) value(56);
     /* Letter Extra Transverse 9\275 x 12 in */
 dcl DMPAPER_A_PLUS                   fixed bin(15) value(57);
     /* SuperA/SuperA/A4 227 x 356 mm      */
 dcl DMPAPER_B_PLUS                   fixed bin(15) value(58);
     /* SuperB/SuperB/A3 305 x 487 mm      */
 dcl DMPAPER_LETTER_PLUS              fixed bin(15) value(59);
     /* Letter Plus 8.5 x 12.69 in         */
 dcl DMPAPER_A4_PLUS                  fixed bin(15) value(60);
     /* A4 Plus 210 x 330 mm               */
 dcl DMPAPER_A5_TRANSVERSE            fixed bin(15) value(61);
     /* A5 Transverse 148 x 210 mm         */
 dcl DMPAPER_B5_TRANSVERSE            fixed bin(15) value(62);
     /* B5 (JIS) Transverse 182 x 257 mm   */
 dcl DMPAPER_A3_EXTRA                 fixed bin(15) value(63);
     /* A3 Extra 322 x 445 mm              */
 dcl DMPAPER_A5_EXTRA                 fixed bin(15) value(64);
     /* A5 Extra 174 x 235 mm              */
 dcl DMPAPER_B5_EXTRA                 fixed bin(15) value(65);
     /* B5 (ISO) Extra 201 x 276 mm        */
 dcl DMPAPER_A2                       fixed bin(15) value(66);
     /* A2 420 x 594 mm                    */
 dcl DMPAPER_A3_TRANSVERSE            fixed bin(15) value(67);
     /* A3 Transverse 297 x 420 mm         */
 dcl DMPAPER_A3_EXTRA_TRANSVERSE      fixed bin(15) value(68);
     /* A3 Extra Transverse 322 x 445 mm   */
 %end; /* WINVER >= 0x0400 */


 %if WINVER >= 1280 %then %do;
 dcl DMPAPER_DBL_JAPANESE_POSTCARD    fixed bin(15) value(69);
     /* Japanese Double Postcard 200 x 148 mm */
 dcl DMPAPER_A6                       fixed bin(15) value(70);
     /* A6 105 x 148 mm                 */
 dcl DMPAPER_JENV_KAKU2               fixed bin(15) value(71);
     /* Japanese Envelope Kaku #2       */
 dcl DMPAPER_JENV_KAKU3               fixed bin(15) value(72);
     /* Japanese Envelope Kaku #3       */
 dcl DMPAPER_JENV_CHOU3               fixed bin(15) value(73);
     /* Japanese Envelope Chou #3       */
 dcl DMPAPER_JENV_CHOU4               fixed bin(15) value(74);
     /* Japanese Envelope Chou #4       */
 dcl DMPAPER_LETTER_ROTATED           fixed bin(15) value(75);
     /* Letter Rotated 11 x 8 1/2 11 in */
 dcl DMPAPER_A3_ROTATED               fixed bin(15) value(76);
     /* A3 Rotated 420 x 297 mm         */
 dcl DMPAPER_A4_ROTATED               fixed bin(15) value(77);
     /* A4 Rotated 297 x 210 mm         */
 dcl DMPAPER_A5_ROTATED               fixed bin(15) value(78);
     /* A5 Rotated 210 x 148 mm         */
 dcl DMPAPER_B4_JIS_ROTATED           fixed bin(15) value(79);
     /* B4 (JIS) Rotated 364 x 257 mm   */
 dcl DMPAPER_B5_JIS_ROTATED           fixed bin(15) value(80);
     /* B5 (JIS) Rotated 257 x 182 mm   */
 dcl DMPAPER_JAPANESE_POSTCARD_ROTATED fixed bin(15) value(81);
     /* Japanese Postcard Rotated 148 x 100 mm */
 dcl DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED fixed bin(15) value(82);
     /* Double Japanese Postcard Rotated 148 x 200 mm */
 dcl DMPAPER_A6_ROTATED               fixed bin(15) value(83);
     /* A6 Rotated 148 x 105 mm         */
 dcl DMPAPER_JENV_KAKU2_ROTATED       fixed bin(15) value(84);
     /* Japanese Envelope Kaku #2 Rotated */
 dcl DMPAPER_JENV_KAKU3_ROTATED       fixed bin(15) value(85);
     /* Japanese Envelope Kaku #3 Rotated */
 dcl DMPAPER_JENV_CHOU3_ROTATED       fixed bin(15) value(86);
     /* Japanese Envelope Chou #3 Rotated */
 dcl DMPAPER_JENV_CHOU4_ROTATED       fixed bin(15) value(87);
     /* Japanese Envelope Chou #4 Rotated */
 dcl DMPAPER_B6_JIS                   fixed bin(15) value(88);
     /* B6 (JIS) 128 x 182 mm           */
 dcl DMPAPER_B6_JIS_ROTATED           fixed bin(15) value(89);
     /* B6 (JIS) Rotated 182 x 128 mm   */
 dcl DMPAPER_12X11                    fixed bin(15) value(90);
     /* 12 x 11 in                      */
 dcl DMPAPER_JENV_YOU4                fixed bin(15) value(91);
     /* Japanese Envelope You #4        */
 dcl DMPAPER_JENV_YOU4_ROTATED        fixed bin(15) value(92);
     /* Japanese Envelope You #4 Rotated*/
 dcl DMPAPER_P16K                     fixed bin(15) value(93);
     /* PRC 16K 146 x 215 mm            */
 dcl DMPAPER_P32K                     fixed bin(15) value(94);
     /* PRC 32K 97 x 151 mm             */
 dcl DMPAPER_P32KBIG                  fixed bin(15) value(95);
     /* PRC 32K(Big) 97 x 151 mm        */
 dcl DMPAPER_PENV_1                   fixed bin(15) value(96);
     /* PRC Envelope #1 102 x 165 mm    */
 dcl DMPAPER_PENV_2                   fixed bin(15) value(97);
     /* PRC Envelope #2 102 x 176 mm    */
 dcl DMPAPER_PENV_3                   fixed bin(15) value(98);
     /* PRC Envelope #3 125 x 176 mm    */
 dcl DMPAPER_PENV_4                   fixed bin(15) value(99);
     /* PRC Envelope #4 110 x 208 mm    */
 dcl DMPAPER_PENV_5                   fixed bin(15) value(100);
     /* PRC Envelope #5 110 x 220 mm    */
 dcl DMPAPER_PENV_6                   fixed bin(15) value(101);
     /* PRC Envelope #6 120 x 230 mm    */
 dcl DMPAPER_PENV_7                   fixed bin(15) value(102);
     /* PRC Envelope #7 160 x 230 mm    */
 dcl DMPAPER_PENV_8                   fixed bin(15) value(103);
     /* PRC Envelope #8 120 x 309 mm    */
 dcl DMPAPER_PENV_9                   fixed bin(15) value(104);
     /* PRC Envelope #9 229 x 324 mm    */
 dcl DMPAPER_PENV_10                  fixed bin(15) value(105);
     /* PRC Envelope #10 324 x 458 mm   */
 dcl DMPAPER_P16K_ROTATED             fixed bin(15) value(106);
     /* PRC 16K Rotated                 */
 dcl DMPAPER_P32K_ROTATED             fixed bin(15) value(107);
     /* PRC 32K Rotated                 */
 dcl DMPAPER_P32KBIG_ROTATED          fixed bin(15) value(108);
     /* PRC 32K(Big) Rotated            */
 dcl DMPAPER_PENV_1_ROTATED           fixed bin(15) value(109);
     /* PRC Envelope #1 Rotated 165 x 102 mm */
 dcl DMPAPER_PENV_2_ROTATED           fixed bin(15) value(110);
     /* PRC Envelope #2 Rotated 176 x 102 mm */
 dcl DMPAPER_PENV_3_ROTATED           fixed bin(15) value(111);
     /* PRC Envelope #3 Rotated 176 x 125 mm */
 dcl DMPAPER_PENV_4_ROTATED           fixed bin(15) value(112);
     /* PRC Envelope #4 Rotated 208 x 110 mm */
 dcl DMPAPER_PENV_5_ROTATED           fixed bin(15) value(113);
     /* PRC Envelope #5 Rotated 220 x 110 mm */
 dcl DMPAPER_PENV_6_ROTATED           fixed bin(15) value(114);
     /* PRC Envelope #6 Rotated 230 x 120 mm */
 dcl DMPAPER_PENV_7_ROTATED           fixed bin(15) value(115);
     /* PRC Envelope #7 Rotated 230 x 160 mm */
 dcl DMPAPER_PENV_8_ROTATED           fixed bin(15) value(116);
     /* PRC Envelope #8 Rotated 309 x 120 mm */
 dcl DMPAPER_PENV_9_ROTATED           fixed bin(15) value(117);
     /* PRC Envelope #9 Rotated 324 x 229 mm */
 dcl DMPAPER_PENV_10_ROTATED          fixed bin(15) value(118);
     /* PRC Envelope #10 Rotated 458 x 324 mm */
 %end; /* WINVER >= 0x0500 */


 dcl DMPAPER_FIRST     fixed bin(15) value(DMPAPER_LETTER);
 %if WINVER >= 1280 %then %do;
 dcl DMPAPER_LAST      fixed bin(15) value(DMPAPER_PENV_10_ROTATED);
 %end; %else %if WINVER >= 1024 %then %do;
 dcl DMPAPER_LAST      fixed bin(15) value(DMPAPER_A3_EXTRA_TRANSVERSE);
 %end; %else %do;
 dcl DMPAPER_LAST      fixed bin(15) value(DMPAPER_FANFOLD_LGL_GERMAN);
 %end;

 dcl DMPAPER_USER      fixed bin(15) value(256);

 /* bin selections */
 dcl DMBIN_UPPER           fixed bin(15) value(1);
 dcl DMBIN_ONLYONE         fixed bin(15) value(1);
 dcl DMBIN_LOWER           fixed bin(15) value(2);
 dcl DMBIN_MIDDLE          fixed bin(15) value(3);
 dcl DMBIN_MANUAL          fixed bin(15) value(4);
 dcl DMBIN_ENVELOPE        fixed bin(15) value(5);
 dcl DMBIN_ENVMANUAL       fixed bin(15) value(6);
 dcl DMBIN_AUTO            fixed bin(15) value(7);
 dcl DMBIN_TRACTOR         fixed bin(15) value(8);
 dcl DMBIN_SMALLFMT        fixed bin(15) value(9);
 dcl DMBIN_LARGEFMT        fixed bin(15) value(10);
 dcl DMBIN_LARGECAPACITY   fixed bin(15) value(11);
 dcl DMBIN_CASSETTE        fixed bin(15) value(14);
 dcl DMBIN_FORMSOURCE      fixed bin(15) value(15);

 dcl DMBIN_FIRST           fixed bin(15) value(DMBIN_UPPER);
 dcl DMBIN_LAST            fixed bin(15) value(DMBIN_FORMSOURCE);

 dcl DMBIN_USER            fixed bin(15) value(256);
 /* device specific bins start here */

 /* print qualities */
 dcl DMRES_DRAFT           fixed bin(15) value(-1);
 dcl DMRES_LOW             fixed bin(15) value(-2);
 dcl DMRES_MEDIUM          fixed bin(15) value(-3);
 dcl DMRES_HIGH            fixed bin(15) value(-4);

 /* color enable/disable for color printers */
 dcl DMCOLOR_MONOCHROME    fixed bin(15) value(1);
 dcl DMCOLOR_COLOR         fixed bin(15) value(2);

 /* duplex enable */
 dcl DMDUP_SIMPLEX         fixed bin(15) value(1);
 dcl DMDUP_VERTICAL        fixed bin(15) value(2);
 dcl DMDUP_HORIZONTAL      fixed bin(15) value(3);

 /* TrueType options */
 dcl DMTT_BITMAP           fixed bin(15) value(1);
     /* print TT fonts as graphics */
 dcl DMTT_DOWNLOAD         fixed bin(15) value(2);
     /* download TT fonts as soft fonts */
 dcl DMTT_SUBDEV           fixed bin(15) value(3);
     /* substitute device fonts for TT fonts */

 %if WINVER >= 1024 %then %do;
 dcl DMTT_DOWNLOAD_OUTLINE fixed bin(15) value(4);
     /* download TT fonts as outline soft fonts */
 %end; /* WINVER >= 0x0400 */

 /* Collation selections */
 dcl DMCOLLATE_FALSE       fixed bin(15) value(0);
 dcl DMCOLLATE_TRUE        fixed bin(15) value(1);

 /* DEVMODE dmDisplayFlags flags */

 /* dcl DM_GRAYSCALE  fixed bin(31) value('00000001'xn) */
     /* This flag is no longer valid */
 /* dcl DM_INTERLACED fixed bin(31) value('00000002'xn) */
     /* This flag is no longer valid */
 dcl DMDISPLAYFLAGS_TEXTMODE type DWORD value('00000004'xu);


 %if WINVER >= 1024 %then %do;
 /* ICM methods */
 dcl DMICMMETHOD_NONE        type DWORD value(1);
     /* ICM disabled */
 dcl DMICMMETHOD_SYSTEM      type DWORD value(2);
     /* ICM handled by system */
 dcl DMICMMETHOD_DRIVER      type DWORD value(3);
     /* ICM handled by driver */
 dcl DMICMMETHOD_DEVICE      type DWORD value(4);
     /* ICM handled by device */

 dcl DMICMMETHOD_USER        type DWORD value(256);
     /* Device-specific methods start here */

     /* ICM Intents */
 dcl DMICM_SATURATE          type DWORD value(1);
     /* Maximize color saturation */
 dcl DMICM_CONTRAST          type DWORD value(2);
     /* Maximize color contrast */
 dcl DMICM_COLORIMETRIC      type DWORD value(3);
     /* Use specific color metric */
 dcl DMICM_ABS_COLORIMETRIC  type DWORD value(4);
     /* Use specific color metric */

 dcl DMICM_USER              type DWORD value(256);
     /* Device-specific intents start here */

 /* Media types */

 dcl DMMEDIA_STANDARD        type DWORD value(1);
     /* Standard paper */
 dcl DMMEDIA_TRANSPARENCY    type DWORD value(2);
     /* Transparency */
 dcl DMMEDIA_GLOSSY          type DWORD value(3);
     /* Glossy paper */

 dcl DMMEDIA_USER            type DWORD value(256);
     /* Device-specific media start here */

 /* Dither types */
 dcl DMDITHER_NONE           type DWORD value(1);
     /* No dithering */
 dcl DMDITHER_COARSE         type DWORD value(2);
     /* Dither with a coarse brush */
 dcl DMDITHER_FINE           type DWORD value(3);
     /* Dither with a fine brush */
 dcl DMDITHER_LINEART        type DWORD value(4);
     /* LineArt dithering */
 dcl DMDITHER_ERRORDIFFUSION type DWORD value(5);
     /* LineArt dithering */
 dcl DMDITHER_RESERVED6      type DWORD value(6);
     /* LineArt dithering */
 dcl DMDITHER_RESERVED7      type DWORD value(7);
     /* LineArt dithering */
 dcl DMDITHER_RESERVED8      type DWORD value(8);
     /* LineArt dithering */
 dcl DMDITHER_RESERVED9      type DWORD value(9);
     /* LineArt dithering */
 dcl DMDITHER_GRAYSCALE      type DWORD value(10);
     /* Device does grayscaling */

 dcl DMDITHER_USER           type DWORD value(256);
     /* Device-specific dithers start here */
 %end; /* WINVER >= 0x0400 */

 define structure
   1 DISPLAY_DEVICEA,
     2 cb           type DWORD,
     2 DeviceName   char(32-1) varz,
     2 DeviceString char(128-1) varz,
     2 StateFlags   type DWORD;
 define alias  PDISPLAY_DEVICEA handle DISPLAY_DEVICEA;
 define alias LPDISPLAY_DEVICEA handle DISPLAY_DEVICEA;

 define structure
   1 DISPLAY_DEVICEW,
     2 cb           type DWORD,
     2 DeviceName   WCHAR(32-1) varz,
     2 DeviceString WCHAR(128-1) varz,
     2 StateFlags   type DWORD;
 define alias  PDISPLAY_DEVICEW handle DISPLAY_DEVICEW;
 define alias LPDISPLAY_DEVICEW handle DISPLAY_DEVICEW;

 %if UNICODE ^= '' %then %do;
 define alias   DISPLAY_DEVICE type DISPLAY_DEVICEW;
 define alias  PDISPLAY_DEVICE type PDISPLAY_DEVICEW;
 define alias LPDISPLAY_DEVICE type LPDISPLAY_DEVICEW;
 %end; %else %do;
 define alias   DISPLAY_DEVICE type DISPLAY_DEVICEA;
 define alias  PDISPLAY_DEVICE type PDISPLAY_DEVICEA;
 define alias LPDISPLAY_DEVICE type LPDISPLAY_DEVICEA;
 %end; /* UNICODE */

 dcl DISPLAY_DEVICE_ATTACHED_TO_DESKTOP type DWORD value('00000001'xu);
 dcl DISPLAY_DEVICE_MULTI_DRIVER        type DWORD value('00000002'xu);
 dcl DISPLAY_DEVICE_PRIMARY_DEVICE      type DWORD value('00000004'xu);
 dcl DISPLAY_DEVICE_MIRRORING_DRIVER    type DWORD value('00000008'xu);
 dcl DISPLAY_DEVICE_VGA_COMPATIBLE      type DWORD value('00000010'xu);

 /* GetRegionData/ExtCreateRegion */

 dcl RDH_RECTANGLES fixed bin(31) value(1);

 define structure
   1 RGNDATAHEADER,
     2 dwSize   type DWORD,
     2 iType    type DWORD,
     2 nCount   type DWORD,
     2 nRgnSize type DWORD,
     2 rcBound  type RECT;
 define alias PRGNDATAHEADER handle RGNDATAHEADER;

 define structure
   1 RGNDATA,
     2 rdh    type RGNDATAHEADER,
     2 Buffer char(1); /* region data */
 define alias  PRGNDATA handle RGNDATA;
 define alias NPRGNDATA handle RGNDATA;
 define alias LPRGNDATA handle RGNDATA;


 define structure
   1 ABC,
     2 abcA fixed bin(31),
     2 abcB type UINT,
     2 abcC fixed bin(31);
 define alias  PABC handle ABC;
 define alias NPABC handle ABC;
 define alias LPABC handle ABC;

 define structure
   1 ABCFLOAT,
     2 abcfA type FLOAT,
     2 abcfB type FLOAT,
     2 abcfC type FLOAT;
 define alias  PABCFLOAT handle ABCFLOAT;
 define alias NPABCFLOAT handle ABCFLOAT;
 define alias LPABCFLOAT handle ABCFLOAT;

 %if NOTEXTMETRIC = '' %then %do;

 define structure
   1 OUTLINETEXTMETRICA,
     2 otmSize                type UINT,
     2 otmTextMetrics         type TEXTMETRICA,
     2 otmFiller              type BYTE,
     2 otmPanoseNumber        type PANOSE,
     2 otmfsSelection         type UINT,
     2 otmfsType              type UINT,
     2 otmsCharSlopeRise      fixed bin(31),
     2 otmsCharSlopeRun       fixed bin(31),
     2 otmItalicAngle         fixed bin(31),
     2 otmEMSquare            type UINT,
     2 otmAscent              fixed bin(31),
     2 otmDescent             fixed bin(31),
     2 otmLineGap             type UINT,
     2 otmsCapEmHeight        type UINT,
     2 otmsXHeight            type UINT,
     2 otmrcFontBox           type RECT,
     2 otmMacAscent           fixed bin(31),
     2 otmMacDescent          fixed bin(31),
     2 otmMacLineGap          type UINT,
     2 otmusMinimumPPEM       type UINT,
     2 otmptSubscriptSize     type POINT,
     2 otmptSubscriptOffset   type POINT,
     2 otmptSuperscriptSize   type POINT,
     2 otmptSuperscriptOffset type POINT,
     2 otmsStrikeoutSize      type UINT,
     2 otmsStrikeoutPosition  fixed bin(31),
     2 otmsUnderscoreSize     fixed bin(31),
     2 otmsUnderscorePosition fixed bin(31),
     2 otmpFamilyName         type PSTR,
     2 otmpFaceName           type PSTR,
     2 otmpStyleName          type PSTR,
     2 otmpFullName           type PSTR;
 define alias  POUTLINETEXTMETRICA handle OUTLINETEXTMETRICA;
 define alias NPOUTLINETEXTMETRICA handle OUTLINETEXTMETRICA;
 define alias LPOUTLINETEXTMETRICA handle OUTLINETEXTMETRICA;

 define structure
   1 OUTLINETEXTMETRICW,
     2 otmSize                type UINT,
     2 otmTextMetrics         type TEXTMETRICW,
     2 otmFiller              type BYTE,
     2 otmPanoseNumber        type PANOSE,
     2 otmfsSelection         type UINT,
     2 otmfsType              type UINT,
     2 otmsCharSlopeRise      fixed bin(31),
     2 otmsCharSlopeRun       fixed bin(31),
     2 otmItalicAngle         fixed bin(31),
     2 otmEMSquare            type UINT,
     2 otmAscent              fixed bin(31),
     2 otmDescent             fixed bin(31),
     2 otmLineGap             type UINT,
     2 otmsCapEmHeight        type UINT,
     2 otmsXHeight            type UINT,
     2 otmrcFontBox           type RECT,
     2 otmMacAscent           fixed bin(31),
     2 otmMacDescent          fixed bin(31),
     2 otmMacLineGap          type UINT,
     2 otmusMinimumPPEM       type UINT,
     2 otmptSubscriptSize     type POINT,
     2 otmptSubscriptOffset   type POINT,
     2 otmptSuperscriptSize   type POINT,
     2 otmptSuperscriptOffset type POINT,
     2 otmsStrikeoutSize      type UINT,
     2 otmsStrikeoutPosition  fixed bin(31),
     2 otmsUnderscoreSize     fixed bin(31),
     2 otmsUnderscorePosition fixed bin(31),
     2 otmpFamilyName         type PSTR,
     2 otmpFaceName           type PSTR,
     2 otmpStyleName          type PSTR,
     2 otmpFullName           type PSTR;
 define alias  POUTLINETEXTMETRICW handle OUTLINETEXTMETRICW;
 define alias NPOUTLINETEXTMETRICW handle OUTLINETEXTMETRICW;
 define alias LPOUTLINETEXTMETRICW handle OUTLINETEXTMETRICW;

 %if UNICODE ^= '' %then %do;
 define alias   OUTLINETEXTMETRIC type OUTLINETEXTMETRICW;
 define alias  POUTLINETEXTMETRIC type POUTLINETEXTMETRICW;
 define alias NPOUTLINETEXTMETRIC type NPOUTLINETEXTMETRICW;
 define alias LPOUTLINETEXTMETRIC type LPOUTLINETEXTMETRICW;
 %end; %else %do;
 define alias   OUTLINETEXTMETRIC type OUTLINETEXTMETRICA;
 define alias  POUTLINETEXTMETRIC type POUTLINETEXTMETRICA;
 define alias NPOUTLINETEXTMETRIC type NPOUTLINETEXTMETRICA;
 define alias LPOUTLINETEXTMETRIC type LPOUTLINETEXTMETRICA;
 %end; /* UNICODE */

 %end; /* NOTEXTMETRIC */

 define structure
   1 POLYTEXTA,
     2 x       fixed bin(31),
     2 y       fixed bin(31),
     2 n       type UINT,
     2 lpstr   type LPCSTR,
     2 uiFlags type UINT,
     2 rcl     type RECT,
     2 pdx     pointer;
 define alias  PPOLYTEXTA handle POLYTEXTA;
 define alias NPPOLYTEXTA handle POLYTEXTA;
 define alias LPPOLYTEXTA handle POLYTEXTA;

 define structure
   1 POLYTEXTW,
     2 x       fixed bin(31),
     2 y       fixed bin(31),
     2 n       type UINT,
     2 lpstr   type LPCWSTR,
     2 uiFlags type UINT,
     2 rcl     type RECT,
     2 pdx     pointer;
 define alias  PPOLYTEXTW handle POLYTEXTW;
 define alias NPPOLYTEXTW handle POLYTEXTW;
 define alias LPPOLYTEXTW handle POLYTEXTW;

 %if UNICODE ^= '' %then %do;
 define alias   POLYTEXT type   POLYTEXTW;
 define alias  PPOLYTEXT type  PPOLYTEXTW;
 define alias NPPOLYTEXT type NPPOLYTEXTW;
 define alias LPPOLYTEXT type LPPOLYTEXTW;
 %end; %else %do;
 define alias   POLYTEXT type   POLYTEXTA;
 define alias  PPOLYTEXT type  PPOLYTEXTA;
 define alias NPPOLYTEXT type NPPOLYTEXTA;
 define alias LPPOLYTEXT type LPPOLYTEXTA;
 %end; /* UNICODE */

 define alias FIXED fixed bin (31,16);
 /* define structure          */
 /*  1 FIXED,                 */
 /*    2 fract type WORD,     */
 /*    2 value fixed bin(15)  */

 define structure
   1 MAT2,
     2 eM11 type FIXED,
     2 eM12 type FIXED,
     2 eM21 type FIXED,
     2 eM22 type FIXED;
 define alias LPMAT2 handle MAT2;

 define structure
   1 GLYPHMETRICS,
     2 gmBlackBoxX     type UINT,
     2 gmBlackBoxY     type UINT,
     2 gmptGlyphOrigin type POINT,
     2 gmCellIncX      fixed bin(15),
     2 gmCellIncY      fixed bin(15);
 define alias LPGLYPHMETRICS handle GLYPHMETRICS;

 /*  GetGlyphOutline constants */

 dcl GGO_METRICS      fixed bin(15) value(0);
 dcl GGO_BITMAP       fixed bin(15) value(1);
 dcl GGO_NATIVE       fixed bin(15) value(2);
 dcl GGO_BEZIER       fixed bin(15) value(3);


 %if WINVER >= 1024 %then %do;
 dcl GGO_GRAY2_BITMAP fixed bin(15) value(4);
 dcl GGO_GRAY4_BITMAP fixed bin(15) value(5);
 dcl GGO_GRAY8_BITMAP fixed bin(15) value(6);
 dcl GGO_GLYPH_INDEX  fixed bin(15) value('0080'xn);
 %end; /* WINVER >= 0x0400 */

 %if #WIN32_WINNT >= 1280 %then %do;
 dcl GGO_UNHINTED     fixed bin(15) value('0100'xn);
 %end; /* (_WIN32_WINNT >= 0x0500) */

 dcl TT_POLYGON_TYPE  fixed bin(31) value(24);

 dcl TT_PRIM_LINE     fixed bin(31) value(1);
 dcl TT_PRIM_QSPLINE  fixed bin(31) value(2);
 dcl TT_PRIM_CSPLINE  fixed bin(31) value(3);

 define structure
   1 POINTFX,
     2 x type FIXED,
     2 y type FIXED;
 define alias LPPOINTFX handle POINTFX;

 define structure
   1 TTPOLYCURVE,
     2 wType type WORD,
     2 cpfx type WORD,
     2 apfx (1) type POINTFX;
 define alias LPTTPOLYCURVE handle TTPOLYCURVE;

 define structure
   1 TTPOLYGONHEADER,
     2 cb type DWORD,
     2 dwType type DWORD,
     2 pfxStart type POINTFX;
 define alias LPTTPOLYGONHEADER handle TTPOLYGONHEADER;


 %if WINVER >= 1024 %then %do;
 dcl GCP_DBCS              type DWORD value('0001'xu);
 dcl GCP_REORDER           type DWORD value('0002'xu);
 dcl GCP_USEKERNING        type DWORD value('0008'xu);
 dcl GCP_GLYPHSHAPE        type DWORD value('0010'xu);
 dcl GCP_LIGATE            type DWORD value('0020'xu);
 /* dcl GCP_GLYPHINDEXING  type DWORD value('0080'xu) */
 dcl GCP_DIACRITIC         type DWORD value('0100'xu);
 dcl GCP_KASHIDA           type DWORD value('0400'xu);
 dcl GCP_ERROR             type DWORD value('8000'xu);
 dcl FLI_MASK              type DWORD value('103B'xu);

 dcl GCP_JUSTIFY           type DWORD value('00010000'xu);
 /* dcl GCP_NODIACRITICS   type DWORD value('00020000'xu) */
 dcl FLI_GLYPHS            type DWORD value('00040000'xu);
 dcl GCP_CLASSIN           type DWORD value('00080000'xu);
 dcl GCP_MAXEXTENT         type DWORD value('00100000'xu);
 dcl GCP_JUSTIFYIN         type DWORD value('00200000'xu);
 dcl GCP_DISPLAYZWG        type DWORD value('00400000'xu);
 dcl GCP_SYMSWAPOFF        type DWORD value('00800000'xu);
 dcl GCP_NUMERICOVERRIDE   type DWORD value('01000000'xu);
 dcl GCP_NEUTRALOVERRIDE   type DWORD value('02000000'xu);
 dcl GCP_NUMERICSLATIN     type DWORD value('04000000'xu);
 dcl GCP_NUMERICSLOCAL     type DWORD value('08000000'xu);

 dcl GCPCLASS_LATIN                  fixed bin(31) value(1);
 dcl GCPCLASS_HEBREW                 fixed bin(31) value(2);
 dcl GCPCLASS_ARABIC                 fixed bin(31) value(2);
 dcl GCPCLASS_NEUTRAL                fixed bin(31) value(3);
 dcl GCPCLASS_LOCALNUMBER            fixed bin(31) value(4);
 dcl GCPCLASS_LATINNUMBER            fixed bin(31) value(5);
 dcl GCPCLASS_LATINNUMERICTERMINATOR fixed bin(31) value(6);
 dcl GCPCLASS_LATINNUMERICSEPARATOR  fixed bin(31) value(7);
 dcl GCPCLASS_NUMERICSEPARATOR       fixed bin(31) value(8);
 dcl GCPCLASS_PREBOUNDLTR            fixed bin(31) value('80'xn);
 dcl GCPCLASS_PREBOUNDRTL            fixed bin(31) value('40'xn);
 dcl GCPCLASS_POSTBOUNDLTR           fixed bin(31) value('20'xn);
 dcl GCPCLASS_POSTBOUNDRTL           fixed bin(31) value('10'xn);

 dcl GCPGLYPH_LINKBEFORE             fixed bin(31) value('8000'xn);
 dcl GCPGLYPH_LINKAFTER              fixed bin(31) value('4000'xn);

 define structure
   1 GCP_RESULTSA,
     2 lStructSize type DWORD,
     2 lpOutString type LPSTR,
     2 lpOrder     pointer, /* to (*) type UINT */
     2 lpDx        pointer, /* to (*) fixed bin(31) */
     2 lpCaretPos  pointer, /* to (*) fixed bin(31) */
     2 lpClass     type LPSTR,
     2 lpGlyphs    type LPWSTR,
     2 nGlyphs     type UINT,
     2 nMaxFit     fixed bin(31);
 define alias LPGCP_RESULTSA handle GCP_RESULTSA;

 define structure
   1 GCP_RESULTSW,
     2 lStructSize type DWORD,
     2 lpOutString type LPWSTR,
     2 lpOrder     pointer, /* to (*) type UINT */
     2 lpDx        pointer, /* to (*) fixed bin(31) */
     2 lpCaretPos  pointer, /* to (*) fixed bin(31) */
     2 lpClass     type LPSTR,
     2 lpGlyphs    type LPWSTR,
     2 nGlyphs     type UINT,
     2 nMaxFit     fixed bin(31);
 define alias LPGCP_RESULTSW handle GCP_RESULTSW;

 %if UNICODE ^= '' %then %do;
 define alias   GCP_RESULTS type   GCP_RESULTSW;
 define alias LPGCP_RESULTS type LPGCP_RESULTSW;
 %end; %else %do;
 define alias   GCP_RESULTS type   GCP_RESULTSA;
 define alias LPGCP_RESULTS type LPGCP_RESULTSA;
 %end; /* UNICODE */
 %end; /* WINVER >= 0x0400 */

 define structure
   1 RASTERIZER_STATUS,
     2 nSize       fixed bin(15),
     2 wFlags      fixed bin(15),
     2 nLanguageID fixed bin(15);
 define alias LPRASTERIZER_STATUS handle RASTERIZER_STATUS;

 /* bits defined in wFlags of RASTERIZER_STATUS */
 dcl TT_AVAILABLE fixed bin(15) value('0001'xn);
 dcl TT_ENABLED   fixed bin(15) value('0002'xn);

 /* Pixel format descriptor */
 define structure
   1 PIXELFORMATDESCRIPTOR,
     2 nSize           type WORD,
     2 nVersion        type WORD,
     2 dwFlags         type DWORD,
     2 iPixelType      type BYTE,
     2 cColorBits      type BYTE,
     2 cRedBits        type BYTE,
     2 cRedShift       type BYTE,
     2 cGreenBits      type BYTE,
     2 cGreenShift     type BYTE,
     2 cBlueBits       type BYTE,
     2 cBlueShift      type BYTE,
     2 cAlphaBits      type BYTE,
     2 cAlphaShift     type BYTE,
     2 cAccumBits      type BYTE,
     2 cAccumRedBits   type BYTE,
     2 cAccumGreenBits type BYTE,
     2 cAccumBlueBits  type BYTE,
     2 cAccumAlphaBits type BYTE,
     2 cDepthBits      type BYTE,
     2 cStencilBits    type BYTE,
     2 cAuxBuffers     type BYTE,
     2 iLayerType      type BYTE,
     2 bReserved       type BYTE,
     2 dwLayerMask     type DWORD,
     2 dwVisibleMask   type DWORD,
     2 dwDamageMask    type DWORD;
 define alias  PPIXELFORMATDESCRIPTOR handle PIXELFORMATDESCRIPTOR;
 define alias LPPIXELFORMATDESCRIPTOR handle PIXELFORMATDESCRIPTOR;

 /* pixel types */
 dcl PFD_TYPE_RGBA             type BYTE value(0);
 dcl PFD_TYPE_COLORINDEX       type BYTE value(1);

 /* layer types */
 dcl PFD_MAIN_PLANE            type BYTE value(0);
 dcl PFD_OVERLAY_PLANE         type BYTE value(1);
 dcl PFD_UNDERLAY_PLANE        type BYTE value('ff'xu /* -1 */);

 /* PIXELFORMATDESCRIPTOR flags */
 dcl PFD_DOUBLEBUFFER          type DWORD value('00000001'xu);
 dcl PFD_STEREO                type DWORD value('00000002'xu);
 dcl PFD_DRAW_TO_WINDOW        type DWORD value('00000004'xu);
 dcl PFD_DRAW_TO_BITMAP        type DWORD value('00000008'xu);
 dcl PFD_SUPPORT_GDI           type DWORD value('00000010'xu);
 dcl PFD_SUPPORT_OPENGL        type DWORD value('00000020'xu);
 dcl PFD_GENERIC_FORMAT        type DWORD value('00000040'xu);
 dcl PFD_NEED_PALETTE          type DWORD value('00000080'xu);
 dcl PFD_NEED_SYSTEM_PALETTE   type DWORD value('00000100'xu);
 dcl PFD_SWAP_EXCHANGE         type DWORD value('00000200'xu);
 dcl PFD_SWAP_COPY             type DWORD value('00000400'xu);
 dcl PFD_SWAP_LAYER_BUFFERS    type DWORD value('00000800'xu);
 dcl PFD_GENERIC_ACCELERATED   type DWORD value('00001000'xu);
 dcl PFD_SUPPORT_DIRECTDRAW    type DWORD value('00002000'xu);

 /* PIXELFORMATDESCRIPTOR flags for use in ChoosePixelFormat only */
 dcl PFD_DEPTH_DONTCARE        type DWORD value('20000000'xu);
 dcl PFD_DOUBLEBUFFER_DONTCARE type DWORD value('40000000'xu);
 dcl PFD_STEREO_DONTCARE       type DWORD value('80000000'xu);

 %if NOTEXTMETRIC='' %then %do;
 define alias OLDFONTENUMPROCA
        entry (type LOGFONTA byaddr nonasgn,
               type TEXTMETRICA byaddr nonasgn,
               type DWORD,
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 define alias OLDFONTENUMPROCW
        entry (type LOGFONTW byaddr nonasgn,
               type TEXTMETRICW byaddr nonasgn,
               type DWORD,
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 %if UNICODE ^= '' %then %do;
 define alias  OLDFONTENUMPROC type OLDFONTENUMPROCW;
 %end; %else %do;
 define alias  OLDFONTENUMPROC type OLDFONTENUMPROCA;
 %end; /* !UNICODE */

 define alias FONTENUMPROCA type OLDFONTENUMPROCA;
 define alias FONTENUMPROCW type OLDFONTENUMPROCW;

 %if UNICODE ^= '' %then %do;
 define alias FONTENUMPROC type FONTENUMPROCW;
 %end; %else %do;
 define alias FONTENUMPROC type FONTENUMPROCA;
 %end; /* UNICODE */

 define alias GOBJENUMPROC
        entry (type LPVOID,
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 define alias LINEDDAPROC
        entry (fixed bin(31),
               fixed bin(31),
               type LPARAM)
        limited CALLBACK;

 %end; %else %do;
 define alias OLDFONTENUMPROC type FARPROC;
 define alias FONTENUMPROCA   type FARPROC;
 define alias FONTENUMPROCW   type FARPROC;

 %if UNICODE ^= '' %then %do;
 define alias FONTENUMPROC type FONTENUMPROCW;
 %end; %else %do;
 define alias FONTENUMPROC type FONTENUMPROCA;
 %end; /* UNICODE */

 define alias GOBJENUMPROC type FARPROC;
 define alias LINEDDAPROC  type FARPROC;
 %end;

 dcl AddFontResourceA
     entry (char(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('AddFontResourceA');

 dcl AddFontResourceW
     entry (WCHAR(*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('AddFontResourceW');

 %dcl AddFontResource char ext;
 %if UNICODE ^= '' %then %do;
   %AddFontResource='AddFontResourceW';
 %end; %else %do;
   %AddFontResource='AddFontResourceA';
 %end; /* !UNICODE */

 dcl AnimatePalette
     entry (type HPALETTE,
            type UINT,
            type UINT,
            (*) type PALETTEENTRY byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('AnimatePalette');

 dcl Arc
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Arc');

 dcl BitBlt
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('BitBlt');

 dcl CancelDC
     entry (type HDC )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CancelDC');

 dcl Chord
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Chord');

 dcl ChoosePixelFormat
     entry (type HDC,
            type PIXELFORMATDESCRIPTOR byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('ChoosePixelFormat');

 dcl CloseMetaFile
     entry (type HDC )
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CloseMetaFile');

 dcl CombineRgn
     entry (type HRGN,
            type HRGN,
            type HRGN,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('CombineRgn');

 dcl CopyMetaFileA
     entry (type HMETAFILE,
            char(*) varz byaddr nonasgn optional)
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CopyMetaFileA');

 dcl CopyMetaFileW
     entry (type HMETAFILE,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CopyMetaFileW');

 %dcl CopyMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %CopyMetaFile='CopyMetaFileW';
 %end; %else %do;
   %CopyMetaFile='CopyMetaFileA';
 %end; /* !UNICODE */

 dcl CreateBitmap
     entry (fixed bin(31),
            fixed bin(31),
            type UINT,
            type UINT,
            pointer) /* to colour data */
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateBitmap');

 dcl CreateBitmapIndirect
     entry (type BITMAP byaddr nonasgn)
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateBitmapIndirect');

 dcl CreateBrushIndirect
     entry (type LOGBRUSH byaddr nonasgn)
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreateBrushIndirect');

 dcl CreateCompatibleBitmap
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateCompatibleBitmap');

 dcl CreateDiscardableBitmap
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateDiscardableBitmap');

 dcl CreateCompatibleDC
     entry (type HDC)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateCompatibleDC');

 dcl CreateDCA
     entry (char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type DEVMODEA byaddr optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateDCA');

 dcl CreateDCW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DEVMODEW byaddr optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateDCW');

 %dcl CreateDC char ext;
 %if UNICODE ^= '' %then %do;
   %CreateDC='CreateDCW';
 %end; %else %do;
   %CreateDC='CreateDCA';
 %end; /* !UNICODE */

 dcl CreateDIBitmap
     entry (type HDC,
            pointer, /* to type BITMAPINFOHEADER or BITMAPV5HEADER */
            type DWORD,
            pointer, /* to data */
            pointer, /* to BITMAPINFO */
            type UINT)
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateDIBitmap');

 dcl CreateDIBPatternBrush
     entry (type HGLOBAL,
            type UINT)
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreateDIBPatternBrush');

 dcl CreateDIBPatternBrushPt
     entry (pointer, /* to structure and bitmap bits */
            type UINT)
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreateDIBPatternBrushPt');

 dcl CreateEllipticRgn
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreateEllipticRgn');

 dcl CreateEllipticRgnIndirect
     entry (type RECT byaddr nonasgn)
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreateEllipticRgnIndirect');

 dcl CreateFontIndirectA
     entry (type LOGFONTA byaddr nonasgn)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontIndirectA');

 dcl CreateFontIndirectW
     entry (type LOGFONTW byaddr nonasgn)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontIndirectW');

 %dcl CreateFontIndirect char ext;
 %if UNICODE ^= '' %then %do;
   %CreateFontIndirect='CreateFontIndirectW';
 %end; %else %do;
   %CreateFontIndirect='CreateFontIndirectA';
 %end; /* !UNICODE */

 dcl CreateFontA
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn optional)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontA');

 dcl CreateFontW
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontW');

 %dcl CreateFont char ext;
 %if UNICODE ^= '' %then %do;
   %CreateFont='CreateFontW';
 %end; %else %do;
   %CreateFont='CreateFontA';
 %end; /* !UNICODE */

 dcl CreateHatchBrush
     entry (fixed bin(31),
            type COLORREF)
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreateHatchBrush');

 dcl CreateICA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type DEVMODEA byaddr nonasgn optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateICA');

 dcl CreateICW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DEVMODEW byaddr nonasgn optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateICW');

 %dcl CreateIC char ext;
 %if UNICODE ^= '' %then %do;
   %CreateIC='CreateICW';
 %end; %else %do;
   %CreateIC='CreateICA';
 %end; /* !UNICODE */

 dcl CreateMetaFileA
     entry (char(*) varz byaddr nonasgn optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateMetaFileA');

 dcl CreateMetaFileW
     entry (WCHAR(*) varz byaddr nonasgn optional)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateMetaFileW');

 %dcl CreateMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %CreateMetaFile='CreateMetaFileW';
 %end; %else %do;
   %CreateMetaFile='CreateMetaFileA';
 %end; /* !UNICODE */

 dcl CreatePalette
     entry (pointer) /* to type LOGPALETTE */
     returns (type HPALETTE byvalue optional)
     WINGDIAPI WINAPI external('CreatePalette');

 dcl CreatePen
     entry (fixed bin(31),
            fixed bin(31),
            type COLORREF)
     returns (type HPEN byvalue optional)
     WINGDIAPI WINAPI external('CreatePen');

 dcl CreatePenIndirect
     entry (type LOGPEN byaddr nonasgn)
     returns (type HPEN byvalue optional)
     WINGDIAPI WINAPI external('CreatePenIndirect');

 dcl CreatePolyPolygonRgn
     entry ((*) type POINT byaddr nonasgn,
            (*) type INT byaddr nonasgn,
            fixed bin(31),
            fixed bin(31))
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreatePolyPolygonRgn');

 dcl CreatePatternBrush
     entry (type HBITMAP )
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreatePatternBrush');

 dcl CreateRectRgn
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreateRectRgn');

 dcl CreateRectRgnIndirect
     entry (type RECT nonasgn byaddr)
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreateRectRgnIndirect');

 dcl CreateRoundRectRgn
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreateRoundRectRgn');

 dcl CreateScalableFontResourceA
     entry (type DWORD,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CreateScalableFontResourceA');

 dcl CreateScalableFontResourceW
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CreateScalableFontResourceW');

 %dcl CreateScalableFontResource char ext;
 %if UNICODE ^= '' %then %do;
   %CreateScalableFontResource='CreateScalableFontResourceW';
 %end; %else %do;
   %CreateScalableFontResource='CreateScalableFontResourceA';
 %end; /* !UNICODE */

 dcl CreateSolidBrush
     entry (type COLORREF )
     returns (type HBRUSH byvalue optional)
     WINGDIAPI WINAPI external('CreateSolidBrush');

 dcl DeleteDC
     entry (type HDC )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DeleteDC');

 dcl DeleteMetaFile
     entry (type HMETAFILE )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DeleteMetaFile');

 dcl DeleteObject
     entry (type HGDIOBJ )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DeleteObject');

 dcl DescribePixelFormat
     entry (type HDC,
            fixed bin(31),
            type UINT,
            type PIXELFORMATDESCRIPTOR byaddr optional)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('DescribePixelFormat');

 /* define types of pointers to ExtDeviceMode() and          */
 /* DeviceCapabilities() functions for Win 3.1 compatibility */

 define alias LPFNDEVMODE
        entry (type HWND,
               type HMODULE,
               type DEVMODE byaddr optional,
               type LPSTR, /* to char(*) varz byaddr */
               type LPSTR, /* to char(*) varz byaddr */
               type DEVMODE byaddr optional,
               type LPSTR, /* to char(*) varz byaddr */
               type UINT)
        returns (type UINT byvalue optional)
        limited CALLBACK;

 define alias LPFNDEVCAPS
        entry (type LPSTR, /* to char(*) varz byaddr */
               type LPSTR, /* to char(*) varz byaddr */
               type UINT,
               type LPSTR, /* to char(*) varz byaddr */
               type DEVMODE byaddr optional)
        returns (type DWORD byvalue optional)
        limited CALLBACK;

 %if 0 = 1 %then %do; /* already declared in WinDef.cpy */
 /* mode selections for the device mode function */
 dcl DM_UPDATE            fixed bin(31) value(1);
 dcl DM_COPY              fixed bin(31) value(2);
 dcl DM_PROMPT            fixed bin(31) value(4);
 dcl DM_MODIFY            fixed bin(31) value(8);

 dcl DM_IN_BUFFER         fixed bin(31) value(DM_MODIFY);
 dcl DM_IN_PROMPT         fixed bin(31) value(DM_PROMPT);
 dcl DM_OUT_BUFFER        fixed bin(31) value(DM_COPY);
 dcl DM_OUT_DEFAULT       fixed bin(31) value(DM_UPDATE);

 /* device capabilities indices */
 dcl DC_FIELDS            type WORD value(1);
 dcl DC_PAPERS            type WORD value(2);
 dcl DC_PAPERSIZE         type WORD value(3);
 dcl DC_MINEXTENT         type WORD value(4);
 dcl DC_MAXEXTENT         type WORD value(5);
 dcl DC_BINS              type WORD value(6);
 dcl DC_DUPLEX            type WORD value(7);
 dcl DC_SIZE              type WORD value(8);
 dcl DC_EXTRA             type WORD value(9);
 dcl DC_VERSION           type WORD value(10);
 dcl DC_DRIVER            type WORD value(11);
 dcl DC_BINNAMES          type WORD value(12);
 dcl DC_ENUMRESOLUTIONS   type WORD value(13);
 dcl DC_FILEDEPENDENCIES  type WORD value(14);
 dcl DC_TRUETYPE          type WORD value(15);
 dcl DC_PAPERNAMES        type WORD value(16);
 dcl DC_ORIENTATION       type WORD value(17);
 dcl DC_COPIES            type WORD value(18);
 %end; /* %if 0 = 1 */

 %if WINVER >= 1024 %then %do;
 dcl DC_BINADJUST         type WORD value(19);
 dcl DC_EMF_COMPLIANT     type WORD value(20);
 dcl DC_DATATYPE_PRODUCED type WORD value(21);
 dcl DC_COLLATE           type WORD value(22);
 dcl DC_MANUFACTURER      type WORD value(23);
 dcl DC_MODEL             type WORD value(24);
 %end; /* WINVER >= 0x0400 */


 %if WINVER >= 1280 %then %do;
 dcl DC_PERSONALITY       type WORD value(25);
 dcl DC_PRINTRATE         type WORD value(26);
 dcl PRINTRATEUNIT_PPM    fixed bin(31) value(1);
 dcl PRINTRATEUNIT_CPS    fixed bin(31) value(2);
 dcl PRINTRATEUNIT_LPM    fixed bin(31) value(3);
 dcl PRINTRATEUNIT_IPM    fixed bin(31) value(4);
 dcl DC_PRINTRATEUNIT     type WORD value(27);
 dcl DC_PRINTERMEM        type WORD value(28);
 dcl DC_MEDIAREADY        type WORD value(29);
 dcl DC_STAPLE            type WORD value(30);
 dcl DC_PRINTRATEPPM      type WORD value(31);
 dcl DC_COLORDEVICE       type WORD value(32);
 dcl DC_NUP               type WORD value(33);
 dcl DC_MEDIATYPENAMES    type WORD value(34);
 dcl DC_MEDIATYPES        type WORD value(35);
 %end;

 /* bit fields of the return value (DWORD) for DC_TRUETYPE */
 dcl DCTT_BITMAP           fixed bin(31) value('0000001'xn);
 dcl DCTT_DOWNLOAD         fixed bin(31) value('0000002'xn);
 dcl DCTT_SUBDEV           fixed bin(31) value('0000004'xn);

 %if WINVER >= 1024 %then %do;
 dcl DCTT_DOWNLOAD_OUTLINE fixed bin(31) value('0000008'xn);

 /* return values for DC_BINADJUST */
 dcl DCBA_FACEUPNONE       fixed bin(31) value('0000'xn);
 dcl DCBA_FACEUPCENTER     fixed bin(31) value('0001'xn);
 dcl DCBA_FACEUPLEFT       fixed bin(31) value('0002'xn);
 dcl DCBA_FACEUPRIGHT      fixed bin(31) value('0003'xn);
 dcl DCBA_FACEDOWNNONE     fixed bin(31) value('0100'xn);
 dcl DCBA_FACEDOWNCENTER   fixed bin(31) value('0101'xn);
 dcl DCBA_FACEDOWNLEFT     fixed bin(31) value('0102'xn);
 dcl DCBA_FACEDOWNRIGHT    fixed bin(31) value('0103'xn);
 %end; /* WINVER >= 0x0400 */

 dcl DeviceCapabilitiesA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type WORD,
            pointer, /* to output buffer */
            type DEVMODEA byaddr optional)
     returns (fixed bin(31) byvalue optional)
     WINSPOOLAPI WINAPI external('DeviceCapabilitiesA');

 dcl DeviceCapabilitiesW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type WORD,
            pointer, /* to output buffer */
            type DEVMODEW byaddr optional)
     returns (fixed bin(31) byvalue optional)
     WINSPOOLAPI WINAPI external('DeviceCapabilitiesW');

 %dcl DeviceCapabilities char ext;
 %if UNICODE ^= '' %then %do;
   %DeviceCapabilities='DeviceCapabilitiesW';
 %end; %else %do;
   %DeviceCapabilities='DeviceCapabilitiesA';
 %end; /* !UNICODE */

 dcl DrawEscape
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            pointer) /* to escape data */
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('DrawEscape');

 dcl Ellipse
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Ellipse');


 %if WINVER >= 1024 %then %do;
 dcl EnumFontFamiliesExA
     entry (type HDC,
            type LOGFONTA byaddr,
            type FONTENUMPROCA,
            type LPARAM,
            type DWORD)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontFamiliesExA');

 dcl EnumFontFamiliesExW
     entry (type HDC,
            type LOGFONTW byaddr,
            type FONTENUMPROCW,
            type LPARAM,
            type DWORD)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontFamiliesExW');

 %dcl EnumFontFamiliesEx char ext;
 %if UNICODE ^= '' %then %do;
   %EnumFontFamiliesEx='EnumFontFamiliesExW';
 %end; %else %do;
   %EnumFontFamiliesEx='EnumFontFamiliesExA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */

 dcl EnumFontFamiliesA
     entry (type HDC,
            char(*) varz byaddr nonasgn optional,
            type FONTENUMPROCA,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontFamiliesA');

 dcl EnumFontFamiliesW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn optional,
            type FONTENUMPROCW,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontFamiliesW');

 %dcl EnumFontFamilies char ext;
 %if UNICODE ^= '' %then %do;
   %EnumFontFamilies='EnumFontFamiliesW';
 %end; %else %do;
   %EnumFontFamilies='EnumFontFamiliesA';
 %end; /* !UNICODE */

 dcl EnumFontsA
     entry (type HDC,
            char(*) varz byaddr nonasgn optional,
            type FONTENUMPROCA,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontsA');

 dcl EnumFontsW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn optional,
            type FONTENUMPROCW,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumFontsW');

 %dcl EnumFonts char ext;
 %if UNICODE ^= '' %then %do;
   %EnumFonts='EnumFontsW';
 %end; %else %do;
   %EnumFonts='EnumFontsA';
 %end; /* !UNICODE */

 dcl EnumObjects
     entry (type HDC,
            fixed bin(31),
            type GOBJENUMPROC,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumObjects');

 dcl EqualRgn
     entry (type HRGN,
            type HRGN)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('EqualRgn');

 dcl Escape
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            pointer,     /* to escape input data */
            type LPVOID) /* to escape output data */
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('Escape');

 dcl ExtEscape
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            pointer,     /* to escape input data */
            fixed bin(31),
            pointer)     /* to escape output data */
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('ExtEscape');

 dcl ExcludeClipRect
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('ExcludeClipRect');

 dcl ExtCreateRegion
     entry (type XFORM byaddr nonasgn optional,
            type DWORD,
            pointer) /* to RGNDATA */
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('ExtCreateRegion');

 dcl ExtFloodFill
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type COLORREF,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ExtFloodFill');

 dcl FillRgn
     entry (type HDC,
            type HRGN,
            type HBRUSH)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FillRgn');

 dcl FloodFill
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type COLORREF)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FloodFill');

 dcl FrameRgn
     entry (type HDC,
            type HRGN,
            type HBRUSH,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FrameRgn');

 dcl GetROP2
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetROP2');

 dcl GetAspectRatioFilterEx
     entry (type HDC,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetAspectRatioFilterEx');

 dcl GetBkColor
     entry (type HDC)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetBkColor');


 %if #WIN32_WINNT >= 1280 %then %do;
 dcl GetDCBrushColor
     entry (type HDC)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetDCBrushColor');

 dcl GetDCPenColor
     entry (type HDC)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetDCPenColor');
 %end;

 dcl GetBkMode
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetBkMode');

 dcl GetBitmapBits
     entry (type HBITMAP,
            type LONG,
            type LPVOID) /* to bitmap bits buffer */
     returns (type LONG byvalue optional)
     WINGDIAPI WINAPI external('GetBitmapBits');

 dcl GetBitmapDimensionEx
     entry (type HBITMAP,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetBitmapDimensionEx');

 dcl GetBoundsRect
     entry (type HDC,
            type RECT byaddr,
            type UINT)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetBoundsRect');

 dcl GetBrushOrgEx
     entry (type HDC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetBrushOrgEx');

 dcl GetCharWidthA
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharWidthA');

 dcl GetCharWidthW
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharWidthW');

 %dcl GetCharWidth char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharWidth='GetCharWidthW';
 %end; %else %do;
   %GetCharWidth='GetCharWidthA';
 %end; /* !UNICODE */

 dcl GetCharWidth32A
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharWidth32A');

 dcl GetCharWidth32W
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharWidth32W');

 %dcl GetCharWidth32 char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharWidth32='GetCharWidth32W';
 %end; %else %do;
   %GetCharWidth32='GetCharWidth32A';
 %end; /* !UNICODE */

 dcl GetCharWidthFloatA
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type FLOAT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharWidthFloatA');

 dcl GetCharWidthFloatW
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type FLOAT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharWidthFloatW');

 %dcl GetCharWidthFloat char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharWidthFloat='GetCharWidthFloatW';
 %end; %else %do;
   %GetCharWidthFloat='GetCharWidthFloatA';
 %end; /* !UNICODE */

 dcl GetCharABCWidthsA
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type ABC byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharABCWidthsA');

 dcl GetCharABCWidthsW
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type ABC byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharABCWidthsW');

 %dcl GetCharABCWidths char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharABCWidths='GetCharABCWidthsW';
 %end; %else %do;
   %GetCharABCWidths='GetCharABCWidthsA';
 %end; /* !UNICODE */

 dcl GetCharABCWidthsFloatA
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type ABCFLOAT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharABCWidthsFloatA');

 dcl GetCharABCWidthsFloatW
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type ABCFLOAT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetCharABCWidthsFloatW');

 %dcl GetCharABCWidthsFloat char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharABCWidthsFloat='GetCharABCWidthsFloatW';
 %end; %else %do;
   %GetCharABCWidthsFloat='GetCharABCWidthsFloatA';
 %end; /* !UNICODE */

 dcl GetClipBox
     entry (type HDC,
            type RECT byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetClipBox');

 dcl GetClipRgn
     entry (type HDC,
            type HRGN)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetClipRgn');

 dcl GetMetaRgn
     entry (type HDC,
            type HRGN)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetMetaRgn');

 dcl GetCurrentObject
     entry (type HDC,
            type UINT)
     returns (type HGDIOBJ byvalue optional)
     WINGDIAPI WINAPI external('GetCurrentObject');

 dcl GetCurrentPositionEx
     entry (type HDC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCurrentPositionEx');

 dcl GetDeviceCaps
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetDeviceCaps');

 dcl GetDIBits
     entry (type HDC,
            type HBITMAP,
            type UINT,
            type UINT,
            type LPVOID,
            pointer, /* to BITMAPINFO */,
            type UINT)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetDIBits');

 dcl GetFontData
     entry (type HDC,
            type DWORD,
            type DWORD,
            type LPVOID, /* to font data */
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetFontData');

 dcl GetGlyphOutlineA
     entry (type HDC,
            type UINT,
            type UINT,
            type GLYPHMETRICS byaddr,
            type DWORD,
            type LPVOID, /* to outline character data */
            type MAT2 byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetGlyphOutlineA');

 dcl GetGlyphOutlineW
     entry (type HDC,
            type UINT,
            type UINT,
            type GLYPHMETRICS byaddr,
            type DWORD,
            type LPVOID, /* to outline character data */
            type MAT2 byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetGlyphOutlineW');

 %dcl GetGlyphOutline char ext;
 %if UNICODE ^= '' %then %do;
   %GetGlyphOutline='GetGlyphOutlineW';
 %end; %else %do;
   %GetGlyphOutline='GetGlyphOutlineA';
 %end; /* !UNICODE */

 dcl GetGraphicsMode
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetGraphicsMode');

 dcl GetMapMode
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetMapMode');

 dcl GetMetaFileBitsEx
     entry (type HMETAFILE,
            type UINT,
            type LPVOID) /* to metafile data buffer */
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetMetaFileBitsEx');

 dcl GetMetaFileA
     entry (char(*) varz byaddr nonasgn )
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('GetMetaFileA');

 dcl GetMetaFileW
     entry (WCHAR(*) varz byaddr nonasgn )
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('GetMetaFileW');

 %dcl GetMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %GetMetaFile='GetMetaFileW';
 %end; %else %do;
   %GetMetaFile='GetMetaFileA';
 %end; /* !UNICODE */

 dcl GetNearestColor
     entry (type HDC,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetNearestColor');

 dcl GetNearestPaletteIndex
     entry (type HPALETTE,
            type COLORREF)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetNearestPaletteIndex');

 dcl GetObjectType
     entry (type HGDIOBJ )
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetObjectType');

 %if NOTEXTMETRIC = '' %then %do;

 dcl GetOutlineTextMetricsA
     entry (type HDC,
            type UINT,
            (*) type OUTLINETEXTMETRICA byaddr optional)
     returns (type UINT byvalue optional)
     APIENTRY external('GetOutlineTextMetricsA');

 dcl GetOutlineTextMetricsW
     entry (type HDC,
            type UINT,
            (*) type LPOUTLINETEXTMETRICW byaddr optional)
     returns (type UINT byvalue optional)
     APIENTRY external('GetOutlineTextMetricsW');

 %dcl GetOutlineTextMetrics char ext;
 %if UNICODE ^= '' %then %do;
   %GetOutlineTextMetrics='GetOutlineTextMetricsW';
 %end; %else %do;
   %GetOutlineTextMetrics='GetOutlineTextMetricsA';
 %end; /* !UNICODE */

 %end; /* NOTEXTMETRIC */

 dcl GetPaletteEntries
     entry (type HPALETTE,
            type UINT,
            type UINT,
            (*) type PALETTEENTRY byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetPaletteEntries');

 dcl GetPixel
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetPixel');

 dcl GetPixelFormat
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetPixelFormat');

 dcl GetPolyFillMode
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetPolyFillMode');

 dcl GetRasterizerCaps
     entry (type RASTERIZER_STATUS byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetRasterizerCaps');

 dcl GetRegionData
     entry (type HRGN,
            type DWORD,
            pointer)  /* to RGNDATA */
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetRegionData');

 dcl GetRgnBox
     entry (type HRGN,
            type RECT byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetRgnBox');

 dcl GetStockObject
     entry (fixed bin(31) )
     returns (type HGDIOBJ byvalue optional)
     WINGDIAPI WINAPI external('GetStockObject');

 dcl GetStretchBltMode
     entry (type HDC )
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetStretchBltMode');

 dcl GetSystemPaletteEntries
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type PALETTEENTRY byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetSystemPaletteEntries');

 dcl GetSystemPaletteUse
     entry (type HDC)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetSystemPaletteUse');

 dcl GetTextCharacterExtra
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetTextCharacterExtra');

 dcl GetTextAlign
     entry (type HDC)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetTextAlign');

 dcl GetTextColor
     entry (type HDC)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('GetTextColor');

 dcl GetTextExtentPointA
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            fixed bin(31),
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentPointA');

 dcl GetTextExtentPointW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31),
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentPointW');

 %dcl GetTextExtentPoint char ext;
 %if UNICODE ^= '' %then %do;
   %GetTextExtentPoint='GetTextExtentPointW';
 %end; %else %do;
   %GetTextExtentPoint='GetTextExtentPointA';
 %end; /* !UNICODE */

 dcl GetTextExtentPoint32A
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            fixed bin(31),
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentPoint32A');

 dcl GetTextExtentPoint32W
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31),
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentPoint32W');

 %dcl GetTextExtentPoint32 char ext;
 %if UNICODE ^= '' %then %do;
   %GetTextExtentPoint32='GetTextExtentPoint32W';
 %end; %else %do;
   %GetTextExtentPoint32='GetTextExtentPoint32A';
 %end; /* !UNICODE */

 dcl GetTextExtentExPointA
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type INT byaddr optional,
            (*) type INT byaddr optional,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentExPointA');

 dcl GetTextExtentExPointW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type INT byaddr optional,
            (*) type INT byaddr optional,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetTextExtentExPointW');

 %dcl GetTextExtentExPoint char ext;
 %if UNICODE ^= '' %then %do;
   %GetTextExtentExPoint='GetTextExtentExPointW';
 %end; %else %do;
   %GetTextExtentExPoint='GetTextExtentExPointA';
 %end; /* !UNICODE */

 %if WINVER >= 1024 %then %do;
 dcl GetTextCharset
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetTextCharset');

 dcl GetTextCharsetInfo
     entry (type HDC,
            type FONTSIGNATURE byaddr,
            type DWORD)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetTextCharsetInfo');

 dcl TranslateCharsetInfo
     entry (type DWORD byaddr,
            type CHARSETINFO byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('TranslateCharsetInfo');

 dcl GetFontLanguageInfo
     entry (type HDC )
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetFontLanguageInfo');

 dcl GetCharacterPlacementA
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type GCP_RESULTSA byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetCharacterPlacementA');

 dcl GetCharacterPlacementW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type GCP_RESULTSW byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetCharacterPlacementW');

 %dcl GetCharacterPlacement char ext;
 %if UNICODE ^= '' %then %do;
   %GetCharacterPlacement='GetCharacterPlacementW';
 %end; %else %do;
   %GetCharacterPlacement='GetCharacterPlacementA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */


 %if #WIN32_WINNT >= 1280 %then %do;

 define structure
   1 WCRANGE,
     2 wcLow   WCHAR,
     2 cGlyphs type USHORT;
 define alias  PWCRANGE handle WCRANGE;
 define alias LPWCRANGE handle WCRANGE;

 define structure
   1 GLYPHSET,
     2 cbThis     type DWORD,
     2 flAccel    type DWORD,
     2 cGlyphsSupported type DWORD,
     2 cRanges    type DWORD,
     2 ranges (1) type WCRANGE;
 define alias  PGLYPHSET handle GLYPHSET;
 define alias LPGLYPHSET handle GLYPHSET;

 /* flAccel flags for the GLYPHSET structure above */

 dcl GS_8BIT_INDICES             type DWORD value('00000001'xu);

 /* flags for GetGlyphIndices */

 dcl GGI_MARK_NONEXISTING_GLYPHS fixed bin(15) value('0001'xn);

 dcl GetFontUnicodeRanges
     entry (type HDC,
            type GLYPHSET byaddr optional)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetFontUnicodeRanges');

 dcl GetGlyphIndicesA
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            fixed bin(31),
            (*) type WORD byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetGlyphIndicesA');

 dcl GetGlyphIndicesW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31),
            (*) type WORD byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetGlyphIndicesW');

 %dcl GetGlyphIndices char ext;
 %if UNICODE ^= '' %then %do;
   %GetGlyphIndices='GetGlyphIndicesW';
 %end; %else %do;
   %GetGlyphIndices='GetGlyphIndicesA';
 %end; /* !UNICODE */

 dcl GetTextExtentPointI
     entry (type HDC,
            type LPWORD,
            fixed bin(31),
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetTextExtentPointI');

 dcl GetTextExtentExPointI
     entry (type HDC,
            type LPWORD,
            fixed bin(31),
            fixed bin(31),
            type LPINT,
            type LPINT,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetTextExtentExPointI');

 dcl GetCharWidthI
     entry (type HDC,
            type UINT,
            type UINT,
            type LPWORD,
            (*) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharWidthI');

 dcl GetCharABCWidthsI
     entry (type HDC,
            type UINT,
            type UINT,
            type LPWORD,
            (*) type ABC byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetCharABCWidthsI');

 dcl STAMP_DESIGNVECTOR type DWORD
     value('8000000'xu + rank('d') + raise2 (rank('v'), 8));
 dcl STAMP_AXESLIST     type DWORD
     value('8000000'xu + rank('a') + raise2 (rank('l'), 8));
 dcl MM_MAX_NUMAXES     type DWORD value(16);


 define structure
   1 DESIGNVECTOR,
     2 dvReserved type DWORD,
     2 dvNumAxes  type DWORD,
     2 dvValues (MM_MAX_NUMAXES) type LONG;
 define alias  PDESIGNVECTOR handle DESIGNVECTOR;
 define alias LPDESIGNVECTOR handle DESIGNVECTOR;

 dcl AddFontResourceExA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type DESIGNVECTOR byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('AddFontResourceExA');

 dcl AddFontResourceExW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DESIGNVECTOR byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('AddFontResourceExW');

 %dcl AddFontResourceEx char ext;
 %if UNICODE ^= '' %then %do;
   %AddFontResourceEx='AddFontResourceExW';
 %end; %else %do;
   %AddFontResourceEx='AddFontResourceExA';
 %end; /* !UNICODE */

 dcl RemoveFontResourceExA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type DESIGNVECTOR byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RemoveFontResourceExA');

 dcl RemoveFontResourceExW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DESIGNVECTOR byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RemoveFontResourceExW');

 %dcl RemoveFontResourceEx char ext;
 %if UNICODE ^= '' %then %do;
   %RemoveFontResourceEx='RemoveFontResourceExW';
 %end; %else %do;
   %RemoveFontResourceEx='RemoveFontResourceExA';
 %end; /* !UNICODE */

 dcl AddFontMemResourceEx
     entry (type PVOID,
            type DWORD,
            type DESIGNVECTOR byaddr,
            type DWORD byaddr)
     returns (type HANDLE byvalue optional)
     WINGDIAPI WINAPI external('AddFontMemResourceEx');

 dcl RemoveFontMemResourceEx
     entry (type HANDLE )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RemoveFontMemResourceEx');

 dcl FR_PRIVATE  fixed bin(15) value('10'xn);
 dcl FR_NOT_ENUM fixed bin(15) value('20'xn);

 /* The actual size of the DESIGNVECTOR and ENUMLOGFONTEXDV */
 /* structures is determined by dvNumAxes,                  */
 /* MM_MAX_NUMAXES only determines the maximal size allowed */

 dcl MM_MAX_AXES_NAMELEN fixed bin(31) value(16);

 define structure
   1 AXISINFOA,
     2 axMinValue type LONG,
     2 axMaxValue type LONG,
     2 axAxisName char(MM_MAX_AXES_NAMELEN-1) varz;
 define alias  PAXISINFOA handle AXISINFOA;
 define alias LPAXISINFOA handle AXISINFOA;

 define structure
   1 AXISINFOW,
     2 axMinValue type LONG,
     2 axMaxValue type LONG,
     2 axAxisName WCHAR(MM_MAX_AXES_NAMELEN-1) varz;
 define alias  PAXISINFOW handle AXISINFOW;
 define alias LPAXISINFOW handle AXISINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   AXISINFO type   AXISINFOW;
 define alias  PAXISINFO type  PAXISINFOW;
 define alias LPAXISINFO type LPAXISINFOW;
 %end; %else %do;
 define alias   AXISINFO type   AXISINFOA;
 define alias  PAXISINFO type  PAXISINFOA;
 define alias LPAXISINFO type LPAXISINFOA;
 %end; /* UNICODE */

 define structure
   1 AXESLISTA,
     2 axlReserved type DWORD,
     2 axlNumAxes  type DWORD,
     2 axlAxisInfo (MM_MAX_NUMAXES) type AXISINFOA;
 define alias  PAXESLISTA handle AXESLISTA;
 define alias LPAXESLISTA handle AXESLISTA;

 define structure
   1 AXESLISTW,
     2 axlReserved type DWORD,
     2 axlNumAxes  type DWORD,
     2 axlAxisInfo (MM_MAX_NUMAXES) type AXISINFOW;
 define alias  PAXESLISTW handle AXESLISTW;
 define alias LPAXESLISTW handle AXESLISTW;

 %if UNICODE ^= '' %then %do;
 define alias   AXESLIST type   AXESLISTW;
 define alias  PAXESLIST type  PAXESLISTW;
 define alias LPAXESLIST type LPAXESLISTW;
 %end; %else %do;
 define alias   AXESLIST type   AXESLISTA;
 define alias  PAXESLIST type  PAXESLISTA;
 define alias LPAXESLIST type LPAXESLISTA;
 %end; /* UNICODE */

 /* The actual size of the AXESLIST and ENUMTEXTMETRIC structure */
 /* is determined by axlNumAxes,                                 */
 /* MM_MAX_NUMAXES only determines the maximal size allowed      */

 define structure
   1 ENUMLOGFONTEXDVA,
     2 elfEnumLogfontEx type ENUMLOGFONTEXA,
     2 elfDesignVector  type DESIGNVECTOR;
 define alias  PENUMLOGFONTEXDVA handle ENUMLOGFONTEXDVA;
 define alias LPENUMLOGFONTEXDVA handle ENUMLOGFONTEXDVA;

 define structure
   1 ENUMLOGFONTEXDVW,
     2 elfEnumLogfontEx type ENUMLOGFONTEXW,
     2 elfDesignVector  type DESIGNVECTOR;
 define alias  PENUMLOGFONTEXDVW handle ENUMLOGFONTEXDVW;
 define alias LPENUMLOGFONTEXDVW handle ENUMLOGFONTEXDVW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUMLOGFONTEXDV type   ENUMLOGFONTEXDVW;
 define alias  PENUMLOGFONTEXDV type  PENUMLOGFONTEXDVW;
 define alias LPENUMLOGFONTEXDV type LPENUMLOGFONTEXDVW;
 %end; %else %do;
 define alias   ENUMLOGFONTEXDV type   ENUMLOGFONTEXDVA;
 define alias  PENUMLOGFONTEXDV type  PENUMLOGFONTEXDVA;
 define alias LPENUMLOGFONTEXDV type LPENUMLOGFONTEXDVA;
 %end; /* UNICODE */


 dcl CreateFontIndirectExA
     entry (type ENUMLOGFONTEXDVA nonasgn byaddr)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontIndirectExA');

 dcl CreateFontIndirectExW
     entry (type ENUMLOGFONTEXDVW nonasgn byaddr)
     returns (type HFONT byvalue optional)
     WINGDIAPI WINAPI external('CreateFontIndirectExW');

 %dcl CreateFontIndirectEx char ext;
 %if UNICODE ^= '' %then %do;
   %CreateFontIndirectEx='CreateFontIndirectExW';
 %end; %else %do;
   %CreateFontIndirectEx='CreateFontIndirectExA';
 %end; /* !UNICODE */


 %if NOTEXTMETRIC = '' %then %do;
 define structure
   1 ENUMTEXTMETRICA,
     2 etmNewTextMetricEx type NEWTEXTMETRICEXA,
     2 etmAxesList        type AXESLISTA;
 define alias  PENUMTEXTMETRICA handle ENUMTEXTMETRICA;
 define alias LPENUMTEXTMETRICA handle ENUMTEXTMETRICA;

 define structure
   1 ENUMTEXTMETRICW,
     2 etmNewTextMetricEx type NEWTEXTMETRICEXW,
     2 etmAxesList        type AXESLISTW;
 define alias  PENUMTEXTMETRICW handle ENUMTEXTMETRICW;
 define alias LPENUMTEXTMETRICW handle ENUMTEXTMETRICW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUMTEXTMETRIC type   ENUMTEXTMETRICW;
 define alias  PENUMTEXTMETRIC type  PENUMTEXTMETRICW;
 define alias LPENUMTEXTMETRIC type LPENUMTEXTMETRICW;
 %end; %else %do;
 define alias   ENUMTEXTMETRIC type   ENUMTEXTMETRICA;
 define alias  PENUMTEXTMETRIC type  PENUMTEXTMETRICA;
 define alias LPENUMTEXTMETRIC type LPENUMTEXTMETRICA;
 %end; /* UNICODE */
 %end; /* NOTEXTMETRIC */

 %end; /* (_WIN32_WINNT >= 0x0500) */


 dcl GetViewportExtEx
     entry (type HDC,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetViewportExtEx');

 dcl GetViewportOrgEx
     entry (type HDC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetViewportOrgEx');

 dcl GetWindowExtEx
     entry (type HDC,
            type SIZE byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetWindowExtEx');

 dcl GetWindowOrgEx
     entry (type HDC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetWindowOrgEx');

 dcl IntersectClipRect
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('IntersectClipRect');

 dcl InvertRgn
     entry (type HDC,
            type HRGN)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('InvertRgn');

 dcl LineDDA
     entry (fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type LINEDDAPROC,
            type LPARAM)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('LineDDA');

 dcl LineTo
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('LineTo');

 dcl MaskBlt
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            type HBITMAP,
            fixed bin(31),
            fixed bin(31),
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('MaskBlt');

 dcl PlgBlt
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HBITMAP,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PlgBlt');

 dcl OffsetClipRgn
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('OffsetClipRgn');

 dcl OffsetRgn
     entry (type HRGN,
            fixed bin(31),
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('OffsetRgn');

 dcl PatBlt
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PatBlt');

 dcl Pie
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Pie');

 dcl PlayMetaFile
     entry (type HDC,
            type HMETAFILE)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PlayMetaFile');

 dcl PaintRgn
     entry (type HDC,
            type HRGN)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PaintRgn');

 dcl PolyPolygon
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            (*) type INT byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyPolygon');

 dcl PtInRegion
     entry (type HRGN,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PtInRegion');

 dcl PtVisible
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PtVisible');

 dcl RectInRegion
     entry (type HRGN,
            type RECT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RectInRegion');

 dcl RectVisible
     entry (type HDC,
            type RECT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RectVisible');

 dcl Rectangle
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Rectangle');

 dcl RestoreDC
     entry (type HDC,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RestoreDC');

 dcl ResetDCA
     entry (type HDC,
            type DEVMODEA byaddr optional nonasgn)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('ResetDCA');

 dcl ResetDCW
     entry (type HDC,
            type DEVMODEW byaddr optional nonasgn)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('ResetDCW');

 %dcl ResetDC char ext;
 %if UNICODE ^= '' %then %do;
   %ResetDC='ResetDCW';
 %end; %else %do;
   %ResetDC='ResetDCA';
 %end; /* !UNICODE */

 dcl RealizePalette
     entry (type HDC )
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('RealizePalette');

 dcl RemoveFontResourceA
     entry (char(*) varz byaddr nonasgn )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RemoveFontResourceA');

 dcl RemoveFontResourceW
     entry (WCHAR(*) varz byaddr nonasgn )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RemoveFontResourceW');

 %dcl RemoveFontResource char ext;
 %if UNICODE ^= '' %then %do;
   %RemoveFontResource='RemoveFontResourceW';
 %end; %else %do;
   %RemoveFontResource='RemoveFontResourceA';
 %end; /* !UNICODE */

 dcl RoundRect
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('RoundRect');

 dcl ResizePalette
     entry (type HPALETTE,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ResizePalette');

 dcl SaveDC
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SaveDC');

 dcl SelectClipRgn
     entry (type HDC,
            type HRGN)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SelectClipRgn');

 dcl ExtSelectClipRgn
     entry (type HDC,
            type HRGN,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('ExtSelectClipRgn');

 dcl SetMetaRgn
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetMetaRgn');

 dcl SelectObject
     entry (type HDC,
            type HGDIOBJ)
     returns (type HGDIOBJ byvalue optional)
     WINGDIAPI WINAPI external('SelectObject');

 dcl SelectPalette
     entry (type HDC,
            type HPALETTE,
            type BOOL)
     returns (type HPALETTE byvalue optional)
     WINGDIAPI WINAPI external('SelectPalette');

 dcl SetBkColor
     entry (type HDC,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('SetBkColor');


 %if #WIN32_WINNT >= 1280 %then %do;
 dcl SetDCBrushColor
     entry (type HDC,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('SetDCBrushColor');

 dcl SetDCPenColor
     entry (type HDC,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('SetDCPenColor');
 %end;

 dcl SetBkMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetBkMode');

 dcl SetBitmapBits
     entry (type HBITMAP,
            type DWORD,
            pointer) /* to array of bitmap bits */
     returns (type LONG byvalue optional)
     WINGDIAPI WINAPI external('SetBitmapBits');

 dcl SetBoundsRect
     entry (type HDC,
            type RECT byaddr nonasgn optional ,
            type UINT)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('SetBoundsRect');

 dcl SetDIBits
     entry (type HDC,
            type HBITMAP,
            type UINT,
            type UINT,
            pointer, /* to bitmap bits */
            pointer, /* to BITMAPINFO */
            type UINT)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetDIBits');

 dcl SetDIBitsToDevice
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type DWORD,
            type DWORD,
            fixed bin(31),
            fixed bin(31),
            type UINT,
            type UINT,
            pointer, /* to bitmap bits */
            pointer, /* to BITMAPINFO */
            type UINT)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetDIBitsToDevice');

 dcl SetMapperFlags
     entry (type HDC,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('SetMapperFlags');

 dcl SetGraphicsMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetGraphicsMode');

 dcl SetMapMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetMapMode');

 %if WINVER >= 1280 %then %do;
 dcl SetLayout
     entry (type HDC,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('SetLayout');

 dcl GetLayout
     entry (type HDC)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetLayout');
 %end; /* WINVER >= 0x0500 */

 dcl SetMetaFileBitsEx
     entry (type UINT,
            pointer) /* to metafile data */
     returns (type HMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('SetMetaFileBitsEx');

 dcl SetPaletteEntries
     entry (type HPALETTE,
            type UINT,
            type UINT,
            (*) type PALETTEENTRY byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('SetPaletteEntries');

 dcl SetPixel
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('SetPixel');

 dcl SetPixelV
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type COLORREF)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetPixelV');

 dcl SetPixelFormat
     entry (type HDC,
            fixed bin(31),
            type PIXELFORMATDESCRIPTOR byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetPixelFormat');

 dcl SetPolyFillMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetPolyFillMode');

 dcl StretchBlt
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('StretchBlt');

 dcl SetRectRgn
     entry (type HRGN,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetRectRgn');

 dcl StretchDIBits
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            pointer, /* to bitmap bits */
            pointer, /* to BITMAPINFO */
            type UINT,
            type DWORD)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('StretchDIBits');

 dcl SetROP2
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetROP2');

 dcl SetStretchBltMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetStretchBltMode');

 dcl SetSystemPaletteUse
     entry (type HDC,
            type UINT)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('SetSystemPaletteUse');

 dcl SetTextCharacterExtra
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetTextCharacterExtra');

 dcl SetTextColor
     entry (type HDC,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINGDIAPI WINAPI external('SetTextColor');

 dcl SetTextAlign
     entry (type HDC,
            type UINT)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('SetTextAlign');

 dcl SetTextJustification
     entry (type HDC,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetTextJustification');

 dcl UpdateColors
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('UpdateColors');


 %if WINVER >= 1024 %then %do;

 /* image blt */

 define alias COLOR16 type USHORT;

 define structure
   1 TRIVERTEX,
     2 x     type LONG,
     2 y     type LONG,
     2 Red   type COLOR16,
     2 Green type COLOR16,
     2 Blue  type COLOR16,
     2 Alpha type COLOR16;
 define alias  PTRIVERTEX handle TRIVERTEX;
 define alias LPTRIVERTEX handle TRIVERTEX;

 define structure
   1 GRADIENT_TRIANGLE,
     2 Vertex1 type ULONG,
     2 Vertex2 type ULONG,
     2 Vertex3 type ULONG;
 define alias  PGRADIENT_TRIANGLE handle GRADIENT_TRIANGLE;
 define alias LPGRADIENT_TRIANGLE handle GRADIENT_TRIANGLE;

 define structure
   1 GRADIENT_RECT,
     2 UpperLeft  type ULONG,
     2 LowerRight type ULONG;

 define alias  PGRADIENT_RECT handle GRADIENT_RECT;
 define alias LPGRADIENT_RECT handle GRADIENT_RECT;

 define structure
   1 BLENDFUNCTION,
     2 BlendOp             type BYTE,
     2 BlendFlags          type BYTE,
     2 SourceConstantAlpha type BYTE,
     2 AlphaFormat         type BYTE;
 define alias  PBLENDFUNCTION handle BLENDFUNCTION;


 /* currently defined blend function */

 dcl AC_SRC_OVER fixed bin(15) value('00'xn);


 /* alpha format flags */

 dcl AC_SRC_NO_PREMULT_ALPHA fixed bin(15) value('01'xn);
 dcl AC_SRC_NO_ALPHA         fixed bin(15) value('02'xn);
 dcl AC_DST_NO_PREMULT_ALPHA fixed bin(15) value('10'xn);
 dcl AC_DST_NO_ALPHA         fixed bin(15) value('20'xn);

 dcl AlphaBlend
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type BLENDFUNCTION)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('AlphaBlend');

 dcl AlphaDIBBlend
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            pointer, /* to data */
            pointer, /* to BITMAPINFO */
            type UINT,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type BLENDFUNCTION)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('AlphaDIBBlend');

 dcl TransparentBlt
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('TransparentBlt');

 dcl TransparentDIBits
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            pointer, /* to data */
            pointer, /* to BITMAPINFO */
            type UINT,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('TransparentDIBits');


 /* gradient drawing modes */

 dcl GRADIENT_FILL_RECT_H   type ULONG value('00000000'xu);
 dcl GRADIENT_FILL_RECT_V   type ULONG value('00000001'xu);
 dcl GRADIENT_FILL_TRIANGLE type ULONG value('00000002'xu);
 dcl GRADIENT_FILL_OP_FLAG  type ULONG value('000000ff'xu);

 dcl GradientFill
     entry (type HDC,
            type TRIVERTEX byaddr,
            type ULONG,
            type PVOID,
            type ULONG,
            type ULONG)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GradientFill');

 %end;


 %if NOMETAFILE = '' %then %do;

 dcl PlayMetaFileRecord
     entry (type HDC,
            type LPHANDLETABLE,
            type LPMETARECORD,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PlayMetaFileRecord');

 define alias MFENUMPROC
        entry (type HDC,
               type LPHANDLETABLE,   /* to HANDLETABLE */
               type LPMETARECORD,    /* to METARECORD */
               fixed bin(31),
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 dcl EnumMetaFile
     entry (type HDC,
            type HMETAFILE,
            type MFENUMPROC,
            type LPARAM)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('EnumMetaFile');

 define alias ENHMFENUMPROC
        entry (type HDC,
               type LPHANDLETABLE,   /* to HANDLETABLE */
               type LPENHMETARECORD, /* to ENHMETARECORD */
               fixed bin(31),
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 /* Enhanced Metafile Function Declarations */

 dcl CloseEnhMetaFile
     entry (type HDC )
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CloseEnhMetaFile');

 dcl CopyEnhMetaFileA
     entry (type HENHMETAFILE,
            char(*) varz byaddr nonasgn)
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CopyEnhMetaFileA');

 dcl CopyEnhMetaFileW
     entry (type HENHMETAFILE,
            WCHAR(*) varz byaddr nonasgn)
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('CopyEnhMetaFileW');

 %dcl CopyEnhMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %CopyEnhMetaFile='CopyEnhMetaFileW';
 %end; %else %do;
   %CopyEnhMetaFile='CopyEnhMetaFileA';
 %end; /* !UNICODE */

 dcl CreateEnhMetaFileA
     entry (type HDC,
            char(*) varz byaddr nonasgn,
            type RECT byaddr nonasgn,
            char(*) varz byaddr nonasgn)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateEnhMetaFileA');

 dcl CreateEnhMetaFileW
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            type RECT byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('CreateEnhMetaFileW');

 %dcl CreateEnhMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %CreateEnhMetaFile='CreateEnhMetaFileW';
 %end; %else %do;
   %CreateEnhMetaFile='CreateEnhMetaFileA';
 %end; /* !UNICODE */

 dcl DeleteEnhMetaFile
     entry (type HENHMETAFILE )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DeleteEnhMetaFile');

 dcl EnumEnhMetaFile
     entry (type HDC,
            type HENHMETAFILE,
            type ENHMFENUMPROC,
            type LPVOID,
            type RECT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('EnumEnhMetaFile');

 dcl GetEnhMetaFileA
     entry (char(*) varz byaddr nonasgn )
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileA');

 dcl GetEnhMetaFileW
     entry (WCHAR(*) varz byaddr nonasgn )
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileW');

 %dcl GetEnhMetaFile char ext;
 %if UNICODE ^= '' %then %do;
   %GetEnhMetaFile='GetEnhMetaFileW';
 %end; %else %do;
   %GetEnhMetaFile='GetEnhMetaFileA';
 %end; /* !UNICODE */

 dcl GetEnhMetaFileBits
     entry (type HENHMETAFILE,
            type UINT,
            type LPBYTE) /* to metafile data buffer */
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileBits');

 dcl GetEnhMetaFileDescriptionA
     entry (type HENHMETAFILE,
            type UINT,
            char(*) varz byaddr optional)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileDescriptionA');

 dcl GetEnhMetaFileDescriptionW
     entry (type HENHMETAFILE,
            type UINT,
            WCHAR(*) varz byaddr optional)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileDescriptionW');

 %dcl GetEnhMetaFileDescription char ext;
 %if UNICODE ^= '' %then %do;
   %GetEnhMetaFileDescription='GetEnhMetaFileDescriptionW';
 %end; %else %do;
   %GetEnhMetaFileDescription='GetEnhMetaFileDescriptionA';
 %end; /* !UNICODE */

 dcl GetEnhMetaFileHeader
     entry (type HENHMETAFILE,
            type UINT,
            type ENHMETAHEADER byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFileHeader');

 dcl GetEnhMetaFilePaletteEntries
     entry (type HENHMETAFILE,
            type UINT,
            type LPPALETTEENTRY) /* to PALETTEENTRY */
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFilePaletteEntries');

 dcl GetEnhMetaFilePixelFormat
     entry (type HENHMETAFILE,
            type UINT,
            type PIXELFORMATDESCRIPTOR byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetEnhMetaFilePixelFormat');

 dcl GetWinMetaFileBits
     entry (type HENHMETAFILE,
            type UINT,
            type LPBYTE, /* buffer for converted records */
            type INT,
            type HDC)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetWinMetaFileBits');

 dcl PlayEnhMetaFile
     entry (type HDC,
            type HENHMETAFILE,
            type RECT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PlayEnhMetaFile');

 dcl PlayEnhMetaFileRecord
     entry (type HDC,
            type LPHANDLETABLE,
            type LPENHMETARECORD, /* to ENHMETARECORD */
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PlayEnhMetaFileRecord');

 dcl SetEnhMetaFileBits
     entry (type UINT,
            type LPBYTE) /* to metafile date buffer */
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('SetEnhMetaFileBits');

 dcl SetWinMetaFileBits
     entry (type UINT,
            type LPBYTE, /* to buffer of converted records */
            type HDC,
            type METAFILEPICT byaddr nonasgn)
     returns (type HENHMETAFILE byvalue optional)
     WINGDIAPI WINAPI external('SetWinMetaFileBits');

 dcl GdiComment
     entry (type HDC,
            type UINT,
            pointer) /* to binary comment data */
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GdiComment');

 %end; /* NOMETAFILE */

 %if NOTEXTMETRIC = '' %then %do;

 dcl GetTextMetricsA
     entry (type HDC,
            type TEXTMETRICA byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetTextMetricsA');

 dcl GetTextMetricsW
     entry (type HDC,
            type TEXTMETRICW byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetTextMetricsW');

 %dcl GetTextMetrics char ext;
 %if UNICODE ^= '' %then %do;
   %GetTextMetrics='GetTextMetricsW';
 %end; %else %do;
   %GetTextMetrics='GetTextMetricsA';
 %end; /* !UNICODE */

 %end;

 /* new GDI */

 define structure
   1 DIBSECTION,
     2 dsBm        type BITMAP,
     2 dsBmih      type BITMAPINFOHEADER,
     2 dsBitfields (3) type DWORD,
     2 dshSection  type HANDLE,
     2 dsOffset    type DWORD;
 define alias LPDIBSECTION handle DIBSECTION;
 define alias  PDIBSECTION handle DIBSECTION;

 dcl AngleArc
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type DWORD,
            type FLOAT,
            type FLOAT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('AngleArc');

 dcl PolyPolyline
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            (*) type DWORD byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyPolyline');

 dcl GetWorldTransform
     entry (type HDC,
            type XFORM byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetWorldTransform');

 dcl SetWorldTransform
     entry (type HDC,
            type XFORM byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetWorldTransform');

 dcl ModifyWorldTransform
     entry (type HDC,
            type XFORM byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ModifyWorldTransform');

 dcl CombineTransform
     entry (type XFORM byaddr,
            type XFORM byaddr nonasgn,
            type XFORM byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CombineTransform');

 dcl CreateDIBSection
     entry (type HDC,
            pointer, /* to BITMAPINFO */,
            type UINT,
            pointer,
            type HANDLE,
            type DWORD)
     returns (type HBITMAP byvalue optional)
     WINGDIAPI WINAPI external('CreateDIBSection');

 dcl GetDIBColorTable
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type RGBQUAD byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('GetDIBColorTable');

 dcl SetDIBColorTable
     entry (type HDC,
            type UINT,
            type UINT,
            (*) type RGBQUAD byaddr)
     returns (type UINT byvalue optional)
     WINGDIAPI WINAPI external('SetDIBColorTable');

 /* Flags value for COLORADJUSTMENT */
 dcl CA_NEGATIVE               type WORD value('0001'xn);
 dcl CA_LOG_FILTER             type WORD value('0002'xn);

 /* IlluminantIndex values */
 dcl ILLUMINANT_DEVICE_DEFAULT type WORD value(0);
 dcl ILLUMINANT_A              type WORD value(1);
 dcl ILLUMINANT_B              type WORD value(2);
 dcl ILLUMINANT_C              type WORD value(3);
 dcl ILLUMINANT_D50            type WORD value(4);
 dcl ILLUMINANT_D55            type WORD value(5);
 dcl ILLUMINANT_D65            type WORD value(6);
 dcl ILLUMINANT_D75            type WORD value(7);
 dcl ILLUMINANT_F2             type WORD value(8);
 dcl ILLUMINANT_MAX_INDEX      type WORD value(ILLUMINANT_F2);

 dcl ILLUMINANT_TUNGSTEN       type WORD value(ILLUMINANT_A);
 dcl ILLUMINANT_DAYLIGHT       type WORD value(ILLUMINANT_C);
 dcl ILLUMINANT_FLUORESCENT    type WORD value(ILLUMINANT_F2);
 dcl ILLUMINANT_NTSC           type WORD value(ILLUMINANT_C);

 /* Min and max for RedGamma, GreenGamma, BlueGamma */
 dcl RGB_GAMMA_MIN             type WORD value(02500);
 dcl RGB_GAMMA_MAX             type WORD value(65000);

 /* Min and max for ReferenceBlack and ReferenceWhite */
 dcl REFERENCE_WHITE_MIN       type WORD value(6000);
 dcl REFERENCE_WHITE_MAX       type WORD value(10000);
 dcl REFERENCE_BLACK_MIN       type WORD value(0);
 dcl REFERENCE_BLACK_MAX       type WORD value(4000);

 /* Min and max for Contrast, Brightness, Colorfulness, RedGreenTint */
 dcl COLOR_ADJ_MIN             type SHORT value(-100);
 dcl COLOR_ADJ_MAX             type SHORT value(100);

 define structure
   1 COLORADJUSTMENT,
     2 caSize            type WORD,
     2 caFlags           type WORD,
     2 caIlluminantIndex type WORD,
     2 caRedGamma        type WORD,
     2 caGreenGamma      type WORD,
     2 caBlueGamma       type WORD,
     2 caReferenceBlack  type WORD,
     2 caReferenceWhite  type WORD,
     2 caContrast        type SHORT,
     2 caBrightness      type SHORT,
     2 caColorfulness    type SHORT,
     2 caRedGreenTint    type SHORT;
 define alias  PCOLORADJUSTMENT handle COLORADJUSTMENT;
 define alias LPCOLORADJUSTMENT handle COLORADJUSTMENT;

 dcl SetColorAdjustment
     entry (type HDC,
            type COLORADJUSTMENT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetColorAdjustment');

 dcl GetColorAdjustment
     entry (type HDC,
            type COLORADJUSTMENT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetColorAdjustment');

 dcl CreateHalftonePalette
     entry (type HDC)
     returns (type HPALETTE byvalue optional)
     WINGDIAPI WINAPI external('CreateHalftonePalette');

 define alias ABORTPROC
        entry (type HDC,
               fixed bin(31))
        returns (type BOOL byvalue optional)
        limited CALLBACK;

 define structure
   1 DOCINFOA,
     2 cbSize       fixed bin(31),
     2 lpszDocName  type LPCSTR,
     2 lpszOutput   type LPCSTR
 %if WINVER >= 1024 %then %do;
   , 2 lpszDatatype type LPCSTR,
     2 fwType       type DWORD
 %end; /* WINVER */
   ;
 define alias LPDOCINFOA handle DOCINFOA;

 define structure
   1 DOCINFOW,
     2 cbSize       fixed bin(31),
     2 lpszDocName  type LPCWSTR,
     2 lpszOutput   type LPCWSTR
 %if WINVER >= 1024 %then %do;
   , 2 lpszDatatype type LPCWSTR,
     2 fwType       type DWORD
 %end; /* WINVER */
   ;
 define alias LPDOCINFOW handle DOCINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   DOCINFO type DOCINFOW;
 define alias LPDOCINFO type LPDOCINFOW;
 %end; %else %do;
 define alias   DOCINFO type DOCINFOA;
 define alias LPDOCINFO type LPDOCINFOA;
 %end; /* UNICODE */


 %if WINVER >= 1024 %then %do;
 dcl DI_APPBANDING            type DWORD value('00000001'xu);
 dcl DI_ROPS_READ_DESTINATION type DWORD value('00000002'xu);
 %end; /* WINVER >= 0x0400 */

 dcl StartDocA
     entry (type HDC,
            type DOCINFOA byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('StartDocA');

 dcl StartDocW
     entry (type HDC,
            type DOCINFOW byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('StartDocW');

 %dcl StartDoc char ext;
 %if UNICODE ^= '' %then %do;
   %StartDoc='StartDocW';
 %end; %else %do;
   %StartDoc='StartDocA';
 %end; /* !UNICODE */

 dcl EndDoc
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EndDoc');

 dcl StartPage
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('StartPage');

 dcl EndPage
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EndPage');

 dcl AbortDoc
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('AbortDoc');

 dcl SetAbortProc
     entry (type HDC,
            type ABORTPROC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetAbortProc');

 dcl AbortPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('AbortPath');

 dcl ArcTo
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ArcTo');

 dcl BeginPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('BeginPath');

 dcl CloseFigure
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CloseFigure');

 dcl EndPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('EndPath');

 dcl FillPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FillPath');

 dcl FlattenPath
     entry (type HDC )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FlattenPath');

 dcl GetPath
     entry (type HDC,
            (*) type POINT byaddr nonasgn optional,
            (*) type BYTE  byaddr nonasgn optional,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetPath');

 dcl PathToRegion
     entry (type HDC)
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('PathToRegion');

 dcl PolyDraw
     entry (type HDC,
            (*) type POINT byaddr nonasgn optional,
            (*) type BYTE  byaddr nonasgn optional,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyDraw');

 dcl SelectClipPath
     entry (type HDC,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SelectClipPath');

 dcl SetArcDirection
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetArcDirection');

 dcl SetMiterLimit
     entry (type HDC,
            type FLOAT,
            type FLOAT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetMiterLimit');

 dcl StrokeAndFillPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('StrokeAndFillPath');

 dcl StrokePath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('StrokePath');

 dcl WidenPath
     entry (type HDC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('WidenPath');

 dcl ExtCreatePen
     entry (type DWORD,
            type DWORD,
            type LOGBRUSH byaddr nonasgn,
            type DWORD,
            (*) type DWORD byaddr optional)
     returns (type HPEN byvalue optional)
     WINGDIAPI WINAPI external('ExtCreatePen');

 dcl GetMiterLimit
     entry (type HDC,
            type FLOAT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetMiterLimit');

 dcl GetArcDirection
     entry (type HDC)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetArcDirection');

 dcl GetObjectA
     entry (type HGDIOBJ,
            fixed bin(31),
            type LPVOID)  /* to object type specific object buffer */
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetObjectA');

 dcl GetObjectW
     entry (type HGDIOBJ,
            fixed bin(31),
            type LPVOID)  /* to object type specific object buffer */
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetObjectW');

 %dcl GetObject char ext;
 %if UNICODE ^= '' %then %do;
   %GetObject='GetObjectW';
 %end; %else %do;
   %GetObject='GetObjectA';
 %end; /* !UNICODE */

 dcl MoveToEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('MoveToEx');

 dcl TextOutA
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            char(*) varz byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('TextOutA');

 dcl TextOutW
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            WCHAR(*) varz byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('TextOutW');

 %dcl TextOut char ext;
 %if UNICODE ^= '' %then %do;
   %TextOut='TextOutW';
 %end; %else %do;
   %TextOut='TextOutA';
 %end; /* !UNICODE */

 dcl ExtTextOutA
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type UINT,
            type RECT byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            type UINT,
            (*) type INT byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ExtTextOutA');

 dcl ExtTextOutW
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type UINT,
            type RECT byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            (*) type INT byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ExtTextOutW');

 %dcl ExtTextOut char ext;
 %if UNICODE ^= '' %then %do;
   %ExtTextOut='ExtTextOutW';
 %end; %else %do;
   %ExtTextOut='ExtTextOutA';
 %end; /* !UNICODE */

 dcl PolyTextOutA
     entry (type HDC,
            (*) type POLYTEXTA byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyTextOutA');

 dcl PolyTextOutW
     entry (type HDC,
            (*) type POLYTEXTW byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyTextOutW');

 %dcl PolyTextOut char ext;
 %if UNICODE ^= '' %then %do;
   %PolyTextOut='PolyTextOutW';
 %end; %else %do;
   %PolyTextOut='PolyTextOutA';
 %end; /* !UNICODE */

 dcl CreatePolygonRgn
     entry ((*) type POINT byaddr nonasgn,
            fixed bin(31),
            fixed bin(31))
     returns (type HRGN byvalue optional)
     WINGDIAPI WINAPI external('CreatePolygonRgn');

 dcl DPtoLP
     entry (type HDC,
            (*) type POINT byaddr,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DPtoLP');

 dcl LPtoDP
     entry (type HDC,
            (*) type POINT byaddr,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('LPtoDP');

 dcl Polygon
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Polygon');

 dcl Polyline
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('Polyline');

 dcl PolyBezier
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyBezier');

 dcl PolyBezierTo
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolyBezierTo');

 dcl PolylineTo
     entry (type HDC,
            (*) type POINT byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('PolylineTo');

 dcl SetViewportExtEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type SIZE byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetViewportExtEx');

 dcl SetViewportOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetViewportOrgEx');

 dcl SetWindowExtEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type SIZE byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetWindowExtEx');

 dcl SetWindowOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetWindowOrgEx');

 dcl OffsetViewportOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('OffsetViewportOrgEx');

 dcl OffsetWindowOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('OffsetWindowOrgEx');

 dcl ScaleViewportExtEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type SIZE byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ScaleViewportExtEx');

 dcl ScaleWindowExtEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type SIZE byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ScaleWindowExtEx');

 dcl SetBitmapDimensionEx
     entry (type HBITMAP,
            fixed bin(31),
            fixed bin(31),
            type SIZE byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetBitmapDimensionEx');

 dcl SetBrushOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr optional)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetBrushOrgEx');

 dcl GetTextFaceA
     entry (type HDC,
            fixed bin(31),
            char(*) varz byaddr optional)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetTextFaceA');

 dcl GetTextFaceW
     entry (type HDC,
            fixed bin(31),
            WCHAR(*) varz byaddr optional)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('GetTextFaceW');

 %dcl GetTextFace char ext;
 %if UNICODE ^= '' %then %do;
   %GetTextFace='GetTextFaceW';
 %end; %else %do;
   %GetTextFace='GetTextFaceA';
 %end; /* !UNICODE */

 dcl FONTMAPPER_MAX fixed bin(31) value(10);

 define structure
   1 KERNINGPAIR,
     2 wFirst      type WORD,
     2 wSecond     type WORD,
     2 iKernAmount fixed bin(31);
 define alias LPKERNINGPAIR handle KERNINGPAIR;

 dcl GetKerningPairsA
     entry (type HDC,
            type DWORD,
            (*) type KERNINGPAIR byaddr optional)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetKerningPairsA');

 dcl GetKerningPairsW
     entry (type HDC,
            type DWORD,
            (*) type KERNINGPAIR byaddr optional)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GetKerningPairsW');

 %dcl GetKerningPairs char ext;
 %if UNICODE ^= '' %then %do;
   %GetKerningPairs='GetKerningPairsW';
 %end; %else %do;
   %GetKerningPairs='GetKerningPairsA';
 %end; /* !UNICODE */

 dcl GetDCOrgEx
     entry (type HDC,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetDCOrgEx');

 dcl FixBrushOrgEx
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('FixBrushOrgEx');

 dcl UnrealizeObject
     entry (type HGDIOBJ )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('UnrealizeObject');

 dcl GdiFlush
     entry ()
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GdiFlush');

 dcl GdiSetBatchLimit
     entry (type DWORD )
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GdiSetBatchLimit');

 dcl GdiGetBatchLimit
     entry ()
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('GdiGetBatchLimit');

 %if WINVER >= 1024 %then %do;

 dcl ICM_OFF            fixed bin(31) value(1);
 dcl ICM_ON             fixed bin(31) value(2);
 dcl ICM_QUERY          fixed bin(31) value(3);
 dcl ICM_DONE_OUTSIDEDC fixed bin(31) value(4);

 define alias ICMENUMPROCA
        entry (type LPSTR,  /* to char(*) varz byaddr */
               type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 define alias ICMENUMPROCW
        entry  (type LPWSTR, /* to WCHAR(*) varz byaddr */
                type LPARAM)
        returns (fixed bin(31) byvalue optional)
        limited CALLBACK;

 %if UNICODE ^= '' %then %do;
 define alias ICMENUMPROC type ICMENUMPROCW;
 %end; %else %do;
 define alias ICMENUMPROC type ICMENUMPROCA;
 %end; /* !UNICODE */

 dcl SetICMMode
     entry (type HDC,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('SetICMMode');

 dcl CheckColorsInGamut
     entry (type HDC,
            type LPVOID,
            type LPVOID,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('CheckColorsInGamut');

 dcl GetColorSpace
     entry (type HDC)
     returns (type HCOLORSPACE byvalue optional)
     WINGDIAPI WINAPI external('GetColorSpace');

 dcl GetLogColorSpaceA
     entry (type HCOLORSPACE,
            type LOGCOLORSPACEA byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetLogColorSpaceA');

 dcl GetLogColorSpaceW
     entry (type HCOLORSPACE,
            type LOGCOLORSPACEW byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetLogColorSpaceW');

 %dcl GetLogColorSpace char ext;
 %if UNICODE ^= '' %then %do;
   %GetLogColorSpace='GetLogColorSpaceW';
 %end; %else %do;
   %GetLogColorSpace='GetLogColorSpaceA';
 %end; /* !UNICODE */

 dcl CreateColorSpaceA
     entry (type LOGCOLORSPACEA byaddr)
     returns (type HCOLORSPACE byvalue optional)
     WINGDIAPI WINAPI external('CreateColorSpaceA');

 dcl CreateColorSpaceW
     entry (type LOGCOLORSPACEW byaddr)
     returns (type HCOLORSPACE byvalue optional)
     WINGDIAPI WINAPI external('CreateColorSpaceW');

 %dcl CreateColorSpace char ext;
 %if UNICODE ^= '' %then %do;
   %CreateColorSpace='CreateColorSpaceW';
 %end; %else %do;
   %CreateColorSpace='CreateColorSpaceA';
 %end; /* !UNICODE */

 dcl SetColorSpace
     entry (type HDC,
            type HCOLORSPACE)
     returns (type HCOLORSPACE byvalue optional)
     WINGDIAPI WINAPI external('SetColorSpace');

 dcl DeleteColorSpace
     entry (type HCOLORSPACE )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('DeleteColorSpace');

 dcl GetICMProfileA
     entry (type HDC,
            type DWORD byaddr,
            char(*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetICMProfileA');

 dcl GetICMProfileW
     entry (type HDC,
            type DWORD byaddr,
            WCHAR(*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetICMProfileW');

 %dcl GetICMProfile char ext;
 %if UNICODE ^= '' %then %do;
   %GetICMProfile='GetICMProfileW';
 %end; %else %do;
   %GetICMProfile='GetICMProfileA';
 %end; /* !UNICODE */

 dcl SetICMProfileA
     entry (type HDC,
            char(*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetICMProfileA');

 dcl SetICMProfileW
     entry (type HDC,
            WCHAR(*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetICMProfileW');

 %dcl SetICMProfile char ext;
 %if UNICODE ^= '' %then %do;
   %SetICMProfile='SetICMProfileW';
 %end; %else %do;
   %SetICMProfile='SetICMProfileA';
 %end; /* !UNICODE */

 dcl GetDeviceGammaRamp
     entry (type HDC,
            (3, 256) type WORD byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('GetDeviceGammaRamp');

 dcl SetDeviceGammaRamp
     entry (type HDC,
            (3, 256) type WORD byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SetDeviceGammaRamp');

 dcl ColorMatchToTarget
     entry (type HDC,
            type HDC,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ColorMatchToTarget');

 dcl EnumICMProfilesA
     entry (type HDC,
            type ICMENUMPROCA,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumICMProfilesA');

 dcl EnumICMProfilesW
     entry (type HDC,
            type ICMENUMPROCW,
            type LPARAM)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('EnumICMProfilesW');

 %dcl EnumICMProfiles char ext;
 %if UNICODE ^= '' %then %do;
   %EnumICMProfiles='EnumICMProfilesW';
 %end; %else %do;
   %EnumICMProfiles='EnumICMProfilesA';
 %end; /* !UNICODE */

 dcl UpdateICMRegKeyA
     entry (type DWORD,
            char(*) varz byaddr,
            char(*) varz byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('UpdateICMRegKeyA');

 dcl UpdateICMRegKeyW
     entry (type DWORD,
            WCHAR(*) varz byaddr,
            WCHAR(*) varz byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('UpdateICMRegKeyW');

 %dcl UpdateICMRegKey char ext;
 %if UNICODE ^= '' %then %do;
   %UpdateICMRegKey='UpdateICMRegKeyW';
 %end; %else %do;
   %UpdateICMRegKey='UpdateICMRegKeyA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */


 %if WINVER >= 1280 %then %do;
 dcl ColorCorrectPalette
     entry (type HDC,
            type HPALETTE,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('ColorCorrectPalette');
 %end;

 %if NOMETAFILE = '' %then %do;

 /* Enhanced metafile constants. */

 dcl ENHMETA_SIGNATURE            type DWORD value('464D4520'xu);

 /* Stock object flag used in the object handle index in the enhanced */
 /* metafile records. */
 /* E.g. The object handle index (META_STOCK_OBJECT | BLACK_BRUSH) */
 /* represents the stock object BLACK_BRUSH. */

 dcl ENHMETA_STOCK_OBJECT         type DWORD value('80000000'xu);

 /* Enhanced metafile record types. */

 dcl EMR_HEADER                   type DWORD value(1);
 dcl EMR_POLYBEZIER               type DWORD value(2);
 dcl EMR_POLYGON                  type DWORD value(3);
 dcl EMR_POLYLINE                 type DWORD value(4);
 dcl EMR_POLYBEZIERTO             type DWORD value(5);
 dcl EMR_POLYLINETO               type DWORD value(6);
 dcl EMR_POLYPOLYLINE             type DWORD value(7);
 dcl EMR_POLYPOLYGON              type DWORD value(8);
 dcl EMR_SETWINDOWEXTEX           type DWORD value(9);
 dcl EMR_SETWINDOWORGEX           type DWORD value(10);
 dcl EMR_SETVIEWPORTEXTEX         type DWORD value(11);
 dcl EMR_SETVIEWPORTORGEX         type DWORD value(12);
 dcl EMR_SETBRUSHORGEX            type DWORD value(13);
 dcl EMR_EOF                      type DWORD value(14);
 dcl EMR_SETPIXELV                type DWORD value(15);
 dcl EMR_SETMAPPERFLAGS           type DWORD value(16);
 dcl EMR_SETMAPMODE               type DWORD value(17);
 dcl EMR_SETBKMODE                type DWORD value(18);
 dcl EMR_SETPOLYFILLMODE          type DWORD value(19);
 dcl EMR_SETROP2                  type DWORD value(20);
 dcl EMR_SETSTRETCHBLTMODE        type DWORD value(21);
 dcl EMR_SETTEXTALIGN             type DWORD value(22);
 dcl EMR_SETCOLORADJUSTMENT       type DWORD value(23);
 dcl EMR_SETTEXTCOLOR             type DWORD value(24);
 dcl EMR_SETBKCOLOR               type DWORD value(25);
 dcl EMR_OFFSETCLIPRGN            type DWORD value(26);
 dcl EMR_MOVETOEX                 type DWORD value(27);
 dcl EMR_SETMETARGN               type DWORD value(28);
 dcl EMR_EXCLUDECLIPRECT          type DWORD value(29);
 dcl EMR_INTERSECTCLIPRECT        type DWORD value(30);
 dcl EMR_SCALEVIEWPORTEXTEX       type DWORD value(31);
 dcl EMR_SCALEWINDOWEXTEX         type DWORD value(32);
 dcl EMR_SAVEDC                   type DWORD value(33);
 dcl EMR_RESTOREDC                type DWORD value(34);
 dcl EMR_SETWORLDTRANSFORM        type DWORD value(35);
 dcl EMR_MODIFYWORLDTRANSFORM     type DWORD value(36);
 dcl EMR_SELECTOBJECT             type DWORD value(37);
 dcl EMR_CREATEPEN                type DWORD value(38);
 dcl EMR_CREATEBRUSHINDIRECT      type DWORD value(39);
 dcl EMR_DELETEOBJECT             type DWORD value(40);
 dcl EMR_ANGLEARC                 type DWORD value(41);
 dcl EMR_ELLIPSE                  type DWORD value(42);
 dcl EMR_RECTANGLE                type DWORD value(43);
 dcl EMR_ROUNDRECT                type DWORD value(44);
 dcl EMR_ARC                      type DWORD value(45);
 dcl EMR_CHORD                    type DWORD value(46);
 dcl EMR_PIE                      type DWORD value(47);
 dcl EMR_SELECTPALETTE            type DWORD value(48);
 dcl EMR_CREATEPALETTE            type DWORD value(49);
 dcl EMR_SETPALETTEENTRIES        type DWORD value(50);
 dcl EMR_RESIZEPALETTE            type DWORD value(51);
 dcl EMR_REALIZEPALETTE           type DWORD value(52);
 dcl EMR_EXTFLOODFILL             type DWORD value(53);
 dcl EMR_LINETO                   type DWORD value(54);
 dcl EMR_ARCTO                    type DWORD value(55);
 dcl EMR_POLYDRAW                 type DWORD value(56);
 dcl EMR_SETARCDIRECTION          type DWORD value(57);
 dcl EMR_SETMITERLIMIT            type DWORD value(58);
 dcl EMR_BEGINPATH                type DWORD value(59);
 dcl EMR_ENDPATH                  type DWORD value(60);
 dcl EMR_CLOSEFIGURE              type DWORD value(61);
 dcl EMR_FILLPATH                 type DWORD value(62);
 dcl EMR_STROKEANDFILLPATH        type DWORD value(63);
 dcl EMR_STROKEPATH               type DWORD value(64);
 dcl EMR_FLATTENPATH              type DWORD value(65);
 dcl EMR_WIDENPATH                type DWORD value(66);
 dcl EMR_SELECTCLIPPATH           type DWORD value(67);
 dcl EMR_ABORTPATH                type DWORD value(68);

 dcl EMR_GDICOMMENT               type DWORD value(70);
 dcl EMR_FILLRGN                  type DWORD value(71);
 dcl EMR_FRAMERGN                 type DWORD value(72);
 dcl EMR_INVERTRGN                type DWORD value(73);
 dcl EMR_PAINTRGN                 type DWORD value(74);
 dcl EMR_EXTSELECTCLIPRGN         type DWORD value(75);
 dcl EMR_BITBLT                   type DWORD value(76);
 dcl EMR_STRETCHBLT               type DWORD value(77);
 dcl EMR_MASKBLT                  type DWORD value(78);
 dcl EMR_PLGBLT                   type DWORD value(79);
 dcl EMR_SETDIBITSTODEVICE        type DWORD value(80);
 dcl EMR_STRETCHDIBITS            type DWORD value(81);
 dcl EMR_EXTCREATEFONTINDIRECTW   type DWORD value(82);
 dcl EMR_EXTTEXTOUTA              type DWORD value(83);
 dcl EMR_EXTTEXTOUTW              type DWORD value(84);
 dcl EMR_POLYBEZIER16             type DWORD value(85);
 dcl EMR_POLYGON16                type DWORD value(86);
 dcl EMR_POLYLINE16               type DWORD value(87);
 dcl EMR_POLYBEZIERTO16           type DWORD value(88);
 dcl EMR_POLYLINETO16             type DWORD value(89);
 dcl EMR_POLYPOLYLINE16           type DWORD value(90);
 dcl EMR_POLYPOLYGON16            type DWORD value(91);
 dcl EMR_POLYDRAW16               type DWORD value(92);
 dcl EMR_CREATEMONOBRUSH          type DWORD value(93);
 dcl EMR_CREATEDIBPATTERNBRUSHPT  type DWORD value(94);
 dcl EMR_EXTCREATEPEN             type DWORD value(95);
 dcl EMR_POLYTEXTOUTA             type DWORD value(96);
 dcl EMR_POLYTEXTOUTW             type DWORD value(97);

 %if WINVER >= 1024 %then %do;
 dcl EMR_SETICMMODE               type DWORD value(98);
 dcl EMR_CREATECOLORSPACE         type DWORD value(99);
 dcl EMR_SETCOLORSPACE            type DWORD value(100);
 dcl EMR_DELETECOLORSPACE         type DWORD value(101);
 dcl EMR_GLSRECORD                type DWORD value(102);
 dcl EMR_GLSBOUNDEDRECORD         type DWORD value(103);
 dcl EMR_PIXELFORMAT              type DWORD value(104);
 %end; /* WINVER >= 0x0400 */

 %if WINVER >= 1280 %then %do;
 dcl EMR_DRAWESCAPE               type DWORD value(105); /* obsolete */
 dcl EMR_EXTESCAPE                type DWORD value(106); /* obsolete */
 dcl EMR_STARTDOC                 type DWORD value(107); /* obsolete */
 dcl EMR_SMALLTEXTOUT             type DWORD value(108); /* obsolete */
 dcl EMR_FORCEUFIMAPPING          type DWORD value(109); /* obsolete */
 dcl EMR_NAMEDESCAPE              type DWORD value(110); /* obsolete */
 dcl EMR_COLORCORRECTPALETTE      type DWORD value(111);
 dcl EMR_SETICMPROFILEA           type DWORD value(112);
 dcl EMR_SETICMPROFILEW           type DWORD value(113);
 dcl EMR_ALPHABLEND               type DWORD value(114);
 dcl EMR_ALPHADIBBLEND            type DWORD value(115);
 dcl EMR_TRANSPARENTBLT           type DWORD value(116);
 dcl EMR_TRANSPARENTDIB           type DWORD value(117); /* obsolete */
 dcl EMR_GRADIENTFILL             type DWORD value(118);
 dcl EMR_SETLINKEDUFIS            type DWORD value(119); /* obsolete */
 dcl EMR_SETTEXTJUSTIFICATION     type DWORD value(120); /* obsolete */
 dcl EMR_COLORMATCHTOTARGETW      type DWORD value(121);
 dcl EMR_CREATECOLORSPACEW        type DWORD value(122);
 %end; /* WINVER >= 0x0500 */

 dcl EMR_MIN                      type DWORD value(1);
 %if WINVER >= 1280 %then %do;
 dcl EMR_MAX                      type DWORD value(122);
 %end; %else %if WINVER >= 1024 %then %do;
 dcl EMR_MAX                      type DWORD value(104);
 %end; %else %do;
 dcl EMR_MAX                      type DWORD value(97);
 %end;

 /* Base record type for the enhanced metafile. */

 define structure
   1 EMR,
     2 iType        type DWORD,/* Enhanced metafile record type */
     2 nSize        type DWORD;/* Length of the record in bytes. */
                               /* This must be a multiple of 4. */
 define alias PEMR handle EMR;

 /* Base text record type for the enhanced metafile. */

 define structure
   1 EMRTEXT,
     2 ptlReference type POINTL,
     2 nChars       type DWORD,
     2 offString    type DWORD,/* Offset to the string */
     2 fOptions     type DWORD,
     2 rcl          type RECTL,
     2 offDx        type DWORD;/* Offset to the inter-character */
                               /* spacing array. This is always given.*/
 define alias PEMRTEXT handle EMRTEXT;

 /* Record structures for the enhanced metafile. */

 define structure
   1 ABORTPATH,
     2 emr type EMR;
 define alias  EMRABORTPATH      type   ABORTPATH;
 define alias PEMRABORTPATH      handle ABORTPATH;
 define alias  EMRBEGINPATH      type   ABORTPATH;
 define alias PEMRBEGINPATH      handle ABORTPATH;
 define alias  EMRENDPATH        type   ABORTPATH;
 define alias PEMRENDPATH        handle ABORTPATH;
 define alias  EMRCLOSEFIGURE    type   ABORTPATH;
 define alias PEMRCLOSEFIGURE    handle ABORTPATH;
 define alias  EMRFLATTENPATH    type   ABORTPATH;
 define alias PEMRFLATTENPATH    handle ABORTPATH;
 define alias  EMRWIDENPATH      type   ABORTPATH;
 define alias PEMRWIDENPATH      handle ABORTPATH;
 define alias  EMRSETMETARGN     type   ABORTPATH;
 define alias PEMRSETMETARGN     handle ABORTPATH;
 define alias  EMRSAVEDC         type   ABORTPATH;
 define alias PEMRSAVEDC         handle ABORTPATH;
 define alias  EMRREALIZEPALETTE type   ABORTPATH;
 define alias PEMRREALIZEPALETTE handle ABORTPATH;

 define structure
   1 EMRSELECTCLIPPATH,
     2 emr   type EMR,
     2 iMode type DWORD;
 define alias PEMRSELECTCLIPPATH    handle EMRSELECTCLIPPATH;
 define alias  EMRSETBKMODE         type   EMRSELECTCLIPPATH;
 define alias PEMRSETBKMODE         handle EMRSELECTCLIPPATH;
 define alias  EMRSETMAPMODE        type   EMRSELECTCLIPPATH;
 define alias PEMRSETMAPMODE        handle EMRSELECTCLIPPATH;
 %if WINVER >= 1280 %then %do;
 define alias  EMRSETLAYOUT         type   EMRSELECTCLIPPATH;
 define alias PEMRSETLAYOUT         handle EMRSETLAYOUT;
 %end; /* WINVER >= 0x0500 */
 define alias  EMRSETPOLYFILLMODE   type   EMRSELECTCLIPPATH;
 define alias PEMRSETPOLYFILLMODE   handle EMRSELECTCLIPPATH;
 define alias  EMRSETROP2           type   EMRSELECTCLIPPATH;
 define alias PEMRSETROP2           handle EMRSELECTCLIPPATH;
 define alias  EMRSETSTRETCHBLTMODE type   EMRSELECTCLIPPATH;
 define alias PEMRSETSTRETCHBLTMODE handle EMRSELECTCLIPPATH;
 define alias  EMRSETICMMODE        type   EMRSELECTCLIPPATH;
 define alias PEMRSETICMMODE        handle EMRSELECTCLIPPATH;
 define alias  EMRSETTEXTALIGN      type   EMRSELECTCLIPPATH;
 define alias PEMRSETTEXTALIGN      handle EMRSELECTCLIPPATH;

 define structure
   1 EMRSETMITERLIMIT,
     2 emr         type EMR,
     2 eMiterLimit type FLOAT;
 define alias PEMRSETMITERLIMIT handle EMRSETMITERLIMIT;

 define structure
   1 EMRRESTOREDC,
     2 emr       type EMR,
     2 iRelative type LONG;/* Specifies a relative instance */
 define alias PEMRRESTOREDC handle EMRRESTOREDC;

 define structure
   1 EMRSETARCDIRECTION,
     2 emr           type EMR,
     2 iArcDirection type DWORD;/* Specifies the arc direction in the */
                                /* advanced graphics mode. */
 define alias PEMRSETARCDIRECTION handle EMRSETARCDIRECTION;

 define structure
   1 EMRSETMAPPERFLAGS,
     2 emr     type EMR,
     2 dwFlags type DWORD;
 define alias PEMRSETMAPPERFLAGS handle EMRSETMAPPERFLAGS;

 define structure
   1 EMRSETTEXTCOLOR,
     2 emr     type EMR,
     2 crColor type COLORREF;
 define alias  EMRSETBKCOLOR   type   EMRSETTEXTCOLOR;
 define alias PEMRSETBKCOLOR   handle EMRSETTEXTCOLOR;
 define alias PEMRSETTEXTCOLOR handle EMRSETTEXTCOLOR;

 define structure
   1 EMRSELECTOBJECT,
     2 emr      type EMR,
     2 ihObject type DWORD;/* Object handle index */
 define alias PEMRSELECTOBJECT handle EMRSELECTOBJECT;
 define alias  EMRDELETEOBJECT type   EMRSELECTOBJECT;
 define alias PEMRDELETEOBJECT handle EMRSELECTOBJECT;


 %if WINVER >= 1024 %then %do;
 define structure
   1 EMRSELECTCOLORSPACE,
     2 emr type EMR,
     2 ihCS type DWORD;/* ColorSpace handle index */
 define alias PEMRSELECTCOLORSPACE handle EMRSELECTCOLORSPACE;
 define alias  EMRDELETECOLORSPACE type   EMRSELECTCOLORSPACE;
 define alias PEMRDELETECOLORSPACE handle EMRSELECTCOLORSPACE;
 %end; /* WINVER >= 0x0400 */

 define structure
   1 EMRSELECTPALETTE,
     2 emr   type EMR,
     2 ihPal type DWORD;/* Palette handle index, background mode only */
 define alias PEMRSELECTPALETTE handle EMRSELECTPALETTE;

 define structure
   1 EMRRESIZEPALETTE,
     2 emr      type EMR,
     2 ihPal    type DWORD,/* Palette handle index */
     2 cEntries type DWORD;
 define alias PEMRRESIZEPALETTE handle EMRRESIZEPALETTE;

 define structure
   1 EMRSETPALETTEENTRIES,
     2 emr         type EMR,
     2 ihPal       type DWORD,/* Palette handle index */
     2 iStart      type DWORD,
     2 cEntries    type DWORD,
     2 aPalEntries (1) type PALETTEENTRY;
                       /* The peFlags fields do not contain any flags */
 define alias PEMRSETPALETTEENTRIES handle EMRSETPALETTEENTRIES;

 define structure
   1 EMRSETCOLORADJUSTMENT,
     2 emr             type EMR,
     2 ColorAdjustment type COLORADJUSTMENT;
 define alias PEMRSETCOLORADJUSTMENT handle EMRSETCOLORADJUSTMENT;

 define structure
   1 EMRGDICOMMENT,
     2 emr      type EMR,
     2 cbData   type DWORD,/* Size of data in bytes */
     2 Data (1) type BYTE;
 define alias PEMRGDICOMMENT handle EMRGDICOMMENT;

 define structure
   1 EMREOF,
     2 emr           type EMR,
     2 nPalEntries   type DWORD,/* Number of palette entries */
     2 offPalEntries type DWORD,/* Offset to the palette entries */
     2 nSizeLast     type DWORD;/* Same as nSize and must be the last */
                                /* DWORD of the record.               */
                                /* The palette entries, if exist,     */
                                /* precede this field.                */
 define alias PEMREOF handle EMREOF;

 define structure
   1 EMRLINETO,
     2 emr type EMR,
     2 ptl type POINTL;
 define alias PEMRLINETO   handle EMRLINETO;
 define alias  EMRMOVETOEX type   EMRLINETO;
 define alias PEMRMOVETOEX handle EMRLINETO;

 define structure
   1 EMROFFSETCLIPRGN,
     2 emr       type EMR,
     2 ptlOffset type POINTL;
 define alias PEMROFFSETCLIPRGN handle EMROFFSETCLIPRGN;

 define structure
   1 EMRFILLPATH,
     2 emr       type EMR,
     2 rclBounds type RECTL;/* Inclusive-inclusive bounds in device */
                            /* units */
 define alias PEMRFILLPATH          handle EMRFILLPATH;
 define alias  EMRSTROKEANDFILLPATH type   EMRFILLPATH;
 define alias PEMRSTROKEANDFILLPATH handle EMRFILLPATH;
 define alias  EMRSTROKEPATH        type   EMRFILLPATH;
 define alias PEMRSTROKEPATH        handle EMRFILLPATH;

 define structure
   1 EMREXCLUDECLIPRECT,
     2 emr     type EMR,
     2 rclClip type RECTL;
 define alias PEMREXCLUDECLIPRECT   handle EMREXCLUDECLIPRECT;
 define alias  EMRINTERSECTCLIPRECT type   EMREXCLUDECLIPRECT;
 define alias PEMRINTERSECTCLIPRECT handle EMREXCLUDECLIPRECT;

 define structure
   1 EMRSETVIEWPORTORGEX,
     2 emr       type EMR,
     2 ptlOrigin type POINTL;
 define alias PEMRSETVIEWPORTORGEX handle EMRSETVIEWPORTORGEX;
 define alias  EMRSETWINDOWORGEX   type   EMRSETVIEWPORTORGEX;
 define alias PEMRSETWINDOWORGEX   handle EMRSETVIEWPORTORGEX;
 define alias  EMRSETBRUSHORGEX    type   EMRSETVIEWPORTORGEX;
 define alias PEMRSETBRUSHORGEX    handle EMRSETVIEWPORTORGEX;

 define structure
   1 EMRSETVIEWPORTEXTEX,
     2 emr       type EMR,
     2 szlExtent type SIZEL;
 define alias PEMRSETVIEWPORTEXTEX handle EMRSETVIEWPORTEXTEX;
 define alias  EMRSETWINDOWEXTEX   type   EMRSETVIEWPORTEXTEX;
 define alias PEMRSETWINDOWEXTEX   handle EMRSETVIEWPORTEXTEX;

 define structure
   1 EMRSCALEVIEWPORTEXTEX,
     2 emr    type EMR,
     2 xNum   type LONG,
     2 xDenom type LONG,
     2 yNum   type LONG,
     2 yDenom type LONG;
 define alias PEMRSCALEVIEWPORTEXTEX handle EMRSCALEVIEWPORTEXTEX;
 define alias  EMRSCALEWINDOWEXTEX   type   EMRSCALEVIEWPORTEXTEX;
 define alias PEMRSCALEWINDOWEXTEX   handle EMRSCALEVIEWPORTEXTEX;

 define structure
   1 EMRSETWORLDTRANSFORM,
     2 emr   type EMR,
     2 xform type XFORM;
 define alias PEMRSETWORLDTRANSFORM handle EMRSETWORLDTRANSFORM;

 define structure
   1 EMRMODIFYWORLDTRANSFORM,
     2 emr   type EMR,
     2 xform type XFORM,
     2 iMode type DWORD;
 define alias PEMRMODIFYWORLDTRANSFORM handle EMRMODIFYWORLDTRANSFORM;

 define structure
   1 EMRSETPIXELV,
     2 emr      type EMR,
     2 ptlPixel type POINTL,
     2 crColor  type COLORREF;
 define alias PEMRSETPIXELV handle EMRSETPIXELV;

 define structure
   1 EMREXTFLOODFILL,
     2 emr      type EMR,
     2 ptlStart type POINTL,
     2 crColor  type COLORREF,
     2 iMode    type DWORD;
 define alias PEMREXTFLOODFILL handle EMREXTFLOODFILL;

 define structure
   1 EMRELLIPSE,
     2 emr    type EMR,
     2 rclBox type RECTL;/* Inclusive-inclusive bounding rectangle */
 define alias PEMRELLIPSE   handle EMRELLIPSE;
 define alias  EMRRECTANGLE type   EMRELLIPSE;
 define alias PEMRRECTANGLE handle EMRELLIPSE;

 define structure
   1 EMRROUNDRECT,
     2 emr       type EMR,
     2 rclBox    type RECTL,/* Inclusive-inclusive bounding rectangle */
     2 szlCorner type SIZEL;
 define alias PEMRROUNDRECT handle EMRROUNDRECT;

 define structure
   1 EMRARC,
     2 emr      type EMR,
     2 rclBox   type RECTL,/* Inclusive-inclusive bounding rectangle */
     2 ptlStart type POINTL,
     2 ptlEnd   type POINTL;
 define alias PEMRARC   handle EMRARC;
 define alias  EMRARCTO type   EMRARC;
 define alias PEMRARCTO handle EMRARC;
 define alias  EMRCHORD type   EMRARC;
 define alias PEMRCHORD handle EMRARC;
 define alias  EMRPIE   type   EMRARC;
 define alias PEMRPIE   handle EMRARC;

 define structure
   1 EMRANGLEARC,
     2 emr         type EMR,
     2 ptlCenter   type POINTL,
     2 nRadius     type DWORD,
     2 eStartAngle type FLOAT,
     2 eSweepAngle type FLOAT;
 define alias PEMRANGLEARC handle EMRANGLEARC;

 define structure
   1 EMRPOLYLINE,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 cptl      type DWORD,
     2 aptl (1)  type POINTL;
 define alias PEMRPOLYLINE     handle EMRPOLYLINE;
 define alias  EMRPOLYBEZIER   type   EMRPOLYLINE;
 define alias PEMRPOLYBEZIER   handle EMRPOLYLINE;
 define alias  EMRPOLYGON      type   EMRPOLYLINE;
 define alias PEMRPOLYGON      handle EMRPOLYLINE;
 define alias  EMRPOLYBEZIERTO type   EMRPOLYLINE;
 define alias PEMRPOLYBEZIERTO handle EMRPOLYLINE;
 define alias  EMRPOLYLINETO   type   EMRPOLYLINE;
 define alias PEMRPOLYLINETO   handle EMRPOLYLINE;

 define structure
   1 EMRPOLYLINE16,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 cpts      type DWORD,
     2 apts (1)  type POINTS;
 define alias PEMRPOLYLINE16     handle EMRPOLYLINE16;
 define alias  EMRPOLYBEZIER16   type   EMRPOLYLINE16;
 define alias PEMRPOLYBEZIER16   handle EMRPOLYLINE16;
 define alias  EMRPOLYGON16      type   EMRPOLYLINE16;
 define alias PEMRPOLYGON16      handle EMRPOLYLINE16;
 define alias  EMRPOLYBEZIERTO16 type   EMRPOLYLINE16;
 define alias PEMRPOLYBEZIERTO16 handle EMRPOLYLINE16;
 define alias  EMRPOLYLINETO16   type   EMRPOLYLINE16;
 define alias PEMRPOLYLINETO16   handle EMRPOLYLINE16;

 define structure
   1 EMRPOLYDRAW,
     2 emr         type EMR,
     2 rclBounds   type RECTL, /* Inclusive-inclusive bounds in device*/
                               /* units */
     2 cptl        type DWORD, /* Number of points */
     2 aptl    (1) type POINTL,/* Array of points */
     2 abTypes (1) type BYTE;  /* Array of point types */
 define alias PEMRPOLYDRAW handle EMRPOLYDRAW;

 define structure
   1 EMRPOLYDRAW16,
     2 emr         type EMR,
     2 rclBounds   type RECTL, /* Inclusive-inclusive bounds in device*/
                               /* units */
     2 cpts        type DWORD, /* Number of points */
     2 apts    (1) type POINTS,/* Array of points */
     2 abTypes (1) type BYTE;  /* Array of point types */
 define alias PEMRPOLYDRAW16 handle EMRPOLYDRAW16;

 define structure
   1 EMRPOLYPOLYLINE,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 nPolys    type DWORD,/* Number of polys */
     2 cptl      type DWORD,/* Total number of points in all polys */
     2 aPolyCounts (1) type DWORD,/* Array of point counts for each */
                                  /* poly */
     2 aptl (1)  type POINTL;/* Array of points */
 define alias PEMRPOLYPOLYLINE handle EMRPOLYPOLYLINE;
 define alias  EMRPOLYPOLYGON  type   EMRPOLYPOLYLINE;
 define alias PEMRPOLYPOLYGON  handle EMRPOLYPOLYLINE;

 define structure
   1 EMRPOLYPOLYLINE16,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 nPolys    type DWORD,/* Number of polys */
     2 cpts      type DWORD,/* Total number of points in all polys */
     2 aPolyCounts (1) type DWORD,/* Array of point counts for each */
                                  /* poly */
     2 apts (1)  type POINTS;/* Array of points */
 define alias PEMRPOLYPOLYLINE16 handle EMRPOLYPOLYLINE16;
 define alias  EMRPOLYPOLYGON16  type   EMRPOLYPOLYLINE16;
 define alias PEMRPOLYPOLYGON16  handle EMRPOLYPOLYLINE16;

 define structure
   1 EMRINVERTRGN,
     2 emr         type EMR,
     2 rclBounds   type RECTL,/* Inclusive-inclusive bounds in device */
                              /* units */
     2 cbRgnData   type DWORD,/* Size of region data in bytes */
     2 RgnData (1) type BYTE;
 define alias PEMRINVERTRGN handle EMRINVERTRGN;
 define alias  EMRPAINTRGN  type   EMRINVERTRGN;
 define alias PEMRPAINTRGN  handle EMRINVERTRGN;

 define structure
   1 EMRFILLRGN,
     2 emr         type EMR,
     2 rclBounds   type RECTL,/* Inclusive-inclusive bounds in device */
                              /* units */
     2 cbRgnData   type DWORD,/* Size of region data in bytes */
     2 ihBrush     type DWORD,/* Brush handle index */
     2 RgnData (1) type BYTE;
 define alias PEMRFILLRGN handle EMRFILLRGN;

 define structure
   1 EMRFRAMERGN,
     2 emr         type EMR,
     2 rclBounds   type RECTL,/* Inclusive-inclusive bounds in device */
                              /* units */
     2 cbRgnData   type DWORD,/* Size of region data in bytes */
     2 ihBrush     type DWORD,/* Brush handle index */
     2 szlStroke   type SIZEL,
     2 RgnData (1) type BYTE;
 define alias PEMRFRAMERGN handle EMRFRAMERGN;

 %if #WIN32_WINNT >= 1280 %then %do;
 define structure
   1 EMRGRADIENTFILL,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 nVer      type DWORD,
     2 nTri      type DWORD,
     2 ulMode    type ULONG,
     2 Ver (1)   type TRIVERTEX;
 define alias PEMRGRADIENTFILL handle EMRGRADIENTFILL;
 %end;

 define structure
   1 EMREXTSELECTCLIPRGN,
     2 emr         type EMR,
     2 cbRgnData   type DWORD,/* Size of region data in bytes */
     2 iMode       type DWORD,
     2 RgnData (1) type BYTE;
 define alias PEMREXTSELECTCLIPRGN handle EMREXTSELECTCLIPRGN;

 define structure
   1 EMREXTTEXTOUTA,
     2 emr           type EMR,
     2 rclBounds     type RECTL,/* Inclusive-inclusive bounds in */
                                /* device units */
     2 iGraphicsMode type DWORD,/* Current graphics mode */
     2 exScale       type FLOAT,/* X and Y scales from Page units to */
                                /* .01mm units */
     2 eyScale       type FLOAT,/* if graphics mode is GM_COMPATIBLE. */
     2 emrtext       type EMRTEXT;
       /* This is followed by the string and spacing array */
 define alias PEMREXTTEXTOUTA handle EMREXTTEXTOUTA;
 define alias  EMREXTTEXTOUTW type   EMREXTTEXTOUTA;
 define alias PEMREXTTEXTOUTW handle EMREXTTEXTOUTA;

 define structure
   1 EMRPOLYTEXTOUTA,
     2 emr           type EMR,
     2 rclBounds     type RECTL,/* Inclusive-inclusive bounds in */
                                /* device units */
     2 iGraphicsMode type DWORD,/* Current graphics mode */
     2 exScale       type FLOAT,/* X and Y scales from Page units to */
                                /* .01mm units */
     2 eyScale       type FLOAT,/* if graphics mode is GM_COMPATIBLE. */
     2 cStrings      type LONG,
     2 aemrtext (1)  type EMRTEXT;/* Array of EMRTEXT structures. */
     /* This is followed by the strings and spacing arrays. */
 define alias PEMRPOLYTEXTOUTA handle EMRPOLYTEXTOUTA;
 define alias  EMRPOLYTEXTOUTW type   EMRPOLYTEXTOUTA;
 define alias PEMRPOLYTEXTOUTW handle EMRPOLYTEXTOUTA;

 define structure
   1 EMRBITBLT,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                             /* units */
     2 xDest      type LONG,
     2 yDest      type LONG,
     2 cxDest     type LONG,
     2 cyDest     type LONG,
     2 dwRop      type DWORD,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 xformSrc   type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
                             /* (DIB_RGB_COLORS) */
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD;/* Size of the source bitmap bits */
 define alias PEMRBITBLT handle EMRBITBLT;

 define structure
   1 EMRSTRETCHBLT,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                             /* units */
     2 xDest      type LONG,
     2 yDest      type LONG,
     2 cxDest     type LONG,
     2 cyDest     type LONG,
     2 dwRop      type DWORD,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 xformSrc   type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
                             /* (DIB_RGB_COLORS) */
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD,/* Size of the source bitmap bits */
     2 cxSrc      type LONG,
     2 cySrc      type LONG;
 define alias PEMRSTRETCHBLT handle EMRSTRETCHBLT;

 define structure
   1 EMRMASKBLT,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                             /* units */
     2 xDest      type LONG,
     2 yDest      type LONG,
     2 cxDest     type LONG,
     2 cyDest     type LONG,
     2 dwRop      type DWORD,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 xformSrc   type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
                             /* (DIB_RGB_COLORS) */
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD,/* Size of the source bitmap bits */
     2 xMask      type LONG,
     2 yMask      type LONG,
     2 iUsageMask type DWORD,/* Mask bitmap info color table usage */
     2 offBmiMask type DWORD,/* Offset to the mask BITMAPINFO */
                             /* structure if any */
     2 cbBmiMask  type DWORD,/* Size of the mask BITMAPINFO structure */
                             /* if any */
     2 offBitsMask type DWORD,/* Offset to the mask bitmap bits if any*/
     2 cbBitsMask type DWORD;/* Size of the mask bitmap bits if any */
 define alias PEMRMASKBLT handle EMRMASKBLT;

 define structure
   1 EMRPLGBLT,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                             /* units */
     2 aptlDest   (3) type POINTL,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 cxSrc      type LONG,
     2 cySrc      type LONG,
     2 xformSrc   type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
                             /* (DIB_RGB_COLORS) */
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD,/* Size of the source bitmap bits */
     2 xMask      type LONG,
     2 yMask      type LONG,
     2 iUsageMask type DWORD,/* Mask bitmap info color table usage */
     2 offBmiMask type DWORD,/* Offset to the mask BITMAPINFO */
                             /* structure if any */
     2 cbBmiMask  type DWORD,/* Size of the mask BITMAPINFO structure */
                             /* if any */
     2 offBitsMask type DWORD,/* Offset to the mask bitmap bits if any*/
     2 cbBitsMask type DWORD;/* Size of the mask bitmap bits if any */
 define alias PEMRPLGBLT handle EMRPLGBLT;

 define structure
   1 EMRSETDIBITSTODEVICE,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                             /* units */
     2 xDest      type LONG,
     2 yDest      type LONG,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 cxSrc      type LONG,
     2 cySrc      type LONG,
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD,/* Size of the source bitmap bits */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
     2 iStartScan type DWORD,
     2 cScans     type DWORD;
 define alias PEMRSETDIBITSTODEVICE handle EMRSETDIBITSTODEVICE;

 define structure
   1 EMRSTRETCHDIBITS,
     2 emr        type EMR,
     2 rclBounds  type RECTL,/* Inclusive-inclusive bounds in device */
                            /* units */
     2 xDest      type LONG,
     2 yDest      type LONG,
     2 xSrc       type LONG,
     2 ySrc       type LONG,
     2 cxSrc      type LONG,
     2 cySrc      type LONG,
     2 offBmiSrc  type DWORD,/* Offset to source BITMAPINFO structure */
     2 cbBmiSrc   type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc  type DWORD,/* Size of the source bitmap bits */
     2 iUsageSrc  type DWORD,/* Source bitmap info color table usage */
     2 dwRop      type DWORD,
     2 cxDest     type LONG,
     2 cyDest     type LONG;
 define alias PEMRSTRETCHDIBITS handle EMRSTRETCHDIBITS;


 %if #WIN32_WINNT >= 1280 %then %do;
 define structure
   1 EMRALPHABLEND,
     2 emr          type EMR,
     2 rclBounds    type RECTL,/* Inclusive-inclusive bounds in device*/
                               /* units */
     2 xDest        type LONG,
     2 yDest        type LONG,
     2 cxDest       type LONG,
     2 cyDest       type LONG,
     2 dwRop        type DWORD,
     2 xSrc         type LONG,
     2 ySrc         type LONG,
     2 xformSrc     type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc    type DWORD,/* Source bitmap info color table usage*/
                               /* (DIB_RGB_COLORS) */
     2 offBmiSrc    type DWORD,/*Offset to source BITMAPINFO structure*/
     2 cbBmiSrc     type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc   type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc    type DWORD,/* Size of the source bitmap bits */
     2 cxSrc        type LONG,
     2 cySrc        type LONG;
 define alias PEMRALPHABLEND handle EMRALPHABLEND;

 define structure
   1 EMRTRANSPARENTBLT,
     2 emr          type EMR,
     2 rclBounds    type RECTL,/* Inclusive-inclusive bounds in device*/
                               /* units */
     2 xDest        type LONG,
     2 yDest        type LONG,
     2 cxDest       type LONG,
     2 cyDest       type LONG,
     2 dwRop        type DWORD,
     2 xSrc         type LONG,
     2 ySrc         type LONG,
     2 xformSrc     type XFORM,/* Source DC transform */
     2 crBkColorSrc type COLORREF,/* Source DC BkColor in RGB */
     2 iUsageSrc    type DWORD,/* Source bitmap info color table usage*/
                               /* (DIB_RGB_COLORS) */
     2 offBmiSrc    type DWORD,/*Offset to source BITMAPINFO structure*/
     2 cbBmiSrc     type DWORD,/* Size of source BITMAPINFO structure */
     2 offBitsSrc   type DWORD,/* Offset to the source bitmap bits */
     2 cbBitsSrc    type DWORD,/* Size of the source bitmap bits */
     2 cxSrc        type LONG,
     2 cySrc        type LONG;
 define alias PEMREMRTRANSPARENTBLT handle EMRTRANSPARENTBLT;
 %end;

 define structure
   1 EMREXTCREATEFONTINDIRECTW,
     2 emr     type EMR,
     2 ihFont  type DWORD,/* Font handle index */
     2 elfw    type EXTLOGFONTW;
 define alias PEMREXTCREATEFONTINDIRECTW
        handle EMREXTCREATEFONTINDIRECTW;


 define structure
   1 EMRCREATEPALETTE,
     2 emr     type EMR,
     2 ihPal   type DWORD, /* Palette handle index */
     2 lgpl    type LOGPALETTE;/* The peFlags fields in the palette */
                               /* entries do not contain any flags  */
 define alias PEMRCREATEPALETTE handle EMRCREATEPALETTE;


 %if WINVER >= 1024 %then %do;

 define structure
   1 EMRCREATECOLORSPACE,
     2 emr     type EMR,
     2 ihCS    type DWORD, /* ColorSpace handle index */
     2 lcs     type LOGCOLORSPACEW;
 define alias PEMRCREATECOLORSPACE handle EMRCREATECOLORSPACE;

 define structure
   1 EMRSETCOLORSPACE,
     2 emr     type EMR,
     2 ihCS    type DWORD; /* ColorSpace handle index */

 define alias PEMRSETCOLORSPACE handle EMRSETCOLORSPACE;
 %end; /* WINVER >= 0x0400 */

 define structure
   1 EMRCREATEPEN,
     2 emr     type EMR,
     2 ihPen   type DWORD,/* Pen handle index */
     2 lopn    type LOGPEN;
 define alias PEMRCREATEPEN handle EMRCREATEPEN;

 define structure
   1 EMREXTCREATEPEN,
     2 emr     type EMR,
     2 ihPen   type DWORD,/* Pen handle index */
     2 offBmi  type DWORD,/* Offset to the BITMAPINFO structure if any*/
     2 cbBmi   type DWORD,/* Size of the BITMAPINFO structure if any */
                          /* The bitmap info is followed by the bitmap*/
                          /* bits to form a packed DIB. */
     2 offBits type DWORD,/* Offset to the brush bitmap bits if any */
     2 cbBits  type DWORD,/* Size of the brush bitmap bits if any */
     2 elp    type EXTLOGPEN;/* The extended pen with the style array.*/
 define alias PEMREXTCREATEPEN handle EMREXTCREATEPEN;

 define structure
   1 EMRCREATEBRUSHINDIRECT,
     2 emr     type EMR,
     2 ihBrush type DWORD,   /* Brush handle index */
     2 lb      type LOGBRUSH;/* The style must be BS_SOLID, BS_HOLLOW,*/
                             /* BS_NULL or BS_HATCHED. */
 define alias PEMRCREATEBRUSHINDIRECT handle EMRCREATEBRUSHINDIRECT;

 define structure
   1 EMRCREATEMONOBRUSH,
     2 emr     type EMR,
     2 ihBrush type DWORD,/* Brush handle index */
     2 iUsage  type DWORD,/* Bitmap info color table usage */
     2 offBmi  type DWORD,/* Offset to the BITMAPINFO structure */
     2 cbBmi   type DWORD,/* Size of the BITMAPINFO structure */
     2 offBits type DWORD,/* Offset to the bitmap bits */
     2 cbBits  type DWORD;/* Size of the bitmap bits */
 define alias PEMRCREATEMONOBRUSH handle EMRCREATEMONOBRUSH;

 define structure
   1 EMRCREATEDIBPATTERNBRUSHPT,
     2 emr     type EMR,
     2 ihBrush type DWORD,/* Brush handle index */
     2 iUsage  type DWORD,/* Bitmap info color table usage */
     2 offBmi  type DWORD,/* Offset to the BITMAPINFO structure */
     2 cbBmi   type DWORD,/* Size of the BITMAPINFO structure */
                          /* The bitmap info is followed by the bitmap*/
                          /* bits to form a packed DIB. */
     2 offBits type DWORD,/* Offset to the bitmap bits */
     2 cbBits  type DWORD;/* Size of the bitmap bits */
 define alias PEMRCREATEDIBPATTERNBRUSHPT
        handle EMRCREATEDIBPATTERNBRUSHPT;

 define structure
   1 EMRFORMAT,
     2 dSignature type DWORD,
                  /* Format signature, e.g. ENHMETA_SIGNATURE. */
     2 nVersion   type DWORD,/* Format version number. */
     2 cbData     type DWORD,/* Size of data in bytes. */
     2 offData    type DWORD;
                  /* Offset to data from GDICOMMENT_IDENTIFIER. */
                  /* It must begin at a DWORD offset. */
 define alias PEMRFORMAT handle EMRFORMAT;

 define structure
   1 EMRGLSRECORD,
     2 emr       type EMR,
     2 cbData    type DWORD,/* Size of data in bytes */
     2 Data (1)  type BYTE;
 define alias PEMRGLSRECORD handle EMRGLSRECORD;

 define structure
   1 EMRGLSBOUNDEDRECORD,
     2 emr       type EMR,
     2 rclBounds type RECTL,/* Bounds in recording coordinates */
     2 cbData    type DWORD,/* Size of data in bytes */
     2 Data (1)  type BYTE;
 define alias PEMRGLSBOUNDEDRECORD handle EMRGLSBOUNDEDRECORD;

 define structure
   1 EMRPIXELFORMAT,
     2 emr      type EMR,
     2 pfd      type PIXELFORMATDESCRIPTOR;
 define alias PEMRPIXELFORMAT handle EMRPIXELFORMAT;

 %if WINVER >= 1280 %then %do;

 define structure
   1 EMREXTESCAPE,
     2 emr         type EMR,
     2 iEscape     type INT,   /* Escape code */
     2 cbEscData   type INT,   /* Size of escape data */
     2 EscData (1) type BYTE;  /* Escape data */
 define alias PEMREXTESCAPE handle EMREXTESCAPE;
 define alias  EMRDRAWESCAPE   type EMREXTESCAPE;
 define alias PEMRDRAWESCAPE handle EMRDRAWESCAPE;

 define structure
   1 EMRNAMEDESCAPE,
     2 emr         type EMR,
     2 iEscape     type INT,   /* Escape code */
     2 cbDriver    type INT,   /* Size of driver name */
     2 cbEscData   type INT,   /* Size of escape data */
     2 EscData (1) type BYTE;  /* Escape data */
 define alias PEMRNAMEDESCAPE handle EMRNAMEDESCAPE;


 dcl SETICMPROFILE_EMBEDED  type DWORD value('00000001'xu);

 define structure
   1 EMRSETICMPROFILE,
     2 emr      type EMR,
     2 dwFlags  type DWORD,/* flags */
     2 cbName   type DWORD,/* Size of desired profile name */
     2 cbData   type DWORD,/* Size of raw profile data if attached */
     2 Data (1) type BYTE; /* Array size is cbName and cbData */
 define alias PEMRSETICMPROFILE handle EMRSETICMPROFILE;


 dcl CREATECOLORSPACE_EMBEDED type DWORD value('00000001'xu);

 define structure
   1 EMRCREATECOLORSPACEW,
     2 emr     type EMR,
     2 ihCS    type DWORD, /* ColorSpace handle index */
     2 lcs     type LOGCOLORSPACEW,
               /* Unicode version of logical color space structure */
     2 dwFlags type DWORD, /* flags */
     2 cbData  type DWORD,
               /* size of raw source profile data if attached */
     2 Data(1) type BYTE; /* Array size is cbData */
 define alias PEMRCREATECOLORSPACEW handle EMRCREATECOLORSPACEW;

 dcl COLORMATCHTOTARGET_EMBEDED type DWORD value('00000001'xu);

 define structure
   1 EMRCOLORMATCHTOTARGET,
     2 emr      type EMR,
     2 dwAction type DWORD,
                /* CS_ENABLE, CS_DISABLE or CS_DELETE_TRANSFORM */
     2 dwFlags  type DWORD, /* flags */
     2 cbName   type DWORD, /* Size of desired target profile name */
     2 cbData   type DWORD,
                /* Size of raw target profile data if attached */
     2 Data(1)  type BYTE;  /* Array size is cbName + cbData */
 define alias PEMRCOLORMATCHTOTARGET handle EMRCOLORMATCHTOTARGET;

 define structure
   1 EMRCOLORCORRECTPALETTE,
     2 emr         type EMR,
     2 ihPalette   type DWORD, /* Palette handle index */
     2 nFirstEntry type DWORD, /* Index of first entry to correct */
     2 nPalEntries type DWORD, /* Number of palette entries to correct*/
     2 nReserved   type DWORD; /* Reserved */
 define alias PEMRCOLORCORRECTPALETTE handle EMRCOLORCORRECTPALETTE;

 %end; /* WINVER >= 0x0500 */

 dcl GDICOMMENT_IDENTIFIER       type DWORD value('43494447'xu);
 dcl GDICOMMENT_WINDOWS_METAFILE type DWORD value('80000001'xu);
 dcl GDICOMMENT_BEGINGROUP       type DWORD value('00000002'xu);
 dcl GDICOMMENT_ENDGROUP         type DWORD value('00000003'xu);
 dcl GDICOMMENT_MULTIFORMATS     type DWORD value('40000004'xu);
 dcl EPS_SIGNATURE               type DWORD value('46535045'xu);
 dcl GDICOMMENT_UNICODE_STRING   type DWORD value('00000040'xu);
 dcl GDICOMMENT_UNICODE_END      type DWORD value('00000080'xu);

 %end; /* NOMETAFILE */


 /* OpenGL wgl prototypes */

 dcl wglCopyContext
     entry (type HGLRC,
            type HGLRC,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglCopyContext');

 dcl wglCreateContext
     entry (type HDC )
     returns (type HGLRC byvalue optional)
     WINGDIAPI WINAPI external('wglCreateContext');

 dcl wglCreateLayerContext
     entry (type HDC,
            fixed bin(31))
     returns (type HGLRC byvalue optional)
     WINGDIAPI WINAPI external('wglCreateLayerContext');

 dcl wglDeleteContext
     entry (type HGLRC )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglDeleteContext');

 dcl wglGetCurrentContext
     entry ()
     returns (type HGLRC byvalue optional)
     WINGDIAPI WINAPI external('wglGetCurrentContext');

 dcl wglGetCurrentDC
     entry ()
     returns (type HDC byvalue optional)
     WINGDIAPI WINAPI external('wglGetCurrentDC');

 dcl wglGetProcAddress
     entry (char(*) varz byaddr nonasgn )
     returns (type PROC byvalue optional)
     WINGDIAPI WINAPI external('wglGetProcAddress');

 dcl wglMakeCurrent
     entry (type HDC,
            type HGLRC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglMakeCurrent');

 dcl wglShareLists
     entry (type HGLRC,
            type HGLRC)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglShareLists');

 dcl wglUseFontBitmapsA
     entry (type HDC,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglUseFontBitmapsA');

 dcl wglUseFontBitmapsW
     entry (type HDC,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglUseFontBitmapsW');

 %dcl wglUseFontBitmaps char ext;
 %if UNICODE ^= '' %then %do;
 %wglUseFontBitmaps='wglUseFontBitmapsW';
 %end; %else %do;
   %wglUseFontBitmaps='wglUseFontBitmapsA';
 %end; /* !UNICODE */

 dcl SwapBuffers
     entry (type HDC )
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('SwapBuffers');

 define structure
   1 POINTFLOAT,
     2 x type FLOAT,
     2 y type FLOAT;
 define alias PPOINTFLOAT handle POINTFLOAT;

 define structure
   1 GLYPHMETRICSFLOAT,
     2 gmfBlackBoxX     type FLOAT,
     2 gmfBlackBoxY     type FLOAT,
     2 gmfptGlyphOrigin type POINTFLOAT,
     2 gmfCellIncX      type FLOAT,
     2 gmfCellIncY      type FLOAT;
 define alias  PGLYPHMETRICSFLOAT handle GLYPHMETRICSFLOAT;
 define alias LPGLYPHMETRICSFLOAT handle GLYPHMETRICSFLOAT;

 dcl WGL_FONT_LINES    fixed bin(31) value(0);
 dcl WGL_FONT_POLYGONS fixed bin(31) value(1);

 dcl wglUseFontOutlinesA
     entry (type HDC,
            type DWORD,
            type DWORD,
            type DWORD,
            type FLOAT,
            type FLOAT,
            fixed bin(31),
            type GLYPHMETRICSFLOAT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglUseFontOutlinesA');

 dcl wglUseFontOutlinesW
     entry (type HDC,
            type DWORD,
            type DWORD,
            type DWORD,
            type FLOAT,
            type FLOAT,
            fixed bin(31),
            type GLYPHMETRICSFLOAT byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglUseFontOutlinesW');

 %dcl wglUseFontOutlines char ext;
 %if UNICODE ^= '' %then %do;
   %wglUseFontOutlines='wglUseFontOutlinesW';
 %end; %else %do;
   %wglUseFontOutlines='wglUseFontOutlinesA';
 %end; /* !UNICODE */

 /* Layer plane descriptor */
 define structure
   1 LAYERPLANEDESCRIPTOR,   /* lpd */
      2 nSize           type WORD,
      2 nVersion        type WORD,
      2 dwFlags         type DWORD,
      2 iPixelType      type BYTE,
      2 cColorBits      type BYTE,
      2 cRedBits        type BYTE,
      2 cRedShift       type BYTE,
      2 cGreenBits      type BYTE,
      2 cGreenShift     type BYTE,
      2 cBlueBits       type BYTE,
      2 cBlueShift      type BYTE,
      2 cAlphaBits      type BYTE,
      2 cAlphaShift     type BYTE,
      2 cAccumBits      type BYTE,
      2 cAccumRedBits   type BYTE,
      2 cAccumGreenBits type BYTE,
      2 cAccumBlueBits  type BYTE,
      2 cAccumAlphaBits type BYTE,
      2 cDepthBits      type BYTE,
      2 cStencilBits    type BYTE,
      2 cAuxBuffers     type BYTE,
      2 iLayerPlane     type BYTE,
      2 bReserved       type BYTE,
      2 crTransparent   type COLORREF;
 define alias  PLAYERPLANEDESCRIPTOR handle LAYERPLANEDESCRIPTOR;
 define alias LPLAYERPLANEDESCRIPTOR handle LAYERPLANEDESCRIPTOR;

 /* LAYERPLANEDESCRIPTOR flags */
 dcl LPD_DOUBLEBUFFER    type DWORD value('00000001'xu);
 dcl LPD_STEREO          type DWORD value('00000002'xu);
 dcl LPD_SUPPORT_GDI     type DWORD value('00000010'xu);
 dcl LPD_SUPPORT_OPENGL  type DWORD value('00000020'xu);
 dcl LPD_SHARE_DEPTH     type DWORD value('00000040'xu);
 dcl LPD_SHARE_STENCIL   type DWORD value('00000080'xu);
 dcl LPD_SHARE_ACCUM     type DWORD value('00000100'xu);
 dcl LPD_SWAP_EXCHANGE   type DWORD value('00000200'xu);
 dcl LPD_SWAP_COPY       type DWORD value('00000400'xu);
 dcl LPD_TRANSPARENT     type DWORD value('00001000'xu);

 dcl LPD_TYPE_RGBA       type BYTE value(0);
 dcl LPD_TYPE_COLORINDEX type BYTE value(1);

 /* wglSwapLayerBuffers flags */
 dcl WGL_SWAP_MAIN_PLANE type UINT value('00000001'xu);
 dcl WGL_SWAP_OVERLAY1   type UINT value('00000002'xu);
 dcl WGL_SWAP_OVERLAY2   type UINT value('00000004'xu);
 dcl WGL_SWAP_OVERLAY3   type UINT value('00000008'xu);
 dcl WGL_SWAP_OVERLAY4   type UINT value('00000010'xu);
 dcl WGL_SWAP_OVERLAY5   type UINT value('00000020'xu);
 dcl WGL_SWAP_OVERLAY6   type UINT value('00000040'xu);
 dcl WGL_SWAP_OVERLAY7   type UINT value('00000080'xu);
 dcl WGL_SWAP_OVERLAY8   type UINT value('00000100'xu);
 dcl WGL_SWAP_OVERLAY9   type UINT value('00000200'xu);
 dcl WGL_SWAP_OVERLAY10  type UINT value('00000400'xu);
 dcl WGL_SWAP_OVERLAY11  type UINT value('00000800'xu);
 dcl WGL_SWAP_OVERLAY12  type UINT value('00001000'xu);
 dcl WGL_SWAP_OVERLAY13  type UINT value('00002000'xu);
 dcl WGL_SWAP_OVERLAY14  type UINT value('00004000'xu);
 dcl WGL_SWAP_OVERLAY15  type UINT value('00008000'xu);
 dcl WGL_SWAP_UNDERLAY1  type UINT value('00010000'xu);
 dcl WGL_SWAP_UNDERLAY2  type UINT value('00020000'xu);
 dcl WGL_SWAP_UNDERLAY3  type UINT value('00040000'xu);
 dcl WGL_SWAP_UNDERLAY4  type UINT value('00080000'xu);
 dcl WGL_SWAP_UNDERLAY5  type UINT value('00100000'xu);
 dcl WGL_SWAP_UNDERLAY6  type UINT value('00200000'xu);
 dcl WGL_SWAP_UNDERLAY7  type UINT value('00400000'xu);
 dcl WGL_SWAP_UNDERLAY8  type UINT value('00800000'xu);
 dcl WGL_SWAP_UNDERLAY9  type UINT value('01000000'xu);
 dcl WGL_SWAP_UNDERLAY10 type UINT value('02000000'xu);
 dcl WGL_SWAP_UNDERLAY11 type UINT value('04000000'xu);
 dcl WGL_SWAP_UNDERLAY12 type UINT value('08000000'xu);
 dcl WGL_SWAP_UNDERLAY13 type UINT value('10000000'xu);
 dcl WGL_SWAP_UNDERLAY14 type UINT value('20000000'xu);
 dcl WGL_SWAP_UNDERLAY15 type UINT value('40000000'xu);

 dcl wglDescribeLayerPlane
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            type UINT,
            type LAYERPLANEDESCRIPTOR byaddr)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglDescribeLayerPlane');

 dcl wglSetLayerPaletteEntries
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            (*) type COLORREF byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('wglSetLayerPaletteEntries');

 dcl wglGetLayerPaletteEntries
     entry (type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            (*) type COLORREF byaddr)
     returns (fixed bin(31) byvalue optional)
     WINGDIAPI WINAPI external('wglGetLayerPaletteEntries');

 dcl wglRealizeLayerPalette
     entry (type HDC,
            fixed bin(31),
            type BOOL)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglRealizeLayerPalette');

 dcl wglSwapLayerBuffers
     entry (type HDC,
            type UINT)
     returns (type BOOL byvalue optional)
     WINGDIAPI WINAPI external('wglSwapLayerBuffers');


 %if WINVER >= 1280 %then %do;

 define structure
   1 WGLSWAP,
     2 hdc     type HDC,
     2 uiFlags type UINT;

 define alias  PWGLSWAP handle WGLSWAP;
 define alias LPWGLSWAP handle WGLSWAP;

 dcl WGL_SWAPMULTIPLE_MAX fixed bin(31) value(16);

 dcl wglSwapMultipleBuffers
     entry (type UINT,
            type WGLSWAP byaddr nonasgn)
     returns (type DWORD byvalue optional)
     WINGDIAPI WINAPI external('wglSwapMultipleBuffers');

 %end; /* (WINVER >= 0x0500) */

 %end; /* NOGDI */

 %end; /* _WINGDI_ */

